<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsBelgeGeneric ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsBelgeGeneric extends AbstractStructArrayBase
{
    /**
     * The clsBelgeGeneric
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsBelgeGeneric[]
     */
    public $clsBelgeGeneric;
    /**
     * Constructor method for ArrayOfClsBelgeGeneric
     * @uses ArrayOfClsBelgeGeneric::setClsBelgeGeneric()
     * @param \StructType\ClsBelgeGeneric[] $clsBelgeGeneric
     */
    public function __construct(array $clsBelgeGeneric = array())
    {
        $this
            ->setClsBelgeGeneric($clsBelgeGeneric);
    }
    /**
     * Get clsBelgeGeneric value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsBelgeGeneric[]|null
     */
    public function getClsBelgeGeneric()
    {
        return isset($this->clsBelgeGeneric) ? $this->clsBelgeGeneric : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsBelgeGeneric method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsBelgeGeneric method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsBelgeGenericForArrayConstraintsFromSetClsBelgeGeneric(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsBelgeGenericClsBelgeGenericItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsBelgeGenericClsBelgeGenericItem instanceof \StructType\ClsBelgeGeneric) {
                $invalidValues[] = is_object($arrayOfClsBelgeGenericClsBelgeGenericItem) ? get_class($arrayOfClsBelgeGenericClsBelgeGenericItem) : sprintf('%s(%s)', gettype($arrayOfClsBelgeGenericClsBelgeGenericItem), var_export($arrayOfClsBelgeGenericClsBelgeGenericItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsBelgeGeneric property can only contain items of type \StructType\ClsBelgeGeneric, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsBelgeGeneric value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsBelgeGeneric[] $clsBelgeGeneric
     * @return \ArrayType\ArrayOfClsBelgeGeneric
     */
    public function setClsBelgeGeneric(array $clsBelgeGeneric = array())
    {
        // validation for constraint: array
        if ('' !== ($clsBelgeGenericArrayErrorMessage = self::validateClsBelgeGenericForArrayConstraintsFromSetClsBelgeGeneric($clsBelgeGeneric))) {
            throw new \InvalidArgumentException($clsBelgeGenericArrayErrorMessage, __LINE__);
        }
        if (is_null($clsBelgeGeneric) || (is_array($clsBelgeGeneric) && empty($clsBelgeGeneric))) {
            unset($this->clsBelgeGeneric);
        } else {
            $this->clsBelgeGeneric = $clsBelgeGeneric;
        }
        return $this;
    }
    /**
     * Add item to clsBelgeGeneric value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsBelgeGeneric $item
     * @return \ArrayType\ArrayOfClsBelgeGeneric
     */
    public function addToClsBelgeGeneric(\StructType\ClsBelgeGeneric $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsBelgeGeneric) {
            throw new \InvalidArgumentException(sprintf('The clsBelgeGeneric property can only contain items of type \StructType\ClsBelgeGeneric, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsBelgeGeneric[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsBelgeGeneric|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsBelgeGeneric|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsBelgeGeneric|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsBelgeGeneric|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsBelgeGeneric|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsBelgeGeneric
     */
    public function getAttributeName()
    {
        return 'clsBelgeGeneric';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsBelgeGeneric
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
