<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsBilgiKriter ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsBilgiKriter extends AbstractStructArrayBase
{
    /**
     * The clsBilgiKriter
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsBilgiKriter[]
     */
    public $clsBilgiKriter;
    /**
     * Constructor method for ArrayOfClsBilgiKriter
     * @uses ArrayOfClsBilgiKriter::setClsBilgiKriter()
     * @param \StructType\ClsBilgiKriter[] $clsBilgiKriter
     */
    public function __construct(array $clsBilgiKriter = array())
    {
        $this
            ->setClsBilgiKriter($clsBilgiKriter);
    }
    /**
     * Get clsBilgiKriter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsBilgiKriter[]|null
     */
    public function getClsBilgiKriter()
    {
        return isset($this->clsBilgiKriter) ? $this->clsBilgiKriter : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsBilgiKriter method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsBilgiKriter method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsBilgiKriterForArrayConstraintsFromSetClsBilgiKriter(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsBilgiKriterClsBilgiKriterItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsBilgiKriterClsBilgiKriterItem instanceof \StructType\ClsBilgiKriter) {
                $invalidValues[] = is_object($arrayOfClsBilgiKriterClsBilgiKriterItem) ? get_class($arrayOfClsBilgiKriterClsBilgiKriterItem) : sprintf('%s(%s)', gettype($arrayOfClsBilgiKriterClsBilgiKriterItem), var_export($arrayOfClsBilgiKriterClsBilgiKriterItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsBilgiKriter property can only contain items of type \StructType\ClsBilgiKriter, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsBilgiKriter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsBilgiKriter[] $clsBilgiKriter
     * @return \ArrayType\ArrayOfClsBilgiKriter
     */
    public function setClsBilgiKriter(array $clsBilgiKriter = array())
    {
        // validation for constraint: array
        if ('' !== ($clsBilgiKriterArrayErrorMessage = self::validateClsBilgiKriterForArrayConstraintsFromSetClsBilgiKriter($clsBilgiKriter))) {
            throw new \InvalidArgumentException($clsBilgiKriterArrayErrorMessage, __LINE__);
        }
        if (is_null($clsBilgiKriter) || (is_array($clsBilgiKriter) && empty($clsBilgiKriter))) {
            unset($this->clsBilgiKriter);
        } else {
            $this->clsBilgiKriter = $clsBilgiKriter;
        }
        return $this;
    }
    /**
     * Add item to clsBilgiKriter value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsBilgiKriter $item
     * @return \ArrayType\ArrayOfClsBilgiKriter
     */
    public function addToClsBilgiKriter(\StructType\ClsBilgiKriter $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsBilgiKriter) {
            throw new \InvalidArgumentException(sprintf('The clsBilgiKriter property can only contain items of type \StructType\ClsBilgiKriter, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsBilgiKriter[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsBilgiKriter|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsBilgiKriter|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsBilgiKriter|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsBilgiKriter|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsBilgiKriter|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsBilgiKriter
     */
    public function getAttributeName()
    {
        return 'clsBilgiKriter';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsBilgiKriter
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
