<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsCariHesapIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsCariHesapIntegration extends AbstractStructArrayBase
{
    /**
     * The clsCariHesapIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsCariHesapIntegration[]
     */
    public $clsCariHesapIntegration;
    /**
     * Constructor method for ArrayOfClsCariHesapIntegration
     * @uses ArrayOfClsCariHesapIntegration::setClsCariHesapIntegration()
     * @param \StructType\ClsCariHesapIntegration[] $clsCariHesapIntegration
     */
    public function __construct(array $clsCariHesapIntegration = array())
    {
        $this
            ->setClsCariHesapIntegration($clsCariHesapIntegration);
    }
    /**
     * Get clsCariHesapIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsCariHesapIntegration[]|null
     */
    public function getClsCariHesapIntegration()
    {
        return isset($this->clsCariHesapIntegration) ? $this->clsCariHesapIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsCariHesapIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsCariHesapIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsCariHesapIntegrationForArrayConstraintsFromSetClsCariHesapIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsCariHesapIntegrationClsCariHesapIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsCariHesapIntegrationClsCariHesapIntegrationItem instanceof \StructType\ClsCariHesapIntegration) {
                $invalidValues[] = is_object($arrayOfClsCariHesapIntegrationClsCariHesapIntegrationItem) ? get_class($arrayOfClsCariHesapIntegrationClsCariHesapIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsCariHesapIntegrationClsCariHesapIntegrationItem), var_export($arrayOfClsCariHesapIntegrationClsCariHesapIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsCariHesapIntegration property can only contain items of type \StructType\ClsCariHesapIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsCariHesapIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsCariHesapIntegration[] $clsCariHesapIntegration
     * @return \ArrayType\ArrayOfClsCariHesapIntegration
     */
    public function setClsCariHesapIntegration(array $clsCariHesapIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsCariHesapIntegrationArrayErrorMessage = self::validateClsCariHesapIntegrationForArrayConstraintsFromSetClsCariHesapIntegration($clsCariHesapIntegration))) {
            throw new \InvalidArgumentException($clsCariHesapIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsCariHesapIntegration) || (is_array($clsCariHesapIntegration) && empty($clsCariHesapIntegration))) {
            unset($this->clsCariHesapIntegration);
        } else {
            $this->clsCariHesapIntegration = $clsCariHesapIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsCariHesapIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsCariHesapIntegration $item
     * @return \ArrayType\ArrayOfClsCariHesapIntegration
     */
    public function addToClsCariHesapIntegration(\StructType\ClsCariHesapIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsCariHesapIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsCariHesapIntegration property can only contain items of type \StructType\ClsCariHesapIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsCariHesapIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsCariHesapIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsCariHesapIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsCariHesapIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsCariHesapIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsCariHesapIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsCariHesapIntegration
     */
    public function getAttributeName()
    {
        return 'clsCariHesapIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsCariHesapIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
