<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsDemirbasGeneric ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsDemirbasGeneric extends AbstractStructArrayBase
{
    /**
     * The clsDemirbasGeneric
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsDemirbasGeneric[]
     */
    public $clsDemirbasGeneric;
    /**
     * Constructor method for ArrayOfClsDemirbasGeneric
     * @uses ArrayOfClsDemirbasGeneric::setClsDemirbasGeneric()
     * @param \StructType\ClsDemirbasGeneric[] $clsDemirbasGeneric
     */
    public function __construct(array $clsDemirbasGeneric = array())
    {
        $this
            ->setClsDemirbasGeneric($clsDemirbasGeneric);
    }
    /**
     * Get clsDemirbasGeneric value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsDemirbasGeneric[]|null
     */
    public function getClsDemirbasGeneric()
    {
        return isset($this->clsDemirbasGeneric) ? $this->clsDemirbasGeneric : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsDemirbasGeneric method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsDemirbasGeneric method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsDemirbasGenericForArrayConstraintsFromSetClsDemirbasGeneric(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsDemirbasGenericClsDemirbasGenericItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsDemirbasGenericClsDemirbasGenericItem instanceof \StructType\ClsDemirbasGeneric) {
                $invalidValues[] = is_object($arrayOfClsDemirbasGenericClsDemirbasGenericItem) ? get_class($arrayOfClsDemirbasGenericClsDemirbasGenericItem) : sprintf('%s(%s)', gettype($arrayOfClsDemirbasGenericClsDemirbasGenericItem), var_export($arrayOfClsDemirbasGenericClsDemirbasGenericItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsDemirbasGeneric property can only contain items of type \StructType\ClsDemirbasGeneric, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsDemirbasGeneric value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDemirbasGeneric[] $clsDemirbasGeneric
     * @return \ArrayType\ArrayOfClsDemirbasGeneric
     */
    public function setClsDemirbasGeneric(array $clsDemirbasGeneric = array())
    {
        // validation for constraint: array
        if ('' !== ($clsDemirbasGenericArrayErrorMessage = self::validateClsDemirbasGenericForArrayConstraintsFromSetClsDemirbasGeneric($clsDemirbasGeneric))) {
            throw new \InvalidArgumentException($clsDemirbasGenericArrayErrorMessage, __LINE__);
        }
        if (is_null($clsDemirbasGeneric) || (is_array($clsDemirbasGeneric) && empty($clsDemirbasGeneric))) {
            unset($this->clsDemirbasGeneric);
        } else {
            $this->clsDemirbasGeneric = $clsDemirbasGeneric;
        }
        return $this;
    }
    /**
     * Add item to clsDemirbasGeneric value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDemirbasGeneric $item
     * @return \ArrayType\ArrayOfClsDemirbasGeneric
     */
    public function addToClsDemirbasGeneric(\StructType\ClsDemirbasGeneric $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsDemirbasGeneric) {
            throw new \InvalidArgumentException(sprintf('The clsDemirbasGeneric property can only contain items of type \StructType\ClsDemirbasGeneric, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsDemirbasGeneric[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsDemirbasGeneric|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsDemirbasGeneric|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsDemirbasGeneric|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsDemirbasGeneric|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsDemirbasGeneric|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsDemirbasGeneric
     */
    public function getAttributeName()
    {
        return 'clsDemirbasGeneric';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsDemirbasGeneric
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
