<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsDepoGeneric ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsDepoGeneric extends AbstractStructArrayBase
{
    /**
     * The clsDepoGeneric
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsDepoGeneric[]
     */
    public $clsDepoGeneric;
    /**
     * Constructor method for ArrayOfClsDepoGeneric
     * @uses ArrayOfClsDepoGeneric::setClsDepoGeneric()
     * @param \StructType\ClsDepoGeneric[] $clsDepoGeneric
     */
    public function __construct(array $clsDepoGeneric = array())
    {
        $this
            ->setClsDepoGeneric($clsDepoGeneric);
    }
    /**
     * Get clsDepoGeneric value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsDepoGeneric[]|null
     */
    public function getClsDepoGeneric()
    {
        return isset($this->clsDepoGeneric) ? $this->clsDepoGeneric : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsDepoGeneric method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsDepoGeneric method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsDepoGenericForArrayConstraintsFromSetClsDepoGeneric(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsDepoGenericClsDepoGenericItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsDepoGenericClsDepoGenericItem instanceof \StructType\ClsDepoGeneric) {
                $invalidValues[] = is_object($arrayOfClsDepoGenericClsDepoGenericItem) ? get_class($arrayOfClsDepoGenericClsDepoGenericItem) : sprintf('%s(%s)', gettype($arrayOfClsDepoGenericClsDepoGenericItem), var_export($arrayOfClsDepoGenericClsDepoGenericItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsDepoGeneric property can only contain items of type \StructType\ClsDepoGeneric, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsDepoGeneric value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDepoGeneric[] $clsDepoGeneric
     * @return \ArrayType\ArrayOfClsDepoGeneric
     */
    public function setClsDepoGeneric(array $clsDepoGeneric = array())
    {
        // validation for constraint: array
        if ('' !== ($clsDepoGenericArrayErrorMessage = self::validateClsDepoGenericForArrayConstraintsFromSetClsDepoGeneric($clsDepoGeneric))) {
            throw new \InvalidArgumentException($clsDepoGenericArrayErrorMessage, __LINE__);
        }
        if (is_null($clsDepoGeneric) || (is_array($clsDepoGeneric) && empty($clsDepoGeneric))) {
            unset($this->clsDepoGeneric);
        } else {
            $this->clsDepoGeneric = $clsDepoGeneric;
        }
        return $this;
    }
    /**
     * Add item to clsDepoGeneric value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDepoGeneric $item
     * @return \ArrayType\ArrayOfClsDepoGeneric
     */
    public function addToClsDepoGeneric(\StructType\ClsDepoGeneric $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsDepoGeneric) {
            throw new \InvalidArgumentException(sprintf('The clsDepoGeneric property can only contain items of type \StructType\ClsDepoGeneric, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsDepoGeneric[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsDepoGeneric|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsDepoGeneric|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsDepoGeneric|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsDepoGeneric|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsDepoGeneric|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsDepoGeneric
     */
    public function getAttributeName()
    {
        return 'clsDepoGeneric';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsDepoGeneric
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
