<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsDepoHareketGeneric ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsDepoHareketGeneric extends AbstractStructArrayBase
{
    /**
     * The clsDepoHareketGeneric
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsDepoHareketGeneric[]
     */
    public $clsDepoHareketGeneric;
    /**
     * Constructor method for ArrayOfClsDepoHareketGeneric
     * @uses ArrayOfClsDepoHareketGeneric::setClsDepoHareketGeneric()
     * @param \StructType\ClsDepoHareketGeneric[] $clsDepoHareketGeneric
     */
    public function __construct(array $clsDepoHareketGeneric = array())
    {
        $this
            ->setClsDepoHareketGeneric($clsDepoHareketGeneric);
    }
    /**
     * Get clsDepoHareketGeneric value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsDepoHareketGeneric[]|null
     */
    public function getClsDepoHareketGeneric()
    {
        return isset($this->clsDepoHareketGeneric) ? $this->clsDepoHareketGeneric : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsDepoHareketGeneric method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsDepoHareketGeneric method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsDepoHareketGenericForArrayConstraintsFromSetClsDepoHareketGeneric(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsDepoHareketGenericClsDepoHareketGenericItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsDepoHareketGenericClsDepoHareketGenericItem instanceof \StructType\ClsDepoHareketGeneric) {
                $invalidValues[] = is_object($arrayOfClsDepoHareketGenericClsDepoHareketGenericItem) ? get_class($arrayOfClsDepoHareketGenericClsDepoHareketGenericItem) : sprintf('%s(%s)', gettype($arrayOfClsDepoHareketGenericClsDepoHareketGenericItem), var_export($arrayOfClsDepoHareketGenericClsDepoHareketGenericItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsDepoHareketGeneric property can only contain items of type \StructType\ClsDepoHareketGeneric, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsDepoHareketGeneric value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDepoHareketGeneric[] $clsDepoHareketGeneric
     * @return \ArrayType\ArrayOfClsDepoHareketGeneric
     */
    public function setClsDepoHareketGeneric(array $clsDepoHareketGeneric = array())
    {
        // validation for constraint: array
        if ('' !== ($clsDepoHareketGenericArrayErrorMessage = self::validateClsDepoHareketGenericForArrayConstraintsFromSetClsDepoHareketGeneric($clsDepoHareketGeneric))) {
            throw new \InvalidArgumentException($clsDepoHareketGenericArrayErrorMessage, __LINE__);
        }
        if (is_null($clsDepoHareketGeneric) || (is_array($clsDepoHareketGeneric) && empty($clsDepoHareketGeneric))) {
            unset($this->clsDepoHareketGeneric);
        } else {
            $this->clsDepoHareketGeneric = $clsDepoHareketGeneric;
        }
        return $this;
    }
    /**
     * Add item to clsDepoHareketGeneric value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDepoHareketGeneric $item
     * @return \ArrayType\ArrayOfClsDepoHareketGeneric
     */
    public function addToClsDepoHareketGeneric(\StructType\ClsDepoHareketGeneric $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsDepoHareketGeneric) {
            throw new \InvalidArgumentException(sprintf('The clsDepoHareketGeneric property can only contain items of type \StructType\ClsDepoHareketGeneric, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsDepoHareketGeneric[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsDepoHareketGeneric|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsDepoHareketGeneric|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsDepoHareketGeneric|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsDepoHareketGeneric|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsDepoHareketGeneric|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsDepoHareketGeneric
     */
    public function getAttributeName()
    {
        return 'clsDepoHareketGeneric';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsDepoHareketGeneric
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
