<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsDepoIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsDepoIntegration extends AbstractStructArrayBase
{
    /**
     * The clsDepoIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsDepoIntegration[]
     */
    public $clsDepoIntegration;
    /**
     * Constructor method for ArrayOfClsDepoIntegration
     * @uses ArrayOfClsDepoIntegration::setClsDepoIntegration()
     * @param \StructType\ClsDepoIntegration[] $clsDepoIntegration
     */
    public function __construct(array $clsDepoIntegration = array())
    {
        $this
            ->setClsDepoIntegration($clsDepoIntegration);
    }
    /**
     * Get clsDepoIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsDepoIntegration[]|null
     */
    public function getClsDepoIntegration()
    {
        return isset($this->clsDepoIntegration) ? $this->clsDepoIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsDepoIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsDepoIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsDepoIntegrationForArrayConstraintsFromSetClsDepoIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsDepoIntegrationClsDepoIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsDepoIntegrationClsDepoIntegrationItem instanceof \StructType\ClsDepoIntegration) {
                $invalidValues[] = is_object($arrayOfClsDepoIntegrationClsDepoIntegrationItem) ? get_class($arrayOfClsDepoIntegrationClsDepoIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsDepoIntegrationClsDepoIntegrationItem), var_export($arrayOfClsDepoIntegrationClsDepoIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsDepoIntegration property can only contain items of type \StructType\ClsDepoIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsDepoIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDepoIntegration[] $clsDepoIntegration
     * @return \ArrayType\ArrayOfClsDepoIntegration
     */
    public function setClsDepoIntegration(array $clsDepoIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsDepoIntegrationArrayErrorMessage = self::validateClsDepoIntegrationForArrayConstraintsFromSetClsDepoIntegration($clsDepoIntegration))) {
            throw new \InvalidArgumentException($clsDepoIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsDepoIntegration) || (is_array($clsDepoIntegration) && empty($clsDepoIntegration))) {
            unset($this->clsDepoIntegration);
        } else {
            $this->clsDepoIntegration = $clsDepoIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsDepoIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDepoIntegration $item
     * @return \ArrayType\ArrayOfClsDepoIntegration
     */
    public function addToClsDepoIntegration(\StructType\ClsDepoIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsDepoIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsDepoIntegration property can only contain items of type \StructType\ClsDepoIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsDepoIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsDepoIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsDepoIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsDepoIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsDepoIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsDepoIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsDepoIntegration
     */
    public function getAttributeName()
    {
        return 'clsDepoIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsDepoIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
