<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsDepozitoIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsDepozitoIntegration extends AbstractStructArrayBase
{
    /**
     * The clsDepozitoIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsDepozitoIntegration[]
     */
    public $clsDepozitoIntegration;
    /**
     * Constructor method for ArrayOfClsDepozitoIntegration
     * @uses ArrayOfClsDepozitoIntegration::setClsDepozitoIntegration()
     * @param \StructType\ClsDepozitoIntegration[] $clsDepozitoIntegration
     */
    public function __construct(array $clsDepozitoIntegration = array())
    {
        $this
            ->setClsDepozitoIntegration($clsDepozitoIntegration);
    }
    /**
     * Get clsDepozitoIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsDepozitoIntegration[]|null
     */
    public function getClsDepozitoIntegration()
    {
        return isset($this->clsDepozitoIntegration) ? $this->clsDepozitoIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsDepozitoIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsDepozitoIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsDepozitoIntegrationForArrayConstraintsFromSetClsDepozitoIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsDepozitoIntegrationClsDepozitoIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsDepozitoIntegrationClsDepozitoIntegrationItem instanceof \StructType\ClsDepozitoIntegration) {
                $invalidValues[] = is_object($arrayOfClsDepozitoIntegrationClsDepozitoIntegrationItem) ? get_class($arrayOfClsDepozitoIntegrationClsDepozitoIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsDepozitoIntegrationClsDepozitoIntegrationItem), var_export($arrayOfClsDepozitoIntegrationClsDepozitoIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsDepozitoIntegration property can only contain items of type \StructType\ClsDepozitoIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsDepozitoIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDepozitoIntegration[] $clsDepozitoIntegration
     * @return \ArrayType\ArrayOfClsDepozitoIntegration
     */
    public function setClsDepozitoIntegration(array $clsDepozitoIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsDepozitoIntegrationArrayErrorMessage = self::validateClsDepozitoIntegrationForArrayConstraintsFromSetClsDepozitoIntegration($clsDepozitoIntegration))) {
            throw new \InvalidArgumentException($clsDepozitoIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsDepozitoIntegration) || (is_array($clsDepozitoIntegration) && empty($clsDepozitoIntegration))) {
            unset($this->clsDepozitoIntegration);
        } else {
            $this->clsDepozitoIntegration = $clsDepozitoIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsDepozitoIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDepozitoIntegration $item
     * @return \ArrayType\ArrayOfClsDepozitoIntegration
     */
    public function addToClsDepozitoIntegration(\StructType\ClsDepozitoIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsDepozitoIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsDepozitoIntegration property can only contain items of type \StructType\ClsDepozitoIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsDepozitoIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsDepozitoIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsDepozitoIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsDepozitoIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsDepozitoIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsDepozitoIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsDepozitoIntegration
     */
    public function getAttributeName()
    {
        return 'clsDepozitoIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsDepozitoIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
