<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsDepozitoSeri ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsDepozitoSeri extends AbstractStructArrayBase
{
    /**
     * The clsDepozitoSeri
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsDepozitoSeri[]
     */
    public $clsDepozitoSeri;
    /**
     * Constructor method for ArrayOfClsDepozitoSeri
     * @uses ArrayOfClsDepozitoSeri::setClsDepozitoSeri()
     * @param \StructType\ClsDepozitoSeri[] $clsDepozitoSeri
     */
    public function __construct(array $clsDepozitoSeri = array())
    {
        $this
            ->setClsDepozitoSeri($clsDepozitoSeri);
    }
    /**
     * Get clsDepozitoSeri value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsDepozitoSeri[]|null
     */
    public function getClsDepozitoSeri()
    {
        return isset($this->clsDepozitoSeri) ? $this->clsDepozitoSeri : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsDepozitoSeri method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsDepozitoSeri method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsDepozitoSeriForArrayConstraintsFromSetClsDepozitoSeri(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsDepozitoSeriClsDepozitoSeriItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsDepozitoSeriClsDepozitoSeriItem instanceof \StructType\ClsDepozitoSeri) {
                $invalidValues[] = is_object($arrayOfClsDepozitoSeriClsDepozitoSeriItem) ? get_class($arrayOfClsDepozitoSeriClsDepozitoSeriItem) : sprintf('%s(%s)', gettype($arrayOfClsDepozitoSeriClsDepozitoSeriItem), var_export($arrayOfClsDepozitoSeriClsDepozitoSeriItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsDepozitoSeri property can only contain items of type \StructType\ClsDepozitoSeri, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsDepozitoSeri value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDepozitoSeri[] $clsDepozitoSeri
     * @return \ArrayType\ArrayOfClsDepozitoSeri
     */
    public function setClsDepozitoSeri(array $clsDepozitoSeri = array())
    {
        // validation for constraint: array
        if ('' !== ($clsDepozitoSeriArrayErrorMessage = self::validateClsDepozitoSeriForArrayConstraintsFromSetClsDepozitoSeri($clsDepozitoSeri))) {
            throw new \InvalidArgumentException($clsDepozitoSeriArrayErrorMessage, __LINE__);
        }
        if (is_null($clsDepozitoSeri) || (is_array($clsDepozitoSeri) && empty($clsDepozitoSeri))) {
            unset($this->clsDepozitoSeri);
        } else {
            $this->clsDepozitoSeri = $clsDepozitoSeri;
        }
        return $this;
    }
    /**
     * Add item to clsDepozitoSeri value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDepozitoSeri $item
     * @return \ArrayType\ArrayOfClsDepozitoSeri
     */
    public function addToClsDepozitoSeri(\StructType\ClsDepozitoSeri $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsDepozitoSeri) {
            throw new \InvalidArgumentException(sprintf('The clsDepozitoSeri property can only contain items of type \StructType\ClsDepozitoSeri, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsDepozitoSeri[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsDepozitoSeri|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsDepozitoSeri|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsDepozitoSeri|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsDepozitoSeri|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsDepozitoSeri|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsDepozitoSeri
     */
    public function getAttributeName()
    {
        return 'clsDepozitoSeri';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsDepozitoSeri
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
