<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsDictionaryOfStringObject ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsDictionaryOfStringObject extends AbstractStructArrayBase
{
    /**
     * The clsDictionaryOfStringObject
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsDictionaryOfStringObject[]
     */
    public $clsDictionaryOfStringObject;
    /**
     * Constructor method for ArrayOfClsDictionaryOfStringObject
     * @uses ArrayOfClsDictionaryOfStringObject::setClsDictionaryOfStringObject()
     * @param \StructType\ClsDictionaryOfStringObject[] $clsDictionaryOfStringObject
     */
    public function __construct(array $clsDictionaryOfStringObject = array())
    {
        $this
            ->setClsDictionaryOfStringObject($clsDictionaryOfStringObject);
    }
    /**
     * Get clsDictionaryOfStringObject value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsDictionaryOfStringObject[]|null
     */
    public function getClsDictionaryOfStringObject()
    {
        return isset($this->clsDictionaryOfStringObject) ? $this->clsDictionaryOfStringObject : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsDictionaryOfStringObject method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsDictionaryOfStringObject method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsDictionaryOfStringObjectForArrayConstraintsFromSetClsDictionaryOfStringObject(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsDictionaryOfStringObjectClsDictionaryOfStringObjectItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsDictionaryOfStringObjectClsDictionaryOfStringObjectItem instanceof \StructType\ClsDictionaryOfStringObject) {
                $invalidValues[] = is_object($arrayOfClsDictionaryOfStringObjectClsDictionaryOfStringObjectItem) ? get_class($arrayOfClsDictionaryOfStringObjectClsDictionaryOfStringObjectItem) : sprintf('%s(%s)', gettype($arrayOfClsDictionaryOfStringObjectClsDictionaryOfStringObjectItem), var_export($arrayOfClsDictionaryOfStringObjectClsDictionaryOfStringObjectItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsDictionaryOfStringObject property can only contain items of type \StructType\ClsDictionaryOfStringObject, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsDictionaryOfStringObject value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDictionaryOfStringObject[] $clsDictionaryOfStringObject
     * @return \ArrayType\ArrayOfClsDictionaryOfStringObject
     */
    public function setClsDictionaryOfStringObject(array $clsDictionaryOfStringObject = array())
    {
        // validation for constraint: array
        if ('' !== ($clsDictionaryOfStringObjectArrayErrorMessage = self::validateClsDictionaryOfStringObjectForArrayConstraintsFromSetClsDictionaryOfStringObject($clsDictionaryOfStringObject))) {
            throw new \InvalidArgumentException($clsDictionaryOfStringObjectArrayErrorMessage, __LINE__);
        }
        if (is_null($clsDictionaryOfStringObject) || (is_array($clsDictionaryOfStringObject) && empty($clsDictionaryOfStringObject))) {
            unset($this->clsDictionaryOfStringObject);
        } else {
            $this->clsDictionaryOfStringObject = $clsDictionaryOfStringObject;
        }
        return $this;
    }
    /**
     * Add item to clsDictionaryOfStringObject value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDictionaryOfStringObject $item
     * @return \ArrayType\ArrayOfClsDictionaryOfStringObject
     */
    public function addToClsDictionaryOfStringObject(\StructType\ClsDictionaryOfStringObject $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsDictionaryOfStringObject) {
            throw new \InvalidArgumentException(sprintf('The clsDictionaryOfStringObject property can only contain items of type \StructType\ClsDictionaryOfStringObject, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsDictionaryOfStringObject[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsDictionaryOfStringObject|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsDictionaryOfStringObject|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsDictionaryOfStringObject|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsDictionaryOfStringObject|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsDictionaryOfStringObject|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsDictionaryOfStringObject
     */
    public function getAttributeName()
    {
        return 'clsDictionaryOfStringObject';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsDictionaryOfStringObject
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
