<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsDictionaryOfStringString ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsDictionaryOfStringString extends AbstractStructArrayBase
{
    /**
     * The clsDictionaryOfStringString
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsDictionaryOfStringString[]
     */
    public $clsDictionaryOfStringString;
    /**
     * Constructor method for ArrayOfClsDictionaryOfStringString
     * @uses ArrayOfClsDictionaryOfStringString::setClsDictionaryOfStringString()
     * @param \StructType\ClsDictionaryOfStringString[] $clsDictionaryOfStringString
     */
    public function __construct(array $clsDictionaryOfStringString = array())
    {
        $this
            ->setClsDictionaryOfStringString($clsDictionaryOfStringString);
    }
    /**
     * Get clsDictionaryOfStringString value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsDictionaryOfStringString[]|null
     */
    public function getClsDictionaryOfStringString()
    {
        return isset($this->clsDictionaryOfStringString) ? $this->clsDictionaryOfStringString : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsDictionaryOfStringString method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsDictionaryOfStringString method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsDictionaryOfStringStringForArrayConstraintsFromSetClsDictionaryOfStringString(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsDictionaryOfStringStringClsDictionaryOfStringStringItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsDictionaryOfStringStringClsDictionaryOfStringStringItem instanceof \StructType\ClsDictionaryOfStringString) {
                $invalidValues[] = is_object($arrayOfClsDictionaryOfStringStringClsDictionaryOfStringStringItem) ? get_class($arrayOfClsDictionaryOfStringStringClsDictionaryOfStringStringItem) : sprintf('%s(%s)', gettype($arrayOfClsDictionaryOfStringStringClsDictionaryOfStringStringItem), var_export($arrayOfClsDictionaryOfStringStringClsDictionaryOfStringStringItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsDictionaryOfStringString property can only contain items of type \StructType\ClsDictionaryOfStringString, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsDictionaryOfStringString value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDictionaryOfStringString[] $clsDictionaryOfStringString
     * @return \ArrayType\ArrayOfClsDictionaryOfStringString
     */
    public function setClsDictionaryOfStringString(array $clsDictionaryOfStringString = array())
    {
        // validation for constraint: array
        if ('' !== ($clsDictionaryOfStringStringArrayErrorMessage = self::validateClsDictionaryOfStringStringForArrayConstraintsFromSetClsDictionaryOfStringString($clsDictionaryOfStringString))) {
            throw new \InvalidArgumentException($clsDictionaryOfStringStringArrayErrorMessage, __LINE__);
        }
        if (is_null($clsDictionaryOfStringString) || (is_array($clsDictionaryOfStringString) && empty($clsDictionaryOfStringString))) {
            unset($this->clsDictionaryOfStringString);
        } else {
            $this->clsDictionaryOfStringString = $clsDictionaryOfStringString;
        }
        return $this;
    }
    /**
     * Add item to clsDictionaryOfStringString value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDictionaryOfStringString $item
     * @return \ArrayType\ArrayOfClsDictionaryOfStringString
     */
    public function addToClsDictionaryOfStringString(\StructType\ClsDictionaryOfStringString $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsDictionaryOfStringString) {
            throw new \InvalidArgumentException(sprintf('The clsDictionaryOfStringString property can only contain items of type \StructType\ClsDictionaryOfStringString, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsDictionaryOfStringString[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsDictionaryOfStringString|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsDictionaryOfStringString|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsDictionaryOfStringString|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsDictionaryOfStringString|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsDictionaryOfStringString|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsDictionaryOfStringString
     */
    public function getAttributeName()
    {
        return 'clsDictionaryOfStringString';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsDictionaryOfStringString
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
