<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsDistAltBayiler ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsDistAltBayiler extends AbstractStructArrayBase
{
    /**
     * The clsDistAltBayiler
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsDistAltBayiler[]
     */
    public $clsDistAltBayiler;
    /**
     * Constructor method for ArrayOfClsDistAltBayiler
     * @uses ArrayOfClsDistAltBayiler::setClsDistAltBayiler()
     * @param \StructType\ClsDistAltBayiler[] $clsDistAltBayiler
     */
    public function __construct(array $clsDistAltBayiler = array())
    {
        $this
            ->setClsDistAltBayiler($clsDistAltBayiler);
    }
    /**
     * Get clsDistAltBayiler value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsDistAltBayiler[]|null
     */
    public function getClsDistAltBayiler()
    {
        return isset($this->clsDistAltBayiler) ? $this->clsDistAltBayiler : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsDistAltBayiler method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsDistAltBayiler method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsDistAltBayilerForArrayConstraintsFromSetClsDistAltBayiler(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsDistAltBayilerClsDistAltBayilerItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsDistAltBayilerClsDistAltBayilerItem instanceof \StructType\ClsDistAltBayiler) {
                $invalidValues[] = is_object($arrayOfClsDistAltBayilerClsDistAltBayilerItem) ? get_class($arrayOfClsDistAltBayilerClsDistAltBayilerItem) : sprintf('%s(%s)', gettype($arrayOfClsDistAltBayilerClsDistAltBayilerItem), var_export($arrayOfClsDistAltBayilerClsDistAltBayilerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsDistAltBayiler property can only contain items of type \StructType\ClsDistAltBayiler, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsDistAltBayiler value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDistAltBayiler[] $clsDistAltBayiler
     * @return \ArrayType\ArrayOfClsDistAltBayiler
     */
    public function setClsDistAltBayiler(array $clsDistAltBayiler = array())
    {
        // validation for constraint: array
        if ('' !== ($clsDistAltBayilerArrayErrorMessage = self::validateClsDistAltBayilerForArrayConstraintsFromSetClsDistAltBayiler($clsDistAltBayiler))) {
            throw new \InvalidArgumentException($clsDistAltBayilerArrayErrorMessage, __LINE__);
        }
        if (is_null($clsDistAltBayiler) || (is_array($clsDistAltBayiler) && empty($clsDistAltBayiler))) {
            unset($this->clsDistAltBayiler);
        } else {
            $this->clsDistAltBayiler = $clsDistAltBayiler;
        }
        return $this;
    }
    /**
     * Add item to clsDistAltBayiler value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsDistAltBayiler $item
     * @return \ArrayType\ArrayOfClsDistAltBayiler
     */
    public function addToClsDistAltBayiler(\StructType\ClsDistAltBayiler $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsDistAltBayiler) {
            throw new \InvalidArgumentException(sprintf('The clsDistAltBayiler property can only contain items of type \StructType\ClsDistAltBayiler, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsDistAltBayiler[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsDistAltBayiler|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsDistAltBayiler|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsDistAltBayiler|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsDistAltBayiler|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsDistAltBayiler|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsDistAltBayiler
     */
    public function getAttributeName()
    {
        return 'clsDistAltBayiler';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsDistAltBayiler
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
