<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsEfesMusteriIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsEfesMusteriIntegration extends AbstractStructArrayBase
{
    /**
     * The clsEfesMusteriIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsEfesMusteriIntegration[]
     */
    public $clsEfesMusteriIntegration;
    /**
     * Constructor method for ArrayOfClsEfesMusteriIntegration
     * @uses ArrayOfClsEfesMusteriIntegration::setClsEfesMusteriIntegration()
     * @param \StructType\ClsEfesMusteriIntegration[] $clsEfesMusteriIntegration
     */
    public function __construct(array $clsEfesMusteriIntegration = array())
    {
        $this
            ->setClsEfesMusteriIntegration($clsEfesMusteriIntegration);
    }
    /**
     * Get clsEfesMusteriIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsEfesMusteriIntegration[]|null
     */
    public function getClsEfesMusteriIntegration()
    {
        return isset($this->clsEfesMusteriIntegration) ? $this->clsEfesMusteriIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsEfesMusteriIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsEfesMusteriIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsEfesMusteriIntegrationForArrayConstraintsFromSetClsEfesMusteriIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsEfesMusteriIntegrationClsEfesMusteriIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsEfesMusteriIntegrationClsEfesMusteriIntegrationItem instanceof \StructType\ClsEfesMusteriIntegration) {
                $invalidValues[] = is_object($arrayOfClsEfesMusteriIntegrationClsEfesMusteriIntegrationItem) ? get_class($arrayOfClsEfesMusteriIntegrationClsEfesMusteriIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsEfesMusteriIntegrationClsEfesMusteriIntegrationItem), var_export($arrayOfClsEfesMusteriIntegrationClsEfesMusteriIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsEfesMusteriIntegration property can only contain items of type \StructType\ClsEfesMusteriIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsEfesMusteriIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsEfesMusteriIntegration[] $clsEfesMusteriIntegration
     * @return \ArrayType\ArrayOfClsEfesMusteriIntegration
     */
    public function setClsEfesMusteriIntegration(array $clsEfesMusteriIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsEfesMusteriIntegrationArrayErrorMessage = self::validateClsEfesMusteriIntegrationForArrayConstraintsFromSetClsEfesMusteriIntegration($clsEfesMusteriIntegration))) {
            throw new \InvalidArgumentException($clsEfesMusteriIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsEfesMusteriIntegration) || (is_array($clsEfesMusteriIntegration) && empty($clsEfesMusteriIntegration))) {
            unset($this->clsEfesMusteriIntegration);
        } else {
            $this->clsEfesMusteriIntegration = $clsEfesMusteriIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsEfesMusteriIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsEfesMusteriIntegration $item
     * @return \ArrayType\ArrayOfClsEfesMusteriIntegration
     */
    public function addToClsEfesMusteriIntegration(\StructType\ClsEfesMusteriIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsEfesMusteriIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsEfesMusteriIntegration property can only contain items of type \StructType\ClsEfesMusteriIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsEfesMusteriIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsEfesMusteriIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsEfesMusteriIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsEfesMusteriIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsEfesMusteriIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsEfesMusteriIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsEfesMusteriIntegration
     */
    public function getAttributeName()
    {
        return 'clsEfesMusteriIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsEfesMusteriIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
