<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsEntegrasyonLog ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsEntegrasyonLog extends AbstractStructArrayBase
{
    /**
     * The clsEntegrasyonLog
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsEntegrasyonLog[]
     */
    public $clsEntegrasyonLog;
    /**
     * Constructor method for ArrayOfClsEntegrasyonLog
     * @uses ArrayOfClsEntegrasyonLog::setClsEntegrasyonLog()
     * @param \StructType\ClsEntegrasyonLog[] $clsEntegrasyonLog
     */
    public function __construct(array $clsEntegrasyonLog = array())
    {
        $this
            ->setClsEntegrasyonLog($clsEntegrasyonLog);
    }
    /**
     * Get clsEntegrasyonLog value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsEntegrasyonLog[]|null
     */
    public function getClsEntegrasyonLog()
    {
        return isset($this->clsEntegrasyonLog) ? $this->clsEntegrasyonLog : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsEntegrasyonLog method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsEntegrasyonLog method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsEntegrasyonLogForArrayConstraintsFromSetClsEntegrasyonLog(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsEntegrasyonLogClsEntegrasyonLogItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsEntegrasyonLogClsEntegrasyonLogItem instanceof \StructType\ClsEntegrasyonLog) {
                $invalidValues[] = is_object($arrayOfClsEntegrasyonLogClsEntegrasyonLogItem) ? get_class($arrayOfClsEntegrasyonLogClsEntegrasyonLogItem) : sprintf('%s(%s)', gettype($arrayOfClsEntegrasyonLogClsEntegrasyonLogItem), var_export($arrayOfClsEntegrasyonLogClsEntegrasyonLogItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsEntegrasyonLog property can only contain items of type \StructType\ClsEntegrasyonLog, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsEntegrasyonLog value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsEntegrasyonLog[] $clsEntegrasyonLog
     * @return \ArrayType\ArrayOfClsEntegrasyonLog
     */
    public function setClsEntegrasyonLog(array $clsEntegrasyonLog = array())
    {
        // validation for constraint: array
        if ('' !== ($clsEntegrasyonLogArrayErrorMessage = self::validateClsEntegrasyonLogForArrayConstraintsFromSetClsEntegrasyonLog($clsEntegrasyonLog))) {
            throw new \InvalidArgumentException($clsEntegrasyonLogArrayErrorMessage, __LINE__);
        }
        if (is_null($clsEntegrasyonLog) || (is_array($clsEntegrasyonLog) && empty($clsEntegrasyonLog))) {
            unset($this->clsEntegrasyonLog);
        } else {
            $this->clsEntegrasyonLog = $clsEntegrasyonLog;
        }
        return $this;
    }
    /**
     * Add item to clsEntegrasyonLog value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsEntegrasyonLog $item
     * @return \ArrayType\ArrayOfClsEntegrasyonLog
     */
    public function addToClsEntegrasyonLog(\StructType\ClsEntegrasyonLog $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsEntegrasyonLog) {
            throw new \InvalidArgumentException(sprintf('The clsEntegrasyonLog property can only contain items of type \StructType\ClsEntegrasyonLog, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsEntegrasyonLog[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsEntegrasyonLog|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsEntegrasyonLog|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsEntegrasyonLog|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsEntegrasyonLog|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsEntegrasyonLog|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsEntegrasyonLog
     */
    public function getAttributeName()
    {
        return 'clsEntegrasyonLog';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsEntegrasyonLog
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
