<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsFatura ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsFatura extends AbstractStructArrayBase
{
    /**
     * The clsFatura
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsFatura[]
     */
    public $clsFatura;
    /**
     * Constructor method for ArrayOfClsFatura
     * @uses ArrayOfClsFatura::setClsFatura()
     * @param \StructType\ClsFatura[] $clsFatura
     */
    public function __construct(array $clsFatura = array())
    {
        $this
            ->setClsFatura($clsFatura);
    }
    /**
     * Get clsFatura value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsFatura[]|null
     */
    public function getClsFatura()
    {
        return isset($this->clsFatura) ? $this->clsFatura : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsFatura method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsFatura method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsFaturaForArrayConstraintsFromSetClsFatura(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsFaturaClsFaturaItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsFaturaClsFaturaItem instanceof \StructType\ClsFatura) {
                $invalidValues[] = is_object($arrayOfClsFaturaClsFaturaItem) ? get_class($arrayOfClsFaturaClsFaturaItem) : sprintf('%s(%s)', gettype($arrayOfClsFaturaClsFaturaItem), var_export($arrayOfClsFaturaClsFaturaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsFatura property can only contain items of type \StructType\ClsFatura, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsFatura value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsFatura[] $clsFatura
     * @return \ArrayType\ArrayOfClsFatura
     */
    public function setClsFatura(array $clsFatura = array())
    {
        // validation for constraint: array
        if ('' !== ($clsFaturaArrayErrorMessage = self::validateClsFaturaForArrayConstraintsFromSetClsFatura($clsFatura))) {
            throw new \InvalidArgumentException($clsFaturaArrayErrorMessage, __LINE__);
        }
        if (is_null($clsFatura) || (is_array($clsFatura) && empty($clsFatura))) {
            unset($this->clsFatura);
        } else {
            $this->clsFatura = $clsFatura;
        }
        return $this;
    }
    /**
     * Add item to clsFatura value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsFatura $item
     * @return \ArrayType\ArrayOfClsFatura
     */
    public function addToClsFatura(\StructType\ClsFatura $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsFatura) {
            throw new \InvalidArgumentException(sprintf('The clsFatura property can only contain items of type \StructType\ClsFatura, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsFatura[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsFatura|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsFatura|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsFatura|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsFatura|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsFatura|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsFatura
     */
    public function getAttributeName()
    {
        return 'clsFatura';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsFatura
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
