<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsFaturaGeneric ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsFaturaGeneric extends AbstractStructArrayBase
{
    /**
     * The clsFaturaGeneric
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsFaturaGeneric[]
     */
    public $clsFaturaGeneric;
    /**
     * Constructor method for ArrayOfClsFaturaGeneric
     * @uses ArrayOfClsFaturaGeneric::setClsFaturaGeneric()
     * @param \StructType\ClsFaturaGeneric[] $clsFaturaGeneric
     */
    public function __construct(array $clsFaturaGeneric = array())
    {
        $this
            ->setClsFaturaGeneric($clsFaturaGeneric);
    }
    /**
     * Get clsFaturaGeneric value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsFaturaGeneric[]|null
     */
    public function getClsFaturaGeneric()
    {
        return isset($this->clsFaturaGeneric) ? $this->clsFaturaGeneric : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsFaturaGeneric method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsFaturaGeneric method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsFaturaGenericForArrayConstraintsFromSetClsFaturaGeneric(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsFaturaGenericClsFaturaGenericItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsFaturaGenericClsFaturaGenericItem instanceof \StructType\ClsFaturaGeneric) {
                $invalidValues[] = is_object($arrayOfClsFaturaGenericClsFaturaGenericItem) ? get_class($arrayOfClsFaturaGenericClsFaturaGenericItem) : sprintf('%s(%s)', gettype($arrayOfClsFaturaGenericClsFaturaGenericItem), var_export($arrayOfClsFaturaGenericClsFaturaGenericItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsFaturaGeneric property can only contain items of type \StructType\ClsFaturaGeneric, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsFaturaGeneric value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsFaturaGeneric[] $clsFaturaGeneric
     * @return \ArrayType\ArrayOfClsFaturaGeneric
     */
    public function setClsFaturaGeneric(array $clsFaturaGeneric = array())
    {
        // validation for constraint: array
        if ('' !== ($clsFaturaGenericArrayErrorMessage = self::validateClsFaturaGenericForArrayConstraintsFromSetClsFaturaGeneric($clsFaturaGeneric))) {
            throw new \InvalidArgumentException($clsFaturaGenericArrayErrorMessage, __LINE__);
        }
        if (is_null($clsFaturaGeneric) || (is_array($clsFaturaGeneric) && empty($clsFaturaGeneric))) {
            unset($this->clsFaturaGeneric);
        } else {
            $this->clsFaturaGeneric = $clsFaturaGeneric;
        }
        return $this;
    }
    /**
     * Add item to clsFaturaGeneric value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsFaturaGeneric $item
     * @return \ArrayType\ArrayOfClsFaturaGeneric
     */
    public function addToClsFaturaGeneric(\StructType\ClsFaturaGeneric $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsFaturaGeneric) {
            throw new \InvalidArgumentException(sprintf('The clsFaturaGeneric property can only contain items of type \StructType\ClsFaturaGeneric, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsFaturaGeneric[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsFaturaGeneric|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsFaturaGeneric|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsFaturaGeneric|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsFaturaGeneric|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsFaturaGeneric|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsFaturaGeneric
     */
    public function getAttributeName()
    {
        return 'clsFaturaGeneric';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsFaturaGeneric
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
