<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsFaturaKapatmaIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsFaturaKapatmaIntegration extends AbstractStructArrayBase
{
    /**
     * The clsFaturaKapatmaIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsFaturaKapatmaIntegration[]
     */
    public $clsFaturaKapatmaIntegration;
    /**
     * Constructor method for ArrayOfClsFaturaKapatmaIntegration
     * @uses ArrayOfClsFaturaKapatmaIntegration::setClsFaturaKapatmaIntegration()
     * @param \StructType\ClsFaturaKapatmaIntegration[] $clsFaturaKapatmaIntegration
     */
    public function __construct(array $clsFaturaKapatmaIntegration = array())
    {
        $this
            ->setClsFaturaKapatmaIntegration($clsFaturaKapatmaIntegration);
    }
    /**
     * Get clsFaturaKapatmaIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsFaturaKapatmaIntegration[]|null
     */
    public function getClsFaturaKapatmaIntegration()
    {
        return isset($this->clsFaturaKapatmaIntegration) ? $this->clsFaturaKapatmaIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsFaturaKapatmaIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsFaturaKapatmaIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsFaturaKapatmaIntegrationForArrayConstraintsFromSetClsFaturaKapatmaIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsFaturaKapatmaIntegrationClsFaturaKapatmaIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsFaturaKapatmaIntegrationClsFaturaKapatmaIntegrationItem instanceof \StructType\ClsFaturaKapatmaIntegration) {
                $invalidValues[] = is_object($arrayOfClsFaturaKapatmaIntegrationClsFaturaKapatmaIntegrationItem) ? get_class($arrayOfClsFaturaKapatmaIntegrationClsFaturaKapatmaIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsFaturaKapatmaIntegrationClsFaturaKapatmaIntegrationItem), var_export($arrayOfClsFaturaKapatmaIntegrationClsFaturaKapatmaIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsFaturaKapatmaIntegration property can only contain items of type \StructType\ClsFaturaKapatmaIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsFaturaKapatmaIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsFaturaKapatmaIntegration[] $clsFaturaKapatmaIntegration
     * @return \ArrayType\ArrayOfClsFaturaKapatmaIntegration
     */
    public function setClsFaturaKapatmaIntegration(array $clsFaturaKapatmaIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsFaturaKapatmaIntegrationArrayErrorMessage = self::validateClsFaturaKapatmaIntegrationForArrayConstraintsFromSetClsFaturaKapatmaIntegration($clsFaturaKapatmaIntegration))) {
            throw new \InvalidArgumentException($clsFaturaKapatmaIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsFaturaKapatmaIntegration) || (is_array($clsFaturaKapatmaIntegration) && empty($clsFaturaKapatmaIntegration))) {
            unset($this->clsFaturaKapatmaIntegration);
        } else {
            $this->clsFaturaKapatmaIntegration = $clsFaturaKapatmaIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsFaturaKapatmaIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsFaturaKapatmaIntegration $item
     * @return \ArrayType\ArrayOfClsFaturaKapatmaIntegration
     */
    public function addToClsFaturaKapatmaIntegration(\StructType\ClsFaturaKapatmaIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsFaturaKapatmaIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsFaturaKapatmaIntegration property can only contain items of type \StructType\ClsFaturaKapatmaIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsFaturaKapatmaIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsFaturaKapatmaIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsFaturaKapatmaIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsFaturaKapatmaIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsFaturaKapatmaIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsFaturaKapatmaIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsFaturaKapatmaIntegration
     */
    public function getAttributeName()
    {
        return 'clsFaturaKapatmaIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsFaturaKapatmaIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
