<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsIadeNeden ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsIadeNeden extends AbstractStructArrayBase
{
    /**
     * The clsIadeNeden
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsIadeNeden[]
     */
    public $clsIadeNeden;
    /**
     * Constructor method for ArrayOfClsIadeNeden
     * @uses ArrayOfClsIadeNeden::setClsIadeNeden()
     * @param \StructType\ClsIadeNeden[] $clsIadeNeden
     */
    public function __construct(array $clsIadeNeden = array())
    {
        $this
            ->setClsIadeNeden($clsIadeNeden);
    }
    /**
     * Get clsIadeNeden value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsIadeNeden[]|null
     */
    public function getClsIadeNeden()
    {
        return isset($this->clsIadeNeden) ? $this->clsIadeNeden : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsIadeNeden method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsIadeNeden method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsIadeNedenForArrayConstraintsFromSetClsIadeNeden(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsIadeNedenClsIadeNedenItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsIadeNedenClsIadeNedenItem instanceof \StructType\ClsIadeNeden) {
                $invalidValues[] = is_object($arrayOfClsIadeNedenClsIadeNedenItem) ? get_class($arrayOfClsIadeNedenClsIadeNedenItem) : sprintf('%s(%s)', gettype($arrayOfClsIadeNedenClsIadeNedenItem), var_export($arrayOfClsIadeNedenClsIadeNedenItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsIadeNeden property can only contain items of type \StructType\ClsIadeNeden, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsIadeNeden value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsIadeNeden[] $clsIadeNeden
     * @return \ArrayType\ArrayOfClsIadeNeden
     */
    public function setClsIadeNeden(array $clsIadeNeden = array())
    {
        // validation for constraint: array
        if ('' !== ($clsIadeNedenArrayErrorMessage = self::validateClsIadeNedenForArrayConstraintsFromSetClsIadeNeden($clsIadeNeden))) {
            throw new \InvalidArgumentException($clsIadeNedenArrayErrorMessage, __LINE__);
        }
        if (is_null($clsIadeNeden) || (is_array($clsIadeNeden) && empty($clsIadeNeden))) {
            unset($this->clsIadeNeden);
        } else {
            $this->clsIadeNeden = $clsIadeNeden;
        }
        return $this;
    }
    /**
     * Add item to clsIadeNeden value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsIadeNeden $item
     * @return \ArrayType\ArrayOfClsIadeNeden
     */
    public function addToClsIadeNeden(\StructType\ClsIadeNeden $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsIadeNeden) {
            throw new \InvalidArgumentException(sprintf('The clsIadeNeden property can only contain items of type \StructType\ClsIadeNeden, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsIadeNeden[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsIadeNeden|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsIadeNeden|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsIadeNeden|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsIadeNeden|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsIadeNeden|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsIadeNeden
     */
    public function getAttributeName()
    {
        return 'clsIadeNeden';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsIadeNeden
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
