<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsIptalBelge ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsIptalBelge extends AbstractStructArrayBase
{
    /**
     * The clsIptalBelge
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsIptalBelge[]
     */
    public $clsIptalBelge;
    /**
     * Constructor method for ArrayOfClsIptalBelge
     * @uses ArrayOfClsIptalBelge::setClsIptalBelge()
     * @param \StructType\ClsIptalBelge[] $clsIptalBelge
     */
    public function __construct(array $clsIptalBelge = array())
    {
        $this
            ->setClsIptalBelge($clsIptalBelge);
    }
    /**
     * Get clsIptalBelge value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsIptalBelge[]|null
     */
    public function getClsIptalBelge()
    {
        return isset($this->clsIptalBelge) ? $this->clsIptalBelge : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsIptalBelge method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsIptalBelge method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsIptalBelgeForArrayConstraintsFromSetClsIptalBelge(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsIptalBelgeClsIptalBelgeItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsIptalBelgeClsIptalBelgeItem instanceof \StructType\ClsIptalBelge) {
                $invalidValues[] = is_object($arrayOfClsIptalBelgeClsIptalBelgeItem) ? get_class($arrayOfClsIptalBelgeClsIptalBelgeItem) : sprintf('%s(%s)', gettype($arrayOfClsIptalBelgeClsIptalBelgeItem), var_export($arrayOfClsIptalBelgeClsIptalBelgeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsIptalBelge property can only contain items of type \StructType\ClsIptalBelge, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsIptalBelge value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsIptalBelge[] $clsIptalBelge
     * @return \ArrayType\ArrayOfClsIptalBelge
     */
    public function setClsIptalBelge(array $clsIptalBelge = array())
    {
        // validation for constraint: array
        if ('' !== ($clsIptalBelgeArrayErrorMessage = self::validateClsIptalBelgeForArrayConstraintsFromSetClsIptalBelge($clsIptalBelge))) {
            throw new \InvalidArgumentException($clsIptalBelgeArrayErrorMessage, __LINE__);
        }
        if (is_null($clsIptalBelge) || (is_array($clsIptalBelge) && empty($clsIptalBelge))) {
            unset($this->clsIptalBelge);
        } else {
            $this->clsIptalBelge = $clsIptalBelge;
        }
        return $this;
    }
    /**
     * Add item to clsIptalBelge value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsIptalBelge $item
     * @return \ArrayType\ArrayOfClsIptalBelge
     */
    public function addToClsIptalBelge(\StructType\ClsIptalBelge $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsIptalBelge) {
            throw new \InvalidArgumentException(sprintf('The clsIptalBelge property can only contain items of type \StructType\ClsIptalBelge, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsIptalBelge[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsIptalBelge|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsIptalBelge|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsIptalBelge|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsIptalBelge|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsIptalBelge|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsIptalBelge
     */
    public function getAttributeName()
    {
        return 'clsIptalBelge';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsIptalBelge
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
