<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsIrsaliye ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsIrsaliye extends AbstractStructArrayBase
{
    /**
     * The clsIrsaliye
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsIrsaliye[]
     */
    public $clsIrsaliye;
    /**
     * Constructor method for ArrayOfClsIrsaliye
     * @uses ArrayOfClsIrsaliye::setClsIrsaliye()
     * @param \StructType\ClsIrsaliye[] $clsIrsaliye
     */
    public function __construct(array $clsIrsaliye = array())
    {
        $this
            ->setClsIrsaliye($clsIrsaliye);
    }
    /**
     * Get clsIrsaliye value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsIrsaliye[]|null
     */
    public function getClsIrsaliye()
    {
        return isset($this->clsIrsaliye) ? $this->clsIrsaliye : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsIrsaliye method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsIrsaliye method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsIrsaliyeForArrayConstraintsFromSetClsIrsaliye(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsIrsaliyeClsIrsaliyeItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsIrsaliyeClsIrsaliyeItem instanceof \StructType\ClsIrsaliye) {
                $invalidValues[] = is_object($arrayOfClsIrsaliyeClsIrsaliyeItem) ? get_class($arrayOfClsIrsaliyeClsIrsaliyeItem) : sprintf('%s(%s)', gettype($arrayOfClsIrsaliyeClsIrsaliyeItem), var_export($arrayOfClsIrsaliyeClsIrsaliyeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsIrsaliye property can only contain items of type \StructType\ClsIrsaliye, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsIrsaliye value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsIrsaliye[] $clsIrsaliye
     * @return \ArrayType\ArrayOfClsIrsaliye
     */
    public function setClsIrsaliye(array $clsIrsaliye = array())
    {
        // validation for constraint: array
        if ('' !== ($clsIrsaliyeArrayErrorMessage = self::validateClsIrsaliyeForArrayConstraintsFromSetClsIrsaliye($clsIrsaliye))) {
            throw new \InvalidArgumentException($clsIrsaliyeArrayErrorMessage, __LINE__);
        }
        if (is_null($clsIrsaliye) || (is_array($clsIrsaliye) && empty($clsIrsaliye))) {
            unset($this->clsIrsaliye);
        } else {
            $this->clsIrsaliye = $clsIrsaliye;
        }
        return $this;
    }
    /**
     * Add item to clsIrsaliye value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsIrsaliye $item
     * @return \ArrayType\ArrayOfClsIrsaliye
     */
    public function addToClsIrsaliye(\StructType\ClsIrsaliye $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsIrsaliye) {
            throw new \InvalidArgumentException(sprintf('The clsIrsaliye property can only contain items of type \StructType\ClsIrsaliye, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsIrsaliye[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsIrsaliye|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsIrsaliye|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsIrsaliye|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsIrsaliye|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsIrsaliye|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsIrsaliye
     */
    public function getAttributeName()
    {
        return 'clsIrsaliye';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsIrsaliye
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
