<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsIskProGeneric ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsIskProGeneric extends AbstractStructArrayBase
{
    /**
     * The clsIskProGeneric
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsIskProGeneric[]
     */
    public $clsIskProGeneric;
    /**
     * Constructor method for ArrayOfClsIskProGeneric
     * @uses ArrayOfClsIskProGeneric::setClsIskProGeneric()
     * @param \StructType\ClsIskProGeneric[] $clsIskProGeneric
     */
    public function __construct(array $clsIskProGeneric = array())
    {
        $this
            ->setClsIskProGeneric($clsIskProGeneric);
    }
    /**
     * Get clsIskProGeneric value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsIskProGeneric[]|null
     */
    public function getClsIskProGeneric()
    {
        return isset($this->clsIskProGeneric) ? $this->clsIskProGeneric : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsIskProGeneric method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsIskProGeneric method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsIskProGenericForArrayConstraintsFromSetClsIskProGeneric(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsIskProGenericClsIskProGenericItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsIskProGenericClsIskProGenericItem instanceof \StructType\ClsIskProGeneric) {
                $invalidValues[] = is_object($arrayOfClsIskProGenericClsIskProGenericItem) ? get_class($arrayOfClsIskProGenericClsIskProGenericItem) : sprintf('%s(%s)', gettype($arrayOfClsIskProGenericClsIskProGenericItem), var_export($arrayOfClsIskProGenericClsIskProGenericItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsIskProGeneric property can only contain items of type \StructType\ClsIskProGeneric, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsIskProGeneric value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsIskProGeneric[] $clsIskProGeneric
     * @return \ArrayType\ArrayOfClsIskProGeneric
     */
    public function setClsIskProGeneric(array $clsIskProGeneric = array())
    {
        // validation for constraint: array
        if ('' !== ($clsIskProGenericArrayErrorMessage = self::validateClsIskProGenericForArrayConstraintsFromSetClsIskProGeneric($clsIskProGeneric))) {
            throw new \InvalidArgumentException($clsIskProGenericArrayErrorMessage, __LINE__);
        }
        if (is_null($clsIskProGeneric) || (is_array($clsIskProGeneric) && empty($clsIskProGeneric))) {
            unset($this->clsIskProGeneric);
        } else {
            $this->clsIskProGeneric = $clsIskProGeneric;
        }
        return $this;
    }
    /**
     * Add item to clsIskProGeneric value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsIskProGeneric $item
     * @return \ArrayType\ArrayOfClsIskProGeneric
     */
    public function addToClsIskProGeneric(\StructType\ClsIskProGeneric $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsIskProGeneric) {
            throw new \InvalidArgumentException(sprintf('The clsIskProGeneric property can only contain items of type \StructType\ClsIskProGeneric, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsIskProGeneric[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsIskProGeneric|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsIskProGeneric|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsIskProGeneric|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsIskProGeneric|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsIskProGeneric|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsIskProGeneric
     */
    public function getAttributeName()
    {
        return 'clsIskProGeneric';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsIskProGeneric
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
