<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsKarmaKoliIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsKarmaKoliIntegration extends AbstractStructArrayBase
{
    /**
     * The clsKarmaKoliIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsKarmaKoliIntegration[]
     */
    public $clsKarmaKoliIntegration;
    /**
     * Constructor method for ArrayOfClsKarmaKoliIntegration
     * @uses ArrayOfClsKarmaKoliIntegration::setClsKarmaKoliIntegration()
     * @param \StructType\ClsKarmaKoliIntegration[] $clsKarmaKoliIntegration
     */
    public function __construct(array $clsKarmaKoliIntegration = array())
    {
        $this
            ->setClsKarmaKoliIntegration($clsKarmaKoliIntegration);
    }
    /**
     * Get clsKarmaKoliIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsKarmaKoliIntegration[]|null
     */
    public function getClsKarmaKoliIntegration()
    {
        return isset($this->clsKarmaKoliIntegration) ? $this->clsKarmaKoliIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsKarmaKoliIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsKarmaKoliIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsKarmaKoliIntegrationForArrayConstraintsFromSetClsKarmaKoliIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsKarmaKoliIntegrationClsKarmaKoliIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsKarmaKoliIntegrationClsKarmaKoliIntegrationItem instanceof \StructType\ClsKarmaKoliIntegration) {
                $invalidValues[] = is_object($arrayOfClsKarmaKoliIntegrationClsKarmaKoliIntegrationItem) ? get_class($arrayOfClsKarmaKoliIntegrationClsKarmaKoliIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsKarmaKoliIntegrationClsKarmaKoliIntegrationItem), var_export($arrayOfClsKarmaKoliIntegrationClsKarmaKoliIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsKarmaKoliIntegration property can only contain items of type \StructType\ClsKarmaKoliIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsKarmaKoliIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsKarmaKoliIntegration[] $clsKarmaKoliIntegration
     * @return \ArrayType\ArrayOfClsKarmaKoliIntegration
     */
    public function setClsKarmaKoliIntegration(array $clsKarmaKoliIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsKarmaKoliIntegrationArrayErrorMessage = self::validateClsKarmaKoliIntegrationForArrayConstraintsFromSetClsKarmaKoliIntegration($clsKarmaKoliIntegration))) {
            throw new \InvalidArgumentException($clsKarmaKoliIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsKarmaKoliIntegration) || (is_array($clsKarmaKoliIntegration) && empty($clsKarmaKoliIntegration))) {
            unset($this->clsKarmaKoliIntegration);
        } else {
            $this->clsKarmaKoliIntegration = $clsKarmaKoliIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsKarmaKoliIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsKarmaKoliIntegration $item
     * @return \ArrayType\ArrayOfClsKarmaKoliIntegration
     */
    public function addToClsKarmaKoliIntegration(\StructType\ClsKarmaKoliIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsKarmaKoliIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsKarmaKoliIntegration property can only contain items of type \StructType\ClsKarmaKoliIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsKarmaKoliIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsKarmaKoliIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsKarmaKoliIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsKarmaKoliIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsKarmaKoliIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsKarmaKoliIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsKarmaKoliIntegration
     */
    public function getAttributeName()
    {
        return 'clsKarmaKoliIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsKarmaKoliIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
