<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsKotaDistGeneric ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsKotaDistGeneric extends AbstractStructArrayBase
{
    /**
     * The clsKotaDistGeneric
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsKotaDistGeneric[]
     */
    public $clsKotaDistGeneric;
    /**
     * Constructor method for ArrayOfClsKotaDistGeneric
     * @uses ArrayOfClsKotaDistGeneric::setClsKotaDistGeneric()
     * @param \StructType\ClsKotaDistGeneric[] $clsKotaDistGeneric
     */
    public function __construct(array $clsKotaDistGeneric = array())
    {
        $this
            ->setClsKotaDistGeneric($clsKotaDistGeneric);
    }
    /**
     * Get clsKotaDistGeneric value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsKotaDistGeneric[]|null
     */
    public function getClsKotaDistGeneric()
    {
        return isset($this->clsKotaDistGeneric) ? $this->clsKotaDistGeneric : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsKotaDistGeneric method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsKotaDistGeneric method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsKotaDistGenericForArrayConstraintsFromSetClsKotaDistGeneric(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsKotaDistGenericClsKotaDistGenericItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsKotaDistGenericClsKotaDistGenericItem instanceof \StructType\ClsKotaDistGeneric) {
                $invalidValues[] = is_object($arrayOfClsKotaDistGenericClsKotaDistGenericItem) ? get_class($arrayOfClsKotaDistGenericClsKotaDistGenericItem) : sprintf('%s(%s)', gettype($arrayOfClsKotaDistGenericClsKotaDistGenericItem), var_export($arrayOfClsKotaDistGenericClsKotaDistGenericItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsKotaDistGeneric property can only contain items of type \StructType\ClsKotaDistGeneric, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsKotaDistGeneric value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsKotaDistGeneric[] $clsKotaDistGeneric
     * @return \ArrayType\ArrayOfClsKotaDistGeneric
     */
    public function setClsKotaDistGeneric(array $clsKotaDistGeneric = array())
    {
        // validation for constraint: array
        if ('' !== ($clsKotaDistGenericArrayErrorMessage = self::validateClsKotaDistGenericForArrayConstraintsFromSetClsKotaDistGeneric($clsKotaDistGeneric))) {
            throw new \InvalidArgumentException($clsKotaDistGenericArrayErrorMessage, __LINE__);
        }
        if (is_null($clsKotaDistGeneric) || (is_array($clsKotaDistGeneric) && empty($clsKotaDistGeneric))) {
            unset($this->clsKotaDistGeneric);
        } else {
            $this->clsKotaDistGeneric = $clsKotaDistGeneric;
        }
        return $this;
    }
    /**
     * Add item to clsKotaDistGeneric value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsKotaDistGeneric $item
     * @return \ArrayType\ArrayOfClsKotaDistGeneric
     */
    public function addToClsKotaDistGeneric(\StructType\ClsKotaDistGeneric $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsKotaDistGeneric) {
            throw new \InvalidArgumentException(sprintf('The clsKotaDistGeneric property can only contain items of type \StructType\ClsKotaDistGeneric, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsKotaDistGeneric[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsKotaDistGeneric|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsKotaDistGeneric|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsKotaDistGeneric|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsKotaDistGeneric|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsKotaDistGeneric|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsKotaDistGeneric
     */
    public function getAttributeName()
    {
        return 'clsKotaDistGeneric';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsKotaDistGeneric
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
