<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsKullaniciIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsKullaniciIntegration extends AbstractStructArrayBase
{
    /**
     * The clsKullaniciIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsKullaniciIntegration[]
     */
    public $clsKullaniciIntegration;
    /**
     * Constructor method for ArrayOfClsKullaniciIntegration
     * @uses ArrayOfClsKullaniciIntegration::setClsKullaniciIntegration()
     * @param \StructType\ClsKullaniciIntegration[] $clsKullaniciIntegration
     */
    public function __construct(array $clsKullaniciIntegration = array())
    {
        $this
            ->setClsKullaniciIntegration($clsKullaniciIntegration);
    }
    /**
     * Get clsKullaniciIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsKullaniciIntegration[]|null
     */
    public function getClsKullaniciIntegration()
    {
        return isset($this->clsKullaniciIntegration) ? $this->clsKullaniciIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsKullaniciIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsKullaniciIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsKullaniciIntegrationForArrayConstraintsFromSetClsKullaniciIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsKullaniciIntegrationClsKullaniciIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsKullaniciIntegrationClsKullaniciIntegrationItem instanceof \StructType\ClsKullaniciIntegration) {
                $invalidValues[] = is_object($arrayOfClsKullaniciIntegrationClsKullaniciIntegrationItem) ? get_class($arrayOfClsKullaniciIntegrationClsKullaniciIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsKullaniciIntegrationClsKullaniciIntegrationItem), var_export($arrayOfClsKullaniciIntegrationClsKullaniciIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsKullaniciIntegration property can only contain items of type \StructType\ClsKullaniciIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsKullaniciIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsKullaniciIntegration[] $clsKullaniciIntegration
     * @return \ArrayType\ArrayOfClsKullaniciIntegration
     */
    public function setClsKullaniciIntegration(array $clsKullaniciIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsKullaniciIntegrationArrayErrorMessage = self::validateClsKullaniciIntegrationForArrayConstraintsFromSetClsKullaniciIntegration($clsKullaniciIntegration))) {
            throw new \InvalidArgumentException($clsKullaniciIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsKullaniciIntegration) || (is_array($clsKullaniciIntegration) && empty($clsKullaniciIntegration))) {
            unset($this->clsKullaniciIntegration);
        } else {
            $this->clsKullaniciIntegration = $clsKullaniciIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsKullaniciIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsKullaniciIntegration $item
     * @return \ArrayType\ArrayOfClsKullaniciIntegration
     */
    public function addToClsKullaniciIntegration(\StructType\ClsKullaniciIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsKullaniciIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsKullaniciIntegration property can only contain items of type \StructType\ClsKullaniciIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsKullaniciIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsKullaniciIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsKullaniciIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsKullaniciIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsKullaniciIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsKullaniciIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsKullaniciIntegration
     */
    public function getAttributeName()
    {
        return 'clsKullaniciIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsKullaniciIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
