<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsMerkezIlIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsMerkezIlIntegration extends AbstractStructArrayBase
{
    /**
     * The clsMerkezIlIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsMerkezIlIntegration[]
     */
    public $clsMerkezIlIntegration;
    /**
     * Constructor method for ArrayOfClsMerkezIlIntegration
     * @uses ArrayOfClsMerkezIlIntegration::setClsMerkezIlIntegration()
     * @param \StructType\ClsMerkezIlIntegration[] $clsMerkezIlIntegration
     */
    public function __construct(array $clsMerkezIlIntegration = array())
    {
        $this
            ->setClsMerkezIlIntegration($clsMerkezIlIntegration);
    }
    /**
     * Get clsMerkezIlIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsMerkezIlIntegration[]|null
     */
    public function getClsMerkezIlIntegration()
    {
        return isset($this->clsMerkezIlIntegration) ? $this->clsMerkezIlIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsMerkezIlIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsMerkezIlIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsMerkezIlIntegrationForArrayConstraintsFromSetClsMerkezIlIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsMerkezIlIntegrationClsMerkezIlIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsMerkezIlIntegrationClsMerkezIlIntegrationItem instanceof \StructType\ClsMerkezIlIntegration) {
                $invalidValues[] = is_object($arrayOfClsMerkezIlIntegrationClsMerkezIlIntegrationItem) ? get_class($arrayOfClsMerkezIlIntegrationClsMerkezIlIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsMerkezIlIntegrationClsMerkezIlIntegrationItem), var_export($arrayOfClsMerkezIlIntegrationClsMerkezIlIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsMerkezIlIntegration property can only contain items of type \StructType\ClsMerkezIlIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsMerkezIlIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMerkezIlIntegration[] $clsMerkezIlIntegration
     * @return \ArrayType\ArrayOfClsMerkezIlIntegration
     */
    public function setClsMerkezIlIntegration(array $clsMerkezIlIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsMerkezIlIntegrationArrayErrorMessage = self::validateClsMerkezIlIntegrationForArrayConstraintsFromSetClsMerkezIlIntegration($clsMerkezIlIntegration))) {
            throw new \InvalidArgumentException($clsMerkezIlIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsMerkezIlIntegration) || (is_array($clsMerkezIlIntegration) && empty($clsMerkezIlIntegration))) {
            unset($this->clsMerkezIlIntegration);
        } else {
            $this->clsMerkezIlIntegration = $clsMerkezIlIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsMerkezIlIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMerkezIlIntegration $item
     * @return \ArrayType\ArrayOfClsMerkezIlIntegration
     */
    public function addToClsMerkezIlIntegration(\StructType\ClsMerkezIlIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsMerkezIlIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsMerkezIlIntegration property can only contain items of type \StructType\ClsMerkezIlIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsMerkezIlIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsMerkezIlIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsMerkezIlIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsMerkezIlIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsMerkezIlIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsMerkezIlIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsMerkezIlIntegration
     */
    public function getAttributeName()
    {
        return 'clsMerkezIlIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsMerkezIlIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
