<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsMerkezSemtIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsMerkezSemtIntegration extends AbstractStructArrayBase
{
    /**
     * The clsMerkezSemtIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsMerkezSemtIntegration[]
     */
    public $clsMerkezSemtIntegration;
    /**
     * Constructor method for ArrayOfClsMerkezSemtIntegration
     * @uses ArrayOfClsMerkezSemtIntegration::setClsMerkezSemtIntegration()
     * @param \StructType\ClsMerkezSemtIntegration[] $clsMerkezSemtIntegration
     */
    public function __construct(array $clsMerkezSemtIntegration = array())
    {
        $this
            ->setClsMerkezSemtIntegration($clsMerkezSemtIntegration);
    }
    /**
     * Get clsMerkezSemtIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsMerkezSemtIntegration[]|null
     */
    public function getClsMerkezSemtIntegration()
    {
        return isset($this->clsMerkezSemtIntegration) ? $this->clsMerkezSemtIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsMerkezSemtIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsMerkezSemtIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsMerkezSemtIntegrationForArrayConstraintsFromSetClsMerkezSemtIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsMerkezSemtIntegrationClsMerkezSemtIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsMerkezSemtIntegrationClsMerkezSemtIntegrationItem instanceof \StructType\ClsMerkezSemtIntegration) {
                $invalidValues[] = is_object($arrayOfClsMerkezSemtIntegrationClsMerkezSemtIntegrationItem) ? get_class($arrayOfClsMerkezSemtIntegrationClsMerkezSemtIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsMerkezSemtIntegrationClsMerkezSemtIntegrationItem), var_export($arrayOfClsMerkezSemtIntegrationClsMerkezSemtIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsMerkezSemtIntegration property can only contain items of type \StructType\ClsMerkezSemtIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsMerkezSemtIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMerkezSemtIntegration[] $clsMerkezSemtIntegration
     * @return \ArrayType\ArrayOfClsMerkezSemtIntegration
     */
    public function setClsMerkezSemtIntegration(array $clsMerkezSemtIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsMerkezSemtIntegrationArrayErrorMessage = self::validateClsMerkezSemtIntegrationForArrayConstraintsFromSetClsMerkezSemtIntegration($clsMerkezSemtIntegration))) {
            throw new \InvalidArgumentException($clsMerkezSemtIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsMerkezSemtIntegration) || (is_array($clsMerkezSemtIntegration) && empty($clsMerkezSemtIntegration))) {
            unset($this->clsMerkezSemtIntegration);
        } else {
            $this->clsMerkezSemtIntegration = $clsMerkezSemtIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsMerkezSemtIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMerkezSemtIntegration $item
     * @return \ArrayType\ArrayOfClsMerkezSemtIntegration
     */
    public function addToClsMerkezSemtIntegration(\StructType\ClsMerkezSemtIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsMerkezSemtIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsMerkezSemtIntegration property can only contain items of type \StructType\ClsMerkezSemtIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsMerkezSemtIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsMerkezSemtIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsMerkezSemtIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsMerkezSemtIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsMerkezSemtIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsMerkezSemtIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsMerkezSemtIntegration
     */
    public function getAttributeName()
    {
        return 'clsMerkezSemtIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsMerkezSemtIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
