<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsMesajIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsMesajIntegration extends AbstractStructArrayBase
{
    /**
     * The clsMesajIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsMesajIntegration[]
     */
    public $clsMesajIntegration;
    /**
     * Constructor method for ArrayOfClsMesajIntegration
     * @uses ArrayOfClsMesajIntegration::setClsMesajIntegration()
     * @param \StructType\ClsMesajIntegration[] $clsMesajIntegration
     */
    public function __construct(array $clsMesajIntegration = array())
    {
        $this
            ->setClsMesajIntegration($clsMesajIntegration);
    }
    /**
     * Get clsMesajIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsMesajIntegration[]|null
     */
    public function getClsMesajIntegration()
    {
        return isset($this->clsMesajIntegration) ? $this->clsMesajIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsMesajIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsMesajIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsMesajIntegrationForArrayConstraintsFromSetClsMesajIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsMesajIntegrationClsMesajIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsMesajIntegrationClsMesajIntegrationItem instanceof \StructType\ClsMesajIntegration) {
                $invalidValues[] = is_object($arrayOfClsMesajIntegrationClsMesajIntegrationItem) ? get_class($arrayOfClsMesajIntegrationClsMesajIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsMesajIntegrationClsMesajIntegrationItem), var_export($arrayOfClsMesajIntegrationClsMesajIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsMesajIntegration property can only contain items of type \StructType\ClsMesajIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsMesajIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMesajIntegration[] $clsMesajIntegration
     * @return \ArrayType\ArrayOfClsMesajIntegration
     */
    public function setClsMesajIntegration(array $clsMesajIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsMesajIntegrationArrayErrorMessage = self::validateClsMesajIntegrationForArrayConstraintsFromSetClsMesajIntegration($clsMesajIntegration))) {
            throw new \InvalidArgumentException($clsMesajIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsMesajIntegration) || (is_array($clsMesajIntegration) && empty($clsMesajIntegration))) {
            unset($this->clsMesajIntegration);
        } else {
            $this->clsMesajIntegration = $clsMesajIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsMesajIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMesajIntegration $item
     * @return \ArrayType\ArrayOfClsMesajIntegration
     */
    public function addToClsMesajIntegration(\StructType\ClsMesajIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsMesajIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsMesajIntegration property can only contain items of type \StructType\ClsMesajIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsMesajIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsMesajIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsMesajIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsMesajIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsMesajIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsMesajIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsMesajIntegration
     */
    public function getAttributeName()
    {
        return 'clsMesajIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsMesajIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
