<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsMusteriAracIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsMusteriAracIntegration extends AbstractStructArrayBase
{
    /**
     * The clsMusteriAracIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsMusteriAracIntegration[]
     */
    public $clsMusteriAracIntegration;
    /**
     * Constructor method for ArrayOfClsMusteriAracIntegration
     * @uses ArrayOfClsMusteriAracIntegration::setClsMusteriAracIntegration()
     * @param \StructType\ClsMusteriAracIntegration[] $clsMusteriAracIntegration
     */
    public function __construct(array $clsMusteriAracIntegration = array())
    {
        $this
            ->setClsMusteriAracIntegration($clsMusteriAracIntegration);
    }
    /**
     * Get clsMusteriAracIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsMusteriAracIntegration[]|null
     */
    public function getClsMusteriAracIntegration()
    {
        return isset($this->clsMusteriAracIntegration) ? $this->clsMusteriAracIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsMusteriAracIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsMusteriAracIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsMusteriAracIntegrationForArrayConstraintsFromSetClsMusteriAracIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsMusteriAracIntegrationClsMusteriAracIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsMusteriAracIntegrationClsMusteriAracIntegrationItem instanceof \StructType\ClsMusteriAracIntegration) {
                $invalidValues[] = is_object($arrayOfClsMusteriAracIntegrationClsMusteriAracIntegrationItem) ? get_class($arrayOfClsMusteriAracIntegrationClsMusteriAracIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsMusteriAracIntegrationClsMusteriAracIntegrationItem), var_export($arrayOfClsMusteriAracIntegrationClsMusteriAracIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsMusteriAracIntegration property can only contain items of type \StructType\ClsMusteriAracIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsMusteriAracIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMusteriAracIntegration[] $clsMusteriAracIntegration
     * @return \ArrayType\ArrayOfClsMusteriAracIntegration
     */
    public function setClsMusteriAracIntegration(array $clsMusteriAracIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsMusteriAracIntegrationArrayErrorMessage = self::validateClsMusteriAracIntegrationForArrayConstraintsFromSetClsMusteriAracIntegration($clsMusteriAracIntegration))) {
            throw new \InvalidArgumentException($clsMusteriAracIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsMusteriAracIntegration) || (is_array($clsMusteriAracIntegration) && empty($clsMusteriAracIntegration))) {
            unset($this->clsMusteriAracIntegration);
        } else {
            $this->clsMusteriAracIntegration = $clsMusteriAracIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsMusteriAracIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMusteriAracIntegration $item
     * @return \ArrayType\ArrayOfClsMusteriAracIntegration
     */
    public function addToClsMusteriAracIntegration(\StructType\ClsMusteriAracIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsMusteriAracIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsMusteriAracIntegration property can only contain items of type \StructType\ClsMusteriAracIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsMusteriAracIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsMusteriAracIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsMusteriAracIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsMusteriAracIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsMusteriAracIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsMusteriAracIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsMusteriAracIntegration
     */
    public function getAttributeName()
    {
        return 'clsMusteriAracIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsMusteriAracIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
