<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsMusteriDurumIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsMusteriDurumIntegration extends AbstractStructArrayBase
{
    /**
     * The clsMusteriDurumIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsMusteriDurumIntegration[]
     */
    public $clsMusteriDurumIntegration;
    /**
     * Constructor method for ArrayOfClsMusteriDurumIntegration
     * @uses ArrayOfClsMusteriDurumIntegration::setClsMusteriDurumIntegration()
     * @param \StructType\ClsMusteriDurumIntegration[] $clsMusteriDurumIntegration
     */
    public function __construct(array $clsMusteriDurumIntegration = array())
    {
        $this
            ->setClsMusteriDurumIntegration($clsMusteriDurumIntegration);
    }
    /**
     * Get clsMusteriDurumIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsMusteriDurumIntegration[]|null
     */
    public function getClsMusteriDurumIntegration()
    {
        return isset($this->clsMusteriDurumIntegration) ? $this->clsMusteriDurumIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsMusteriDurumIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsMusteriDurumIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsMusteriDurumIntegrationForArrayConstraintsFromSetClsMusteriDurumIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsMusteriDurumIntegrationClsMusteriDurumIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsMusteriDurumIntegrationClsMusteriDurumIntegrationItem instanceof \StructType\ClsMusteriDurumIntegration) {
                $invalidValues[] = is_object($arrayOfClsMusteriDurumIntegrationClsMusteriDurumIntegrationItem) ? get_class($arrayOfClsMusteriDurumIntegrationClsMusteriDurumIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsMusteriDurumIntegrationClsMusteriDurumIntegrationItem), var_export($arrayOfClsMusteriDurumIntegrationClsMusteriDurumIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsMusteriDurumIntegration property can only contain items of type \StructType\ClsMusteriDurumIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsMusteriDurumIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMusteriDurumIntegration[] $clsMusteriDurumIntegration
     * @return \ArrayType\ArrayOfClsMusteriDurumIntegration
     */
    public function setClsMusteriDurumIntegration(array $clsMusteriDurumIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsMusteriDurumIntegrationArrayErrorMessage = self::validateClsMusteriDurumIntegrationForArrayConstraintsFromSetClsMusteriDurumIntegration($clsMusteriDurumIntegration))) {
            throw new \InvalidArgumentException($clsMusteriDurumIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsMusteriDurumIntegration) || (is_array($clsMusteriDurumIntegration) && empty($clsMusteriDurumIntegration))) {
            unset($this->clsMusteriDurumIntegration);
        } else {
            $this->clsMusteriDurumIntegration = $clsMusteriDurumIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsMusteriDurumIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMusteriDurumIntegration $item
     * @return \ArrayType\ArrayOfClsMusteriDurumIntegration
     */
    public function addToClsMusteriDurumIntegration(\StructType\ClsMusteriDurumIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsMusteriDurumIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsMusteriDurumIntegration property can only contain items of type \StructType\ClsMusteriDurumIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsMusteriDurumIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsMusteriDurumIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsMusteriDurumIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsMusteriDurumIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsMusteriDurumIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsMusteriDurumIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsMusteriDurumIntegration
     */
    public function getAttributeName()
    {
        return 'clsMusteriDurumIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsMusteriDurumIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
