<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsMusteriEkGrupIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsMusteriEkGrupIntegration extends AbstractStructArrayBase
{
    /**
     * The clsMusteriEkGrupIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsMusteriEkGrupIntegration[]
     */
    public $clsMusteriEkGrupIntegration;
    /**
     * Constructor method for ArrayOfClsMusteriEkGrupIntegration
     * @uses ArrayOfClsMusteriEkGrupIntegration::setClsMusteriEkGrupIntegration()
     * @param \StructType\ClsMusteriEkGrupIntegration[] $clsMusteriEkGrupIntegration
     */
    public function __construct(array $clsMusteriEkGrupIntegration = array())
    {
        $this
            ->setClsMusteriEkGrupIntegration($clsMusteriEkGrupIntegration);
    }
    /**
     * Get clsMusteriEkGrupIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsMusteriEkGrupIntegration[]|null
     */
    public function getClsMusteriEkGrupIntegration()
    {
        return isset($this->clsMusteriEkGrupIntegration) ? $this->clsMusteriEkGrupIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsMusteriEkGrupIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsMusteriEkGrupIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsMusteriEkGrupIntegrationForArrayConstraintsFromSetClsMusteriEkGrupIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsMusteriEkGrupIntegrationClsMusteriEkGrupIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsMusteriEkGrupIntegrationClsMusteriEkGrupIntegrationItem instanceof \StructType\ClsMusteriEkGrupIntegration) {
                $invalidValues[] = is_object($arrayOfClsMusteriEkGrupIntegrationClsMusteriEkGrupIntegrationItem) ? get_class($arrayOfClsMusteriEkGrupIntegrationClsMusteriEkGrupIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsMusteriEkGrupIntegrationClsMusteriEkGrupIntegrationItem), var_export($arrayOfClsMusteriEkGrupIntegrationClsMusteriEkGrupIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsMusteriEkGrupIntegration property can only contain items of type \StructType\ClsMusteriEkGrupIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsMusteriEkGrupIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMusteriEkGrupIntegration[] $clsMusteriEkGrupIntegration
     * @return \ArrayType\ArrayOfClsMusteriEkGrupIntegration
     */
    public function setClsMusteriEkGrupIntegration(array $clsMusteriEkGrupIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsMusteriEkGrupIntegrationArrayErrorMessage = self::validateClsMusteriEkGrupIntegrationForArrayConstraintsFromSetClsMusteriEkGrupIntegration($clsMusteriEkGrupIntegration))) {
            throw new \InvalidArgumentException($clsMusteriEkGrupIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsMusteriEkGrupIntegration) || (is_array($clsMusteriEkGrupIntegration) && empty($clsMusteriEkGrupIntegration))) {
            unset($this->clsMusteriEkGrupIntegration);
        } else {
            $this->clsMusteriEkGrupIntegration = $clsMusteriEkGrupIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsMusteriEkGrupIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMusteriEkGrupIntegration $item
     * @return \ArrayType\ArrayOfClsMusteriEkGrupIntegration
     */
    public function addToClsMusteriEkGrupIntegration(\StructType\ClsMusteriEkGrupIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsMusteriEkGrupIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsMusteriEkGrupIntegration property can only contain items of type \StructType\ClsMusteriEkGrupIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsMusteriEkGrupIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsMusteriEkGrupIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsMusteriEkGrupIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsMusteriEkGrupIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsMusteriEkGrupIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsMusteriEkGrupIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsMusteriEkGrupIntegration
     */
    public function getAttributeName()
    {
        return 'clsMusteriEkGrupIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsMusteriEkGrupIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
