<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsMusteriGeneric ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsMusteriGeneric extends AbstractStructArrayBase
{
    /**
     * The clsMusteriGeneric
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsMusteriGeneric[]
     */
    public $clsMusteriGeneric;
    /**
     * Constructor method for ArrayOfClsMusteriGeneric
     * @uses ArrayOfClsMusteriGeneric::setClsMusteriGeneric()
     * @param \StructType\ClsMusteriGeneric[] $clsMusteriGeneric
     */
    public function __construct(array $clsMusteriGeneric = array())
    {
        $this
            ->setClsMusteriGeneric($clsMusteriGeneric);
    }
    /**
     * Get clsMusteriGeneric value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsMusteriGeneric[]|null
     */
    public function getClsMusteriGeneric()
    {
        return isset($this->clsMusteriGeneric) ? $this->clsMusteriGeneric : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsMusteriGeneric method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsMusteriGeneric method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsMusteriGenericForArrayConstraintsFromSetClsMusteriGeneric(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsMusteriGenericClsMusteriGenericItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsMusteriGenericClsMusteriGenericItem instanceof \StructType\ClsMusteriGeneric) {
                $invalidValues[] = is_object($arrayOfClsMusteriGenericClsMusteriGenericItem) ? get_class($arrayOfClsMusteriGenericClsMusteriGenericItem) : sprintf('%s(%s)', gettype($arrayOfClsMusteriGenericClsMusteriGenericItem), var_export($arrayOfClsMusteriGenericClsMusteriGenericItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsMusteriGeneric property can only contain items of type \StructType\ClsMusteriGeneric, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsMusteriGeneric value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMusteriGeneric[] $clsMusteriGeneric
     * @return \ArrayType\ArrayOfClsMusteriGeneric
     */
    public function setClsMusteriGeneric(array $clsMusteriGeneric = array())
    {
        // validation for constraint: array
        if ('' !== ($clsMusteriGenericArrayErrorMessage = self::validateClsMusteriGenericForArrayConstraintsFromSetClsMusteriGeneric($clsMusteriGeneric))) {
            throw new \InvalidArgumentException($clsMusteriGenericArrayErrorMessage, __LINE__);
        }
        if (is_null($clsMusteriGeneric) || (is_array($clsMusteriGeneric) && empty($clsMusteriGeneric))) {
            unset($this->clsMusteriGeneric);
        } else {
            $this->clsMusteriGeneric = $clsMusteriGeneric;
        }
        return $this;
    }
    /**
     * Add item to clsMusteriGeneric value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMusteriGeneric $item
     * @return \ArrayType\ArrayOfClsMusteriGeneric
     */
    public function addToClsMusteriGeneric(\StructType\ClsMusteriGeneric $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsMusteriGeneric) {
            throw new \InvalidArgumentException(sprintf('The clsMusteriGeneric property can only contain items of type \StructType\ClsMusteriGeneric, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsMusteriGeneric[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsMusteriGeneric|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsMusteriGeneric|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsMusteriGeneric|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsMusteriGeneric|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsMusteriGeneric|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsMusteriGeneric
     */
    public function getAttributeName()
    {
        return 'clsMusteriGeneric';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsMusteriGeneric
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
