<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsMusteriIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsMusteriIntegration extends AbstractStructArrayBase
{
    /**
     * The clsMusteriIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsMusteriIntegration[]
     */
    public $clsMusteriIntegration;
    /**
     * Constructor method for ArrayOfClsMusteriIntegration
     * @uses ArrayOfClsMusteriIntegration::setClsMusteriIntegration()
     * @param \StructType\ClsMusteriIntegration[] $clsMusteriIntegration
     */
    public function __construct(array $clsMusteriIntegration = array())
    {
        $this
            ->setClsMusteriIntegration($clsMusteriIntegration);
    }
    /**
     * Get clsMusteriIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsMusteriIntegration[]|null
     */
    public function getClsMusteriIntegration()
    {
        return isset($this->clsMusteriIntegration) ? $this->clsMusteriIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsMusteriIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsMusteriIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsMusteriIntegrationForArrayConstraintsFromSetClsMusteriIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsMusteriIntegrationClsMusteriIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsMusteriIntegrationClsMusteriIntegrationItem instanceof \StructType\ClsMusteriIntegration) {
                $invalidValues[] = is_object($arrayOfClsMusteriIntegrationClsMusteriIntegrationItem) ? get_class($arrayOfClsMusteriIntegrationClsMusteriIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsMusteriIntegrationClsMusteriIntegrationItem), var_export($arrayOfClsMusteriIntegrationClsMusteriIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsMusteriIntegration property can only contain items of type \StructType\ClsMusteriIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsMusteriIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMusteriIntegration[] $clsMusteriIntegration
     * @return \ArrayType\ArrayOfClsMusteriIntegration
     */
    public function setClsMusteriIntegration(array $clsMusteriIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsMusteriIntegrationArrayErrorMessage = self::validateClsMusteriIntegrationForArrayConstraintsFromSetClsMusteriIntegration($clsMusteriIntegration))) {
            throw new \InvalidArgumentException($clsMusteriIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsMusteriIntegration) || (is_array($clsMusteriIntegration) && empty($clsMusteriIntegration))) {
            unset($this->clsMusteriIntegration);
        } else {
            $this->clsMusteriIntegration = $clsMusteriIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsMusteriIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMusteriIntegration $item
     * @return \ArrayType\ArrayOfClsMusteriIntegration
     */
    public function addToClsMusteriIntegration(\StructType\ClsMusteriIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsMusteriIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsMusteriIntegration property can only contain items of type \StructType\ClsMusteriIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsMusteriIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsMusteriIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsMusteriIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsMusteriIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsMusteriIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsMusteriIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsMusteriIntegration
     */
    public function getAttributeName()
    {
        return 'clsMusteriIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsMusteriIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
