<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsMusteriKoordinatIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsMusteriKoordinatIntegration extends AbstractStructArrayBase
{
    /**
     * The clsMusteriKoordinatIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsMusteriKoordinatIntegration[]
     */
    public $clsMusteriKoordinatIntegration;
    /**
     * Constructor method for ArrayOfClsMusteriKoordinatIntegration
     * @uses ArrayOfClsMusteriKoordinatIntegration::setClsMusteriKoordinatIntegration()
     * @param \StructType\ClsMusteriKoordinatIntegration[] $clsMusteriKoordinatIntegration
     */
    public function __construct(array $clsMusteriKoordinatIntegration = array())
    {
        $this
            ->setClsMusteriKoordinatIntegration($clsMusteriKoordinatIntegration);
    }
    /**
     * Get clsMusteriKoordinatIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsMusteriKoordinatIntegration[]|null
     */
    public function getClsMusteriKoordinatIntegration()
    {
        return isset($this->clsMusteriKoordinatIntegration) ? $this->clsMusteriKoordinatIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsMusteriKoordinatIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsMusteriKoordinatIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsMusteriKoordinatIntegrationForArrayConstraintsFromSetClsMusteriKoordinatIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsMusteriKoordinatIntegrationClsMusteriKoordinatIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsMusteriKoordinatIntegrationClsMusteriKoordinatIntegrationItem instanceof \StructType\ClsMusteriKoordinatIntegration) {
                $invalidValues[] = is_object($arrayOfClsMusteriKoordinatIntegrationClsMusteriKoordinatIntegrationItem) ? get_class($arrayOfClsMusteriKoordinatIntegrationClsMusteriKoordinatIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsMusteriKoordinatIntegrationClsMusteriKoordinatIntegrationItem), var_export($arrayOfClsMusteriKoordinatIntegrationClsMusteriKoordinatIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsMusteriKoordinatIntegration property can only contain items of type \StructType\ClsMusteriKoordinatIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsMusteriKoordinatIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMusteriKoordinatIntegration[] $clsMusteriKoordinatIntegration
     * @return \ArrayType\ArrayOfClsMusteriKoordinatIntegration
     */
    public function setClsMusteriKoordinatIntegration(array $clsMusteriKoordinatIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsMusteriKoordinatIntegrationArrayErrorMessage = self::validateClsMusteriKoordinatIntegrationForArrayConstraintsFromSetClsMusteriKoordinatIntegration($clsMusteriKoordinatIntegration))) {
            throw new \InvalidArgumentException($clsMusteriKoordinatIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsMusteriKoordinatIntegration) || (is_array($clsMusteriKoordinatIntegration) && empty($clsMusteriKoordinatIntegration))) {
            unset($this->clsMusteriKoordinatIntegration);
        } else {
            $this->clsMusteriKoordinatIntegration = $clsMusteriKoordinatIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsMusteriKoordinatIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMusteriKoordinatIntegration $item
     * @return \ArrayType\ArrayOfClsMusteriKoordinatIntegration
     */
    public function addToClsMusteriKoordinatIntegration(\StructType\ClsMusteriKoordinatIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsMusteriKoordinatIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsMusteriKoordinatIntegration property can only contain items of type \StructType\ClsMusteriKoordinatIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsMusteriKoordinatIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsMusteriKoordinatIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsMusteriKoordinatIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsMusteriKoordinatIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsMusteriKoordinatIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsMusteriKoordinatIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsMusteriKoordinatIntegration
     */
    public function getAttributeName()
    {
        return 'clsMusteriKoordinatIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsMusteriKoordinatIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
