<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsMusteriSiparis ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsMusteriSiparis extends AbstractStructArrayBase
{
    /**
     * The clsMusteriSiparis
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsMusteriSiparis[]
     */
    public $clsMusteriSiparis;
    /**
     * Constructor method for ArrayOfClsMusteriSiparis
     * @uses ArrayOfClsMusteriSiparis::setClsMusteriSiparis()
     * @param \StructType\ClsMusteriSiparis[] $clsMusteriSiparis
     */
    public function __construct(array $clsMusteriSiparis = array())
    {
        $this
            ->setClsMusteriSiparis($clsMusteriSiparis);
    }
    /**
     * Get clsMusteriSiparis value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsMusteriSiparis[]|null
     */
    public function getClsMusteriSiparis()
    {
        return isset($this->clsMusteriSiparis) ? $this->clsMusteriSiparis : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsMusteriSiparis method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsMusteriSiparis method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsMusteriSiparisForArrayConstraintsFromSetClsMusteriSiparis(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsMusteriSiparisClsMusteriSiparisItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsMusteriSiparisClsMusteriSiparisItem instanceof \StructType\ClsMusteriSiparis) {
                $invalidValues[] = is_object($arrayOfClsMusteriSiparisClsMusteriSiparisItem) ? get_class($arrayOfClsMusteriSiparisClsMusteriSiparisItem) : sprintf('%s(%s)', gettype($arrayOfClsMusteriSiparisClsMusteriSiparisItem), var_export($arrayOfClsMusteriSiparisClsMusteriSiparisItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsMusteriSiparis property can only contain items of type \StructType\ClsMusteriSiparis, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsMusteriSiparis value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMusteriSiparis[] $clsMusteriSiparis
     * @return \ArrayType\ArrayOfClsMusteriSiparis
     */
    public function setClsMusteriSiparis(array $clsMusteriSiparis = array())
    {
        // validation for constraint: array
        if ('' !== ($clsMusteriSiparisArrayErrorMessage = self::validateClsMusteriSiparisForArrayConstraintsFromSetClsMusteriSiparis($clsMusteriSiparis))) {
            throw new \InvalidArgumentException($clsMusteriSiparisArrayErrorMessage, __LINE__);
        }
        if (is_null($clsMusteriSiparis) || (is_array($clsMusteriSiparis) && empty($clsMusteriSiparis))) {
            unset($this->clsMusteriSiparis);
        } else {
            $this->clsMusteriSiparis = $clsMusteriSiparis;
        }
        return $this;
    }
    /**
     * Add item to clsMusteriSiparis value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMusteriSiparis $item
     * @return \ArrayType\ArrayOfClsMusteriSiparis
     */
    public function addToClsMusteriSiparis(\StructType\ClsMusteriSiparis $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsMusteriSiparis) {
            throw new \InvalidArgumentException(sprintf('The clsMusteriSiparis property can only contain items of type \StructType\ClsMusteriSiparis, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsMusteriSiparis[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsMusteriSiparis|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsMusteriSiparis|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsMusteriSiparis|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsMusteriSiparis|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsMusteriSiparis|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsMusteriSiparis
     */
    public function getAttributeName()
    {
        return 'clsMusteriSiparis';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsMusteriSiparis
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
