<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsMutabakatLogIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsMutabakatLogIntegration extends AbstractStructArrayBase
{
    /**
     * The clsMutabakatLogIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsMutabakatLogIntegration[]
     */
    public $clsMutabakatLogIntegration;
    /**
     * Constructor method for ArrayOfClsMutabakatLogIntegration
     * @uses ArrayOfClsMutabakatLogIntegration::setClsMutabakatLogIntegration()
     * @param \StructType\ClsMutabakatLogIntegration[] $clsMutabakatLogIntegration
     */
    public function __construct(array $clsMutabakatLogIntegration = array())
    {
        $this
            ->setClsMutabakatLogIntegration($clsMutabakatLogIntegration);
    }
    /**
     * Get clsMutabakatLogIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsMutabakatLogIntegration[]|null
     */
    public function getClsMutabakatLogIntegration()
    {
        return isset($this->clsMutabakatLogIntegration) ? $this->clsMutabakatLogIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsMutabakatLogIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsMutabakatLogIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsMutabakatLogIntegrationForArrayConstraintsFromSetClsMutabakatLogIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsMutabakatLogIntegrationClsMutabakatLogIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsMutabakatLogIntegrationClsMutabakatLogIntegrationItem instanceof \StructType\ClsMutabakatLogIntegration) {
                $invalidValues[] = is_object($arrayOfClsMutabakatLogIntegrationClsMutabakatLogIntegrationItem) ? get_class($arrayOfClsMutabakatLogIntegrationClsMutabakatLogIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsMutabakatLogIntegrationClsMutabakatLogIntegrationItem), var_export($arrayOfClsMutabakatLogIntegrationClsMutabakatLogIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsMutabakatLogIntegration property can only contain items of type \StructType\ClsMutabakatLogIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsMutabakatLogIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMutabakatLogIntegration[] $clsMutabakatLogIntegration
     * @return \ArrayType\ArrayOfClsMutabakatLogIntegration
     */
    public function setClsMutabakatLogIntegration(array $clsMutabakatLogIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsMutabakatLogIntegrationArrayErrorMessage = self::validateClsMutabakatLogIntegrationForArrayConstraintsFromSetClsMutabakatLogIntegration($clsMutabakatLogIntegration))) {
            throw new \InvalidArgumentException($clsMutabakatLogIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsMutabakatLogIntegration) || (is_array($clsMutabakatLogIntegration) && empty($clsMutabakatLogIntegration))) {
            unset($this->clsMutabakatLogIntegration);
        } else {
            $this->clsMutabakatLogIntegration = $clsMutabakatLogIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsMutabakatLogIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsMutabakatLogIntegration $item
     * @return \ArrayType\ArrayOfClsMutabakatLogIntegration
     */
    public function addToClsMutabakatLogIntegration(\StructType\ClsMutabakatLogIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsMutabakatLogIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsMutabakatLogIntegration property can only contain items of type \StructType\ClsMutabakatLogIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsMutabakatLogIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsMutabakatLogIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsMutabakatLogIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsMutabakatLogIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsMutabakatLogIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsMutabakatLogIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsMutabakatLogIntegration
     */
    public function getAttributeName()
    {
        return 'clsMutabakatLogIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsMutabakatLogIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
