<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsPaketTabloDetay ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsPaketTabloDetay extends AbstractStructArrayBase
{
    /**
     * The clsPaketTabloDetay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsPaketTabloDetay[]
     */
    public $clsPaketTabloDetay;
    /**
     * Constructor method for ArrayOfClsPaketTabloDetay
     * @uses ArrayOfClsPaketTabloDetay::setClsPaketTabloDetay()
     * @param \StructType\ClsPaketTabloDetay[] $clsPaketTabloDetay
     */
    public function __construct(array $clsPaketTabloDetay = array())
    {
        $this
            ->setClsPaketTabloDetay($clsPaketTabloDetay);
    }
    /**
     * Get clsPaketTabloDetay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsPaketTabloDetay[]|null
     */
    public function getClsPaketTabloDetay()
    {
        return isset($this->clsPaketTabloDetay) ? $this->clsPaketTabloDetay : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsPaketTabloDetay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsPaketTabloDetay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsPaketTabloDetayForArrayConstraintsFromSetClsPaketTabloDetay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsPaketTabloDetayClsPaketTabloDetayItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsPaketTabloDetayClsPaketTabloDetayItem instanceof \StructType\ClsPaketTabloDetay) {
                $invalidValues[] = is_object($arrayOfClsPaketTabloDetayClsPaketTabloDetayItem) ? get_class($arrayOfClsPaketTabloDetayClsPaketTabloDetayItem) : sprintf('%s(%s)', gettype($arrayOfClsPaketTabloDetayClsPaketTabloDetayItem), var_export($arrayOfClsPaketTabloDetayClsPaketTabloDetayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsPaketTabloDetay property can only contain items of type \StructType\ClsPaketTabloDetay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsPaketTabloDetay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsPaketTabloDetay[] $clsPaketTabloDetay
     * @return \ArrayType\ArrayOfClsPaketTabloDetay
     */
    public function setClsPaketTabloDetay(array $clsPaketTabloDetay = array())
    {
        // validation for constraint: array
        if ('' !== ($clsPaketTabloDetayArrayErrorMessage = self::validateClsPaketTabloDetayForArrayConstraintsFromSetClsPaketTabloDetay($clsPaketTabloDetay))) {
            throw new \InvalidArgumentException($clsPaketTabloDetayArrayErrorMessage, __LINE__);
        }
        if (is_null($clsPaketTabloDetay) || (is_array($clsPaketTabloDetay) && empty($clsPaketTabloDetay))) {
            unset($this->clsPaketTabloDetay);
        } else {
            $this->clsPaketTabloDetay = $clsPaketTabloDetay;
        }
        return $this;
    }
    /**
     * Add item to clsPaketTabloDetay value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsPaketTabloDetay $item
     * @return \ArrayType\ArrayOfClsPaketTabloDetay
     */
    public function addToClsPaketTabloDetay(\StructType\ClsPaketTabloDetay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsPaketTabloDetay) {
            throw new \InvalidArgumentException(sprintf('The clsPaketTabloDetay property can only contain items of type \StructType\ClsPaketTabloDetay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsPaketTabloDetay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsPaketTabloDetay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsPaketTabloDetay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsPaketTabloDetay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsPaketTabloDetay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsPaketTabloDetay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsPaketTabloDetay
     */
    public function getAttributeName()
    {
        return 'clsPaketTabloDetay';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsPaketTabloDetay
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
