<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsPaketTanim ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsPaketTanim extends AbstractStructArrayBase
{
    /**
     * The clsPaketTanim
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsPaketTanim[]
     */
    public $clsPaketTanim;
    /**
     * Constructor method for ArrayOfClsPaketTanim
     * @uses ArrayOfClsPaketTanim::setClsPaketTanim()
     * @param \StructType\ClsPaketTanim[] $clsPaketTanim
     */
    public function __construct(array $clsPaketTanim = array())
    {
        $this
            ->setClsPaketTanim($clsPaketTanim);
    }
    /**
     * Get clsPaketTanim value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsPaketTanim[]|null
     */
    public function getClsPaketTanim()
    {
        return isset($this->clsPaketTanim) ? $this->clsPaketTanim : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsPaketTanim method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsPaketTanim method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsPaketTanimForArrayConstraintsFromSetClsPaketTanim(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsPaketTanimClsPaketTanimItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsPaketTanimClsPaketTanimItem instanceof \StructType\ClsPaketTanim) {
                $invalidValues[] = is_object($arrayOfClsPaketTanimClsPaketTanimItem) ? get_class($arrayOfClsPaketTanimClsPaketTanimItem) : sprintf('%s(%s)', gettype($arrayOfClsPaketTanimClsPaketTanimItem), var_export($arrayOfClsPaketTanimClsPaketTanimItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsPaketTanim property can only contain items of type \StructType\ClsPaketTanim, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsPaketTanim value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsPaketTanim[] $clsPaketTanim
     * @return \ArrayType\ArrayOfClsPaketTanim
     */
    public function setClsPaketTanim(array $clsPaketTanim = array())
    {
        // validation for constraint: array
        if ('' !== ($clsPaketTanimArrayErrorMessage = self::validateClsPaketTanimForArrayConstraintsFromSetClsPaketTanim($clsPaketTanim))) {
            throw new \InvalidArgumentException($clsPaketTanimArrayErrorMessage, __LINE__);
        }
        if (is_null($clsPaketTanim) || (is_array($clsPaketTanim) && empty($clsPaketTanim))) {
            unset($this->clsPaketTanim);
        } else {
            $this->clsPaketTanim = $clsPaketTanim;
        }
        return $this;
    }
    /**
     * Add item to clsPaketTanim value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsPaketTanim $item
     * @return \ArrayType\ArrayOfClsPaketTanim
     */
    public function addToClsPaketTanim(\StructType\ClsPaketTanim $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsPaketTanim) {
            throw new \InvalidArgumentException(sprintf('The clsPaketTanim property can only contain items of type \StructType\ClsPaketTanim, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsPaketTanim[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsPaketTanim|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsPaketTanim|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsPaketTanim|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsPaketTanim|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsPaketTanim|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsPaketTanim
     */
    public function getAttributeName()
    {
        return 'clsPaketTanim';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsPaketTanim
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
