<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsPalyeGeneric ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsPalyeGeneric extends AbstractStructArrayBase
{
    /**
     * The clsPalyeGeneric
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsPalyeGeneric[]
     */
    public $clsPalyeGeneric;
    /**
     * Constructor method for ArrayOfClsPalyeGeneric
     * @uses ArrayOfClsPalyeGeneric::setClsPalyeGeneric()
     * @param \StructType\ClsPalyeGeneric[] $clsPalyeGeneric
     */
    public function __construct(array $clsPalyeGeneric = array())
    {
        $this
            ->setClsPalyeGeneric($clsPalyeGeneric);
    }
    /**
     * Get clsPalyeGeneric value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsPalyeGeneric[]|null
     */
    public function getClsPalyeGeneric()
    {
        return isset($this->clsPalyeGeneric) ? $this->clsPalyeGeneric : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsPalyeGeneric method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsPalyeGeneric method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsPalyeGenericForArrayConstraintsFromSetClsPalyeGeneric(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsPalyeGenericClsPalyeGenericItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsPalyeGenericClsPalyeGenericItem instanceof \StructType\ClsPalyeGeneric) {
                $invalidValues[] = is_object($arrayOfClsPalyeGenericClsPalyeGenericItem) ? get_class($arrayOfClsPalyeGenericClsPalyeGenericItem) : sprintf('%s(%s)', gettype($arrayOfClsPalyeGenericClsPalyeGenericItem), var_export($arrayOfClsPalyeGenericClsPalyeGenericItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsPalyeGeneric property can only contain items of type \StructType\ClsPalyeGeneric, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsPalyeGeneric value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsPalyeGeneric[] $clsPalyeGeneric
     * @return \ArrayType\ArrayOfClsPalyeGeneric
     */
    public function setClsPalyeGeneric(array $clsPalyeGeneric = array())
    {
        // validation for constraint: array
        if ('' !== ($clsPalyeGenericArrayErrorMessage = self::validateClsPalyeGenericForArrayConstraintsFromSetClsPalyeGeneric($clsPalyeGeneric))) {
            throw new \InvalidArgumentException($clsPalyeGenericArrayErrorMessage, __LINE__);
        }
        if (is_null($clsPalyeGeneric) || (is_array($clsPalyeGeneric) && empty($clsPalyeGeneric))) {
            unset($this->clsPalyeGeneric);
        } else {
            $this->clsPalyeGeneric = $clsPalyeGeneric;
        }
        return $this;
    }
    /**
     * Add item to clsPalyeGeneric value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsPalyeGeneric $item
     * @return \ArrayType\ArrayOfClsPalyeGeneric
     */
    public function addToClsPalyeGeneric(\StructType\ClsPalyeGeneric $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsPalyeGeneric) {
            throw new \InvalidArgumentException(sprintf('The clsPalyeGeneric property can only contain items of type \StructType\ClsPalyeGeneric, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsPalyeGeneric[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsPalyeGeneric|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsPalyeGeneric|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsPalyeGeneric|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsPalyeGeneric|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsPalyeGeneric|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsPalyeGeneric
     */
    public function getAttributeName()
    {
        return 'clsPalyeGeneric';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsPalyeGeneric
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
