<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsPersonelTipIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsPersonelTipIntegration extends AbstractStructArrayBase
{
    /**
     * The clsPersonelTipIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsPersonelTipIntegration[]
     */
    public $clsPersonelTipIntegration;
    /**
     * Constructor method for ArrayOfClsPersonelTipIntegration
     * @uses ArrayOfClsPersonelTipIntegration::setClsPersonelTipIntegration()
     * @param \StructType\ClsPersonelTipIntegration[] $clsPersonelTipIntegration
     */
    public function __construct(array $clsPersonelTipIntegration = array())
    {
        $this
            ->setClsPersonelTipIntegration($clsPersonelTipIntegration);
    }
    /**
     * Get clsPersonelTipIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsPersonelTipIntegration[]|null
     */
    public function getClsPersonelTipIntegration()
    {
        return isset($this->clsPersonelTipIntegration) ? $this->clsPersonelTipIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsPersonelTipIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsPersonelTipIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsPersonelTipIntegrationForArrayConstraintsFromSetClsPersonelTipIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsPersonelTipIntegrationClsPersonelTipIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsPersonelTipIntegrationClsPersonelTipIntegrationItem instanceof \StructType\ClsPersonelTipIntegration) {
                $invalidValues[] = is_object($arrayOfClsPersonelTipIntegrationClsPersonelTipIntegrationItem) ? get_class($arrayOfClsPersonelTipIntegrationClsPersonelTipIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsPersonelTipIntegrationClsPersonelTipIntegrationItem), var_export($arrayOfClsPersonelTipIntegrationClsPersonelTipIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsPersonelTipIntegration property can only contain items of type \StructType\ClsPersonelTipIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsPersonelTipIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsPersonelTipIntegration[] $clsPersonelTipIntegration
     * @return \ArrayType\ArrayOfClsPersonelTipIntegration
     */
    public function setClsPersonelTipIntegration(array $clsPersonelTipIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsPersonelTipIntegrationArrayErrorMessage = self::validateClsPersonelTipIntegrationForArrayConstraintsFromSetClsPersonelTipIntegration($clsPersonelTipIntegration))) {
            throw new \InvalidArgumentException($clsPersonelTipIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsPersonelTipIntegration) || (is_array($clsPersonelTipIntegration) && empty($clsPersonelTipIntegration))) {
            unset($this->clsPersonelTipIntegration);
        } else {
            $this->clsPersonelTipIntegration = $clsPersonelTipIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsPersonelTipIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsPersonelTipIntegration $item
     * @return \ArrayType\ArrayOfClsPersonelTipIntegration
     */
    public function addToClsPersonelTipIntegration(\StructType\ClsPersonelTipIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsPersonelTipIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsPersonelTipIntegration property can only contain items of type \StructType\ClsPersonelTipIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsPersonelTipIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsPersonelTipIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsPersonelTipIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsPersonelTipIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsPersonelTipIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsPersonelTipIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsPersonelTipIntegration
     */
    public function getAttributeName()
    {
        return 'clsPersonelTipIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsPersonelTipIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
