<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsQuestMusteriIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsQuestMusteriIntegration extends AbstractStructArrayBase
{
    /**
     * The clsQuestMusteriIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsQuestMusteriIntegration[]
     */
    public $clsQuestMusteriIntegration;
    /**
     * Constructor method for ArrayOfClsQuestMusteriIntegration
     * @uses ArrayOfClsQuestMusteriIntegration::setClsQuestMusteriIntegration()
     * @param \StructType\ClsQuestMusteriIntegration[] $clsQuestMusteriIntegration
     */
    public function __construct(array $clsQuestMusteriIntegration = array())
    {
        $this
            ->setClsQuestMusteriIntegration($clsQuestMusteriIntegration);
    }
    /**
     * Get clsQuestMusteriIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsQuestMusteriIntegration[]|null
     */
    public function getClsQuestMusteriIntegration()
    {
        return isset($this->clsQuestMusteriIntegration) ? $this->clsQuestMusteriIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsQuestMusteriIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsQuestMusteriIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsQuestMusteriIntegrationForArrayConstraintsFromSetClsQuestMusteriIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsQuestMusteriIntegrationClsQuestMusteriIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsQuestMusteriIntegrationClsQuestMusteriIntegrationItem instanceof \StructType\ClsQuestMusteriIntegration) {
                $invalidValues[] = is_object($arrayOfClsQuestMusteriIntegrationClsQuestMusteriIntegrationItem) ? get_class($arrayOfClsQuestMusteriIntegrationClsQuestMusteriIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsQuestMusteriIntegrationClsQuestMusteriIntegrationItem), var_export($arrayOfClsQuestMusteriIntegrationClsQuestMusteriIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsQuestMusteriIntegration property can only contain items of type \StructType\ClsQuestMusteriIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsQuestMusteriIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsQuestMusteriIntegration[] $clsQuestMusteriIntegration
     * @return \ArrayType\ArrayOfClsQuestMusteriIntegration
     */
    public function setClsQuestMusteriIntegration(array $clsQuestMusteriIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsQuestMusteriIntegrationArrayErrorMessage = self::validateClsQuestMusteriIntegrationForArrayConstraintsFromSetClsQuestMusteriIntegration($clsQuestMusteriIntegration))) {
            throw new \InvalidArgumentException($clsQuestMusteriIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsQuestMusteriIntegration) || (is_array($clsQuestMusteriIntegration) && empty($clsQuestMusteriIntegration))) {
            unset($this->clsQuestMusteriIntegration);
        } else {
            $this->clsQuestMusteriIntegration = $clsQuestMusteriIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsQuestMusteriIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsQuestMusteriIntegration $item
     * @return \ArrayType\ArrayOfClsQuestMusteriIntegration
     */
    public function addToClsQuestMusteriIntegration(\StructType\ClsQuestMusteriIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsQuestMusteriIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsQuestMusteriIntegration property can only contain items of type \StructType\ClsQuestMusteriIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsQuestMusteriIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsQuestMusteriIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsQuestMusteriIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsQuestMusteriIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsQuestMusteriIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsQuestMusteriIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsQuestMusteriIntegration
     */
    public function getAttributeName()
    {
        return 'clsQuestMusteriIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsQuestMusteriIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
