<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsRepAdvisorIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsRepAdvisorIntegration extends AbstractStructArrayBase
{
    /**
     * The clsRepAdvisorIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsRepAdvisorIntegration[]
     */
    public $clsRepAdvisorIntegration;
    /**
     * Constructor method for ArrayOfClsRepAdvisorIntegration
     * @uses ArrayOfClsRepAdvisorIntegration::setClsRepAdvisorIntegration()
     * @param \StructType\ClsRepAdvisorIntegration[] $clsRepAdvisorIntegration
     */
    public function __construct(array $clsRepAdvisorIntegration = array())
    {
        $this
            ->setClsRepAdvisorIntegration($clsRepAdvisorIntegration);
    }
    /**
     * Get clsRepAdvisorIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsRepAdvisorIntegration[]|null
     */
    public function getClsRepAdvisorIntegration()
    {
        return isset($this->clsRepAdvisorIntegration) ? $this->clsRepAdvisorIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsRepAdvisorIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsRepAdvisorIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsRepAdvisorIntegrationForArrayConstraintsFromSetClsRepAdvisorIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsRepAdvisorIntegrationClsRepAdvisorIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsRepAdvisorIntegrationClsRepAdvisorIntegrationItem instanceof \StructType\ClsRepAdvisorIntegration) {
                $invalidValues[] = is_object($arrayOfClsRepAdvisorIntegrationClsRepAdvisorIntegrationItem) ? get_class($arrayOfClsRepAdvisorIntegrationClsRepAdvisorIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsRepAdvisorIntegrationClsRepAdvisorIntegrationItem), var_export($arrayOfClsRepAdvisorIntegrationClsRepAdvisorIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsRepAdvisorIntegration property can only contain items of type \StructType\ClsRepAdvisorIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsRepAdvisorIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsRepAdvisorIntegration[] $clsRepAdvisorIntegration
     * @return \ArrayType\ArrayOfClsRepAdvisorIntegration
     */
    public function setClsRepAdvisorIntegration(array $clsRepAdvisorIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsRepAdvisorIntegrationArrayErrorMessage = self::validateClsRepAdvisorIntegrationForArrayConstraintsFromSetClsRepAdvisorIntegration($clsRepAdvisorIntegration))) {
            throw new \InvalidArgumentException($clsRepAdvisorIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsRepAdvisorIntegration) || (is_array($clsRepAdvisorIntegration) && empty($clsRepAdvisorIntegration))) {
            unset($this->clsRepAdvisorIntegration);
        } else {
            $this->clsRepAdvisorIntegration = $clsRepAdvisorIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsRepAdvisorIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsRepAdvisorIntegration $item
     * @return \ArrayType\ArrayOfClsRepAdvisorIntegration
     */
    public function addToClsRepAdvisorIntegration(\StructType\ClsRepAdvisorIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsRepAdvisorIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsRepAdvisorIntegration property can only contain items of type \StructType\ClsRepAdvisorIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsRepAdvisorIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsRepAdvisorIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsRepAdvisorIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsRepAdvisorIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsRepAdvisorIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsRepAdvisorIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsRepAdvisorIntegration
     */
    public function getAttributeName()
    {
        return 'clsRepAdvisorIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsRepAdvisorIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
