<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsRutTanimGeneric ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsRutTanimGeneric extends AbstractStructArrayBase
{
    /**
     * The clsRutTanimGeneric
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsRutTanimGeneric[]
     */
    public $clsRutTanimGeneric;
    /**
     * Constructor method for ArrayOfClsRutTanimGeneric
     * @uses ArrayOfClsRutTanimGeneric::setClsRutTanimGeneric()
     * @param \StructType\ClsRutTanimGeneric[] $clsRutTanimGeneric
     */
    public function __construct(array $clsRutTanimGeneric = array())
    {
        $this
            ->setClsRutTanimGeneric($clsRutTanimGeneric);
    }
    /**
     * Get clsRutTanimGeneric value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsRutTanimGeneric[]|null
     */
    public function getClsRutTanimGeneric()
    {
        return isset($this->clsRutTanimGeneric) ? $this->clsRutTanimGeneric : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsRutTanimGeneric method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsRutTanimGeneric method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsRutTanimGenericForArrayConstraintsFromSetClsRutTanimGeneric(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsRutTanimGenericClsRutTanimGenericItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsRutTanimGenericClsRutTanimGenericItem instanceof \StructType\ClsRutTanimGeneric) {
                $invalidValues[] = is_object($arrayOfClsRutTanimGenericClsRutTanimGenericItem) ? get_class($arrayOfClsRutTanimGenericClsRutTanimGenericItem) : sprintf('%s(%s)', gettype($arrayOfClsRutTanimGenericClsRutTanimGenericItem), var_export($arrayOfClsRutTanimGenericClsRutTanimGenericItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsRutTanimGeneric property can only contain items of type \StructType\ClsRutTanimGeneric, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsRutTanimGeneric value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsRutTanimGeneric[] $clsRutTanimGeneric
     * @return \ArrayType\ArrayOfClsRutTanimGeneric
     */
    public function setClsRutTanimGeneric(array $clsRutTanimGeneric = array())
    {
        // validation for constraint: array
        if ('' !== ($clsRutTanimGenericArrayErrorMessage = self::validateClsRutTanimGenericForArrayConstraintsFromSetClsRutTanimGeneric($clsRutTanimGeneric))) {
            throw new \InvalidArgumentException($clsRutTanimGenericArrayErrorMessage, __LINE__);
        }
        if (is_null($clsRutTanimGeneric) || (is_array($clsRutTanimGeneric) && empty($clsRutTanimGeneric))) {
            unset($this->clsRutTanimGeneric);
        } else {
            $this->clsRutTanimGeneric = $clsRutTanimGeneric;
        }
        return $this;
    }
    /**
     * Add item to clsRutTanimGeneric value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsRutTanimGeneric $item
     * @return \ArrayType\ArrayOfClsRutTanimGeneric
     */
    public function addToClsRutTanimGeneric(\StructType\ClsRutTanimGeneric $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsRutTanimGeneric) {
            throw new \InvalidArgumentException(sprintf('The clsRutTanimGeneric property can only contain items of type \StructType\ClsRutTanimGeneric, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsRutTanimGeneric[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsRutTanimGeneric|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsRutTanimGeneric|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsRutTanimGeneric|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsRutTanimGeneric|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsRutTanimGeneric|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsRutTanimGeneric
     */
    public function getAttributeName()
    {
        return 'clsRutTanimGeneric';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsRutTanimGeneric
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
