<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsSERutPlanIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsSERutPlanIntegration extends AbstractStructArrayBase
{
    /**
     * The clsSERutPlanIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsSERutPlanIntegration[]
     */
    public $clsSERutPlanIntegration;
    /**
     * Constructor method for ArrayOfClsSERutPlanIntegration
     * @uses ArrayOfClsSERutPlanIntegration::setClsSERutPlanIntegration()
     * @param \StructType\ClsSERutPlanIntegration[] $clsSERutPlanIntegration
     */
    public function __construct(array $clsSERutPlanIntegration = array())
    {
        $this
            ->setClsSERutPlanIntegration($clsSERutPlanIntegration);
    }
    /**
     * Get clsSERutPlanIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsSERutPlanIntegration[]|null
     */
    public function getClsSERutPlanIntegration()
    {
        return isset($this->clsSERutPlanIntegration) ? $this->clsSERutPlanIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsSERutPlanIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsSERutPlanIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsSERutPlanIntegrationForArrayConstraintsFromSetClsSERutPlanIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsSERutPlanIntegrationClsSERutPlanIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsSERutPlanIntegrationClsSERutPlanIntegrationItem instanceof \StructType\ClsSERutPlanIntegration) {
                $invalidValues[] = is_object($arrayOfClsSERutPlanIntegrationClsSERutPlanIntegrationItem) ? get_class($arrayOfClsSERutPlanIntegrationClsSERutPlanIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsSERutPlanIntegrationClsSERutPlanIntegrationItem), var_export($arrayOfClsSERutPlanIntegrationClsSERutPlanIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsSERutPlanIntegration property can only contain items of type \StructType\ClsSERutPlanIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsSERutPlanIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsSERutPlanIntegration[] $clsSERutPlanIntegration
     * @return \ArrayType\ArrayOfClsSERutPlanIntegration
     */
    public function setClsSERutPlanIntegration(array $clsSERutPlanIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsSERutPlanIntegrationArrayErrorMessage = self::validateClsSERutPlanIntegrationForArrayConstraintsFromSetClsSERutPlanIntegration($clsSERutPlanIntegration))) {
            throw new \InvalidArgumentException($clsSERutPlanIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsSERutPlanIntegration) || (is_array($clsSERutPlanIntegration) && empty($clsSERutPlanIntegration))) {
            unset($this->clsSERutPlanIntegration);
        } else {
            $this->clsSERutPlanIntegration = $clsSERutPlanIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsSERutPlanIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsSERutPlanIntegration $item
     * @return \ArrayType\ArrayOfClsSERutPlanIntegration
     */
    public function addToClsSERutPlanIntegration(\StructType\ClsSERutPlanIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsSERutPlanIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsSERutPlanIntegration property can only contain items of type \StructType\ClsSERutPlanIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsSERutPlanIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsSERutPlanIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsSERutPlanIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsSERutPlanIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsSERutPlanIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsSERutPlanIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsSERutPlanIntegration
     */
    public function getAttributeName()
    {
        return 'clsSERutPlanIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsSERutPlanIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
