<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsSESefIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsSESefIntegration extends AbstractStructArrayBase
{
    /**
     * The clsSESefIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsSESefIntegration[]
     */
    public $clsSESefIntegration;
    /**
     * Constructor method for ArrayOfClsSESefIntegration
     * @uses ArrayOfClsSESefIntegration::setClsSESefIntegration()
     * @param \StructType\ClsSESefIntegration[] $clsSESefIntegration
     */
    public function __construct(array $clsSESefIntegration = array())
    {
        $this
            ->setClsSESefIntegration($clsSESefIntegration);
    }
    /**
     * Get clsSESefIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsSESefIntegration[]|null
     */
    public function getClsSESefIntegration()
    {
        return isset($this->clsSESefIntegration) ? $this->clsSESefIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsSESefIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsSESefIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsSESefIntegrationForArrayConstraintsFromSetClsSESefIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsSESefIntegrationClsSESefIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsSESefIntegrationClsSESefIntegrationItem instanceof \StructType\ClsSESefIntegration) {
                $invalidValues[] = is_object($arrayOfClsSESefIntegrationClsSESefIntegrationItem) ? get_class($arrayOfClsSESefIntegrationClsSESefIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsSESefIntegrationClsSESefIntegrationItem), var_export($arrayOfClsSESefIntegrationClsSESefIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsSESefIntegration property can only contain items of type \StructType\ClsSESefIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsSESefIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsSESefIntegration[] $clsSESefIntegration
     * @return \ArrayType\ArrayOfClsSESefIntegration
     */
    public function setClsSESefIntegration(array $clsSESefIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsSESefIntegrationArrayErrorMessage = self::validateClsSESefIntegrationForArrayConstraintsFromSetClsSESefIntegration($clsSESefIntegration))) {
            throw new \InvalidArgumentException($clsSESefIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsSESefIntegration) || (is_array($clsSESefIntegration) && empty($clsSESefIntegration))) {
            unset($this->clsSESefIntegration);
        } else {
            $this->clsSESefIntegration = $clsSESefIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsSESefIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsSESefIntegration $item
     * @return \ArrayType\ArrayOfClsSESefIntegration
     */
    public function addToClsSESefIntegration(\StructType\ClsSESefIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsSESefIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsSESefIntegration property can only contain items of type \StructType\ClsSESefIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsSESefIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsSESefIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsSESefIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsSESefIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsSESefIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsSESefIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsSESefIntegration
     */
    public function getAttributeName()
    {
        return 'clsSESefIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsSESefIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
