<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsSTGrupIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsSTGrupIntegration extends AbstractStructArrayBase
{
    /**
     * The clsSTGrupIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsSTGrupIntegration[]
     */
    public $clsSTGrupIntegration;
    /**
     * Constructor method for ArrayOfClsSTGrupIntegration
     * @uses ArrayOfClsSTGrupIntegration::setClsSTGrupIntegration()
     * @param \StructType\ClsSTGrupIntegration[] $clsSTGrupIntegration
     */
    public function __construct(array $clsSTGrupIntegration = array())
    {
        $this
            ->setClsSTGrupIntegration($clsSTGrupIntegration);
    }
    /**
     * Get clsSTGrupIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsSTGrupIntegration[]|null
     */
    public function getClsSTGrupIntegration()
    {
        return isset($this->clsSTGrupIntegration) ? $this->clsSTGrupIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsSTGrupIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsSTGrupIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsSTGrupIntegrationForArrayConstraintsFromSetClsSTGrupIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsSTGrupIntegrationClsSTGrupIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsSTGrupIntegrationClsSTGrupIntegrationItem instanceof \StructType\ClsSTGrupIntegration) {
                $invalidValues[] = is_object($arrayOfClsSTGrupIntegrationClsSTGrupIntegrationItem) ? get_class($arrayOfClsSTGrupIntegrationClsSTGrupIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsSTGrupIntegrationClsSTGrupIntegrationItem), var_export($arrayOfClsSTGrupIntegrationClsSTGrupIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsSTGrupIntegration property can only contain items of type \StructType\ClsSTGrupIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsSTGrupIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsSTGrupIntegration[] $clsSTGrupIntegration
     * @return \ArrayType\ArrayOfClsSTGrupIntegration
     */
    public function setClsSTGrupIntegration(array $clsSTGrupIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsSTGrupIntegrationArrayErrorMessage = self::validateClsSTGrupIntegrationForArrayConstraintsFromSetClsSTGrupIntegration($clsSTGrupIntegration))) {
            throw new \InvalidArgumentException($clsSTGrupIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsSTGrupIntegration) || (is_array($clsSTGrupIntegration) && empty($clsSTGrupIntegration))) {
            unset($this->clsSTGrupIntegration);
        } else {
            $this->clsSTGrupIntegration = $clsSTGrupIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsSTGrupIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsSTGrupIntegration $item
     * @return \ArrayType\ArrayOfClsSTGrupIntegration
     */
    public function addToClsSTGrupIntegration(\StructType\ClsSTGrupIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsSTGrupIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsSTGrupIntegration property can only contain items of type \StructType\ClsSTGrupIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsSTGrupIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsSTGrupIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsSTGrupIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsSTGrupIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsSTGrupIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsSTGrupIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsSTGrupIntegration
     */
    public function getAttributeName()
    {
        return 'clsSTGrupIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsSTGrupIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
