<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsSahaElemaniIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsSahaElemaniIntegration extends AbstractStructArrayBase
{
    /**
     * The clsSahaElemaniIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsSahaElemaniIntegration[]
     */
    public $clsSahaElemaniIntegration;
    /**
     * Constructor method for ArrayOfClsSahaElemaniIntegration
     * @uses ArrayOfClsSahaElemaniIntegration::setClsSahaElemaniIntegration()
     * @param \StructType\ClsSahaElemaniIntegration[] $clsSahaElemaniIntegration
     */
    public function __construct(array $clsSahaElemaniIntegration = array())
    {
        $this
            ->setClsSahaElemaniIntegration($clsSahaElemaniIntegration);
    }
    /**
     * Get clsSahaElemaniIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsSahaElemaniIntegration[]|null
     */
    public function getClsSahaElemaniIntegration()
    {
        return isset($this->clsSahaElemaniIntegration) ? $this->clsSahaElemaniIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsSahaElemaniIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsSahaElemaniIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsSahaElemaniIntegrationForArrayConstraintsFromSetClsSahaElemaniIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsSahaElemaniIntegrationClsSahaElemaniIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsSahaElemaniIntegrationClsSahaElemaniIntegrationItem instanceof \StructType\ClsSahaElemaniIntegration) {
                $invalidValues[] = is_object($arrayOfClsSahaElemaniIntegrationClsSahaElemaniIntegrationItem) ? get_class($arrayOfClsSahaElemaniIntegrationClsSahaElemaniIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsSahaElemaniIntegrationClsSahaElemaniIntegrationItem), var_export($arrayOfClsSahaElemaniIntegrationClsSahaElemaniIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsSahaElemaniIntegration property can only contain items of type \StructType\ClsSahaElemaniIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsSahaElemaniIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsSahaElemaniIntegration[] $clsSahaElemaniIntegration
     * @return \ArrayType\ArrayOfClsSahaElemaniIntegration
     */
    public function setClsSahaElemaniIntegration(array $clsSahaElemaniIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsSahaElemaniIntegrationArrayErrorMessage = self::validateClsSahaElemaniIntegrationForArrayConstraintsFromSetClsSahaElemaniIntegration($clsSahaElemaniIntegration))) {
            throw new \InvalidArgumentException($clsSahaElemaniIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsSahaElemaniIntegration) || (is_array($clsSahaElemaniIntegration) && empty($clsSahaElemaniIntegration))) {
            unset($this->clsSahaElemaniIntegration);
        } else {
            $this->clsSahaElemaniIntegration = $clsSahaElemaniIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsSahaElemaniIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsSahaElemaniIntegration $item
     * @return \ArrayType\ArrayOfClsSahaElemaniIntegration
     */
    public function addToClsSahaElemaniIntegration(\StructType\ClsSahaElemaniIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsSahaElemaniIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsSahaElemaniIntegration property can only contain items of type \StructType\ClsSahaElemaniIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsSahaElemaniIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsSahaElemaniIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsSahaElemaniIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsSahaElemaniIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsSahaElemaniIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsSahaElemaniIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsSahaElemaniIntegration
     */
    public function getAttributeName()
    {
        return 'clsSahaElemaniIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsSahaElemaniIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
