<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsSharedBelgeDetay ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsSharedBelgeDetay extends AbstractStructArrayBase
{
    /**
     * The clsSharedBelgeDetay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsSharedBelgeDetay[]
     */
    public $clsSharedBelgeDetay;
    /**
     * Constructor method for ArrayOfClsSharedBelgeDetay
     * @uses ArrayOfClsSharedBelgeDetay::setClsSharedBelgeDetay()
     * @param \StructType\ClsSharedBelgeDetay[] $clsSharedBelgeDetay
     */
    public function __construct(array $clsSharedBelgeDetay = array())
    {
        $this
            ->setClsSharedBelgeDetay($clsSharedBelgeDetay);
    }
    /**
     * Get clsSharedBelgeDetay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsSharedBelgeDetay[]|null
     */
    public function getClsSharedBelgeDetay()
    {
        return isset($this->clsSharedBelgeDetay) ? $this->clsSharedBelgeDetay : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsSharedBelgeDetay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsSharedBelgeDetay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsSharedBelgeDetayForArrayConstraintsFromSetClsSharedBelgeDetay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsSharedBelgeDetayClsSharedBelgeDetayItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsSharedBelgeDetayClsSharedBelgeDetayItem instanceof \StructType\ClsSharedBelgeDetay) {
                $invalidValues[] = is_object($arrayOfClsSharedBelgeDetayClsSharedBelgeDetayItem) ? get_class($arrayOfClsSharedBelgeDetayClsSharedBelgeDetayItem) : sprintf('%s(%s)', gettype($arrayOfClsSharedBelgeDetayClsSharedBelgeDetayItem), var_export($arrayOfClsSharedBelgeDetayClsSharedBelgeDetayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsSharedBelgeDetay property can only contain items of type \StructType\ClsSharedBelgeDetay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsSharedBelgeDetay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsSharedBelgeDetay[] $clsSharedBelgeDetay
     * @return \ArrayType\ArrayOfClsSharedBelgeDetay
     */
    public function setClsSharedBelgeDetay(array $clsSharedBelgeDetay = array())
    {
        // validation for constraint: array
        if ('' !== ($clsSharedBelgeDetayArrayErrorMessage = self::validateClsSharedBelgeDetayForArrayConstraintsFromSetClsSharedBelgeDetay($clsSharedBelgeDetay))) {
            throw new \InvalidArgumentException($clsSharedBelgeDetayArrayErrorMessage, __LINE__);
        }
        if (is_null($clsSharedBelgeDetay) || (is_array($clsSharedBelgeDetay) && empty($clsSharedBelgeDetay))) {
            unset($this->clsSharedBelgeDetay);
        } else {
            $this->clsSharedBelgeDetay = $clsSharedBelgeDetay;
        }
        return $this;
    }
    /**
     * Add item to clsSharedBelgeDetay value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsSharedBelgeDetay $item
     * @return \ArrayType\ArrayOfClsSharedBelgeDetay
     */
    public function addToClsSharedBelgeDetay(\StructType\ClsSharedBelgeDetay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsSharedBelgeDetay) {
            throw new \InvalidArgumentException(sprintf('The clsSharedBelgeDetay property can only contain items of type \StructType\ClsSharedBelgeDetay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsSharedBelgeDetay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsSharedBelgeDetay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsSharedBelgeDetay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsSharedBelgeDetay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsSharedBelgeDetay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsSharedBelgeDetay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsSharedBelgeDetay
     */
    public function getAttributeName()
    {
        return 'clsSharedBelgeDetay';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsSharedBelgeDetay
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
