<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsSuperSessionGeneric ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsSuperSessionGeneric extends AbstractStructArrayBase
{
    /**
     * The clsSuperSessionGeneric
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsSuperSessionGeneric[]
     */
    public $clsSuperSessionGeneric;
    /**
     * Constructor method for ArrayOfClsSuperSessionGeneric
     * @uses ArrayOfClsSuperSessionGeneric::setClsSuperSessionGeneric()
     * @param \StructType\ClsSuperSessionGeneric[] $clsSuperSessionGeneric
     */
    public function __construct(array $clsSuperSessionGeneric = array())
    {
        $this
            ->setClsSuperSessionGeneric($clsSuperSessionGeneric);
    }
    /**
     * Get clsSuperSessionGeneric value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsSuperSessionGeneric[]|null
     */
    public function getClsSuperSessionGeneric()
    {
        return isset($this->clsSuperSessionGeneric) ? $this->clsSuperSessionGeneric : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsSuperSessionGeneric method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsSuperSessionGeneric method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsSuperSessionGenericForArrayConstraintsFromSetClsSuperSessionGeneric(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsSuperSessionGenericClsSuperSessionGenericItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsSuperSessionGenericClsSuperSessionGenericItem instanceof \StructType\ClsSuperSessionGeneric) {
                $invalidValues[] = is_object($arrayOfClsSuperSessionGenericClsSuperSessionGenericItem) ? get_class($arrayOfClsSuperSessionGenericClsSuperSessionGenericItem) : sprintf('%s(%s)', gettype($arrayOfClsSuperSessionGenericClsSuperSessionGenericItem), var_export($arrayOfClsSuperSessionGenericClsSuperSessionGenericItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsSuperSessionGeneric property can only contain items of type \StructType\ClsSuperSessionGeneric, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsSuperSessionGeneric value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsSuperSessionGeneric[] $clsSuperSessionGeneric
     * @return \ArrayType\ArrayOfClsSuperSessionGeneric
     */
    public function setClsSuperSessionGeneric(array $clsSuperSessionGeneric = array())
    {
        // validation for constraint: array
        if ('' !== ($clsSuperSessionGenericArrayErrorMessage = self::validateClsSuperSessionGenericForArrayConstraintsFromSetClsSuperSessionGeneric($clsSuperSessionGeneric))) {
            throw new \InvalidArgumentException($clsSuperSessionGenericArrayErrorMessage, __LINE__);
        }
        if (is_null($clsSuperSessionGeneric) || (is_array($clsSuperSessionGeneric) && empty($clsSuperSessionGeneric))) {
            unset($this->clsSuperSessionGeneric);
        } else {
            $this->clsSuperSessionGeneric = $clsSuperSessionGeneric;
        }
        return $this;
    }
    /**
     * Add item to clsSuperSessionGeneric value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsSuperSessionGeneric $item
     * @return \ArrayType\ArrayOfClsSuperSessionGeneric
     */
    public function addToClsSuperSessionGeneric(\StructType\ClsSuperSessionGeneric $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsSuperSessionGeneric) {
            throw new \InvalidArgumentException(sprintf('The clsSuperSessionGeneric property can only contain items of type \StructType\ClsSuperSessionGeneric, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsSuperSessionGeneric[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsSuperSessionGeneric|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsSuperSessionGeneric|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsSuperSessionGeneric|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsSuperSessionGeneric|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsSuperSessionGeneric|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsSuperSessionGeneric
     */
    public function getAttributeName()
    {
        return 'clsSuperSessionGeneric';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsSuperSessionGeneric
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
