<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsUrunGeneric ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsUrunGeneric extends AbstractStructArrayBase
{
    /**
     * The clsUrunGeneric
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsUrunGeneric[]
     */
    public $clsUrunGeneric;
    /**
     * Constructor method for ArrayOfClsUrunGeneric
     * @uses ArrayOfClsUrunGeneric::setClsUrunGeneric()
     * @param \StructType\ClsUrunGeneric[] $clsUrunGeneric
     */
    public function __construct(array $clsUrunGeneric = array())
    {
        $this
            ->setClsUrunGeneric($clsUrunGeneric);
    }
    /**
     * Get clsUrunGeneric value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsUrunGeneric[]|null
     */
    public function getClsUrunGeneric()
    {
        return isset($this->clsUrunGeneric) ? $this->clsUrunGeneric : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsUrunGeneric method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsUrunGeneric method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsUrunGenericForArrayConstraintsFromSetClsUrunGeneric(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsUrunGenericClsUrunGenericItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsUrunGenericClsUrunGenericItem instanceof \StructType\ClsUrunGeneric) {
                $invalidValues[] = is_object($arrayOfClsUrunGenericClsUrunGenericItem) ? get_class($arrayOfClsUrunGenericClsUrunGenericItem) : sprintf('%s(%s)', gettype($arrayOfClsUrunGenericClsUrunGenericItem), var_export($arrayOfClsUrunGenericClsUrunGenericItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsUrunGeneric property can only contain items of type \StructType\ClsUrunGeneric, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsUrunGeneric value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsUrunGeneric[] $clsUrunGeneric
     * @return \ArrayType\ArrayOfClsUrunGeneric
     */
    public function setClsUrunGeneric(array $clsUrunGeneric = array())
    {
        // validation for constraint: array
        if ('' !== ($clsUrunGenericArrayErrorMessage = self::validateClsUrunGenericForArrayConstraintsFromSetClsUrunGeneric($clsUrunGeneric))) {
            throw new \InvalidArgumentException($clsUrunGenericArrayErrorMessage, __LINE__);
        }
        if (is_null($clsUrunGeneric) || (is_array($clsUrunGeneric) && empty($clsUrunGeneric))) {
            unset($this->clsUrunGeneric);
        } else {
            $this->clsUrunGeneric = $clsUrunGeneric;
        }
        return $this;
    }
    /**
     * Add item to clsUrunGeneric value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsUrunGeneric $item
     * @return \ArrayType\ArrayOfClsUrunGeneric
     */
    public function addToClsUrunGeneric(\StructType\ClsUrunGeneric $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsUrunGeneric) {
            throw new \InvalidArgumentException(sprintf('The clsUrunGeneric property can only contain items of type \StructType\ClsUrunGeneric, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsUrunGeneric[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsUrunGeneric|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsUrunGeneric|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsUrunGeneric|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsUrunGeneric|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsUrunGeneric|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsUrunGeneric
     */
    public function getAttributeName()
    {
        return 'clsUrunGeneric';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsUrunGeneric
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
