<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsUrunIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsUrunIntegration extends AbstractStructArrayBase
{
    /**
     * The clsUrunIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsUrunIntegration[]
     */
    public $clsUrunIntegration;
    /**
     * Constructor method for ArrayOfClsUrunIntegration
     * @uses ArrayOfClsUrunIntegration::setClsUrunIntegration()
     * @param \StructType\ClsUrunIntegration[] $clsUrunIntegration
     */
    public function __construct(array $clsUrunIntegration = array())
    {
        $this
            ->setClsUrunIntegration($clsUrunIntegration);
    }
    /**
     * Get clsUrunIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsUrunIntegration[]|null
     */
    public function getClsUrunIntegration()
    {
        return isset($this->clsUrunIntegration) ? $this->clsUrunIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsUrunIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsUrunIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsUrunIntegrationForArrayConstraintsFromSetClsUrunIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsUrunIntegrationClsUrunIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsUrunIntegrationClsUrunIntegrationItem instanceof \StructType\ClsUrunIntegration) {
                $invalidValues[] = is_object($arrayOfClsUrunIntegrationClsUrunIntegrationItem) ? get_class($arrayOfClsUrunIntegrationClsUrunIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsUrunIntegrationClsUrunIntegrationItem), var_export($arrayOfClsUrunIntegrationClsUrunIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsUrunIntegration property can only contain items of type \StructType\ClsUrunIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsUrunIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsUrunIntegration[] $clsUrunIntegration
     * @return \ArrayType\ArrayOfClsUrunIntegration
     */
    public function setClsUrunIntegration(array $clsUrunIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsUrunIntegrationArrayErrorMessage = self::validateClsUrunIntegrationForArrayConstraintsFromSetClsUrunIntegration($clsUrunIntegration))) {
            throw new \InvalidArgumentException($clsUrunIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsUrunIntegration) || (is_array($clsUrunIntegration) && empty($clsUrunIntegration))) {
            unset($this->clsUrunIntegration);
        } else {
            $this->clsUrunIntegration = $clsUrunIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsUrunIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsUrunIntegration $item
     * @return \ArrayType\ArrayOfClsUrunIntegration
     */
    public function addToClsUrunIntegration(\StructType\ClsUrunIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsUrunIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsUrunIntegration property can only contain items of type \StructType\ClsUrunIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsUrunIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsUrunIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsUrunIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsUrunIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsUrunIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsUrunIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsUrunIntegration
     */
    public function getAttributeName()
    {
        return 'clsUrunIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsUrunIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
