<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsUrunMuadilIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsUrunMuadilIntegration extends AbstractStructArrayBase
{
    /**
     * The clsUrunMuadilIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsUrunMuadilIntegration[]
     */
    public $clsUrunMuadilIntegration;
    /**
     * Constructor method for ArrayOfClsUrunMuadilIntegration
     * @uses ArrayOfClsUrunMuadilIntegration::setClsUrunMuadilIntegration()
     * @param \StructType\ClsUrunMuadilIntegration[] $clsUrunMuadilIntegration
     */
    public function __construct(array $clsUrunMuadilIntegration = array())
    {
        $this
            ->setClsUrunMuadilIntegration($clsUrunMuadilIntegration);
    }
    /**
     * Get clsUrunMuadilIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsUrunMuadilIntegration[]|null
     */
    public function getClsUrunMuadilIntegration()
    {
        return isset($this->clsUrunMuadilIntegration) ? $this->clsUrunMuadilIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsUrunMuadilIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsUrunMuadilIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsUrunMuadilIntegrationForArrayConstraintsFromSetClsUrunMuadilIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsUrunMuadilIntegrationClsUrunMuadilIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsUrunMuadilIntegrationClsUrunMuadilIntegrationItem instanceof \StructType\ClsUrunMuadilIntegration) {
                $invalidValues[] = is_object($arrayOfClsUrunMuadilIntegrationClsUrunMuadilIntegrationItem) ? get_class($arrayOfClsUrunMuadilIntegrationClsUrunMuadilIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsUrunMuadilIntegrationClsUrunMuadilIntegrationItem), var_export($arrayOfClsUrunMuadilIntegrationClsUrunMuadilIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsUrunMuadilIntegration property can only contain items of type \StructType\ClsUrunMuadilIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsUrunMuadilIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsUrunMuadilIntegration[] $clsUrunMuadilIntegration
     * @return \ArrayType\ArrayOfClsUrunMuadilIntegration
     */
    public function setClsUrunMuadilIntegration(array $clsUrunMuadilIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsUrunMuadilIntegrationArrayErrorMessage = self::validateClsUrunMuadilIntegrationForArrayConstraintsFromSetClsUrunMuadilIntegration($clsUrunMuadilIntegration))) {
            throw new \InvalidArgumentException($clsUrunMuadilIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsUrunMuadilIntegration) || (is_array($clsUrunMuadilIntegration) && empty($clsUrunMuadilIntegration))) {
            unset($this->clsUrunMuadilIntegration);
        } else {
            $this->clsUrunMuadilIntegration = $clsUrunMuadilIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsUrunMuadilIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsUrunMuadilIntegration $item
     * @return \ArrayType\ArrayOfClsUrunMuadilIntegration
     */
    public function addToClsUrunMuadilIntegration(\StructType\ClsUrunMuadilIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsUrunMuadilIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsUrunMuadilIntegration property can only contain items of type \StructType\ClsUrunMuadilIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsUrunMuadilIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsUrunMuadilIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsUrunMuadilIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsUrunMuadilIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsUrunMuadilIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsUrunMuadilIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsUrunMuadilIntegration
     */
    public function getAttributeName()
    {
        return 'clsUrunMuadilIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsUrunMuadilIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
