<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsYolYardimIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsYolYardimIntegration extends AbstractStructArrayBase
{
    /**
     * The clsYolYardimIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsYolYardimIntegration[]
     */
    public $clsYolYardimIntegration;
    /**
     * Constructor method for ArrayOfClsYolYardimIntegration
     * @uses ArrayOfClsYolYardimIntegration::setClsYolYardimIntegration()
     * @param \StructType\ClsYolYardimIntegration[] $clsYolYardimIntegration
     */
    public function __construct(array $clsYolYardimIntegration = array())
    {
        $this
            ->setClsYolYardimIntegration($clsYolYardimIntegration);
    }
    /**
     * Get clsYolYardimIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsYolYardimIntegration[]|null
     */
    public function getClsYolYardimIntegration()
    {
        return isset($this->clsYolYardimIntegration) ? $this->clsYolYardimIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsYolYardimIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsYolYardimIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsYolYardimIntegrationForArrayConstraintsFromSetClsYolYardimIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsYolYardimIntegrationClsYolYardimIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsYolYardimIntegrationClsYolYardimIntegrationItem instanceof \StructType\ClsYolYardimIntegration) {
                $invalidValues[] = is_object($arrayOfClsYolYardimIntegrationClsYolYardimIntegrationItem) ? get_class($arrayOfClsYolYardimIntegrationClsYolYardimIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsYolYardimIntegrationClsYolYardimIntegrationItem), var_export($arrayOfClsYolYardimIntegrationClsYolYardimIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsYolYardimIntegration property can only contain items of type \StructType\ClsYolYardimIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsYolYardimIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsYolYardimIntegration[] $clsYolYardimIntegration
     * @return \ArrayType\ArrayOfClsYolYardimIntegration
     */
    public function setClsYolYardimIntegration(array $clsYolYardimIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsYolYardimIntegrationArrayErrorMessage = self::validateClsYolYardimIntegrationForArrayConstraintsFromSetClsYolYardimIntegration($clsYolYardimIntegration))) {
            throw new \InvalidArgumentException($clsYolYardimIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsYolYardimIntegration) || (is_array($clsYolYardimIntegration) && empty($clsYolYardimIntegration))) {
            unset($this->clsYolYardimIntegration);
        } else {
            $this->clsYolYardimIntegration = $clsYolYardimIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsYolYardimIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsYolYardimIntegration $item
     * @return \ArrayType\ArrayOfClsYolYardimIntegration
     */
    public function addToClsYolYardimIntegration(\StructType\ClsYolYardimIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsYolYardimIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsYolYardimIntegration property can only contain items of type \StructType\ClsYolYardimIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsYolYardimIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsYolYardimIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsYolYardimIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsYolYardimIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsYolYardimIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsYolYardimIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsYolYardimIntegration
     */
    public function getAttributeName()
    {
        return 'clsYolYardimIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsYolYardimIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
