<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClsZincirIntegration ArrayType
 * @subpackage Arrays
 */
class ArrayOfClsZincirIntegration extends AbstractStructArrayBase
{
    /**
     * The clsZincirIntegration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClsZincirIntegration[]
     */
    public $clsZincirIntegration;
    /**
     * Constructor method for ArrayOfClsZincirIntegration
     * @uses ArrayOfClsZincirIntegration::setClsZincirIntegration()
     * @param \StructType\ClsZincirIntegration[] $clsZincirIntegration
     */
    public function __construct(array $clsZincirIntegration = array())
    {
        $this
            ->setClsZincirIntegration($clsZincirIntegration);
    }
    /**
     * Get clsZincirIntegration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClsZincirIntegration[]|null
     */
    public function getClsZincirIntegration()
    {
        return isset($this->clsZincirIntegration) ? $this->clsZincirIntegration : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClsZincirIntegration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClsZincirIntegration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClsZincirIntegrationForArrayConstraintsFromSetClsZincirIntegration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClsZincirIntegrationClsZincirIntegrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClsZincirIntegrationClsZincirIntegrationItem instanceof \StructType\ClsZincirIntegration) {
                $invalidValues[] = is_object($arrayOfClsZincirIntegrationClsZincirIntegrationItem) ? get_class($arrayOfClsZincirIntegrationClsZincirIntegrationItem) : sprintf('%s(%s)', gettype($arrayOfClsZincirIntegrationClsZincirIntegrationItem), var_export($arrayOfClsZincirIntegrationClsZincirIntegrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clsZincirIntegration property can only contain items of type \StructType\ClsZincirIntegration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clsZincirIntegration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClsZincirIntegration[] $clsZincirIntegration
     * @return \ArrayType\ArrayOfClsZincirIntegration
     */
    public function setClsZincirIntegration(array $clsZincirIntegration = array())
    {
        // validation for constraint: array
        if ('' !== ($clsZincirIntegrationArrayErrorMessage = self::validateClsZincirIntegrationForArrayConstraintsFromSetClsZincirIntegration($clsZincirIntegration))) {
            throw new \InvalidArgumentException($clsZincirIntegrationArrayErrorMessage, __LINE__);
        }
        if (is_null($clsZincirIntegration) || (is_array($clsZincirIntegration) && empty($clsZincirIntegration))) {
            unset($this->clsZincirIntegration);
        } else {
            $this->clsZincirIntegration = $clsZincirIntegration;
        }
        return $this;
    }
    /**
     * Add item to clsZincirIntegration value
     * @throws \InvalidArgumentException
     * @param \StructType\ClsZincirIntegration $item
     * @return \ArrayType\ArrayOfClsZincirIntegration
     */
    public function addToClsZincirIntegration(\StructType\ClsZincirIntegration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClsZincirIntegration) {
            throw new \InvalidArgumentException(sprintf('The clsZincirIntegration property can only contain items of type \StructType\ClsZincirIntegration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clsZincirIntegration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClsZincirIntegration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClsZincirIntegration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClsZincirIntegration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClsZincirIntegration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClsZincirIntegration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string clsZincirIntegration
     */
    public function getAttributeName()
    {
        return 'clsZincirIntegration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClsZincirIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
