<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Test' => '\\StructType\\Test',
            'TestResponse' => '\\StructType\\TestResponse',
            'IntegrationSendEntitySetWithLogin' => '\\StructType\\IntegrationSendEntitySetWithLogin',
            'clsPanoramaIntegrationEntitySet' => '\\StructType\\ClsPanoramaIntegrationEntitySet',
            'clsIntegrationEntitySet' => '\\StructType\\ClsIntegrationEntitySet',
            'clsEnRouteEntitySet' => '\\StructType\\ClsEnRouteEntitySet',
            'clsEntitySet' => '\\StructType\\ClsEntitySet',
            'ArrayOfClsPaketTabloDetay' => '\\ArrayType\\ArrayOfClsPaketTabloDetay',
            'clsPaketTabloDetay' => '\\StructType\\ClsPaketTabloDetay',
            'clsEntity' => '\\StructType\\ClsEntity',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'clsFiloHizmetTanimIntegration' => '\\StructType\\ClsFiloHizmetTanimIntegration',
            'clsUrunMuadilIntegration' => '\\StructType\\ClsUrunMuadilIntegration',
            'clsUrunOpsiyonUrun' => '\\StructType\\ClsUrunOpsiyonUrun',
            'clsUrunOpsiyonUrunGeneric' => '\\StructType\\ClsUrunOpsiyonUrunGeneric',
            'clsSuperSession' => '\\StructType\\ClsSuperSession',
            'clsSuperSessionGeneric' => '\\StructType\\ClsSuperSessionGeneric',
            'clsKotaDistGeneric' => '\\StructType\\ClsKotaDistGeneric',
            'clsUrunKombinasyonIntegration' => '\\StructType\\ClsUrunKombinasyonIntegration',
            'clsCagriMerkeziBildirimIntegration' => '\\StructType\\ClsCagriMerkeziBildirimIntegration',
            'clsQuestThingGrup' => '\\StructType\\ClsQuestThingGrup',
            'clsSharedPalye' => '\\StructType\\ClsSharedPalye',
            'clsPalye' => '\\StructType\\ClsPalye',
            'clsPalyeGeneric' => '\\StructType\\ClsPalyeGeneric',
            'clsFaturaKapatmaIntegration' => '\\StructType\\ClsFaturaKapatmaIntegration',
            'clsDisSistemBelgeAlanGuncelleme' => '\\StructType\\ClsDisSistemBelgeAlanGuncelleme',
            'clsSharedIadeNeden' => '\\StructType\\ClsSharedIadeNeden',
            'clsIadeNeden' => '\\StructType\\ClsIadeNeden',
            'clsDepozitoSeriIntegration' => '\\StructType\\ClsDepozitoSeriIntegration',
            'ArrayOfClsDepozitoSeri' => '\\ArrayType\\ArrayOfClsDepozitoSeri',
            'clsDepozitoSeri' => '\\StructType\\ClsDepozitoSeri',
            'clsOzelUrunIntegration' => '\\StructType\\ClsOzelUrunIntegration',
            'clsMusteriDurumIntegration' => '\\StructType\\ClsMusteriDurumIntegration',
            'clsTeminatBilgileri' => '\\StructType\\ClsTeminatBilgileri',
            'clsTeminatBilgileriIntegration' => '\\StructType\\ClsTeminatBilgileriIntegration',
            'clsSharedTercihliUrunDetay' => '\\StructType\\ClsSharedTercihliUrunDetay',
            'clsTercihliUrunDetay' => '\\StructType\\ClsTercihliUrunDetay',
            'clsTercihliUrunGenericDetayUrun' => '\\StructType\\ClsTercihliUrunGenericDetayUrun',
            'clsSharedTercihliUrunBaslik' => '\\StructType\\ClsSharedTercihliUrunBaslik',
            'clsTercihliUrunBaslik' => '\\StructType\\ClsTercihliUrunBaslik',
            'clsTercihliUrunGeneric' => '\\StructType\\ClsTercihliUrunGeneric',
            'ArrayOfClsTercihliUrunGenericDetayUrun' => '\\ArrayType\\ArrayOfClsTercihliUrunGenericDetayUrun',
            'clsCaykurIrsaliyeGeneric' => '\\StructType\\ClsCaykurIrsaliyeGeneric',
            'clsMiktarFarkIntegration' => '\\StructType\\ClsMiktarFarkIntegration',
            'clsRepAdvisorIntegration' => '\\StructType\\ClsRepAdvisorIntegration',
            'clsRpaAcikSiparis' => '\\StructType\\ClsRpaAcikSiparis',
            'clsRpaAcikSiparisIntegration' => '\\StructType\\ClsRpaAcikSiparisIntegration',
            'clsSharedSadakatBakiye' => '\\StructType\\ClsSharedSadakatBakiye',
            'clsSadakatBakiye' => '\\StructType\\ClsSadakatBakiye',
            'clsSadakatBakiyeIntegration' => '\\StructType\\ClsSadakatBakiyeIntegration',
            'clsERYasakliUrunDetayUrun' => '\\StructType\\ClsERYasakliUrunDetayUrun',
            'clsYasakliUrunDetayUrun' => '\\StructType\\ClsYasakliUrunDetayUrun',
            'clsYasakliSatilabilirUrunGenericDetayUrun' => '\\StructType\\ClsYasakliSatilabilirUrunGenericDetayUrun',
            'clsERYasakliUrunDetayKriter' => '\\StructType\\ClsERYasakliUrunDetayKriter',
            'clsYasakliUrunDetayKriter' => '\\StructType\\ClsYasakliUrunDetayKriter',
            'clsYasakliSatilabilirUrunGenericKriter' => '\\StructType\\ClsYasakliSatilabilirUrunGenericKriter',
            'clsERYasakliUrunBaslik' => '\\StructType\\ClsERYasakliUrunBaslik',
            'clsYasakliUrunBaslik' => '\\StructType\\ClsYasakliUrunBaslik',
            'clsYasakliSatilabilirUrunGeneric' => '\\StructType\\ClsYasakliSatilabilirUrunGeneric',
            'ArrayOfClsYasakliSatilabilirUrunGenericKriter' => '\\ArrayType\\ArrayOfClsYasakliSatilabilirUrunGenericKriter',
            'ArrayOfClsYasakliSatilabilirUrunGenericDetayUrun' => '\\ArrayType\\ArrayOfClsYasakliSatilabilirUrunGenericDetayUrun',
            'clsTCPUrunAlanEslestirme' => '\\StructType\\ClsTCPUrunAlanEslestirme',
            'clsYolYardimIntegrationBase' => '\\StructType\\ClsYolYardimIntegrationBase',
            'clsYolYardimIntegration' => '\\StructType\\ClsYolYardimIntegration',
            'clsMusteriArac' => '\\StructType\\ClsMusteriArac',
            'clsMusteriAracIntegration' => '\\StructType\\ClsMusteriAracIntegration',
            'clsSharedMusteriSevkAdres' => '\\StructType\\ClsSharedMusteriSevkAdres',
            'clsMusteriSevkAdres' => '\\StructType\\ClsMusteriSevkAdres',
            'clsMusteriSevkAdresIntegration' => '\\StructType\\ClsMusteriSevkAdresIntegration',
            'clsDistYoldakiUrunlerIntegration' => '\\StructType\\ClsDistYoldakiUrunlerIntegration',
            'clsDistGunlukStokIntegration' => '\\StructType\\ClsDistGunlukStokIntegration',
            'clsRutPlan' => '\\StructType\\ClsRutPlan',
            'clsSERutPlanIntegration' => '\\StructType\\ClsSERutPlanIntegration',
            'clsSahaEleman' => '\\StructType\\ClsSahaEleman',
            'clsSahaElemaniIntegration' => '\\StructType\\ClsSahaElemaniIntegration',
            'clsSESef' => '\\StructType\\ClsSESef',
            'clsSESefIntegration' => '\\StructType\\ClsSESefIntegration',
            'clsSharedCariHesapIntegration' => '\\StructType\\ClsSharedCariHesapIntegration',
            'clsCariHesapIntegration' => '\\StructType\\ClsCariHesapIntegration',
            'clsFaturaSatisUrunMiktarGeneric' => '\\StructType\\ClsFaturaSatisUrunMiktarGeneric',
            'clsGerceklesenPrim' => '\\StructType\\ClsGerceklesenPrim',
            'clsGerceklesenPrimIntegration' => '\\StructType\\ClsGerceklesenPrimIntegration',
            'clsDistEkGrup' => '\\StructType\\ClsDistEkGrup',
            'clsDistEkGrupIntegration' => '\\StructType\\ClsDistEkGrupIntegration',
            'LoginUser' => '\\StructType\\LoginUser',
            'clsKullaniciIntegration' => '\\StructType\\ClsKullaniciIntegration',
            'clsMesaj' => '\\StructType\\ClsMesaj',
            'clsMesajIntegration' => '\\StructType\\ClsMesajIntegration',
            'clsUrunFotoIntegration' => '\\StructType\\ClsUrunFotoIntegration',
            'clsTCPDistSubeEslestirme' => '\\StructType\\ClsTCPDistSubeEslestirme',
            'clsFaturaIrsaliyeBaglantiIntegration' => '\\StructType\\ClsFaturaIrsaliyeBaglantiIntegration',
            'clsSharedDepo' => '\\StructType\\ClsSharedDepo',
            'clsDepo' => '\\StructType\\ClsDepo',
            'clsDepoIntegration' => '\\StructType\\ClsDepoIntegration',
            'clsUrunMiktarliDinamikGrupGeneric' => '\\StructType\\ClsUrunMiktarliDinamikGrupGeneric',
            'clsUrunDinamikGrupGeneric' => '\\StructType\\ClsUrunDinamikGrupGeneric',
            'clsMusteriDinamikGrupGeneric' => '\\StructType\\ClsMusteriDinamikGrupGeneric',
            'clsZiyaretGeneric' => '\\StructType\\ClsZiyaretGeneric',
            'clsSharedEntegrasyonLog' => '\\StructType\\ClsSharedEntegrasyonLog',
            'clsEntegrasyonLog' => '\\StructType\\ClsEntegrasyonLog',
            'clsMusteriSiparis' => '\\StructType\\ClsMusteriSiparis',
            'clsSharedMusteriBakiye' => '\\StructType\\ClsSharedMusteriBakiye',
            'clsMusteriBakiye' => '\\StructType\\ClsMusteriBakiye',
            'clsMusteriBakiyeIntegration' => '\\StructType\\ClsMusteriBakiyeIntegration',
            'clsTCPMusteriBakiye' => '\\StructType\\ClsTCPMusteriBakiye',
            'clsTCPMusteriBakiyeIntegration' => '\\StructType\\ClsTCPMusteriBakiyeIntegration',
            'clsTCPStokSonDurum' => '\\StructType\\ClsTCPStokSonDurum',
            'clsTCPStokSonDurumIntegration' => '\\StructType\\ClsTCPStokSonDurumIntegration',
            'clsDistAltBayiler' => '\\StructType\\ClsDistAltBayiler',
            'clsSharedDist' => '\\StructType\\ClsSharedDist',
            'clsDist' => '\\StructType\\ClsDist',
            'ArrayOfClsDistAltBayiler' => '\\ArrayType\\ArrayOfClsDistAltBayiler',
            'clsDistIntegration' => '\\StructType\\ClsDistIntegration',
            'clsStParametre' => '\\StructType\\ClsStParametre',
            'clsSharedSatisTemsilcisi' => '\\StructType\\ClsSharedSatisTemsilcisi',
            'clsSatisTemsilcisi' => '\\StructType\\ClsSatisTemsilcisi',
            'ArrayOfClsStParametre' => '\\ArrayType\\ArrayOfClsStParametre',
            'ArrayOfInt' => '\\ArrayType\\ArrayOfInt',
            'clsSatisTemsilcisiIntegration' => '\\StructType\\ClsSatisTemsilcisiIntegration',
            'clsTCPBaglantiProfil' => '\\StructType\\ClsTCPBaglantiProfil',
            'clsCompanyParamsGeneric' => '\\StructType\\ClsCompanyParamsGeneric',
            'clsEntegrasyonKarsilik' => '\\StructType\\ClsEntegrasyonKarsilik',
            'clsMusteriEntegrasyon' => '\\StructType\\ClsMusteriEntegrasyon',
            'clsSharedDepoStokDurum' => '\\StructType\\ClsSharedDepoStokDurum',
            'clsDepoStokDurum' => '\\StructType\\ClsDepoStokDurum',
            'clsDepoStokDurumIntegration' => '\\StructType\\ClsDepoStokDurumIntegration',
            'clsSharedBelgeDetayIskpro' => '\\StructType\\ClsSharedBelgeDetayIskpro',
            'clsSharedSiparisDetayIskpro' => '\\StructType\\ClsSharedSiparisDetayIskpro',
            'clsSiparisdetayiskpro' => '\\StructType\\ClsSiparisdetayiskpro',
            'clsSiparisDetayIskProIntegration' => '\\StructType\\ClsSiparisDetayIskProIntegration',
            'clsSharedIrsaliyeDetayIskpro' => '\\StructType\\ClsSharedIrsaliyeDetayIskpro',
            'clsSharedFaturaDetayIskpro' => '\\StructType\\ClsSharedFaturaDetayIskpro',
            'clsFaturadetayiskpro' => '\\StructType\\ClsFaturadetayiskpro',
            'clsFaturadetayiskproIntegration' => '\\StructType\\ClsFaturadetayiskproIntegration',
            'clsERHareketGeneric' => '\\StructType\\ClsERHareketGeneric',
            'ArrayOfClsERUrunSeriAralik' => '\\ArrayType\\ArrayOfClsERUrunSeriAralik',
            'clsERUrunSeriAralik' => '\\StructType\\ClsERUrunSeriAralik',
            'clsIsBildirimDepoHareketGeneric' => '\\StructType\\ClsIsBildirimDepoHareketGeneric',
            'clsMusteriGeneric' => '\\StructType\\ClsMusteriGeneric',
            'clsUrunGeneric' => '\\StructType\\ClsUrunGeneric',
            'clsSharedMobilAnonymous' => '\\StructType\\ClsSharedMobilAnonymous',
            'clsSharedBonusHarcama' => '\\StructType\\ClsSharedBonusHarcama',
            'clsSharedParaBirimi' => '\\StructType\\ClsSharedParaBirimi',
            'clsERBelgeToplama' => '\\StructType\\ClsERBelgeToplama',
            'clsSharedSeriLot' => '\\StructType\\ClsSharedSeriLot',
            'clsSeriLot' => '\\StructType\\ClsSeriLot',
            'clsSharedBelgeDetay' => '\\StructType\\ClsSharedBelgeDetay',
            'clsSharedFiyatVade' => '\\StructType\\ClsSharedFiyatVade',
            'clsFiyatVade' => '\\StructType\\ClsFiyatVade',
            'clsFiyatVadeIntegration' => '\\StructType\\ClsFiyatVadeIntegration',
            'clsSharedIrsaliyeDetay' => '\\StructType\\ClsSharedIrsaliyeDetay',
            'clsIrsaliyedetay' => '\\StructType\\ClsIrsaliyedetay',
            'clsSharedFaturaDetay' => '\\StructType\\ClsSharedFaturaDetay',
            'clsFaturadetay' => '\\StructType\\ClsFaturadetay',
            'clsSharedBelge' => '\\StructType\\ClsSharedBelge',
            'ArrayOfClsResult' => '\\ArrayType\\ArrayOfClsResult',
            'clsResult' => '\\StructType\\ClsResult',
            'ArrayOfInt1' => '\\ArrayType\\ArrayOfInt1',
            'ArrayOfClsSharedBelgeDetay' => '\\ArrayType\\ArrayOfClsSharedBelgeDetay',
            'ArrayOfClsERBelgeToplama' => '\\ArrayType\\ArrayOfClsERBelgeToplama',
            'Doviz' => '\\StructType\\Doviz',
            'ArrayOfClsERTreeEPuanDocInfo' => '\\ArrayType\\ArrayOfClsERTreeEPuanDocInfo',
            'clsERTreeEPuanDocInfo' => '\\StructType\\ClsERTreeEPuanDocInfo',
            'ArrayOfClsERTreeEPuanHarcamaInfo' => '\\ArrayType\\ArrayOfClsERTreeEPuanHarcamaInfo',
            'clsERTreeEPuanHarcamaInfo' => '\\StructType\\ClsERTreeEPuanHarcamaInfo',
            'clsSharedIrsaliye' => '\\StructType\\ClsSharedIrsaliye',
            'clsIrsaliye' => '\\StructType\\ClsIrsaliye',
            'clsSharedFatura' => '\\StructType\\ClsSharedFatura',
            'clsFatura' => '\\StructType\\ClsFatura',
            'clsIptalFaturaGeneric' => '\\StructType\\ClsIptalFaturaGeneric',
            'clsERDepoGeneric' => '\\StructType\\ClsERDepoGeneric',
            'clsDepoGeneric' => '\\StructType\\ClsDepoGeneric',
            'clsSharedMsdBelgeDetayEk' => '\\StructType\\ClsSharedMsdBelgeDetayEk',
            'clsERBelgeGeneric' => '\\StructType\\ClsERBelgeGeneric',
            'ArrayOfClsSecimliIskPro' => '\\ArrayType\\ArrayOfClsSecimliIskPro',
            'clsSecimliIskPro' => '\\StructType\\ClsSecimliIskPro',
            'ArrayOfClsSecimliIskProGrup' => '\\ArrayType\\ArrayOfClsSecimliIskProGrup',
            'clsSecimliIskProGrup' => '\\StructType\\ClsSecimliIskProGrup',
            'clsBelgeGeneric' => '\\StructType\\ClsBelgeGeneric',
            'clsIsBildirimGeneric' => '\\StructType\\ClsIsBildirimGeneric',
            'clsSiparisGeneric' => '\\StructType\\ClsSiparisGeneric',
            'clsGecSevkSiparisGeneric' => '\\StructType\\ClsGecSevkSiparisGeneric',
            'clsKAMusteriSiparisGeneric' => '\\StructType\\ClsKAMusteriSiparisGeneric',
            'clsDepoHareketGeneric' => '\\StructType\\ClsDepoHareketGeneric',
            'clsIrsaliyeGeneric' => '\\StructType\\ClsIrsaliyeGeneric',
            'clsFaturaGeneric' => '\\StructType\\ClsFaturaGeneric',
            'clsMutabakatLogIntegration' => '\\StructType\\ClsMutabakatLogIntegration',
            'clsVirmanFisiGeneric' => '\\StructType\\ClsVirmanFisiGeneric',
            'clsERTahsilatGeneric' => '\\StructType\\ClsERTahsilatGeneric',
            'clsTahsilatGeneric' => '\\StructType\\ClsTahsilatGeneric',
            'clsERRutTanimGeneric' => '\\StructType\\ClsERRutTanimGeneric',
            'clsRutTanimGeneric' => '\\StructType\\ClsRutTanimGeneric',
            'clsERIskProGeneric' => '\\StructType\\ClsERIskProGeneric',
            'clsIskProGeneric' => '\\StructType\\ClsIskProGeneric',
            'clsERDemirbasGeneric' => '\\StructType\\ClsERDemirbasGeneric',
            'clsDemirbasGeneric' => '\\StructType\\ClsDemirbasGeneric',
            'clsSharedKarmaKoli' => '\\StructType\\ClsSharedKarmaKoli',
            'clsKarmaKoli' => '\\StructType\\ClsKarmaKoli',
            'clsKarmaKoliIntegration' => '\\StructType\\ClsKarmaKoliIntegration',
            'clsZincir' => '\\StructType\\ClsZincir',
            'clsZincirIntegration' => '\\StructType\\ClsZincirIntegration',
            'clsMusteriEkSaha' => '\\StructType\\ClsMusteriEkSaha',
            'clsMusteriEkSahaIntegration' => '\\StructType\\ClsMusteriEkSahaIntegration',
            'clsPotansiyelMusteriEkSaha' => '\\StructType\\ClsPotansiyelMusteriEkSaha',
            'clsMusteriSorgulama' => '\\StructType\\ClsMusteriSorgulama',
            'clsSharedMusteri' => '\\StructType\\ClsSharedMusteri',
            'clsMusteri' => '\\StructType\\ClsMusteri',
            'ArrayOfClsPotansiyelMusteriEkSaha' => '\\ArrayType\\ArrayOfClsPotansiyelMusteriEkSaha',
            'clsMusteriRiskLimitiIntegration' => '\\StructType\\ClsMusteriRiskLimitiIntegration',
            'clsTCPMusteriRiskLimitiIntegration' => '\\StructType\\ClsTCPMusteriRiskLimitiIntegration',
            'clsMusteriKoordinatIntegration' => '\\StructType\\ClsMusteriKoordinatIntegration',
            'clsEfesMusteriSegmentasyonIntegration' => '\\StructType\\ClsEfesMusteriSegmentasyonIntegration',
            'clsEfesMusteriIntegration' => '\\StructType\\ClsEfesMusteriIntegration',
            'clsQuestMusteriIntegration' => '\\StructType\\ClsQuestMusteriIntegration',
            'clsMusteriIntegration' => '\\StructType\\ClsMusteriIntegration',
            'clsMsdBolge' => '\\StructType\\ClsMsdBolge',
            'clsMsdBolgeIntegration' => '\\StructType\\ClsMsdBolgeIntegration',
            'clsSharedVergiDairesi' => '\\StructType\\ClsSharedVergiDairesi',
            'clsVergiDairesi' => '\\StructType\\ClsVergiDairesi',
            'clsVergiDairesiIntegration' => '\\StructType\\ClsVergiDairesiIntegration',
            'clsSharedPersonel' => '\\StructType\\ClsSharedPersonel',
            'clsPersonel' => '\\StructType\\ClsPersonel',
            'clsPersonelIntegration' => '\\StructType\\ClsPersonelIntegration',
            'clsOgrenimDurumu' => '\\StructType\\ClsOgrenimDurumu',
            'clsOgrenimDurumuIntegration' => '\\StructType\\ClsOgrenimDurumuIntegration',
            'clsPersonelTip' => '\\StructType\\ClsPersonelTip',
            'clsPersonelTipIntegration' => '\\StructType\\ClsPersonelTipIntegration',
            'clsMusteriEkGrup' => '\\StructType\\ClsMusteriEkGrup',
            'clsMusteriEkGrupIntegration' => '\\StructType\\ClsMusteriEkGrupIntegration',
            'clsMusteriGrup' => '\\StructType\\ClsMusteriGrup',
            'clsMusteriGrupIntegration' => '\\StructType\\ClsMusteriGrupIntegration',
            'clsSTGrup' => '\\StructType\\ClsSTGrup',
            'clsSTGrupIntegration' => '\\StructType\\ClsSTGrupIntegration',
            'clsErcsemt' => '\\StructType\\ClsErcsemt',
            'clsMerkezSemtIntegration' => '\\StructType\\ClsMerkezSemtIntegration',
            'clsSharedErcIlce' => '\\StructType\\ClsSharedErcIlce',
            'clsErcIlce' => '\\StructType\\ClsErcIlce',
            'clsMerkezIlceIntegration' => '\\StructType\\ClsMerkezIlceIntegration',
            'clsSharedErcIl' => '\\StructType\\ClsSharedErcIl',
            'clsErcIl' => '\\StructType\\ClsErcIl',
            'clsMerkezIlIntegration' => '\\StructType\\ClsMerkezIlIntegration',
            'clsUrunEkSaha' => '\\StructType\\ClsUrunEkSaha',
            'clsUrunEkSahaIntegration' => '\\StructType\\ClsUrunEkSahaIntegration',
            'clsSharedDepozito' => '\\StructType\\ClsSharedDepozito',
            'clsDepozito' => '\\StructType\\ClsDepozito',
            'clsDepozitoIntegration' => '\\StructType\\ClsDepozitoIntegration',
            'clsSTRutPlanGeneric' => '\\StructType\\ClsSTRutPlanGeneric',
            'clsStRutPlan' => '\\StructType\\ClsStRutPlan',
            'clsSTRutPlanIntegration' => '\\StructType\\ClsSTRutPlanIntegration',
            'clsSharedUrun' => '\\StructType\\ClsSharedUrun',
            'clsUrun' => '\\StructType\\ClsUrun',
            'clsUrunIntegration' => '\\StructType\\ClsUrunIntegration',
            'clsSharedHiyerarsi' => '\\StructType\\ClsSharedHiyerarsi',
            'clsHiyerarsi' => '\\StructType\\ClsHiyerarsi',
            'clsYonetimHiyerarsi2' => '\\StructType\\ClsYonetimHiyerarsi2',
            'clsYonetimHiyerarsi2Integration' => '\\StructType\\ClsYonetimHiyerarsi2Integration',
            'clsYonetimHiyerarsi1' => '\\StructType\\ClsYonetimHiyerarsi1',
            'clsYonetimHiyerarsi1Integration' => '\\StructType\\ClsYonetimHiyerarsi1Integration',
            'clsUrunHiyerarsi2' => '\\StructType\\ClsUrunHiyerarsi2',
            'clsUrunHiyerarsi2Integration' => '\\StructType\\ClsUrunHiyerarsi2Integration',
            'clsUrunHiyerarsi1' => '\\StructType\\ClsUrunHiyerarsi1',
            'clsUrunHiyerarsi1Integration' => '\\StructType\\ClsUrunHiyerarsi1Integration',
            'clsSharedUretici' => '\\StructType\\ClsSharedUretici',
            'clsUretici' => '\\StructType\\ClsUretici',
            'clsUreticiIntegration' => '\\StructType\\ClsUreticiIntegration',
            'clsUrunEkGrup' => '\\StructType\\ClsUrunEkGrup',
            'clsUrunEkGrupIntegration' => '\\StructType\\ClsUrunEkGrupIntegration',
            'clsUrunGrup' => '\\StructType\\ClsUrunGrup',
            'clsUrunGrupIntegration' => '\\StructType\\ClsUrunGrupIntegration',
            'clsBilgiKriter' => '\\StructType\\ClsBilgiKriter',
            'clsPaketTanim' => '\\StructType\\ClsPaketTanim',
            'clsBilgiHazirlamaKriter' => '\\StructType\\ClsBilgiHazirlamaKriter',
            'clsDatabaseKriter' => '\\StructType\\ClsDatabaseKriter',
            'clsMailKriter' => '\\StructType\\ClsMailKriter',
            'clsDistMailKriter' => '\\StructType\\ClsDistMailKriter',
            'clsWMSBilgiKriter' => '\\StructType\\ClsWMSBilgiKriter',
            'clsMobileBilgiHazirlamaKriter' => '\\StructType\\ClsMobileBilgiHazirlamaKriter',
            'clsMobileBilgiIslemeKriter' => '\\StructType\\ClsMobileBilgiIslemeKriter',
            'clsBilgiIslemeKriter' => '\\StructType\\ClsBilgiIslemeKriter',
            'ArrayOfClsGorevSonucBilgi' => '\\ArrayType\\ArrayOfClsGorevSonucBilgi',
            'clsGorevSonucBilgi' => '\\StructType\\ClsGorevSonucBilgi',
            'clsServiceConfig' => '\\StructType\\ClsServiceConfig',
            'ArrayOfClsPaketTanim' => '\\ArrayType\\ArrayOfClsPaketTanim',
            'ArrayOfClsBilgiKriter' => '\\ArrayType\\ArrayOfClsBilgiKriter',
            'ArrayOfClsUrunGrupIntegration' => '\\ArrayType\\ArrayOfClsUrunGrupIntegration',
            'ArrayOfClsUrunEkGrupIntegration' => '\\ArrayType\\ArrayOfClsUrunEkGrupIntegration',
            'ArrayOfClsUreticiIntegration' => '\\ArrayType\\ArrayOfClsUreticiIntegration',
            'ArrayOfClsUrunHiyerarsi1Integration' => '\\ArrayType\\ArrayOfClsUrunHiyerarsi1Integration',
            'ArrayOfClsUrunHiyerarsi2Integration' => '\\ArrayType\\ArrayOfClsUrunHiyerarsi2Integration',
            'ArrayOfClsUrunIntegration' => '\\ArrayType\\ArrayOfClsUrunIntegration',
            'ArrayOfClsSTRutPlanIntegration' => '\\ArrayType\\ArrayOfClsSTRutPlanIntegration',
            'ArrayOfClsSTRutPlanGeneric' => '\\ArrayType\\ArrayOfClsSTRutPlanGeneric',
            'ArrayOfClsDepozitoIntegration' => '\\ArrayType\\ArrayOfClsDepozitoIntegration',
            'ArrayOfClsUrunEkSahaIntegration' => '\\ArrayType\\ArrayOfClsUrunEkSahaIntegration',
            'ArrayOfClsMerkezIlIntegration' => '\\ArrayType\\ArrayOfClsMerkezIlIntegration',
            'ArrayOfClsMerkezIlceIntegration' => '\\ArrayType\\ArrayOfClsMerkezIlceIntegration',
            'ArrayOfClsMerkezSemtIntegration' => '\\ArrayType\\ArrayOfClsMerkezSemtIntegration',
            'ArrayOfClsSTGrupIntegration' => '\\ArrayType\\ArrayOfClsSTGrupIntegration',
            'ArrayOfClsMusteriGrupIntegration' => '\\ArrayType\\ArrayOfClsMusteriGrupIntegration',
            'ArrayOfClsMusteriEkGrupIntegration' => '\\ArrayType\\ArrayOfClsMusteriEkGrupIntegration',
            'ArrayOfClsPersonelTipIntegration' => '\\ArrayType\\ArrayOfClsPersonelTipIntegration',
            'ArrayOfClsOgrenimDurumuIntegration' => '\\ArrayType\\ArrayOfClsOgrenimDurumuIntegration',
            'ArrayOfClsPersonelIntegration' => '\\ArrayType\\ArrayOfClsPersonelIntegration',
            'ArrayOfClsYonetimHiyerarsi1Integration' => '\\ArrayType\\ArrayOfClsYonetimHiyerarsi1Integration',
            'ArrayOfClsYonetimHiyerarsi2Integration' => '\\ArrayType\\ArrayOfClsYonetimHiyerarsi2Integration',
            'ArrayOfClsVergiDairesiIntegration' => '\\ArrayType\\ArrayOfClsVergiDairesiIntegration',
            'ArrayOfClsMsdBolgeIntegration' => '\\ArrayType\\ArrayOfClsMsdBolgeIntegration',
            'ArrayOfClsMusteriIntegration' => '\\ArrayType\\ArrayOfClsMusteriIntegration',
            'ArrayOfClsQuestMusteriIntegration' => '\\ArrayType\\ArrayOfClsQuestMusteriIntegration',
            'ArrayOfClsEfesMusteriIntegration' => '\\ArrayType\\ArrayOfClsEfesMusteriIntegration',
            'ArrayOfClsEfesMusteriSegmentasyonIntegration' => '\\ArrayType\\ArrayOfClsEfesMusteriSegmentasyonIntegration',
            'ArrayOfClsMusteriKoordinatIntegration' => '\\ArrayType\\ArrayOfClsMusteriKoordinatIntegration',
            'ArrayOfClsMusteriEkSahaIntegration' => '\\ArrayType\\ArrayOfClsMusteriEkSahaIntegration',
            'ArrayOfClsZincirIntegration' => '\\ArrayType\\ArrayOfClsZincirIntegration',
            'ArrayOfClsKarmaKoliIntegration' => '\\ArrayType\\ArrayOfClsKarmaKoliIntegration',
            'ArrayOfClsFiyatVadeIntegration' => '\\ArrayType\\ArrayOfClsFiyatVadeIntegration',
            'ArrayOfClsDemirbasGeneric' => '\\ArrayType\\ArrayOfClsDemirbasGeneric',
            'ArrayOfClsIskProGeneric' => '\\ArrayType\\ArrayOfClsIskProGeneric',
            'ArrayOfClsRutTanimGeneric' => '\\ArrayType\\ArrayOfClsRutTanimGeneric',
            'ArrayOfClsTahsilatGeneric' => '\\ArrayType\\ArrayOfClsTahsilatGeneric',
            'ArrayOfClsVirmanFisiGeneric' => '\\ArrayType\\ArrayOfClsVirmanFisiGeneric',
            'ArrayOfClsBelgeGeneric' => '\\ArrayType\\ArrayOfClsBelgeGeneric',
            'ArrayOfClsDepoGeneric' => '\\ArrayType\\ArrayOfClsDepoGeneric',
            'ArrayOfClsIptalFaturaGeneric' => '\\ArrayType\\ArrayOfClsIptalFaturaGeneric',
            'ArrayOfClsFaturaGeneric' => '\\ArrayType\\ArrayOfClsFaturaGeneric',
            'ArrayOfClsFatura' => '\\ArrayType\\ArrayOfClsFatura',
            'ArrayOfClsIrsaliye' => '\\ArrayType\\ArrayOfClsIrsaliye',
            'ArrayOfClsUrunGeneric' => '\\ArrayType\\ArrayOfClsUrunGeneric',
            'ArrayOfClsMusteriGeneric' => '\\ArrayType\\ArrayOfClsMusteriGeneric',
            'ArrayOfClsIrsaliyeGeneric' => '\\ArrayType\\ArrayOfClsIrsaliyeGeneric',
            'ArrayOfClsDepoHareketGeneric' => '\\ArrayType\\ArrayOfClsDepoHareketGeneric',
            'ArrayOfClsSiparisGeneric' => '\\ArrayType\\ArrayOfClsSiparisGeneric',
            'ArrayOfClsIsBildirimGeneric' => '\\ArrayType\\ArrayOfClsIsBildirimGeneric',
            'ArrayOfClsIsBildirimDepoHareketGeneric' => '\\ArrayType\\ArrayOfClsIsBildirimDepoHareketGeneric',
            'ArrayOfClsFaturadetayiskproIntegration' => '\\ArrayType\\ArrayOfClsFaturadetayiskproIntegration',
            'ArrayOfClsDepoStokDurumIntegration' => '\\ArrayType\\ArrayOfClsDepoStokDurumIntegration',
            'ArrayOfClsMusteriEntegrasyon' => '\\ArrayType\\ArrayOfClsMusteriEntegrasyon',
            'clsTCPParametreler' => '\\StructType\\ClsTCPParametreler',
            'clsTCPYetkiTanimlar' => '\\StructType\\ClsTCPYetkiTanimlar',
            'ArrayOfClsTCPBaglantiProfil' => '\\ArrayType\\ArrayOfClsTCPBaglantiProfil',
            'ArrayOfClsSatisTemsilcisiIntegration' => '\\ArrayType\\ArrayOfClsSatisTemsilcisiIntegration',
            'ArrayOfClsDistIntegration' => '\\ArrayType\\ArrayOfClsDistIntegration',
            'ArrayOfClsTCPStokSonDurumIntegration' => '\\ArrayType\\ArrayOfClsTCPStokSonDurumIntegration',
            'ArrayOfClsTCPMusteriRiskLimitiIntegration' => '\\ArrayType\\ArrayOfClsTCPMusteriRiskLimitiIntegration',
            'ArrayOfClsTCPMusteriBakiyeIntegration' => '\\ArrayType\\ArrayOfClsTCPMusteriBakiyeIntegration',
            'ArrayOfClsMusteriBakiyeIntegration' => '\\ArrayType\\ArrayOfClsMusteriBakiyeIntegration',
            'ArrayOfClsMusteriSiparis' => '\\ArrayType\\ArrayOfClsMusteriSiparis',
            'ArrayOfClsEntegrasyonLog' => '\\ArrayType\\ArrayOfClsEntegrasyonLog',
            'ArrayOfClsZiyaretGeneric' => '\\ArrayType\\ArrayOfClsZiyaretGeneric',
            'ArrayOfClsMusteriDinamikGrupGeneric' => '\\ArrayType\\ArrayOfClsMusteriDinamikGrupGeneric',
            'ArrayOfClsUrunDinamikGrupGeneric' => '\\ArrayType\\ArrayOfClsUrunDinamikGrupGeneric',
            'ArrayOfClsUrunMiktarliDinamikGrupGeneric' => '\\ArrayType\\ArrayOfClsUrunMiktarliDinamikGrupGeneric',
            'ArrayOfClsDepoIntegration' => '\\ArrayType\\ArrayOfClsDepoIntegration',
            'ArrayOfClsKAMusteriSiparisGeneric' => '\\ArrayType\\ArrayOfClsKAMusteriSiparisGeneric',
            'ArrayOfClsGecSevkSiparisGeneric' => '\\ArrayType\\ArrayOfClsGecSevkSiparisGeneric',
            'ArrayOfClsFaturaIrsaliyeBaglantiIntegration' => '\\ArrayType\\ArrayOfClsFaturaIrsaliyeBaglantiIntegration',
            'ArrayOfClsTCPDistSubeEslestirme' => '\\ArrayType\\ArrayOfClsTCPDistSubeEslestirme',
            'ArrayOfClsUrunFotoIntegration' => '\\ArrayType\\ArrayOfClsUrunFotoIntegration',
            'ArrayOfClsMutabakatLogIntegration' => '\\ArrayType\\ArrayOfClsMutabakatLogIntegration',
            'ArrayOfClsMesajIntegration' => '\\ArrayType\\ArrayOfClsMesajIntegration',
            'ArrayOfClsKullaniciIntegration' => '\\ArrayType\\ArrayOfClsKullaniciIntegration',
            'ArrayOfClsDistEkGrupIntegration' => '\\ArrayType\\ArrayOfClsDistEkGrupIntegration',
            'ArrayOfClsGerceklesenPrimIntegration' => '\\ArrayType\\ArrayOfClsGerceklesenPrimIntegration',
            'ArrayOfClsFaturaSatisUrunMiktarGeneric' => '\\ArrayType\\ArrayOfClsFaturaSatisUrunMiktarGeneric',
            'ArrayOfClsCariHesapIntegration' => '\\ArrayType\\ArrayOfClsCariHesapIntegration',
            'ArrayOfClsSESefIntegration' => '\\ArrayType\\ArrayOfClsSESefIntegration',
            'ArrayOfClsSahaElemaniIntegration' => '\\ArrayType\\ArrayOfClsSahaElemaniIntegration',
            'ArrayOfClsSERutPlanIntegration' => '\\ArrayType\\ArrayOfClsSERutPlanIntegration',
            'ArrayOfClsDistGunlukStokIntegration' => '\\ArrayType\\ArrayOfClsDistGunlukStokIntegration',
            'ArrayOfClsDistYoldakiUrunlerIntegration' => '\\ArrayType\\ArrayOfClsDistYoldakiUrunlerIntegration',
            'ArrayOfClsMusteriSevkAdresIntegration' => '\\ArrayType\\ArrayOfClsMusteriSevkAdresIntegration',
            'ArrayOfArrayOfClsDictionaryOfStringObject' => '\\ArrayType\\ArrayOfArrayOfClsDictionaryOfStringObject',
            'ArrayOfClsDictionaryOfStringObject' => '\\ArrayType\\ArrayOfClsDictionaryOfStringObject',
            'clsDictionaryOfStringObject' => '\\StructType\\ClsDictionaryOfStringObject',
            'ArrayOfClsMusteriAracIntegration' => '\\ArrayType\\ArrayOfClsMusteriAracIntegration',
            'ArrayOfClsYolYardimIntegration' => '\\ArrayType\\ArrayOfClsYolYardimIntegration',
            'ArrayOfClsTCPUrunAlanEslestirme' => '\\ArrayType\\ArrayOfClsTCPUrunAlanEslestirme',
            'ArrayOfClsYasakliSatilabilirUrunGeneric' => '\\ArrayType\\ArrayOfClsYasakliSatilabilirUrunGeneric',
            'ArrayOfClsSadakatBakiyeIntegration' => '\\ArrayType\\ArrayOfClsSadakatBakiyeIntegration',
            'ArrayOfClsRpaAcikSiparisIntegration' => '\\ArrayType\\ArrayOfClsRpaAcikSiparisIntegration',
            'ArrayOfClsRepAdvisorIntegration' => '\\ArrayType\\ArrayOfClsRepAdvisorIntegration',
            'ArrayOfClsMiktarFarkIntegration' => '\\ArrayType\\ArrayOfClsMiktarFarkIntegration',
            'ArrayOfClsCaykurIrsaliyeGeneric' => '\\ArrayType\\ArrayOfClsCaykurIrsaliyeGeneric',
            'ArrayOfClsTercihliUrunGeneric' => '\\ArrayType\\ArrayOfClsTercihliUrunGeneric',
            'ArrayOfClsTeminatBilgileriIntegration' => '\\ArrayType\\ArrayOfClsTeminatBilgileriIntegration',
            'ArrayOfClsMusteriDurumIntegration' => '\\ArrayType\\ArrayOfClsMusteriDurumIntegration',
            'ArrayOfClsOzelUrunIntegration' => '\\ArrayType\\ArrayOfClsOzelUrunIntegration',
            'ArrayOfClsDepozitoSeriIntegration' => '\\ArrayType\\ArrayOfClsDepozitoSeriIntegration',
            'ArrayOfClsSiparisDetayIskProIntegration' => '\\ArrayType\\ArrayOfClsSiparisDetayIskProIntegration',
            'ArrayOfClsIadeNeden' => '\\ArrayType\\ArrayOfClsIadeNeden',
            'ArrayOfClsDisSistemBelgeAlanGuncelleme' => '\\ArrayType\\ArrayOfClsDisSistemBelgeAlanGuncelleme',
            'ArrayOfClsFaturaKapatmaIntegration' => '\\ArrayType\\ArrayOfClsFaturaKapatmaIntegration',
            'ArrayOfClsPalyeGeneric' => '\\ArrayType\\ArrayOfClsPalyeGeneric',
            'ArrayOfClsQuestThingGrup' => '\\ArrayType\\ArrayOfClsQuestThingGrup',
            'ArrayOfClsCagriMerkeziBildirimIntegration' => '\\ArrayType\\ArrayOfClsCagriMerkeziBildirimIntegration',
            'ArrayOfClsUrunKombinasyonIntegration' => '\\ArrayType\\ArrayOfClsUrunKombinasyonIntegration',
            'ArrayOfClsKotaDistGeneric' => '\\ArrayType\\ArrayOfClsKotaDistGeneric',
            'ArrayOfClsSuperSessionGeneric' => '\\ArrayType\\ArrayOfClsSuperSessionGeneric',
            'ArrayOfClsUrunOpsiyonUrunGeneric' => '\\ArrayType\\ArrayOfClsUrunOpsiyonUrunGeneric',
            'ArrayOfClsUrunMuadilIntegration' => '\\ArrayType\\ArrayOfClsUrunMuadilIntegration',
            'ArrayOfClsFiloHizmetTanimIntegration' => '\\ArrayType\\ArrayOfClsFiloHizmetTanimIntegration',
            'clsIntegrationWebMethodResult' => '\\StructType\\ClsIntegrationWebMethodResult',
            'IntegrationSendEntitySetWithLoginResponse' => '\\StructType\\IntegrationSendEntitySetWithLoginResponse',
            'IntegrationSendCancelledEntitySetWithLogin' => '\\StructType\\IntegrationSendCancelledEntitySetWithLogin',
            'ArrayOfClsIptalBelge' => '\\ArrayType\\ArrayOfClsIptalBelge',
            'clsIptalBelge' => '\\StructType\\ClsIptalBelge',
            'IntegrationSendCancelledEntitySetWithLoginResponse' => '\\StructType\\IntegrationSendCancelledEntitySetWithLoginResponse',
            'IntegrationLogin' => '\\StructType\\IntegrationLogin',
            'IntegrationLoginResponse' => '\\StructType\\IntegrationLoginResponse',
            'IntegrationLogout' => '\\StructType\\IntegrationLogout',
            'IntegrationLogoutResponse' => '\\StructType\\IntegrationLogoutResponse',
            'Logout' => '\\StructType\\Logout',
            'LogoutResponse' => '\\StructType\\LogoutResponse',
            'IntegrationSendEntitySet' => '\\StructType\\IntegrationSendEntitySet',
            'IntegrationSendEntitySetResponse' => '\\StructType\\IntegrationSendEntitySetResponse',
            'IntegrationGetEntitySet' => '\\StructType\\IntegrationGetEntitySet',
            'IntegrationGetEntitySetResponse' => '\\StructType\\IntegrationGetEntitySetResponse',
            'clsIntegrationEntitySetResult' => '\\StructType\\ClsIntegrationEntitySetResult',
            'IntegrationGetEntitySetWithLogin' => '\\StructType\\IntegrationGetEntitySetWithLogin',
            'IntegrationGetEntitySetWithLoginResponse' => '\\StructType\\IntegrationGetEntitySetWithLoginResponse',
            'IntegrationGetEntitySetWithPacketLogin' => '\\StructType\\IntegrationGetEntitySetWithPacketLogin',
            'IntegrationGetEntitySetWithPacketLoginResponse' => '\\StructType\\IntegrationGetEntitySetWithPacketLoginResponse',
            'IntegrationSendSuccessResult' => '\\StructType\\IntegrationSendSuccessResult',
            'ArrayOfClsDictionaryOfStringString' => '\\ArrayType\\ArrayOfClsDictionaryOfStringString',
            'clsDictionaryOfStringString' => '\\StructType\\ClsDictionaryOfStringString',
            'IntegrationSendSuccessResultResponse' => '\\StructType\\IntegrationSendSuccessResultResponse',
            'IntegrationDeleteTransferStatus' => '\\StructType\\IntegrationDeleteTransferStatus',
            'IntegrationDeleteTransferStatusResponse' => '\\StructType\\IntegrationDeleteTransferStatusResponse',
            'IntegrationSendUpdateRecord' => '\\StructType\\IntegrationSendUpdateRecord',
            'IntegrationSendUpdateRecordResponse' => '\\StructType\\IntegrationSendUpdateRecordResponse',
            'IntegrationSendUpdateRecordWithCode' => '\\StructType\\IntegrationSendUpdateRecordWithCode',
            'IntegrationSendUpdateRecordWithCodeResponse' => '\\StructType\\IntegrationSendUpdateRecordWithCodeResponse',
            'IntegrationSendCollectionPaid' => '\\StructType\\IntegrationSendCollectionPaid',
            'IntegrationSendCollectionPaidResponse' => '\\StructType\\IntegrationSendCollectionPaidResponse',
        );
    }
}
