<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsBilgiIslemeKriter StructType
 * @subpackage Structs
 */
class ClsBilgiIslemeKriter extends AbstractStructBase
{
    /**
     * The Kaynak
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $Kaynak;
    /**
     * The DistKodlar
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInt
     */
    public $DistKodlar;
    /**
     * The LocalFtpPath
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LocalFtpPath;
    /**
     * The FileName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FileName;
    /**
     * The DatabaseKriter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ClsDatabaseKriter
     */
    public $DatabaseKriter;
    /**
     * The MailKriter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ClsMailKriter
     */
    public $MailKriter;
    /**
     * The SonucMailKriter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ClsMailKriter
     */
    public $SonucMailKriter;
    /**
     * The BasariliMailKriter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ClsMailKriter
     */
    public $BasariliMailKriter;
    /**
     * The ERARaporTanimPath
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ERARaporTanimPath;
    /**
     * The Version
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Version;
    /**
     * The DistMailInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ClsDistMailKriter
     */
    public $DistMailInfo;
    /**
     * Constructor method for clsBilgiIslemeKriter
     * @uses ClsBilgiIslemeKriter::setKaynak()
     * @uses ClsBilgiIslemeKriter::setDistKodlar()
     * @uses ClsBilgiIslemeKriter::setLocalFtpPath()
     * @uses ClsBilgiIslemeKriter::setFileName()
     * @uses ClsBilgiIslemeKriter::setDatabaseKriter()
     * @uses ClsBilgiIslemeKriter::setMailKriter()
     * @uses ClsBilgiIslemeKriter::setSonucMailKriter()
     * @uses ClsBilgiIslemeKriter::setBasariliMailKriter()
     * @uses ClsBilgiIslemeKriter::setERARaporTanimPath()
     * @uses ClsBilgiIslemeKriter::setVersion()
     * @uses ClsBilgiIslemeKriter::setDistMailInfo()
     * @param string $kaynak
     * @param \ArrayType\ArrayOfInt $distKodlar
     * @param string $localFtpPath
     * @param string $fileName
     * @param \StructType\ClsDatabaseKriter $databaseKriter
     * @param \StructType\ClsMailKriter $mailKriter
     * @param \StructType\ClsMailKriter $sonucMailKriter
     * @param \StructType\ClsMailKriter $basariliMailKriter
     * @param string $eRARaporTanimPath
     * @param string $version
     * @param \StructType\ClsDistMailKriter $distMailInfo
     */
    public function __construct($kaynak = null, \ArrayType\ArrayOfInt $distKodlar = null, $localFtpPath = null, $fileName = null, \StructType\ClsDatabaseKriter $databaseKriter = null, \StructType\ClsMailKriter $mailKriter = null, \StructType\ClsMailKriter $sonucMailKriter = null, \StructType\ClsMailKriter $basariliMailKriter = null, $eRARaporTanimPath = null, $version = null, \StructType\ClsDistMailKriter $distMailInfo = null)
    {
        $this
            ->setKaynak($kaynak)
            ->setDistKodlar($distKodlar)
            ->setLocalFtpPath($localFtpPath)
            ->setFileName($fileName)
            ->setDatabaseKriter($databaseKriter)
            ->setMailKriter($mailKriter)
            ->setSonucMailKriter($sonucMailKriter)
            ->setBasariliMailKriter($basariliMailKriter)
            ->setERARaporTanimPath($eRARaporTanimPath)
            ->setVersion($version)
            ->setDistMailInfo($distMailInfo);
    }
    /**
     * Get Kaynak value
     * @return string
     */
    public function getKaynak()
    {
        return $this->Kaynak;
    }
    /**
     * Set Kaynak value
     * @uses \EnumType\GorevKaynak::valueIsValid()
     * @uses \EnumType\GorevKaynak::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $kaynak
     * @return \StructType\ClsBilgiIslemeKriter
     */
    public function setKaynak($kaynak = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\GorevKaynak::valueIsValid($kaynak)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\GorevKaynak', is_array($kaynak) ? implode(', ', $kaynak) : var_export($kaynak, true), implode(', ', \EnumType\GorevKaynak::getValidValues())), __LINE__);
        }
        $this->Kaynak = $kaynak;
        return $this;
    }
    /**
     * Get DistKodlar value
     * @return \ArrayType\ArrayOfInt|null
     */
    public function getDistKodlar()
    {
        return $this->DistKodlar;
    }
    /**
     * Set DistKodlar value
     * @param \ArrayType\ArrayOfInt $distKodlar
     * @return \StructType\ClsBilgiIslemeKriter
     */
    public function setDistKodlar(\ArrayType\ArrayOfInt $distKodlar = null)
    {
        $this->DistKodlar = $distKodlar;
        return $this;
    }
    /**
     * Get LocalFtpPath value
     * @return string|null
     */
    public function getLocalFtpPath()
    {
        return $this->LocalFtpPath;
    }
    /**
     * Set LocalFtpPath value
     * @param string $localFtpPath
     * @return \StructType\ClsBilgiIslemeKriter
     */
    public function setLocalFtpPath($localFtpPath = null)
    {
        // validation for constraint: string
        if (!is_null($localFtpPath) && !is_string($localFtpPath)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($localFtpPath, true), gettype($localFtpPath)), __LINE__);
        }
        $this->LocalFtpPath = $localFtpPath;
        return $this;
    }
    /**
     * Get FileName value
     * @return string|null
     */
    public function getFileName()
    {
        return $this->FileName;
    }
    /**
     * Set FileName value
     * @param string $fileName
     * @return \StructType\ClsBilgiIslemeKriter
     */
    public function setFileName($fileName = null)
    {
        // validation for constraint: string
        if (!is_null($fileName) && !is_string($fileName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fileName, true), gettype($fileName)), __LINE__);
        }
        $this->FileName = $fileName;
        return $this;
    }
    /**
     * Get DatabaseKriter value
     * @return \StructType\ClsDatabaseKriter|null
     */
    public function getDatabaseKriter()
    {
        return $this->DatabaseKriter;
    }
    /**
     * Set DatabaseKriter value
     * @param \StructType\ClsDatabaseKriter $databaseKriter
     * @return \StructType\ClsBilgiIslemeKriter
     */
    public function setDatabaseKriter(\StructType\ClsDatabaseKriter $databaseKriter = null)
    {
        $this->DatabaseKriter = $databaseKriter;
        return $this;
    }
    /**
     * Get MailKriter value
     * @return \StructType\ClsMailKriter|null
     */
    public function getMailKriter()
    {
        return $this->MailKriter;
    }
    /**
     * Set MailKriter value
     * @param \StructType\ClsMailKriter $mailKriter
     * @return \StructType\ClsBilgiIslemeKriter
     */
    public function setMailKriter(\StructType\ClsMailKriter $mailKriter = null)
    {
        $this->MailKriter = $mailKriter;
        return $this;
    }
    /**
     * Get SonucMailKriter value
     * @return \StructType\ClsMailKriter|null
     */
    public function getSonucMailKriter()
    {
        return $this->SonucMailKriter;
    }
    /**
     * Set SonucMailKriter value
     * @param \StructType\ClsMailKriter $sonucMailKriter
     * @return \StructType\ClsBilgiIslemeKriter
     */
    public function setSonucMailKriter(\StructType\ClsMailKriter $sonucMailKriter = null)
    {
        $this->SonucMailKriter = $sonucMailKriter;
        return $this;
    }
    /**
     * Get BasariliMailKriter value
     * @return \StructType\ClsMailKriter|null
     */
    public function getBasariliMailKriter()
    {
        return $this->BasariliMailKriter;
    }
    /**
     * Set BasariliMailKriter value
     * @param \StructType\ClsMailKriter $basariliMailKriter
     * @return \StructType\ClsBilgiIslemeKriter
     */
    public function setBasariliMailKriter(\StructType\ClsMailKriter $basariliMailKriter = null)
    {
        $this->BasariliMailKriter = $basariliMailKriter;
        return $this;
    }
    /**
     * Get ERARaporTanimPath value
     * @return string|null
     */
    public function getERARaporTanimPath()
    {
        return $this->ERARaporTanimPath;
    }
    /**
     * Set ERARaporTanimPath value
     * @param string $eRARaporTanimPath
     * @return \StructType\ClsBilgiIslemeKriter
     */
    public function setERARaporTanimPath($eRARaporTanimPath = null)
    {
        // validation for constraint: string
        if (!is_null($eRARaporTanimPath) && !is_string($eRARaporTanimPath)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eRARaporTanimPath, true), gettype($eRARaporTanimPath)), __LINE__);
        }
        $this->ERARaporTanimPath = $eRARaporTanimPath;
        return $this;
    }
    /**
     * Get Version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->Version;
    }
    /**
     * Set Version value
     * @param string $version
     * @return \StructType\ClsBilgiIslemeKriter
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->Version = $version;
        return $this;
    }
    /**
     * Get DistMailInfo value
     * @return \StructType\ClsDistMailKriter|null
     */
    public function getDistMailInfo()
    {
        return $this->DistMailInfo;
    }
    /**
     * Set DistMailInfo value
     * @param \StructType\ClsDistMailKriter $distMailInfo
     * @return \StructType\ClsBilgiIslemeKriter
     */
    public function setDistMailInfo(\StructType\ClsDistMailKriter $distMailInfo = null)
    {
        $this->DistMailInfo = $distMailInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsBilgiIslemeKriter
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
