<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsDepoIntegration StructType
 * @subpackage Structs
 */
class ClsDepoIntegration extends ClsDepo
{
    /**
     * The DistTextKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DistTextKod;
    /**
     * The DistReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DistReferans;
    /**
     * The DepoGrupAd
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DepoGrupAd;
    /**
     * Constructor method for clsDepoIntegration
     * @uses ClsDepoIntegration::setDistTextKod()
     * @uses ClsDepoIntegration::setDistReferans()
     * @uses ClsDepoIntegration::setDepoGrupAd()
     * @param string $distTextKod
     * @param string $distReferans
     * @param string $depoGrupAd
     */
    public function __construct($distTextKod = null, $distReferans = null, $depoGrupAd = null)
    {
        $this
            ->setDistTextKod($distTextKod)
            ->setDistReferans($distReferans)
            ->setDepoGrupAd($depoGrupAd);
    }
    /**
     * Get DistTextKod value
     * @return string|null
     */
    public function getDistTextKod()
    {
        return $this->DistTextKod;
    }
    /**
     * Set DistTextKod value
     * @param string $distTextKod
     * @return \StructType\ClsDepoIntegration
     */
    public function setDistTextKod($distTextKod = null)
    {
        // validation for constraint: string
        if (!is_null($distTextKod) && !is_string($distTextKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($distTextKod, true), gettype($distTextKod)), __LINE__);
        }
        $this->DistTextKod = $distTextKod;
        return $this;
    }
    /**
     * Get DistReferans value
     * @return string|null
     */
    public function getDistReferans()
    {
        return $this->DistReferans;
    }
    /**
     * Set DistReferans value
     * @param string $distReferans
     * @return \StructType\ClsDepoIntegration
     */
    public function setDistReferans($distReferans = null)
    {
        // validation for constraint: string
        if (!is_null($distReferans) && !is_string($distReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($distReferans, true), gettype($distReferans)), __LINE__);
        }
        $this->DistReferans = $distReferans;
        return $this;
    }
    /**
     * Get DepoGrupAd value
     * @return string|null
     */
    public function getDepoGrupAd()
    {
        return $this->DepoGrupAd;
    }
    /**
     * Set DepoGrupAd value
     * @param string $depoGrupAd
     * @return \StructType\ClsDepoIntegration
     */
    public function setDepoGrupAd($depoGrupAd = null)
    {
        // validation for constraint: string
        if (!is_null($depoGrupAd) && !is_string($depoGrupAd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($depoGrupAd, true), gettype($depoGrupAd)), __LINE__);
        }
        $this->DepoGrupAd = $depoGrupAd;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsDepoIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
