<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsDepozitoIntegration StructType
 * @subpackage Structs
 */
class ClsDepozitoIntegration extends ClsDepozito
{
    /**
     * The UrunTextKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UrunTextKod;
    /**
     * The UrunReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UrunReferans;
    /**
     * The DepozitoUrunTextKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DepozitoUrunTextKod;
    /**
     * The DepozitoUrunReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DepozitoUrunReferans;
    /**
     * Constructor method for clsDepozitoIntegration
     * @uses ClsDepozitoIntegration::setUrunTextKod()
     * @uses ClsDepozitoIntegration::setUrunReferans()
     * @uses ClsDepozitoIntegration::setDepozitoUrunTextKod()
     * @uses ClsDepozitoIntegration::setDepozitoUrunReferans()
     * @param string $urunTextKod
     * @param string $urunReferans
     * @param string $depozitoUrunTextKod
     * @param string $depozitoUrunReferans
     */
    public function __construct($urunTextKod = null, $urunReferans = null, $depozitoUrunTextKod = null, $depozitoUrunReferans = null)
    {
        $this
            ->setUrunTextKod($urunTextKod)
            ->setUrunReferans($urunReferans)
            ->setDepozitoUrunTextKod($depozitoUrunTextKod)
            ->setDepozitoUrunReferans($depozitoUrunReferans);
    }
    /**
     * Get UrunTextKod value
     * @return string|null
     */
    public function getUrunTextKod()
    {
        return $this->UrunTextKod;
    }
    /**
     * Set UrunTextKod value
     * @param string $urunTextKod
     * @return \StructType\ClsDepozitoIntegration
     */
    public function setUrunTextKod($urunTextKod = null)
    {
        // validation for constraint: string
        if (!is_null($urunTextKod) && !is_string($urunTextKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($urunTextKod, true), gettype($urunTextKod)), __LINE__);
        }
        $this->UrunTextKod = $urunTextKod;
        return $this;
    }
    /**
     * Get UrunReferans value
     * @return string|null
     */
    public function getUrunReferans()
    {
        return $this->UrunReferans;
    }
    /**
     * Set UrunReferans value
     * @param string $urunReferans
     * @return \StructType\ClsDepozitoIntegration
     */
    public function setUrunReferans($urunReferans = null)
    {
        // validation for constraint: string
        if (!is_null($urunReferans) && !is_string($urunReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($urunReferans, true), gettype($urunReferans)), __LINE__);
        }
        $this->UrunReferans = $urunReferans;
        return $this;
    }
    /**
     * Get DepozitoUrunTextKod value
     * @return string|null
     */
    public function getDepozitoUrunTextKod()
    {
        return $this->DepozitoUrunTextKod;
    }
    /**
     * Set DepozitoUrunTextKod value
     * @param string $depozitoUrunTextKod
     * @return \StructType\ClsDepozitoIntegration
     */
    public function setDepozitoUrunTextKod($depozitoUrunTextKod = null)
    {
        // validation for constraint: string
        if (!is_null($depozitoUrunTextKod) && !is_string($depozitoUrunTextKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($depozitoUrunTextKod, true), gettype($depozitoUrunTextKod)), __LINE__);
        }
        $this->DepozitoUrunTextKod = $depozitoUrunTextKod;
        return $this;
    }
    /**
     * Get DepozitoUrunReferans value
     * @return string|null
     */
    public function getDepozitoUrunReferans()
    {
        return $this->DepozitoUrunReferans;
    }
    /**
     * Set DepozitoUrunReferans value
     * @param string $depozitoUrunReferans
     * @return \StructType\ClsDepozitoIntegration
     */
    public function setDepozitoUrunReferans($depozitoUrunReferans = null)
    {
        // validation for constraint: string
        if (!is_null($depozitoUrunReferans) && !is_string($depozitoUrunReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($depozitoUrunReferans, true), gettype($depozitoUrunReferans)), __LINE__);
        }
        $this->DepozitoUrunReferans = $depozitoUrunReferans;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsDepozitoIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
