<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsDepozitoSeriIntegration StructType
 * @subpackage Structs
 */
class ClsDepozitoSeriIntegration extends ClsEntity
{
    /**
     * The BelgeTarihi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $BelgeTarihi;
    /**
     * The Tip
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $Tip;
    /**
     * The Yil
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $Yil;
    /**
     * The Referans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Referans;
    /**
     * The MatbuNo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MatbuNo;
    /**
     * The DistReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DistReferans;
    /**
     * The UrunReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UrunReferans;
    /**
     * The SeriList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfClsDepozitoSeri
     */
    public $SeriList;
    /**
     * Constructor method for clsDepozitoSeriIntegration
     * @uses ClsDepozitoSeriIntegration::setBelgeTarihi()
     * @uses ClsDepozitoSeriIntegration::setTip()
     * @uses ClsDepozitoSeriIntegration::setYil()
     * @uses ClsDepozitoSeriIntegration::setReferans()
     * @uses ClsDepozitoSeriIntegration::setMatbuNo()
     * @uses ClsDepozitoSeriIntegration::setDistReferans()
     * @uses ClsDepozitoSeriIntegration::setUrunReferans()
     * @uses ClsDepozitoSeriIntegration::setSeriList()
     * @param string $belgeTarihi
     * @param int $tip
     * @param int $yil
     * @param string $referans
     * @param string $matbuNo
     * @param string $distReferans
     * @param string $urunReferans
     * @param \ArrayType\ArrayOfClsDepozitoSeri $seriList
     */
    public function __construct($belgeTarihi = null, $tip = null, $yil = null, $referans = null, $matbuNo = null, $distReferans = null, $urunReferans = null, \ArrayType\ArrayOfClsDepozitoSeri $seriList = null)
    {
        $this
            ->setBelgeTarihi($belgeTarihi)
            ->setTip($tip)
            ->setYil($yil)
            ->setReferans($referans)
            ->setMatbuNo($matbuNo)
            ->setDistReferans($distReferans)
            ->setUrunReferans($urunReferans)
            ->setSeriList($seriList);
    }
    /**
     * Get BelgeTarihi value
     * @return string
     */
    public function getBelgeTarihi()
    {
        return $this->BelgeTarihi;
    }
    /**
     * Set BelgeTarihi value
     * @param string $belgeTarihi
     * @return \StructType\ClsDepozitoSeriIntegration
     */
    public function setBelgeTarihi($belgeTarihi = null)
    {
        // validation for constraint: string
        if (!is_null($belgeTarihi) && !is_string($belgeTarihi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($belgeTarihi, true), gettype($belgeTarihi)), __LINE__);
        }
        $this->BelgeTarihi = $belgeTarihi;
        return $this;
    }
    /**
     * Get Tip value
     * @return int
     */
    public function getTip()
    {
        return $this->Tip;
    }
    /**
     * Set Tip value
     * @param int $tip
     * @return \StructType\ClsDepozitoSeriIntegration
     */
    public function setTip($tip = null)
    {
        // validation for constraint: int
        if (!is_null($tip) && !(is_int($tip) || ctype_digit($tip))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($tip, true), gettype($tip)), __LINE__);
        }
        $this->Tip = $tip;
        return $this;
    }
    /**
     * Get Yil value
     * @return int
     */
    public function getYil()
    {
        return $this->Yil;
    }
    /**
     * Set Yil value
     * @param int $yil
     * @return \StructType\ClsDepozitoSeriIntegration
     */
    public function setYil($yil = null)
    {
        // validation for constraint: int
        if (!is_null($yil) && !(is_int($yil) || ctype_digit($yil))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($yil, true), gettype($yil)), __LINE__);
        }
        $this->Yil = $yil;
        return $this;
    }
    /**
     * Get Referans value
     * @return string|null
     */
    public function getReferans()
    {
        return $this->Referans;
    }
    /**
     * Set Referans value
     * @param string $referans
     * @return \StructType\ClsDepozitoSeriIntegration
     */
    public function setReferans($referans = null)
    {
        // validation for constraint: string
        if (!is_null($referans) && !is_string($referans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($referans, true), gettype($referans)), __LINE__);
        }
        $this->Referans = $referans;
        return $this;
    }
    /**
     * Get MatbuNo value
     * @return string|null
     */
    public function getMatbuNo()
    {
        return $this->MatbuNo;
    }
    /**
     * Set MatbuNo value
     * @param string $matbuNo
     * @return \StructType\ClsDepozitoSeriIntegration
     */
    public function setMatbuNo($matbuNo = null)
    {
        // validation for constraint: string
        if (!is_null($matbuNo) && !is_string($matbuNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($matbuNo, true), gettype($matbuNo)), __LINE__);
        }
        $this->MatbuNo = $matbuNo;
        return $this;
    }
    /**
     * Get DistReferans value
     * @return string|null
     */
    public function getDistReferans()
    {
        return $this->DistReferans;
    }
    /**
     * Set DistReferans value
     * @param string $distReferans
     * @return \StructType\ClsDepozitoSeriIntegration
     */
    public function setDistReferans($distReferans = null)
    {
        // validation for constraint: string
        if (!is_null($distReferans) && !is_string($distReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($distReferans, true), gettype($distReferans)), __LINE__);
        }
        $this->DistReferans = $distReferans;
        return $this;
    }
    /**
     * Get UrunReferans value
     * @return string|null
     */
    public function getUrunReferans()
    {
        return $this->UrunReferans;
    }
    /**
     * Set UrunReferans value
     * @param string $urunReferans
     * @return \StructType\ClsDepozitoSeriIntegration
     */
    public function setUrunReferans($urunReferans = null)
    {
        // validation for constraint: string
        if (!is_null($urunReferans) && !is_string($urunReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($urunReferans, true), gettype($urunReferans)), __LINE__);
        }
        $this->UrunReferans = $urunReferans;
        return $this;
    }
    /**
     * Get SeriList value
     * @return \ArrayType\ArrayOfClsDepozitoSeri|null
     */
    public function getSeriList()
    {
        return $this->SeriList;
    }
    /**
     * Set SeriList value
     * @param \ArrayType\ArrayOfClsDepozitoSeri $seriList
     * @return \StructType\ClsDepozitoSeriIntegration
     */
    public function setSeriList(\ArrayType\ArrayOfClsDepozitoSeri $seriList = null)
    {
        $this->SeriList = $seriList;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsDepozitoSeriIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
