<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsDisSistemBelgeAlanGuncelleme StructType
 * @subpackage Structs
 */
class ClsDisSistemBelgeAlanGuncelleme extends ClsEntity
{
    /**
     * The Belgetip
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Belgetip;
    /**
     * The BelgeKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $BelgeKod;
    /**
     * The Yil
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Yil;
    /**
     * The Durum
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Durum;
    /**
     * The Referans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Referans;
    /**
     * Constructor method for clsDisSistemBelgeAlanGuncelleme
     * @uses ClsDisSistemBelgeAlanGuncelleme::setBelgetip()
     * @uses ClsDisSistemBelgeAlanGuncelleme::setBelgeKod()
     * @uses ClsDisSistemBelgeAlanGuncelleme::setYil()
     * @uses ClsDisSistemBelgeAlanGuncelleme::setDurum()
     * @uses ClsDisSistemBelgeAlanGuncelleme::setReferans()
     * @param int $belgetip
     * @param int $belgeKod
     * @param int $yil
     * @param string $durum
     * @param string $referans
     */
    public function __construct($belgetip = null, $belgeKod = null, $yil = null, $durum = null, $referans = null)
    {
        $this
            ->setBelgetip($belgetip)
            ->setBelgeKod($belgeKod)
            ->setYil($yil)
            ->setDurum($durum)
            ->setReferans($referans);
    }
    /**
     * Get Belgetip value
     * @return int
     */
    public function getBelgetip()
    {
        return $this->Belgetip;
    }
    /**
     * Set Belgetip value
     * @param int $belgetip
     * @return \StructType\ClsDisSistemBelgeAlanGuncelleme
     */
    public function setBelgetip($belgetip = null)
    {
        // validation for constraint: int
        if (!is_null($belgetip) && !(is_int($belgetip) || ctype_digit($belgetip))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($belgetip, true), gettype($belgetip)), __LINE__);
        }
        $this->Belgetip = $belgetip;
        return $this;
    }
    /**
     * Get BelgeKod value
     * @return int
     */
    public function getBelgeKod()
    {
        return $this->BelgeKod;
    }
    /**
     * Set BelgeKod value
     * @param int $belgeKod
     * @return \StructType\ClsDisSistemBelgeAlanGuncelleme
     */
    public function setBelgeKod($belgeKod = null)
    {
        // validation for constraint: int
        if (!is_null($belgeKod) && !(is_int($belgeKod) || ctype_digit($belgeKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($belgeKod, true), gettype($belgeKod)), __LINE__);
        }
        $this->BelgeKod = $belgeKod;
        return $this;
    }
    /**
     * Get Yil value
     * @return int
     */
    public function getYil()
    {
        return $this->Yil;
    }
    /**
     * Set Yil value
     * @param int $yil
     * @return \StructType\ClsDisSistemBelgeAlanGuncelleme
     */
    public function setYil($yil = null)
    {
        // validation for constraint: int
        if (!is_null($yil) && !(is_int($yil) || ctype_digit($yil))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($yil, true), gettype($yil)), __LINE__);
        }
        $this->Yil = $yil;
        return $this;
    }
    /**
     * Get Durum value
     * @return string
     */
    public function getDurum()
    {
        return $this->Durum;
    }
    /**
     * Set Durum value
     * @param string $durum
     * @return \StructType\ClsDisSistemBelgeAlanGuncelleme
     */
    public function setDurum($durum = null)
    {
        // validation for constraint: string
        if (!is_null($durum) && !is_string($durum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($durum, true), gettype($durum)), __LINE__);
        }
        $this->Durum = $durum;
        return $this;
    }
    /**
     * Get Referans value
     * @return string|null
     */
    public function getReferans()
    {
        return $this->Referans;
    }
    /**
     * Set Referans value
     * @param string $referans
     * @return \StructType\ClsDisSistemBelgeAlanGuncelleme
     */
    public function setReferans($referans = null)
    {
        // validation for constraint: string
        if (!is_null($referans) && !is_string($referans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($referans, true), gettype($referans)), __LINE__);
        }
        $this->Referans = $referans;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsDisSistemBelgeAlanGuncelleme
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
