<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsDist StructType
 * @subpackage Structs
 */
class ClsDist extends ClsSharedDist
{
    /**
     * The PasifNeden
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $PasifNeden;
    /**
     * The MerkezDist
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $MerkezDist;
    /**
     * The VerSiparisi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $VerSiparisi;
    /**
     * The SonIslemTarihiVerSiparisi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $SonIslemTarihiVerSiparisi;
    /**
     * The AlisDistKrediLimit
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $AlisDistKrediLimit;
    /**
     * The Referans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Referans;
    /**
     * The SiparisYonlendirmeDist
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SiparisYonlendirmeDist;
    /**
     * The EMail2
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $EMail2;
    /**
     * The EMail3
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $EMail3;
    /**
     * The UrunSablon
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UrunSablon;
    /**
     * The AltBayilerList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfClsDistAltBayiler
     */
    public $AltBayilerList;
    /**
     * The UreticiYetkisi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UreticiYetkisi;
    /**
     * Constructor method for clsDist
     * @uses ClsDist::setPasifNeden()
     * @uses ClsDist::setMerkezDist()
     * @uses ClsDist::setVerSiparisi()
     * @uses ClsDist::setSonIslemTarihiVerSiparisi()
     * @uses ClsDist::setAlisDistKrediLimit()
     * @uses ClsDist::setReferans()
     * @uses ClsDist::setSiparisYonlendirmeDist()
     * @uses ClsDist::setEMail2()
     * @uses ClsDist::setEMail3()
     * @uses ClsDist::setUrunSablon()
     * @uses ClsDist::setAltBayilerList()
     * @uses ClsDist::setUreticiYetkisi()
     * @param int $pasifNeden
     * @param string $merkezDist
     * @param string $verSiparisi
     * @param string $sonIslemTarihiVerSiparisi
     * @param float $alisDistKrediLimit
     * @param string $referans
     * @param string $siparisYonlendirmeDist
     * @param string $eMail2
     * @param string $eMail3
     * @param string $urunSablon
     * @param \ArrayType\ArrayOfClsDistAltBayiler $altBayilerList
     * @param string $ureticiYetkisi
     */
    public function __construct($pasifNeden = null, $merkezDist = null, $verSiparisi = null, $sonIslemTarihiVerSiparisi = null, $alisDistKrediLimit = null, $referans = null, $siparisYonlendirmeDist = null, $eMail2 = null, $eMail3 = null, $urunSablon = null, \ArrayType\ArrayOfClsDistAltBayiler $altBayilerList = null, $ureticiYetkisi = null)
    {
        $this
            ->setPasifNeden($pasifNeden)
            ->setMerkezDist($merkezDist)
            ->setVerSiparisi($verSiparisi)
            ->setSonIslemTarihiVerSiparisi($sonIslemTarihiVerSiparisi)
            ->setAlisDistKrediLimit($alisDistKrediLimit)
            ->setReferans($referans)
            ->setSiparisYonlendirmeDist($siparisYonlendirmeDist)
            ->setEMail2($eMail2)
            ->setEMail3($eMail3)
            ->setUrunSablon($urunSablon)
            ->setAltBayilerList($altBayilerList)
            ->setUreticiYetkisi($ureticiYetkisi);
    }
    /**
     * Get PasifNeden value
     * @return int
     */
    public function getPasifNeden()
    {
        return $this->PasifNeden;
    }
    /**
     * Set PasifNeden value
     * @param int $pasifNeden
     * @return \StructType\ClsDist
     */
    public function setPasifNeden($pasifNeden = null)
    {
        // validation for constraint: int
        if (!is_null($pasifNeden) && !(is_int($pasifNeden) || ctype_digit($pasifNeden))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($pasifNeden, true), gettype($pasifNeden)), __LINE__);
        }
        $this->PasifNeden = $pasifNeden;
        return $this;
    }
    /**
     * Get MerkezDist value
     * @return string
     */
    public function getMerkezDist()
    {
        return $this->MerkezDist;
    }
    /**
     * Set MerkezDist value
     * @param string $merkezDist
     * @return \StructType\ClsDist
     */
    public function setMerkezDist($merkezDist = null)
    {
        // validation for constraint: string
        if (!is_null($merkezDist) && !is_string($merkezDist)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($merkezDist, true), gettype($merkezDist)), __LINE__);
        }
        $this->MerkezDist = $merkezDist;
        return $this;
    }
    /**
     * Get VerSiparisi value
     * @return string
     */
    public function getVerSiparisi()
    {
        return $this->VerSiparisi;
    }
    /**
     * Set VerSiparisi value
     * @param string $verSiparisi
     * @return \StructType\ClsDist
     */
    public function setVerSiparisi($verSiparisi = null)
    {
        // validation for constraint: string
        if (!is_null($verSiparisi) && !is_string($verSiparisi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($verSiparisi, true), gettype($verSiparisi)), __LINE__);
        }
        $this->VerSiparisi = $verSiparisi;
        return $this;
    }
    /**
     * Get SonIslemTarihiVerSiparisi value
     * @return string
     */
    public function getSonIslemTarihiVerSiparisi()
    {
        return $this->SonIslemTarihiVerSiparisi;
    }
    /**
     * Set SonIslemTarihiVerSiparisi value
     * @param string $sonIslemTarihiVerSiparisi
     * @return \StructType\ClsDist
     */
    public function setSonIslemTarihiVerSiparisi($sonIslemTarihiVerSiparisi = null)
    {
        // validation for constraint: string
        if (!is_null($sonIslemTarihiVerSiparisi) && !is_string($sonIslemTarihiVerSiparisi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonIslemTarihiVerSiparisi, true), gettype($sonIslemTarihiVerSiparisi)), __LINE__);
        }
        $this->SonIslemTarihiVerSiparisi = $sonIslemTarihiVerSiparisi;
        return $this;
    }
    /**
     * Get AlisDistKrediLimit value
     * @return float
     */
    public function getAlisDistKrediLimit()
    {
        return $this->AlisDistKrediLimit;
    }
    /**
     * Set AlisDistKrediLimit value
     * @param float $alisDistKrediLimit
     * @return \StructType\ClsDist
     */
    public function setAlisDistKrediLimit($alisDistKrediLimit = null)
    {
        // validation for constraint: float
        if (!is_null($alisDistKrediLimit) && !(is_float($alisDistKrediLimit) || is_numeric($alisDistKrediLimit))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($alisDistKrediLimit, true), gettype($alisDistKrediLimit)), __LINE__);
        }
        $this->AlisDistKrediLimit = $alisDistKrediLimit;
        return $this;
    }
    /**
     * Get Referans value
     * @return string|null
     */
    public function getReferans()
    {
        return $this->Referans;
    }
    /**
     * Set Referans value
     * @param string $referans
     * @return \StructType\ClsDist
     */
    public function setReferans($referans = null)
    {
        // validation for constraint: string
        if (!is_null($referans) && !is_string($referans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($referans, true), gettype($referans)), __LINE__);
        }
        $this->Referans = $referans;
        return $this;
    }
    /**
     * Get SiparisYonlendirmeDist value
     * @return string|null
     */
    public function getSiparisYonlendirmeDist()
    {
        return $this->SiparisYonlendirmeDist;
    }
    /**
     * Set SiparisYonlendirmeDist value
     * @param string $siparisYonlendirmeDist
     * @return \StructType\ClsDist
     */
    public function setSiparisYonlendirmeDist($siparisYonlendirmeDist = null)
    {
        // validation for constraint: string
        if (!is_null($siparisYonlendirmeDist) && !is_string($siparisYonlendirmeDist)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($siparisYonlendirmeDist, true), gettype($siparisYonlendirmeDist)), __LINE__);
        }
        $this->SiparisYonlendirmeDist = $siparisYonlendirmeDist;
        return $this;
    }
    /**
     * Get EMail2 value
     * @return string|null
     */
    public function getEMail2()
    {
        return $this->EMail2;
    }
    /**
     * Set EMail2 value
     * @param string $eMail2
     * @return \StructType\ClsDist
     */
    public function setEMail2($eMail2 = null)
    {
        // validation for constraint: string
        if (!is_null($eMail2) && !is_string($eMail2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eMail2, true), gettype($eMail2)), __LINE__);
        }
        $this->EMail2 = $eMail2;
        return $this;
    }
    /**
     * Get EMail3 value
     * @return string|null
     */
    public function getEMail3()
    {
        return $this->EMail3;
    }
    /**
     * Set EMail3 value
     * @param string $eMail3
     * @return \StructType\ClsDist
     */
    public function setEMail3($eMail3 = null)
    {
        // validation for constraint: string
        if (!is_null($eMail3) && !is_string($eMail3)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eMail3, true), gettype($eMail3)), __LINE__);
        }
        $this->EMail3 = $eMail3;
        return $this;
    }
    /**
     * Get UrunSablon value
     * @return string|null
     */
    public function getUrunSablon()
    {
        return $this->UrunSablon;
    }
    /**
     * Set UrunSablon value
     * @param string $urunSablon
     * @return \StructType\ClsDist
     */
    public function setUrunSablon($urunSablon = null)
    {
        // validation for constraint: string
        if (!is_null($urunSablon) && !is_string($urunSablon)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($urunSablon, true), gettype($urunSablon)), __LINE__);
        }
        $this->UrunSablon = $urunSablon;
        return $this;
    }
    /**
     * Get AltBayilerList value
     * @return \ArrayType\ArrayOfClsDistAltBayiler|null
     */
    public function getAltBayilerList()
    {
        return $this->AltBayilerList;
    }
    /**
     * Set AltBayilerList value
     * @param \ArrayType\ArrayOfClsDistAltBayiler $altBayilerList
     * @return \StructType\ClsDist
     */
    public function setAltBayilerList(\ArrayType\ArrayOfClsDistAltBayiler $altBayilerList = null)
    {
        $this->AltBayilerList = $altBayilerList;
        return $this;
    }
    /**
     * Get UreticiYetkisi value
     * @return string|null
     */
    public function getUreticiYetkisi()
    {
        return $this->UreticiYetkisi;
    }
    /**
     * Set UreticiYetkisi value
     * @param string $ureticiYetkisi
     * @return \StructType\ClsDist
     */
    public function setUreticiYetkisi($ureticiYetkisi = null)
    {
        // validation for constraint: string
        if (!is_null($ureticiYetkisi) && !is_string($ureticiYetkisi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ureticiYetkisi, true), gettype($ureticiYetkisi)), __LINE__);
        }
        $this->UreticiYetkisi = $ureticiYetkisi;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsDist
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
