<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsERTreeEPuanDocInfo StructType
 * @subpackage Structs
 */
class ClsERTreeEPuanDocInfo extends AbstractStructBase
{
    /**
     * The BelgeKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $BelgeKod;
    /**
     * The IskTutari
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $IskTutari;
    /**
     * The MusteriKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $MusteriKod;
    /**
     * The MusteriAd
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MusteriAd;
    /**
     * The DistAd
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DistAd;
    /**
     * The EPuanHarcamaList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfClsERTreeEPuanHarcamaInfo
     */
    public $EPuanHarcamaList;
    /**
     * The Aciklama
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Aciklama;
    /**
     * Constructor method for clsERTreeEPuanDocInfo
     * @uses ClsERTreeEPuanDocInfo::setBelgeKod()
     * @uses ClsERTreeEPuanDocInfo::setIskTutari()
     * @uses ClsERTreeEPuanDocInfo::setMusteriKod()
     * @uses ClsERTreeEPuanDocInfo::setMusteriAd()
     * @uses ClsERTreeEPuanDocInfo::setDistAd()
     * @uses ClsERTreeEPuanDocInfo::setEPuanHarcamaList()
     * @uses ClsERTreeEPuanDocInfo::setAciklama()
     * @param int $belgeKod
     * @param float $iskTutari
     * @param int $musteriKod
     * @param string $musteriAd
     * @param string $distAd
     * @param \ArrayType\ArrayOfClsERTreeEPuanHarcamaInfo $ePuanHarcamaList
     * @param string $aciklama
     */
    public function __construct($belgeKod = null, $iskTutari = null, $musteriKod = null, $musteriAd = null, $distAd = null, \ArrayType\ArrayOfClsERTreeEPuanHarcamaInfo $ePuanHarcamaList = null, $aciklama = null)
    {
        $this
            ->setBelgeKod($belgeKod)
            ->setIskTutari($iskTutari)
            ->setMusteriKod($musteriKod)
            ->setMusteriAd($musteriAd)
            ->setDistAd($distAd)
            ->setEPuanHarcamaList($ePuanHarcamaList)
            ->setAciklama($aciklama);
    }
    /**
     * Get BelgeKod value
     * @return int
     */
    public function getBelgeKod()
    {
        return $this->BelgeKod;
    }
    /**
     * Set BelgeKod value
     * @param int $belgeKod
     * @return \StructType\ClsERTreeEPuanDocInfo
     */
    public function setBelgeKod($belgeKod = null)
    {
        // validation for constraint: int
        if (!is_null($belgeKod) && !(is_int($belgeKod) || ctype_digit($belgeKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($belgeKod, true), gettype($belgeKod)), __LINE__);
        }
        $this->BelgeKod = $belgeKod;
        return $this;
    }
    /**
     * Get IskTutari value
     * @return float
     */
    public function getIskTutari()
    {
        return $this->IskTutari;
    }
    /**
     * Set IskTutari value
     * @param float $iskTutari
     * @return \StructType\ClsERTreeEPuanDocInfo
     */
    public function setIskTutari($iskTutari = null)
    {
        // validation for constraint: float
        if (!is_null($iskTutari) && !(is_float($iskTutari) || is_numeric($iskTutari))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($iskTutari, true), gettype($iskTutari)), __LINE__);
        }
        $this->IskTutari = $iskTutari;
        return $this;
    }
    /**
     * Get MusteriKod value
     * @return int
     */
    public function getMusteriKod()
    {
        return $this->MusteriKod;
    }
    /**
     * Set MusteriKod value
     * @param int $musteriKod
     * @return \StructType\ClsERTreeEPuanDocInfo
     */
    public function setMusteriKod($musteriKod = null)
    {
        // validation for constraint: int
        if (!is_null($musteriKod) && !(is_int($musteriKod) || ctype_digit($musteriKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($musteriKod, true), gettype($musteriKod)), __LINE__);
        }
        $this->MusteriKod = $musteriKod;
        return $this;
    }
    /**
     * Get MusteriAd value
     * @return string|null
     */
    public function getMusteriAd()
    {
        return $this->MusteriAd;
    }
    /**
     * Set MusteriAd value
     * @param string $musteriAd
     * @return \StructType\ClsERTreeEPuanDocInfo
     */
    public function setMusteriAd($musteriAd = null)
    {
        // validation for constraint: string
        if (!is_null($musteriAd) && !is_string($musteriAd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($musteriAd, true), gettype($musteriAd)), __LINE__);
        }
        $this->MusteriAd = $musteriAd;
        return $this;
    }
    /**
     * Get DistAd value
     * @return string|null
     */
    public function getDistAd()
    {
        return $this->DistAd;
    }
    /**
     * Set DistAd value
     * @param string $distAd
     * @return \StructType\ClsERTreeEPuanDocInfo
     */
    public function setDistAd($distAd = null)
    {
        // validation for constraint: string
        if (!is_null($distAd) && !is_string($distAd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($distAd, true), gettype($distAd)), __LINE__);
        }
        $this->DistAd = $distAd;
        return $this;
    }
    /**
     * Get EPuanHarcamaList value
     * @return \ArrayType\ArrayOfClsERTreeEPuanHarcamaInfo|null
     */
    public function getEPuanHarcamaList()
    {
        return $this->EPuanHarcamaList;
    }
    /**
     * Set EPuanHarcamaList value
     * @param \ArrayType\ArrayOfClsERTreeEPuanHarcamaInfo $ePuanHarcamaList
     * @return \StructType\ClsERTreeEPuanDocInfo
     */
    public function setEPuanHarcamaList(\ArrayType\ArrayOfClsERTreeEPuanHarcamaInfo $ePuanHarcamaList = null)
    {
        $this->EPuanHarcamaList = $ePuanHarcamaList;
        return $this;
    }
    /**
     * Get Aciklama value
     * @return string|null
     */
    public function getAciklama()
    {
        return $this->Aciklama;
    }
    /**
     * Set Aciklama value
     * @param string $aciklama
     * @return \StructType\ClsERTreeEPuanDocInfo
     */
    public function setAciklama($aciklama = null)
    {
        // validation for constraint: string
        if (!is_null($aciklama) && !is_string($aciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aciklama, true), gettype($aciklama)), __LINE__);
        }
        $this->Aciklama = $aciklama;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsERTreeEPuanDocInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
