<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsERTreeEPuanHarcamaInfo StructType
 * @subpackage Structs
 */
class ClsERTreeEPuanHarcamaInfo extends AbstractStructBase
{
    /**
     * The BelgeKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $BelgeKod;
    /**
     * The BonusTip
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $BonusTip;
    /**
     * The UrunList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInt
     */
    public $UrunList;
    /**
     * The EPuanHarcamaDetay
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ClsSharedBonusHarcama
     */
    public $EPuanHarcamaDetay;
    /**
     * The EPuanHarcamaAciklama
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $EPuanHarcamaAciklama;
    /**
     * Constructor method for clsERTreeEPuanHarcamaInfo
     * @uses ClsERTreeEPuanHarcamaInfo::setBelgeKod()
     * @uses ClsERTreeEPuanHarcamaInfo::setBonusTip()
     * @uses ClsERTreeEPuanHarcamaInfo::setUrunList()
     * @uses ClsERTreeEPuanHarcamaInfo::setEPuanHarcamaDetay()
     * @uses ClsERTreeEPuanHarcamaInfo::setEPuanHarcamaAciklama()
     * @param int $belgeKod
     * @param int $bonusTip
     * @param \ArrayType\ArrayOfInt $urunList
     * @param \StructType\ClsSharedBonusHarcama $ePuanHarcamaDetay
     * @param string $ePuanHarcamaAciklama
     */
    public function __construct($belgeKod = null, $bonusTip = null, \ArrayType\ArrayOfInt $urunList = null, \StructType\ClsSharedBonusHarcama $ePuanHarcamaDetay = null, $ePuanHarcamaAciklama = null)
    {
        $this
            ->setBelgeKod($belgeKod)
            ->setBonusTip($bonusTip)
            ->setUrunList($urunList)
            ->setEPuanHarcamaDetay($ePuanHarcamaDetay)
            ->setEPuanHarcamaAciklama($ePuanHarcamaAciklama);
    }
    /**
     * Get BelgeKod value
     * @return int
     */
    public function getBelgeKod()
    {
        return $this->BelgeKod;
    }
    /**
     * Set BelgeKod value
     * @param int $belgeKod
     * @return \StructType\ClsERTreeEPuanHarcamaInfo
     */
    public function setBelgeKod($belgeKod = null)
    {
        // validation for constraint: int
        if (!is_null($belgeKod) && !(is_int($belgeKod) || ctype_digit($belgeKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($belgeKod, true), gettype($belgeKod)), __LINE__);
        }
        $this->BelgeKod = $belgeKod;
        return $this;
    }
    /**
     * Get BonusTip value
     * @return int
     */
    public function getBonusTip()
    {
        return $this->BonusTip;
    }
    /**
     * Set BonusTip value
     * @param int $bonusTip
     * @return \StructType\ClsERTreeEPuanHarcamaInfo
     */
    public function setBonusTip($bonusTip = null)
    {
        // validation for constraint: int
        if (!is_null($bonusTip) && !(is_int($bonusTip) || ctype_digit($bonusTip))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($bonusTip, true), gettype($bonusTip)), __LINE__);
        }
        $this->BonusTip = $bonusTip;
        return $this;
    }
    /**
     * Get UrunList value
     * @return \ArrayType\ArrayOfInt|null
     */
    public function getUrunList()
    {
        return $this->UrunList;
    }
    /**
     * Set UrunList value
     * @param \ArrayType\ArrayOfInt $urunList
     * @return \StructType\ClsERTreeEPuanHarcamaInfo
     */
    public function setUrunList(\ArrayType\ArrayOfInt $urunList = null)
    {
        $this->UrunList = $urunList;
        return $this;
    }
    /**
     * Get EPuanHarcamaDetay value
     * @return \StructType\ClsSharedBonusHarcama|null
     */
    public function getEPuanHarcamaDetay()
    {
        return $this->EPuanHarcamaDetay;
    }
    /**
     * Set EPuanHarcamaDetay value
     * @param \StructType\ClsSharedBonusHarcama $ePuanHarcamaDetay
     * @return \StructType\ClsERTreeEPuanHarcamaInfo
     */
    public function setEPuanHarcamaDetay(\StructType\ClsSharedBonusHarcama $ePuanHarcamaDetay = null)
    {
        $this->EPuanHarcamaDetay = $ePuanHarcamaDetay;
        return $this;
    }
    /**
     * Get EPuanHarcamaAciklama value
     * @return string|null
     */
    public function getEPuanHarcamaAciklama()
    {
        return $this->EPuanHarcamaAciklama;
    }
    /**
     * Set EPuanHarcamaAciklama value
     * @param string $ePuanHarcamaAciklama
     * @return \StructType\ClsERTreeEPuanHarcamaInfo
     */
    public function setEPuanHarcamaAciklama($ePuanHarcamaAciklama = null)
    {
        // validation for constraint: string
        if (!is_null($ePuanHarcamaAciklama) && !is_string($ePuanHarcamaAciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ePuanHarcamaAciklama, true), gettype($ePuanHarcamaAciklama)), __LINE__);
        }
        $this->EPuanHarcamaAciklama = $ePuanHarcamaAciklama;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsERTreeEPuanHarcamaInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
