<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsIntegrationWebMethodResult StructType
 * @subpackage Structs
 */
class ClsIntegrationWebMethodResult extends AbstractStructBase
{
    /**
     * The IsSuccess
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsSuccess;
    /**
     * The ResultString
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ResultString;
    /**
     * The ResultByteArray
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ResultByteArray;
    /**
     * The ResultObject
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var mixed
     */
    public $ResultObject;
    /**
     * The Exc
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Exc;
    /**
     * The exMes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $exMes;
    /**
     * The errorLoglist
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfClsEntegrasyonLog
     */
    public $errorLoglist;
    /**
     * The pilotPanAdres
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $pilotPanAdres;
    /**
     * The PilotCikisFlag
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var mixed
     */
    public $PilotCikisFlag;
    /**
     * The WCFAdresPort
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $WCFAdresPort;
    /**
     * Constructor method for clsIntegrationWebMethodResult
     * @uses ClsIntegrationWebMethodResult::setIsSuccess()
     * @uses ClsIntegrationWebMethodResult::setResultString()
     * @uses ClsIntegrationWebMethodResult::setResultByteArray()
     * @uses ClsIntegrationWebMethodResult::setResultObject()
     * @uses ClsIntegrationWebMethodResult::setExc()
     * @uses ClsIntegrationWebMethodResult::setExMes()
     * @uses ClsIntegrationWebMethodResult::setErrorLoglist()
     * @uses ClsIntegrationWebMethodResult::setPilotPanAdres()
     * @uses ClsIntegrationWebMethodResult::setPilotCikisFlag()
     * @uses ClsIntegrationWebMethodResult::setWCFAdresPort()
     * @param bool $isSuccess
     * @param string $resultString
     * @param string $resultByteArray
     * @param mixed $resultObject
     * @param string $exc
     * @param string $exMes
     * @param \ArrayType\ArrayOfClsEntegrasyonLog $errorLoglist
     * @param string $pilotPanAdres
     * @param mixed $pilotCikisFlag
     * @param string $wCFAdresPort
     */
    public function __construct($isSuccess = null, $resultString = null, $resultByteArray = null, $resultObject = null, $exc = null, $exMes = null, \ArrayType\ArrayOfClsEntegrasyonLog $errorLoglist = null, $pilotPanAdres = null, $pilotCikisFlag = null, $wCFAdresPort = null)
    {
        $this
            ->setIsSuccess($isSuccess)
            ->setResultString($resultString)
            ->setResultByteArray($resultByteArray)
            ->setResultObject($resultObject)
            ->setExc($exc)
            ->setExMes($exMes)
            ->setErrorLoglist($errorLoglist)
            ->setPilotPanAdres($pilotPanAdres)
            ->setPilotCikisFlag($pilotCikisFlag)
            ->setWCFAdresPort($wCFAdresPort);
    }
    /**
     * Get IsSuccess value
     * @return bool
     */
    public function getIsSuccess()
    {
        return $this->IsSuccess;
    }
    /**
     * Set IsSuccess value
     * @param bool $isSuccess
     * @return \StructType\ClsIntegrationWebMethodResult
     */
    public function setIsSuccess($isSuccess = null)
    {
        // validation for constraint: boolean
        if (!is_null($isSuccess) && !is_bool($isSuccess)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isSuccess, true), gettype($isSuccess)), __LINE__);
        }
        $this->IsSuccess = $isSuccess;
        return $this;
    }
    /**
     * Get ResultString value
     * @return string|null
     */
    public function getResultString()
    {
        return $this->ResultString;
    }
    /**
     * Set ResultString value
     * @param string $resultString
     * @return \StructType\ClsIntegrationWebMethodResult
     */
    public function setResultString($resultString = null)
    {
        // validation for constraint: string
        if (!is_null($resultString) && !is_string($resultString)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($resultString, true), gettype($resultString)), __LINE__);
        }
        $this->ResultString = $resultString;
        return $this;
    }
    /**
     * Get ResultByteArray value
     * @return string|null
     */
    public function getResultByteArray()
    {
        return $this->ResultByteArray;
    }
    /**
     * Set ResultByteArray value
     * @param string $resultByteArray
     * @return \StructType\ClsIntegrationWebMethodResult
     */
    public function setResultByteArray($resultByteArray = null)
    {
        // validation for constraint: string
        if (!is_null($resultByteArray) && !is_string($resultByteArray)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($resultByteArray, true), gettype($resultByteArray)), __LINE__);
        }
        $this->ResultByteArray = $resultByteArray;
        return $this;
    }
    /**
     * Get ResultObject value
     * @return mixed|null
     */
    public function getResultObject()
    {
        return $this->ResultObject;
    }
    /**
     * Set ResultObject value
     * @param mixed $resultObject
     * @return \StructType\ClsIntegrationWebMethodResult
     */
    public function setResultObject($resultObject = null)
    {
        $this->ResultObject = $resultObject;
        return $this;
    }
    /**
     * Get Exc value
     * @return string|null
     */
    public function getExc()
    {
        return $this->Exc;
    }
    /**
     * Set Exc value
     * @param string $exc
     * @return \StructType\ClsIntegrationWebMethodResult
     */
    public function setExc($exc = null)
    {
        // validation for constraint: string
        if (!is_null($exc) && !is_string($exc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($exc, true), gettype($exc)), __LINE__);
        }
        $this->Exc = $exc;
        return $this;
    }
    /**
     * Get exMes value
     * @return string|null
     */
    public function getExMes()
    {
        return $this->exMes;
    }
    /**
     * Set exMes value
     * @param string $exMes
     * @return \StructType\ClsIntegrationWebMethodResult
     */
    public function setExMes($exMes = null)
    {
        // validation for constraint: string
        if (!is_null($exMes) && !is_string($exMes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($exMes, true), gettype($exMes)), __LINE__);
        }
        $this->exMes = $exMes;
        return $this;
    }
    /**
     * Get errorLoglist value
     * @return \ArrayType\ArrayOfClsEntegrasyonLog|null
     */
    public function getErrorLoglist()
    {
        return $this->errorLoglist;
    }
    /**
     * Set errorLoglist value
     * @param \ArrayType\ArrayOfClsEntegrasyonLog $errorLoglist
     * @return \StructType\ClsIntegrationWebMethodResult
     */
    public function setErrorLoglist(\ArrayType\ArrayOfClsEntegrasyonLog $errorLoglist = null)
    {
        $this->errorLoglist = $errorLoglist;
        return $this;
    }
    /**
     * Get pilotPanAdres value
     * @return string|null
     */
    public function getPilotPanAdres()
    {
        return $this->pilotPanAdres;
    }
    /**
     * Set pilotPanAdres value
     * @param string $pilotPanAdres
     * @return \StructType\ClsIntegrationWebMethodResult
     */
    public function setPilotPanAdres($pilotPanAdres = null)
    {
        // validation for constraint: string
        if (!is_null($pilotPanAdres) && !is_string($pilotPanAdres)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pilotPanAdres, true), gettype($pilotPanAdres)), __LINE__);
        }
        $this->pilotPanAdres = $pilotPanAdres;
        return $this;
    }
    /**
     * Get PilotCikisFlag value
     * @return mixed|null
     */
    public function getPilotCikisFlag()
    {
        return $this->PilotCikisFlag;
    }
    /**
     * Set PilotCikisFlag value
     * @param mixed $pilotCikisFlag
     * @return \StructType\ClsIntegrationWebMethodResult
     */
    public function setPilotCikisFlag($pilotCikisFlag = null)
    {
        $this->PilotCikisFlag = $pilotCikisFlag;
        return $this;
    }
    /**
     * Get WCFAdresPort value
     * @return string|null
     */
    public function getWCFAdresPort()
    {
        return $this->WCFAdresPort;
    }
    /**
     * Set WCFAdresPort value
     * @param string $wCFAdresPort
     * @return \StructType\ClsIntegrationWebMethodResult
     */
    public function setWCFAdresPort($wCFAdresPort = null)
    {
        // validation for constraint: string
        if (!is_null($wCFAdresPort) && !is_string($wCFAdresPort)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($wCFAdresPort, true), gettype($wCFAdresPort)), __LINE__);
        }
        $this->WCFAdresPort = $wCFAdresPort;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsIntegrationWebMethodResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
