<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsIptalBelge StructType
 * @subpackage Structs
 */
class ClsIptalBelge extends ClsEntity
{
    /**
     * The BelgeTip
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $BelgeTip;
    /**
     * The BelgeTur
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $BelgeTur;
    /**
     * The BelgeYil
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $BelgeYil;
    /**
     * The BelgeKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $BelgeKod;
    /**
     * The BagliBelgeIptalDurumu
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $BagliBelgeIptalDurumu;
    /**
     * The DistKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $DistKod;
    /**
     * The BelgeReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $BelgeReferans;
    /**
     * The DistTextKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DistTextKod;
    /**
     * The DistReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DistReferans;
    /**
     * Constructor method for clsIptalBelge
     * @uses ClsIptalBelge::setBelgeTip()
     * @uses ClsIptalBelge::setBelgeTur()
     * @uses ClsIptalBelge::setBelgeYil()
     * @uses ClsIptalBelge::setBelgeKod()
     * @uses ClsIptalBelge::setBagliBelgeIptalDurumu()
     * @uses ClsIptalBelge::setDistKod()
     * @uses ClsIptalBelge::setBelgeReferans()
     * @uses ClsIptalBelge::setDistTextKod()
     * @uses ClsIptalBelge::setDistReferans()
     * @param string $belgeTip
     * @param string $belgeTur
     * @param int $belgeYil
     * @param int $belgeKod
     * @param string $bagliBelgeIptalDurumu
     * @param int $distKod
     * @param string $belgeReferans
     * @param string $distTextKod
     * @param string $distReferans
     */
    public function __construct($belgeTip = null, $belgeTur = null, $belgeYil = null, $belgeKod = null, $bagliBelgeIptalDurumu = null, $distKod = null, $belgeReferans = null, $distTextKod = null, $distReferans = null)
    {
        $this
            ->setBelgeTip($belgeTip)
            ->setBelgeTur($belgeTur)
            ->setBelgeYil($belgeYil)
            ->setBelgeKod($belgeKod)
            ->setBagliBelgeIptalDurumu($bagliBelgeIptalDurumu)
            ->setDistKod($distKod)
            ->setBelgeReferans($belgeReferans)
            ->setDistTextKod($distTextKod)
            ->setDistReferans($distReferans);
    }
    /**
     * Get BelgeTip value
     * @return string
     */
    public function getBelgeTip()
    {
        return $this->BelgeTip;
    }
    /**
     * Set BelgeTip value
     * @param string $belgeTip
     * @return \StructType\ClsIptalBelge
     */
    public function setBelgeTip($belgeTip = null)
    {
        // validation for constraint: string
        if (!is_null($belgeTip) && !is_string($belgeTip)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($belgeTip, true), gettype($belgeTip)), __LINE__);
        }
        $this->BelgeTip = $belgeTip;
        return $this;
    }
    /**
     * Get BelgeTur value
     * @return string
     */
    public function getBelgeTur()
    {
        return $this->BelgeTur;
    }
    /**
     * Set BelgeTur value
     * @param string $belgeTur
     * @return \StructType\ClsIptalBelge
     */
    public function setBelgeTur($belgeTur = null)
    {
        // validation for constraint: string
        if (!is_null($belgeTur) && !is_string($belgeTur)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($belgeTur, true), gettype($belgeTur)), __LINE__);
        }
        $this->BelgeTur = $belgeTur;
        return $this;
    }
    /**
     * Get BelgeYil value
     * @return int
     */
    public function getBelgeYil()
    {
        return $this->BelgeYil;
    }
    /**
     * Set BelgeYil value
     * @param int $belgeYil
     * @return \StructType\ClsIptalBelge
     */
    public function setBelgeYil($belgeYil = null)
    {
        // validation for constraint: int
        if (!is_null($belgeYil) && !(is_int($belgeYil) || ctype_digit($belgeYil))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($belgeYil, true), gettype($belgeYil)), __LINE__);
        }
        $this->BelgeYil = $belgeYil;
        return $this;
    }
    /**
     * Get BelgeKod value
     * @return int
     */
    public function getBelgeKod()
    {
        return $this->BelgeKod;
    }
    /**
     * Set BelgeKod value
     * @param int $belgeKod
     * @return \StructType\ClsIptalBelge
     */
    public function setBelgeKod($belgeKod = null)
    {
        // validation for constraint: int
        if (!is_null($belgeKod) && !(is_int($belgeKod) || ctype_digit($belgeKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($belgeKod, true), gettype($belgeKod)), __LINE__);
        }
        $this->BelgeKod = $belgeKod;
        return $this;
    }
    /**
     * Get BagliBelgeIptalDurumu value
     * @return string
     */
    public function getBagliBelgeIptalDurumu()
    {
        return $this->BagliBelgeIptalDurumu;
    }
    /**
     * Set BagliBelgeIptalDurumu value
     * @param string $bagliBelgeIptalDurumu
     * @return \StructType\ClsIptalBelge
     */
    public function setBagliBelgeIptalDurumu($bagliBelgeIptalDurumu = null)
    {
        // validation for constraint: string
        if (!is_null($bagliBelgeIptalDurumu) && !is_string($bagliBelgeIptalDurumu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bagliBelgeIptalDurumu, true), gettype($bagliBelgeIptalDurumu)), __LINE__);
        }
        $this->BagliBelgeIptalDurumu = $bagliBelgeIptalDurumu;
        return $this;
    }
    /**
     * Get DistKod value
     * @return int
     */
    public function getDistKod()
    {
        return $this->DistKod;
    }
    /**
     * Set DistKod value
     * @param int $distKod
     * @return \StructType\ClsIptalBelge
     */
    public function setDistKod($distKod = null)
    {
        // validation for constraint: int
        if (!is_null($distKod) && !(is_int($distKod) || ctype_digit($distKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($distKod, true), gettype($distKod)), __LINE__);
        }
        $this->DistKod = $distKod;
        return $this;
    }
    /**
     * Get BelgeReferans value
     * @return string|null
     */
    public function getBelgeReferans()
    {
        return $this->BelgeReferans;
    }
    /**
     * Set BelgeReferans value
     * @param string $belgeReferans
     * @return \StructType\ClsIptalBelge
     */
    public function setBelgeReferans($belgeReferans = null)
    {
        // validation for constraint: string
        if (!is_null($belgeReferans) && !is_string($belgeReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($belgeReferans, true), gettype($belgeReferans)), __LINE__);
        }
        $this->BelgeReferans = $belgeReferans;
        return $this;
    }
    /**
     * Get DistTextKod value
     * @return string|null
     */
    public function getDistTextKod()
    {
        return $this->DistTextKod;
    }
    /**
     * Set DistTextKod value
     * @param string $distTextKod
     * @return \StructType\ClsIptalBelge
     */
    public function setDistTextKod($distTextKod = null)
    {
        // validation for constraint: string
        if (!is_null($distTextKod) && !is_string($distTextKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($distTextKod, true), gettype($distTextKod)), __LINE__);
        }
        $this->DistTextKod = $distTextKod;
        return $this;
    }
    /**
     * Get DistReferans value
     * @return string|null
     */
    public function getDistReferans()
    {
        return $this->DistReferans;
    }
    /**
     * Set DistReferans value
     * @param string $distReferans
     * @return \StructType\ClsIptalBelge
     */
    public function setDistReferans($distReferans = null)
    {
        // validation for constraint: string
        if (!is_null($distReferans) && !is_string($distReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($distReferans, true), gettype($distReferans)), __LINE__);
        }
        $this->DistReferans = $distReferans;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsIptalBelge
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
