<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsKullaniciIntegration StructType
 * @subpackage Structs
 */
class ClsKullaniciIntegration extends LoginUser
{
    /**
     * The LngDistKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $LngDistKod;
    /**
     * The KullaniciGrupKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $KullaniciGrupKod;
    /**
     * The Distkod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Distkod;
    /**
     * The DistReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DistReferans;
    /**
     * The Ceptelefon
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Ceptelefon;
    /**
     * The KullaniciGrupIsim
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $KullaniciGrupIsim;
    /**
     * The YonetimHiyerarsiTextKod1
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $YonetimHiyerarsiTextKod1;
    /**
     * Constructor method for clsKullaniciIntegration
     * @uses ClsKullaniciIntegration::setLngDistKod()
     * @uses ClsKullaniciIntegration::setKullaniciGrupKod()
     * @uses ClsKullaniciIntegration::setDistkod()
     * @uses ClsKullaniciIntegration::setDistReferans()
     * @uses ClsKullaniciIntegration::setCeptelefon()
     * @uses ClsKullaniciIntegration::setKullaniciGrupIsim()
     * @uses ClsKullaniciIntegration::setYonetimHiyerarsiTextKod1()
     * @param int $lngDistKod
     * @param int $kullaniciGrupKod
     * @param string $distkod
     * @param string $distReferans
     * @param string $ceptelefon
     * @param string $kullaniciGrupIsim
     * @param string $yonetimHiyerarsiTextKod1
     */
    public function __construct($lngDistKod = null, $kullaniciGrupKod = null, $distkod = null, $distReferans = null, $ceptelefon = null, $kullaniciGrupIsim = null, $yonetimHiyerarsiTextKod1 = null)
    {
        $this
            ->setLngDistKod($lngDistKod)
            ->setKullaniciGrupKod($kullaniciGrupKod)
            ->setDistkod($distkod)
            ->setDistReferans($distReferans)
            ->setCeptelefon($ceptelefon)
            ->setKullaniciGrupIsim($kullaniciGrupIsim)
            ->setYonetimHiyerarsiTextKod1($yonetimHiyerarsiTextKod1);
    }
    /**
     * Get LngDistKod value
     * @return int
     */
    public function getLngDistKod()
    {
        return $this->LngDistKod;
    }
    /**
     * Set LngDistKod value
     * @param int $lngDistKod
     * @return \StructType\ClsKullaniciIntegration
     */
    public function setLngDistKod($lngDistKod = null)
    {
        // validation for constraint: int
        if (!is_null($lngDistKod) && !(is_int($lngDistKod) || ctype_digit($lngDistKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($lngDistKod, true), gettype($lngDistKod)), __LINE__);
        }
        $this->LngDistKod = $lngDistKod;
        return $this;
    }
    /**
     * Get KullaniciGrupKod value
     * @return int
     */
    public function getKullaniciGrupKod()
    {
        return $this->KullaniciGrupKod;
    }
    /**
     * Set KullaniciGrupKod value
     * @param int $kullaniciGrupKod
     * @return \StructType\ClsKullaniciIntegration
     */
    public function setKullaniciGrupKod($kullaniciGrupKod = null)
    {
        // validation for constraint: int
        if (!is_null($kullaniciGrupKod) && !(is_int($kullaniciGrupKod) || ctype_digit($kullaniciGrupKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($kullaniciGrupKod, true), gettype($kullaniciGrupKod)), __LINE__);
        }
        $this->KullaniciGrupKod = $kullaniciGrupKod;
        return $this;
    }
    /**
     * Get Distkod value
     * @return string|null
     */
    public function getDistkod()
    {
        return $this->Distkod;
    }
    /**
     * Set Distkod value
     * @param string $distkod
     * @return \StructType\ClsKullaniciIntegration
     */
    public function setDistkod($distkod = null)
    {
        // validation for constraint: string
        if (!is_null($distkod) && !is_string($distkod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($distkod, true), gettype($distkod)), __LINE__);
        }
        $this->Distkod = $distkod;
        return $this;
    }
    /**
     * Get DistReferans value
     * @return string|null
     */
    public function getDistReferans()
    {
        return $this->DistReferans;
    }
    /**
     * Set DistReferans value
     * @param string $distReferans
     * @return \StructType\ClsKullaniciIntegration
     */
    public function setDistReferans($distReferans = null)
    {
        // validation for constraint: string
        if (!is_null($distReferans) && !is_string($distReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($distReferans, true), gettype($distReferans)), __LINE__);
        }
        $this->DistReferans = $distReferans;
        return $this;
    }
    /**
     * Get Ceptelefon value
     * @return string|null
     */
    public function getCeptelefon()
    {
        return $this->Ceptelefon;
    }
    /**
     * Set Ceptelefon value
     * @param string $ceptelefon
     * @return \StructType\ClsKullaniciIntegration
     */
    public function setCeptelefon($ceptelefon = null)
    {
        // validation for constraint: string
        if (!is_null($ceptelefon) && !is_string($ceptelefon)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ceptelefon, true), gettype($ceptelefon)), __LINE__);
        }
        $this->Ceptelefon = $ceptelefon;
        return $this;
    }
    /**
     * Get KullaniciGrupIsim value
     * @return string|null
     */
    public function getKullaniciGrupIsim()
    {
        return $this->KullaniciGrupIsim;
    }
    /**
     * Set KullaniciGrupIsim value
     * @param string $kullaniciGrupIsim
     * @return \StructType\ClsKullaniciIntegration
     */
    public function setKullaniciGrupIsim($kullaniciGrupIsim = null)
    {
        // validation for constraint: string
        if (!is_null($kullaniciGrupIsim) && !is_string($kullaniciGrupIsim)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kullaniciGrupIsim, true), gettype($kullaniciGrupIsim)), __LINE__);
        }
        $this->KullaniciGrupIsim = $kullaniciGrupIsim;
        return $this;
    }
    /**
     * Get YonetimHiyerarsiTextKod1 value
     * @return string|null
     */
    public function getYonetimHiyerarsiTextKod1()
    {
        return $this->YonetimHiyerarsiTextKod1;
    }
    /**
     * Set YonetimHiyerarsiTextKod1 value
     * @param string $yonetimHiyerarsiTextKod1
     * @return \StructType\ClsKullaniciIntegration
     */
    public function setYonetimHiyerarsiTextKod1($yonetimHiyerarsiTextKod1 = null)
    {
        // validation for constraint: string
        if (!is_null($yonetimHiyerarsiTextKod1) && !is_string($yonetimHiyerarsiTextKod1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($yonetimHiyerarsiTextKod1, true), gettype($yonetimHiyerarsiTextKod1)), __LINE__);
        }
        $this->YonetimHiyerarsiTextKod1 = $yonetimHiyerarsiTextKod1;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsKullaniciIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
