<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsMailKriter StructType
 * @subpackage Structs
 */
class ClsMailKriter extends AbstractStructBase
{
    /**
     * The SendSocialPost
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $SendSocialPost;
    /**
     * The strRaporFileName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $strRaporFileName;
    /**
     * The objRaporBody
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $objRaporBody;
    /**
     * The Konu
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Konu;
    /**
     * The Kimden
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Kimden;
    /**
     * The Kime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $Kime;
    /**
     * The Bcc
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $Bcc;
    /**
     * The Cc
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $Cc;
    /**
     * The SmtpHost
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SmtpHost;
    /**
     * The SmtpUser
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SmtpUser;
    /**
     * The SmtpPassword
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SmtpPassword;
    /**
     * The Port
     * Meta information extracted from the WSDL
     * - default: 22
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $Port;
    /**
     * The SSL
     * Meta information extracted from the WSDL
     * - default: false
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $SSL;
    /**
     * The EklentiIsimler
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $EklentiIsimler;
    /**
     * The EklentiDosyaYolu
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $EklentiDosyaYolu;
    /**
     * Constructor method for clsMailKriter
     * @uses ClsMailKriter::setSendSocialPost()
     * @uses ClsMailKriter::setStrRaporFileName()
     * @uses ClsMailKriter::setObjRaporBody()
     * @uses ClsMailKriter::setKonu()
     * @uses ClsMailKriter::setKimden()
     * @uses ClsMailKriter::setKime()
     * @uses ClsMailKriter::setBcc()
     * @uses ClsMailKriter::setCc()
     * @uses ClsMailKriter::setSmtpHost()
     * @uses ClsMailKriter::setSmtpUser()
     * @uses ClsMailKriter::setSmtpPassword()
     * @uses ClsMailKriter::setPort()
     * @uses ClsMailKriter::setSSL()
     * @uses ClsMailKriter::setEklentiIsimler()
     * @uses ClsMailKriter::setEklentiDosyaYolu()
     * @param bool $sendSocialPost
     * @param string $strRaporFileName
     * @param string $objRaporBody
     * @param string $konu
     * @param string $kimden
     * @param \ArrayType\ArrayOfString $kime
     * @param \ArrayType\ArrayOfString $bcc
     * @param \ArrayType\ArrayOfString $cc
     * @param string $smtpHost
     * @param string $smtpUser
     * @param string $smtpPassword
     * @param int $port
     * @param bool $sSL
     * @param \ArrayType\ArrayOfString $eklentiIsimler
     * @param \ArrayType\ArrayOfString $eklentiDosyaYolu
     */
    public function __construct($sendSocialPost = null, $strRaporFileName = null, $objRaporBody = null, $konu = null, $kimden = null, \ArrayType\ArrayOfString $kime = null, \ArrayType\ArrayOfString $bcc = null, \ArrayType\ArrayOfString $cc = null, $smtpHost = null, $smtpUser = null, $smtpPassword = null, $port = 22, $sSL = false, \ArrayType\ArrayOfString $eklentiIsimler = null, \ArrayType\ArrayOfString $eklentiDosyaYolu = null)
    {
        $this
            ->setSendSocialPost($sendSocialPost)
            ->setStrRaporFileName($strRaporFileName)
            ->setObjRaporBody($objRaporBody)
            ->setKonu($konu)
            ->setKimden($kimden)
            ->setKime($kime)
            ->setBcc($bcc)
            ->setCc($cc)
            ->setSmtpHost($smtpHost)
            ->setSmtpUser($smtpUser)
            ->setSmtpPassword($smtpPassword)
            ->setPort($port)
            ->setSSL($sSL)
            ->setEklentiIsimler($eklentiIsimler)
            ->setEklentiDosyaYolu($eklentiDosyaYolu);
    }
    /**
     * Get SendSocialPost value
     * @return bool
     */
    public function getSendSocialPost()
    {
        return $this->SendSocialPost;
    }
    /**
     * Set SendSocialPost value
     * @param bool $sendSocialPost
     * @return \StructType\ClsMailKriter
     */
    public function setSendSocialPost($sendSocialPost = null)
    {
        // validation for constraint: boolean
        if (!is_null($sendSocialPost) && !is_bool($sendSocialPost)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sendSocialPost, true), gettype($sendSocialPost)), __LINE__);
        }
        $this->SendSocialPost = $sendSocialPost;
        return $this;
    }
    /**
     * Get strRaporFileName value
     * @return string|null
     */
    public function getStrRaporFileName()
    {
        return $this->strRaporFileName;
    }
    /**
     * Set strRaporFileName value
     * @param string $strRaporFileName
     * @return \StructType\ClsMailKriter
     */
    public function setStrRaporFileName($strRaporFileName = null)
    {
        // validation for constraint: string
        if (!is_null($strRaporFileName) && !is_string($strRaporFileName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($strRaporFileName, true), gettype($strRaporFileName)), __LINE__);
        }
        $this->strRaporFileName = $strRaporFileName;
        return $this;
    }
    /**
     * Get objRaporBody value
     * @return string|null
     */
    public function getObjRaporBody()
    {
        return $this->objRaporBody;
    }
    /**
     * Set objRaporBody value
     * @param string $objRaporBody
     * @return \StructType\ClsMailKriter
     */
    public function setObjRaporBody($objRaporBody = null)
    {
        // validation for constraint: string
        if (!is_null($objRaporBody) && !is_string($objRaporBody)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($objRaporBody, true), gettype($objRaporBody)), __LINE__);
        }
        $this->objRaporBody = $objRaporBody;
        return $this;
    }
    /**
     * Get Konu value
     * @return string|null
     */
    public function getKonu()
    {
        return $this->Konu;
    }
    /**
     * Set Konu value
     * @param string $konu
     * @return \StructType\ClsMailKriter
     */
    public function setKonu($konu = null)
    {
        // validation for constraint: string
        if (!is_null($konu) && !is_string($konu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($konu, true), gettype($konu)), __LINE__);
        }
        $this->Konu = $konu;
        return $this;
    }
    /**
     * Get Kimden value
     * @return string|null
     */
    public function getKimden()
    {
        return $this->Kimden;
    }
    /**
     * Set Kimden value
     * @param string $kimden
     * @return \StructType\ClsMailKriter
     */
    public function setKimden($kimden = null)
    {
        // validation for constraint: string
        if (!is_null($kimden) && !is_string($kimden)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kimden, true), gettype($kimden)), __LINE__);
        }
        $this->Kimden = $kimden;
        return $this;
    }
    /**
     * Get Kime value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getKime()
    {
        return $this->Kime;
    }
    /**
     * Set Kime value
     * @param \ArrayType\ArrayOfString $kime
     * @return \StructType\ClsMailKriter
     */
    public function setKime(\ArrayType\ArrayOfString $kime = null)
    {
        $this->Kime = $kime;
        return $this;
    }
    /**
     * Get Bcc value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getBcc()
    {
        return $this->Bcc;
    }
    /**
     * Set Bcc value
     * @param \ArrayType\ArrayOfString $bcc
     * @return \StructType\ClsMailKriter
     */
    public function setBcc(\ArrayType\ArrayOfString $bcc = null)
    {
        $this->Bcc = $bcc;
        return $this;
    }
    /**
     * Get Cc value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getCc()
    {
        return $this->Cc;
    }
    /**
     * Set Cc value
     * @param \ArrayType\ArrayOfString $cc
     * @return \StructType\ClsMailKriter
     */
    public function setCc(\ArrayType\ArrayOfString $cc = null)
    {
        $this->Cc = $cc;
        return $this;
    }
    /**
     * Get SmtpHost value
     * @return string|null
     */
    public function getSmtpHost()
    {
        return $this->SmtpHost;
    }
    /**
     * Set SmtpHost value
     * @param string $smtpHost
     * @return \StructType\ClsMailKriter
     */
    public function setSmtpHost($smtpHost = null)
    {
        // validation for constraint: string
        if (!is_null($smtpHost) && !is_string($smtpHost)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($smtpHost, true), gettype($smtpHost)), __LINE__);
        }
        $this->SmtpHost = $smtpHost;
        return $this;
    }
    /**
     * Get SmtpUser value
     * @return string|null
     */
    public function getSmtpUser()
    {
        return $this->SmtpUser;
    }
    /**
     * Set SmtpUser value
     * @param string $smtpUser
     * @return \StructType\ClsMailKriter
     */
    public function setSmtpUser($smtpUser = null)
    {
        // validation for constraint: string
        if (!is_null($smtpUser) && !is_string($smtpUser)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($smtpUser, true), gettype($smtpUser)), __LINE__);
        }
        $this->SmtpUser = $smtpUser;
        return $this;
    }
    /**
     * Get SmtpPassword value
     * @return string|null
     */
    public function getSmtpPassword()
    {
        return $this->SmtpPassword;
    }
    /**
     * Set SmtpPassword value
     * @param string $smtpPassword
     * @return \StructType\ClsMailKriter
     */
    public function setSmtpPassword($smtpPassword = null)
    {
        // validation for constraint: string
        if (!is_null($smtpPassword) && !is_string($smtpPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($smtpPassword, true), gettype($smtpPassword)), __LINE__);
        }
        $this->SmtpPassword = $smtpPassword;
        return $this;
    }
    /**
     * Get Port value
     * @return int|null
     */
    public function getPort()
    {
        return $this->Port;
    }
    /**
     * Set Port value
     * @param int $port
     * @return \StructType\ClsMailKriter
     */
    public function setPort($port = 22)
    {
        // validation for constraint: int
        if (!is_null($port) && !(is_int($port) || ctype_digit($port))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($port, true), gettype($port)), __LINE__);
        }
        $this->Port = $port;
        return $this;
    }
    /**
     * Get SSL value
     * @return bool|null
     */
    public function getSSL()
    {
        return $this->SSL;
    }
    /**
     * Set SSL value
     * @param bool $sSL
     * @return \StructType\ClsMailKriter
     */
    public function setSSL($sSL = false)
    {
        // validation for constraint: boolean
        if (!is_null($sSL) && !is_bool($sSL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sSL, true), gettype($sSL)), __LINE__);
        }
        $this->SSL = $sSL;
        return $this;
    }
    /**
     * Get EklentiIsimler value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getEklentiIsimler()
    {
        return $this->EklentiIsimler;
    }
    /**
     * Set EklentiIsimler value
     * @param \ArrayType\ArrayOfString $eklentiIsimler
     * @return \StructType\ClsMailKriter
     */
    public function setEklentiIsimler(\ArrayType\ArrayOfString $eklentiIsimler = null)
    {
        $this->EklentiIsimler = $eklentiIsimler;
        return $this;
    }
    /**
     * Get EklentiDosyaYolu value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getEklentiDosyaYolu()
    {
        return $this->EklentiDosyaYolu;
    }
    /**
     * Set EklentiDosyaYolu value
     * @param \ArrayType\ArrayOfString $eklentiDosyaYolu
     * @return \StructType\ClsMailKriter
     */
    public function setEklentiDosyaYolu(\ArrayType\ArrayOfString $eklentiDosyaYolu = null)
    {
        $this->EklentiDosyaYolu = $eklentiDosyaYolu;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsMailKriter
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
