<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsMesajIntegration StructType
 * @subpackage Structs
 */
class ClsMesajIntegration extends ClsMesaj
{
    /**
     * The DistIntegrationKriterTip
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $DistIntegrationKriterTip;
    /**
     * The MusteriIntegrationKriterTip
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $MusteriIntegrationKriterTip;
    /**
     * The STIntegrationKriterTip
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $STIntegrationKriterTip;
    /**
     * The UrunIntegrationKriterTip
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $UrunIntegrationKriterTip;
    /**
     * The DistTextKriter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DistTextKriter;
    /**
     * The MusteriTextKriter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MusteriTextKriter;
    /**
     * The STTextKriter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $STTextKriter;
    /**
     * The UrunTextKriter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UrunTextKriter;
    /**
     * Constructor method for clsMesajIntegration
     * @uses ClsMesajIntegration::setDistIntegrationKriterTip()
     * @uses ClsMesajIntegration::setMusteriIntegrationKriterTip()
     * @uses ClsMesajIntegration::setSTIntegrationKriterTip()
     * @uses ClsMesajIntegration::setUrunIntegrationKriterTip()
     * @uses ClsMesajIntegration::setDistTextKriter()
     * @uses ClsMesajIntegration::setMusteriTextKriter()
     * @uses ClsMesajIntegration::setSTTextKriter()
     * @uses ClsMesajIntegration::setUrunTextKriter()
     * @param int $distIntegrationKriterTip
     * @param int $musteriIntegrationKriterTip
     * @param int $sTIntegrationKriterTip
     * @param int $urunIntegrationKriterTip
     * @param string $distTextKriter
     * @param string $musteriTextKriter
     * @param string $sTTextKriter
     * @param string $urunTextKriter
     */
    public function __construct($distIntegrationKriterTip = null, $musteriIntegrationKriterTip = null, $sTIntegrationKriterTip = null, $urunIntegrationKriterTip = null, $distTextKriter = null, $musteriTextKriter = null, $sTTextKriter = null, $urunTextKriter = null)
    {
        $this
            ->setDistIntegrationKriterTip($distIntegrationKriterTip)
            ->setMusteriIntegrationKriterTip($musteriIntegrationKriterTip)
            ->setSTIntegrationKriterTip($sTIntegrationKriterTip)
            ->setUrunIntegrationKriterTip($urunIntegrationKriterTip)
            ->setDistTextKriter($distTextKriter)
            ->setMusteriTextKriter($musteriTextKriter)
            ->setSTTextKriter($sTTextKriter)
            ->setUrunTextKriter($urunTextKriter);
    }
    /**
     * Get DistIntegrationKriterTip value
     * @return int
     */
    public function getDistIntegrationKriterTip()
    {
        return $this->DistIntegrationKriterTip;
    }
    /**
     * Set DistIntegrationKriterTip value
     * @param int $distIntegrationKriterTip
     * @return \StructType\ClsMesajIntegration
     */
    public function setDistIntegrationKriterTip($distIntegrationKriterTip = null)
    {
        // validation for constraint: int
        if (!is_null($distIntegrationKriterTip) && !(is_int($distIntegrationKriterTip) || ctype_digit($distIntegrationKriterTip))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($distIntegrationKriterTip, true), gettype($distIntegrationKriterTip)), __LINE__);
        }
        $this->DistIntegrationKriterTip = $distIntegrationKriterTip;
        return $this;
    }
    /**
     * Get MusteriIntegrationKriterTip value
     * @return int
     */
    public function getMusteriIntegrationKriterTip()
    {
        return $this->MusteriIntegrationKriterTip;
    }
    /**
     * Set MusteriIntegrationKriterTip value
     * @param int $musteriIntegrationKriterTip
     * @return \StructType\ClsMesajIntegration
     */
    public function setMusteriIntegrationKriterTip($musteriIntegrationKriterTip = null)
    {
        // validation for constraint: int
        if (!is_null($musteriIntegrationKriterTip) && !(is_int($musteriIntegrationKriterTip) || ctype_digit($musteriIntegrationKriterTip))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($musteriIntegrationKriterTip, true), gettype($musteriIntegrationKriterTip)), __LINE__);
        }
        $this->MusteriIntegrationKriterTip = $musteriIntegrationKriterTip;
        return $this;
    }
    /**
     * Get STIntegrationKriterTip value
     * @return int
     */
    public function getSTIntegrationKriterTip()
    {
        return $this->STIntegrationKriterTip;
    }
    /**
     * Set STIntegrationKriterTip value
     * @param int $sTIntegrationKriterTip
     * @return \StructType\ClsMesajIntegration
     */
    public function setSTIntegrationKriterTip($sTIntegrationKriterTip = null)
    {
        // validation for constraint: int
        if (!is_null($sTIntegrationKriterTip) && !(is_int($sTIntegrationKriterTip) || ctype_digit($sTIntegrationKriterTip))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sTIntegrationKriterTip, true), gettype($sTIntegrationKriterTip)), __LINE__);
        }
        $this->STIntegrationKriterTip = $sTIntegrationKriterTip;
        return $this;
    }
    /**
     * Get UrunIntegrationKriterTip value
     * @return int
     */
    public function getUrunIntegrationKriterTip()
    {
        return $this->UrunIntegrationKriterTip;
    }
    /**
     * Set UrunIntegrationKriterTip value
     * @param int $urunIntegrationKriterTip
     * @return \StructType\ClsMesajIntegration
     */
    public function setUrunIntegrationKriterTip($urunIntegrationKriterTip = null)
    {
        // validation for constraint: int
        if (!is_null($urunIntegrationKriterTip) && !(is_int($urunIntegrationKriterTip) || ctype_digit($urunIntegrationKriterTip))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($urunIntegrationKriterTip, true), gettype($urunIntegrationKriterTip)), __LINE__);
        }
        $this->UrunIntegrationKriterTip = $urunIntegrationKriterTip;
        return $this;
    }
    /**
     * Get DistTextKriter value
     * @return string|null
     */
    public function getDistTextKriter()
    {
        return $this->DistTextKriter;
    }
    /**
     * Set DistTextKriter value
     * @param string $distTextKriter
     * @return \StructType\ClsMesajIntegration
     */
    public function setDistTextKriter($distTextKriter = null)
    {
        // validation for constraint: string
        if (!is_null($distTextKriter) && !is_string($distTextKriter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($distTextKriter, true), gettype($distTextKriter)), __LINE__);
        }
        $this->DistTextKriter = $distTextKriter;
        return $this;
    }
    /**
     * Get MusteriTextKriter value
     * @return string|null
     */
    public function getMusteriTextKriter()
    {
        return $this->MusteriTextKriter;
    }
    /**
     * Set MusteriTextKriter value
     * @param string $musteriTextKriter
     * @return \StructType\ClsMesajIntegration
     */
    public function setMusteriTextKriter($musteriTextKriter = null)
    {
        // validation for constraint: string
        if (!is_null($musteriTextKriter) && !is_string($musteriTextKriter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($musteriTextKriter, true), gettype($musteriTextKriter)), __LINE__);
        }
        $this->MusteriTextKriter = $musteriTextKriter;
        return $this;
    }
    /**
     * Get STTextKriter value
     * @return string|null
     */
    public function getSTTextKriter()
    {
        return $this->STTextKriter;
    }
    /**
     * Set STTextKriter value
     * @param string $sTTextKriter
     * @return \StructType\ClsMesajIntegration
     */
    public function setSTTextKriter($sTTextKriter = null)
    {
        // validation for constraint: string
        if (!is_null($sTTextKriter) && !is_string($sTTextKriter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sTTextKriter, true), gettype($sTTextKriter)), __LINE__);
        }
        $this->STTextKriter = $sTTextKriter;
        return $this;
    }
    /**
     * Get UrunTextKriter value
     * @return string|null
     */
    public function getUrunTextKriter()
    {
        return $this->UrunTextKriter;
    }
    /**
     * Set UrunTextKriter value
     * @param string $urunTextKriter
     * @return \StructType\ClsMesajIntegration
     */
    public function setUrunTextKriter($urunTextKriter = null)
    {
        // validation for constraint: string
        if (!is_null($urunTextKriter) && !is_string($urunTextKriter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($urunTextKriter, true), gettype($urunTextKriter)), __LINE__);
        }
        $this->UrunTextKriter = $urunTextKriter;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsMesajIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
