<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsMusteriBakiye StructType
 * @subpackage Structs
 */
class ClsMusteriBakiye extends ClsSharedMusteriBakiye
{
    /**
     * The AyAlacak
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $AyAlacak;
    /**
     * The AyBorc
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $AyBorc;
    /**
     * The AyBakiye
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $AyBakiye;
    /**
     * The AyCiro
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $AyCiro;
    /**
     * The Ay
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Ay;
    /**
     * The BorcAlacakBilgi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $BorcAlacakBilgi;
    /**
     * Constructor method for clsMusteriBakiye
     * @uses ClsMusteriBakiye::setAyAlacak()
     * @uses ClsMusteriBakiye::setAyBorc()
     * @uses ClsMusteriBakiye::setAyBakiye()
     * @uses ClsMusteriBakiye::setAyCiro()
     * @uses ClsMusteriBakiye::setAy()
     * @uses ClsMusteriBakiye::setBorcAlacakBilgi()
     * @param float $ayAlacak
     * @param float $ayBorc
     * @param float $ayBakiye
     * @param float $ayCiro
     * @param string $ay
     * @param string $borcAlacakBilgi
     */
    public function __construct($ayAlacak = null, $ayBorc = null, $ayBakiye = null, $ayCiro = null, $ay = null, $borcAlacakBilgi = null)
    {
        $this
            ->setAyAlacak($ayAlacak)
            ->setAyBorc($ayBorc)
            ->setAyBakiye($ayBakiye)
            ->setAyCiro($ayCiro)
            ->setAy($ay)
            ->setBorcAlacakBilgi($borcAlacakBilgi);
    }
    /**
     * Get AyAlacak value
     * @return float
     */
    public function getAyAlacak()
    {
        return $this->AyAlacak;
    }
    /**
     * Set AyAlacak value
     * @param float $ayAlacak
     * @return \StructType\ClsMusteriBakiye
     */
    public function setAyAlacak($ayAlacak = null)
    {
        // validation for constraint: float
        if (!is_null($ayAlacak) && !(is_float($ayAlacak) || is_numeric($ayAlacak))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($ayAlacak, true), gettype($ayAlacak)), __LINE__);
        }
        $this->AyAlacak = $ayAlacak;
        return $this;
    }
    /**
     * Get AyBorc value
     * @return float
     */
    public function getAyBorc()
    {
        return $this->AyBorc;
    }
    /**
     * Set AyBorc value
     * @param float $ayBorc
     * @return \StructType\ClsMusteriBakiye
     */
    public function setAyBorc($ayBorc = null)
    {
        // validation for constraint: float
        if (!is_null($ayBorc) && !(is_float($ayBorc) || is_numeric($ayBorc))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($ayBorc, true), gettype($ayBorc)), __LINE__);
        }
        $this->AyBorc = $ayBorc;
        return $this;
    }
    /**
     * Get AyBakiye value
     * @return float
     */
    public function getAyBakiye()
    {
        return $this->AyBakiye;
    }
    /**
     * Set AyBakiye value
     * @param float $ayBakiye
     * @return \StructType\ClsMusteriBakiye
     */
    public function setAyBakiye($ayBakiye = null)
    {
        // validation for constraint: float
        if (!is_null($ayBakiye) && !(is_float($ayBakiye) || is_numeric($ayBakiye))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($ayBakiye, true), gettype($ayBakiye)), __LINE__);
        }
        $this->AyBakiye = $ayBakiye;
        return $this;
    }
    /**
     * Get AyCiro value
     * @return float
     */
    public function getAyCiro()
    {
        return $this->AyCiro;
    }
    /**
     * Set AyCiro value
     * @param float $ayCiro
     * @return \StructType\ClsMusteriBakiye
     */
    public function setAyCiro($ayCiro = null)
    {
        // validation for constraint: float
        if (!is_null($ayCiro) && !(is_float($ayCiro) || is_numeric($ayCiro))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($ayCiro, true), gettype($ayCiro)), __LINE__);
        }
        $this->AyCiro = $ayCiro;
        return $this;
    }
    /**
     * Get Ay value
     * @return string|null
     */
    public function getAy()
    {
        return $this->Ay;
    }
    /**
     * Set Ay value
     * @param string $ay
     * @return \StructType\ClsMusteriBakiye
     */
    public function setAy($ay = null)
    {
        // validation for constraint: string
        if (!is_null($ay) && !is_string($ay)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ay, true), gettype($ay)), __LINE__);
        }
        $this->Ay = $ay;
        return $this;
    }
    /**
     * Get BorcAlacakBilgi value
     * @return string|null
     */
    public function getBorcAlacakBilgi()
    {
        return $this->BorcAlacakBilgi;
    }
    /**
     * Set BorcAlacakBilgi value
     * @param string $borcAlacakBilgi
     * @return \StructType\ClsMusteriBakiye
     */
    public function setBorcAlacakBilgi($borcAlacakBilgi = null)
    {
        // validation for constraint: string
        if (!is_null($borcAlacakBilgi) && !is_string($borcAlacakBilgi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($borcAlacakBilgi, true), gettype($borcAlacakBilgi)), __LINE__);
        }
        $this->BorcAlacakBilgi = $borcAlacakBilgi;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsMusteriBakiye
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
