<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsMusteriDurumIntegration StructType
 * @subpackage Structs
 */
class ClsMusteriDurumIntegration extends ClsEntity
{
    /**
     * The MusteriLngKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $MusteriLngKod;
    /**
     * The Durum
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $Durum;
    /**
     * The IptalNeden
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $IptalNeden;
    /**
     * The KapanisTarihi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $KapanisTarihi;
    /**
     * The MusteriKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MusteriKod;
    /**
     * The MusteriReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MusteriReferans;
    /**
     * The IptalAciklama
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $IptalAciklama;
    /**
     * Constructor method for clsMusteriDurumIntegration
     * @uses ClsMusteriDurumIntegration::setMusteriLngKod()
     * @uses ClsMusteriDurumIntegration::setDurum()
     * @uses ClsMusteriDurumIntegration::setIptalNeden()
     * @uses ClsMusteriDurumIntegration::setKapanisTarihi()
     * @uses ClsMusteriDurumIntegration::setMusteriKod()
     * @uses ClsMusteriDurumIntegration::setMusteriReferans()
     * @uses ClsMusteriDurumIntegration::setIptalAciklama()
     * @param int $musteriLngKod
     * @param string $durum
     * @param int $iptalNeden
     * @param string $kapanisTarihi
     * @param string $musteriKod
     * @param string $musteriReferans
     * @param string $iptalAciklama
     */
    public function __construct($musteriLngKod = null, $durum = null, $iptalNeden = null, $kapanisTarihi = null, $musteriKod = null, $musteriReferans = null, $iptalAciklama = null)
    {
        $this
            ->setMusteriLngKod($musteriLngKod)
            ->setDurum($durum)
            ->setIptalNeden($iptalNeden)
            ->setKapanisTarihi($kapanisTarihi)
            ->setMusteriKod($musteriKod)
            ->setMusteriReferans($musteriReferans)
            ->setIptalAciklama($iptalAciklama);
    }
    /**
     * Get MusteriLngKod value
     * @return int
     */
    public function getMusteriLngKod()
    {
        return $this->MusteriLngKod;
    }
    /**
     * Set MusteriLngKod value
     * @param int $musteriLngKod
     * @return \StructType\ClsMusteriDurumIntegration
     */
    public function setMusteriLngKod($musteriLngKod = null)
    {
        // validation for constraint: int
        if (!is_null($musteriLngKod) && !(is_int($musteriLngKod) || ctype_digit($musteriLngKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($musteriLngKod, true), gettype($musteriLngKod)), __LINE__);
        }
        $this->MusteriLngKod = $musteriLngKod;
        return $this;
    }
    /**
     * Get Durum value
     * @return string
     */
    public function getDurum()
    {
        return $this->Durum;
    }
    /**
     * Set Durum value
     * @param string $durum
     * @return \StructType\ClsMusteriDurumIntegration
     */
    public function setDurum($durum = null)
    {
        // validation for constraint: string
        if (!is_null($durum) && !is_string($durum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($durum, true), gettype($durum)), __LINE__);
        }
        $this->Durum = $durum;
        return $this;
    }
    /**
     * Get IptalNeden value
     * @return int
     */
    public function getIptalNeden()
    {
        return $this->IptalNeden;
    }
    /**
     * Set IptalNeden value
     * @param int $iptalNeden
     * @return \StructType\ClsMusteriDurumIntegration
     */
    public function setIptalNeden($iptalNeden = null)
    {
        // validation for constraint: int
        if (!is_null($iptalNeden) && !(is_int($iptalNeden) || ctype_digit($iptalNeden))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($iptalNeden, true), gettype($iptalNeden)), __LINE__);
        }
        $this->IptalNeden = $iptalNeden;
        return $this;
    }
    /**
     * Get KapanisTarihi value
     * @return string
     */
    public function getKapanisTarihi()
    {
        return $this->KapanisTarihi;
    }
    /**
     * Set KapanisTarihi value
     * @param string $kapanisTarihi
     * @return \StructType\ClsMusteriDurumIntegration
     */
    public function setKapanisTarihi($kapanisTarihi = null)
    {
        // validation for constraint: string
        if (!is_null($kapanisTarihi) && !is_string($kapanisTarihi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kapanisTarihi, true), gettype($kapanisTarihi)), __LINE__);
        }
        $this->KapanisTarihi = $kapanisTarihi;
        return $this;
    }
    /**
     * Get MusteriKod value
     * @return string|null
     */
    public function getMusteriKod()
    {
        return $this->MusteriKod;
    }
    /**
     * Set MusteriKod value
     * @param string $musteriKod
     * @return \StructType\ClsMusteriDurumIntegration
     */
    public function setMusteriKod($musteriKod = null)
    {
        // validation for constraint: string
        if (!is_null($musteriKod) && !is_string($musteriKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($musteriKod, true), gettype($musteriKod)), __LINE__);
        }
        $this->MusteriKod = $musteriKod;
        return $this;
    }
    /**
     * Get MusteriReferans value
     * @return string|null
     */
    public function getMusteriReferans()
    {
        return $this->MusteriReferans;
    }
    /**
     * Set MusteriReferans value
     * @param string $musteriReferans
     * @return \StructType\ClsMusteriDurumIntegration
     */
    public function setMusteriReferans($musteriReferans = null)
    {
        // validation for constraint: string
        if (!is_null($musteriReferans) && !is_string($musteriReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($musteriReferans, true), gettype($musteriReferans)), __LINE__);
        }
        $this->MusteriReferans = $musteriReferans;
        return $this;
    }
    /**
     * Get IptalAciklama value
     * @return string|null
     */
    public function getIptalAciklama()
    {
        return $this->IptalAciklama;
    }
    /**
     * Set IptalAciklama value
     * @param string $iptalAciklama
     * @return \StructType\ClsMusteriDurumIntegration
     */
    public function setIptalAciklama($iptalAciklama = null)
    {
        // validation for constraint: string
        if (!is_null($iptalAciklama) && !is_string($iptalAciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iptalAciklama, true), gettype($iptalAciklama)), __LINE__);
        }
        $this->IptalAciklama = $iptalAciklama;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsMusteriDurumIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
