<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsMusteriEkSaha StructType
 * @subpackage Structs
 */
class ClsMusteriEkSaha extends ClsEntity
{
    /**
     * The MusteriRef
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $MusteriRef;
    /**
     * The DistKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $DistKod;
    /**
     * The EkSahaKodu
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $EkSahaKodu;
    /**
     * The SonIslemTarihi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $SonIslemTarihi;
    /**
     * The Ilkislemtarihi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $Ilkislemtarihi;
    /**
     * The Ilkkullanicikod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $Ilkkullanicikod;
    /**
     * The Sonkullanicikod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $Sonkullanicikod;
    /**
     * The EkSahaAciklama
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $EkSahaAciklama;
    /**
     * The EkSahaOldAciklama
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $EkSahaOldAciklama;
    /**
     * Constructor method for clsMusteriEkSaha
     * @uses ClsMusteriEkSaha::setMusteriRef()
     * @uses ClsMusteriEkSaha::setDistKod()
     * @uses ClsMusteriEkSaha::setEkSahaKodu()
     * @uses ClsMusteriEkSaha::setSonIslemTarihi()
     * @uses ClsMusteriEkSaha::setIlkislemtarihi()
     * @uses ClsMusteriEkSaha::setIlkkullanicikod()
     * @uses ClsMusteriEkSaha::setSonkullanicikod()
     * @uses ClsMusteriEkSaha::setEkSahaAciklama()
     * @uses ClsMusteriEkSaha::setEkSahaOldAciklama()
     * @param int $musteriRef
     * @param int $distKod
     * @param int $ekSahaKodu
     * @param string $sonIslemTarihi
     * @param string $ilkislemtarihi
     * @param int $ilkkullanicikod
     * @param int $sonkullanicikod
     * @param string $ekSahaAciklama
     * @param string $ekSahaOldAciklama
     */
    public function __construct($musteriRef = null, $distKod = null, $ekSahaKodu = null, $sonIslemTarihi = null, $ilkislemtarihi = null, $ilkkullanicikod = null, $sonkullanicikod = null, $ekSahaAciklama = null, $ekSahaOldAciklama = null)
    {
        $this
            ->setMusteriRef($musteriRef)
            ->setDistKod($distKod)
            ->setEkSahaKodu($ekSahaKodu)
            ->setSonIslemTarihi($sonIslemTarihi)
            ->setIlkislemtarihi($ilkislemtarihi)
            ->setIlkkullanicikod($ilkkullanicikod)
            ->setSonkullanicikod($sonkullanicikod)
            ->setEkSahaAciklama($ekSahaAciklama)
            ->setEkSahaOldAciklama($ekSahaOldAciklama);
    }
    /**
     * Get MusteriRef value
     * @return int
     */
    public function getMusteriRef()
    {
        return $this->MusteriRef;
    }
    /**
     * Set MusteriRef value
     * @param int $musteriRef
     * @return \StructType\ClsMusteriEkSaha
     */
    public function setMusteriRef($musteriRef = null)
    {
        // validation for constraint: int
        if (!is_null($musteriRef) && !(is_int($musteriRef) || ctype_digit($musteriRef))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($musteriRef, true), gettype($musteriRef)), __LINE__);
        }
        $this->MusteriRef = $musteriRef;
        return $this;
    }
    /**
     * Get DistKod value
     * @return int
     */
    public function getDistKod()
    {
        return $this->DistKod;
    }
    /**
     * Set DistKod value
     * @param int $distKod
     * @return \StructType\ClsMusteriEkSaha
     */
    public function setDistKod($distKod = null)
    {
        // validation for constraint: int
        if (!is_null($distKod) && !(is_int($distKod) || ctype_digit($distKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($distKod, true), gettype($distKod)), __LINE__);
        }
        $this->DistKod = $distKod;
        return $this;
    }
    /**
     * Get EkSahaKodu value
     * @return int
     */
    public function getEkSahaKodu()
    {
        return $this->EkSahaKodu;
    }
    /**
     * Set EkSahaKodu value
     * @param int $ekSahaKodu
     * @return \StructType\ClsMusteriEkSaha
     */
    public function setEkSahaKodu($ekSahaKodu = null)
    {
        // validation for constraint: int
        if (!is_null($ekSahaKodu) && !(is_int($ekSahaKodu) || ctype_digit($ekSahaKodu))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($ekSahaKodu, true), gettype($ekSahaKodu)), __LINE__);
        }
        $this->EkSahaKodu = $ekSahaKodu;
        return $this;
    }
    /**
     * Get SonIslemTarihi value
     * @return string
     */
    public function getSonIslemTarihi()
    {
        return $this->SonIslemTarihi;
    }
    /**
     * Set SonIslemTarihi value
     * @param string $sonIslemTarihi
     * @return \StructType\ClsMusteriEkSaha
     */
    public function setSonIslemTarihi($sonIslemTarihi = null)
    {
        // validation for constraint: string
        if (!is_null($sonIslemTarihi) && !is_string($sonIslemTarihi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonIslemTarihi, true), gettype($sonIslemTarihi)), __LINE__);
        }
        $this->SonIslemTarihi = $sonIslemTarihi;
        return $this;
    }
    /**
     * Get Ilkislemtarihi value
     * @return string
     */
    public function getIlkislemtarihi()
    {
        return $this->Ilkislemtarihi;
    }
    /**
     * Set Ilkislemtarihi value
     * @param string $ilkislemtarihi
     * @return \StructType\ClsMusteriEkSaha
     */
    public function setIlkislemtarihi($ilkislemtarihi = null)
    {
        // validation for constraint: string
        if (!is_null($ilkislemtarihi) && !is_string($ilkislemtarihi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ilkislemtarihi, true), gettype($ilkislemtarihi)), __LINE__);
        }
        $this->Ilkislemtarihi = $ilkislemtarihi;
        return $this;
    }
    /**
     * Get Ilkkullanicikod value
     * @return int
     */
    public function getIlkkullanicikod()
    {
        return $this->Ilkkullanicikod;
    }
    /**
     * Set Ilkkullanicikod value
     * @param int $ilkkullanicikod
     * @return \StructType\ClsMusteriEkSaha
     */
    public function setIlkkullanicikod($ilkkullanicikod = null)
    {
        // validation for constraint: int
        if (!is_null($ilkkullanicikod) && !(is_int($ilkkullanicikod) || ctype_digit($ilkkullanicikod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($ilkkullanicikod, true), gettype($ilkkullanicikod)), __LINE__);
        }
        $this->Ilkkullanicikod = $ilkkullanicikod;
        return $this;
    }
    /**
     * Get Sonkullanicikod value
     * @return int
     */
    public function getSonkullanicikod()
    {
        return $this->Sonkullanicikod;
    }
    /**
     * Set Sonkullanicikod value
     * @param int $sonkullanicikod
     * @return \StructType\ClsMusteriEkSaha
     */
    public function setSonkullanicikod($sonkullanicikod = null)
    {
        // validation for constraint: int
        if (!is_null($sonkullanicikod) && !(is_int($sonkullanicikod) || ctype_digit($sonkullanicikod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sonkullanicikod, true), gettype($sonkullanicikod)), __LINE__);
        }
        $this->Sonkullanicikod = $sonkullanicikod;
        return $this;
    }
    /**
     * Get EkSahaAciklama value
     * @return string|null
     */
    public function getEkSahaAciklama()
    {
        return $this->EkSahaAciklama;
    }
    /**
     * Set EkSahaAciklama value
     * @param string $ekSahaAciklama
     * @return \StructType\ClsMusteriEkSaha
     */
    public function setEkSahaAciklama($ekSahaAciklama = null)
    {
        // validation for constraint: string
        if (!is_null($ekSahaAciklama) && !is_string($ekSahaAciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ekSahaAciklama, true), gettype($ekSahaAciklama)), __LINE__);
        }
        $this->EkSahaAciklama = $ekSahaAciklama;
        return $this;
    }
    /**
     * Get EkSahaOldAciklama value
     * @return string|null
     */
    public function getEkSahaOldAciklama()
    {
        return $this->EkSahaOldAciklama;
    }
    /**
     * Set EkSahaOldAciklama value
     * @param string $ekSahaOldAciklama
     * @return \StructType\ClsMusteriEkSaha
     */
    public function setEkSahaOldAciklama($ekSahaOldAciklama = null)
    {
        // validation for constraint: string
        if (!is_null($ekSahaOldAciklama) && !is_string($ekSahaOldAciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ekSahaOldAciklama, true), gettype($ekSahaOldAciklama)), __LINE__);
        }
        $this->EkSahaOldAciklama = $ekSahaOldAciklama;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsMusteriEkSaha
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
