<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsMusteriSevkAdresIntegration StructType
 * @subpackage Structs
 */
class ClsMusteriSevkAdresIntegration extends ClsMusteriSevkAdres
{
    /**
     * The LngDistKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $LngDistKod;
    /**
     * The Durum
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Durum;
    /**
     * The Distkod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Distkod;
    /**
     * The DistReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DistReferans;
    /**
     * The MusteriTextKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MusteriTextKod;
    /**
     * The MusteriReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MusteriReferans;
    /**
     * Constructor method for clsMusteriSevkAdresIntegration
     * @uses ClsMusteriSevkAdresIntegration::setLngDistKod()
     * @uses ClsMusteriSevkAdresIntegration::setDurum()
     * @uses ClsMusteriSevkAdresIntegration::setDistkod()
     * @uses ClsMusteriSevkAdresIntegration::setDistReferans()
     * @uses ClsMusteriSevkAdresIntegration::setMusteriTextKod()
     * @uses ClsMusteriSevkAdresIntegration::setMusteriReferans()
     * @param int $lngDistKod
     * @param string $durum
     * @param string $distkod
     * @param string $distReferans
     * @param string $musteriTextKod
     * @param string $musteriReferans
     */
    public function __construct($lngDistKod = null, $durum = null, $distkod = null, $distReferans = null, $musteriTextKod = null, $musteriReferans = null)
    {
        $this
            ->setLngDistKod($lngDistKod)
            ->setDurum($durum)
            ->setDistkod($distkod)
            ->setDistReferans($distReferans)
            ->setMusteriTextKod($musteriTextKod)
            ->setMusteriReferans($musteriReferans);
    }
    /**
     * Get LngDistKod value
     * @return int
     */
    public function getLngDistKod()
    {
        return $this->LngDistKod;
    }
    /**
     * Set LngDistKod value
     * @param int $lngDistKod
     * @return \StructType\ClsMusteriSevkAdresIntegration
     */
    public function setLngDistKod($lngDistKod = null)
    {
        // validation for constraint: int
        if (!is_null($lngDistKod) && !(is_int($lngDistKod) || ctype_digit($lngDistKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($lngDistKod, true), gettype($lngDistKod)), __LINE__);
        }
        $this->LngDistKod = $lngDistKod;
        return $this;
    }
    /**
     * Get Durum value
     * @return string
     */
    public function getDurum()
    {
        return $this->Durum;
    }
    /**
     * Set Durum value
     * @param string $durum
     * @return \StructType\ClsMusteriSevkAdresIntegration
     */
    public function setDurum($durum = null)
    {
        // validation for constraint: string
        if (!is_null($durum) && !is_string($durum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($durum, true), gettype($durum)), __LINE__);
        }
        $this->Durum = $durum;
        return $this;
    }
    /**
     * Get Distkod value
     * @return string|null
     */
    public function getDistkod()
    {
        return $this->Distkod;
    }
    /**
     * Set Distkod value
     * @param string $distkod
     * @return \StructType\ClsMusteriSevkAdresIntegration
     */
    public function setDistkod($distkod = null)
    {
        // validation for constraint: string
        if (!is_null($distkod) && !is_string($distkod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($distkod, true), gettype($distkod)), __LINE__);
        }
        $this->Distkod = $distkod;
        return $this;
    }
    /**
     * Get DistReferans value
     * @return string|null
     */
    public function getDistReferans()
    {
        return $this->DistReferans;
    }
    /**
     * Set DistReferans value
     * @param string $distReferans
     * @return \StructType\ClsMusteriSevkAdresIntegration
     */
    public function setDistReferans($distReferans = null)
    {
        // validation for constraint: string
        if (!is_null($distReferans) && !is_string($distReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($distReferans, true), gettype($distReferans)), __LINE__);
        }
        $this->DistReferans = $distReferans;
        return $this;
    }
    /**
     * Get MusteriTextKod value
     * @return string|null
     */
    public function getMusteriTextKod()
    {
        return $this->MusteriTextKod;
    }
    /**
     * Set MusteriTextKod value
     * @param string $musteriTextKod
     * @return \StructType\ClsMusteriSevkAdresIntegration
     */
    public function setMusteriTextKod($musteriTextKod = null)
    {
        // validation for constraint: string
        if (!is_null($musteriTextKod) && !is_string($musteriTextKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($musteriTextKod, true), gettype($musteriTextKod)), __LINE__);
        }
        $this->MusteriTextKod = $musteriTextKod;
        return $this;
    }
    /**
     * Get MusteriReferans value
     * @return string|null
     */
    public function getMusteriReferans()
    {
        return $this->MusteriReferans;
    }
    /**
     * Set MusteriReferans value
     * @param string $musteriReferans
     * @return \StructType\ClsMusteriSevkAdresIntegration
     */
    public function setMusteriReferans($musteriReferans = null)
    {
        // validation for constraint: string
        if (!is_null($musteriReferans) && !is_string($musteriReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($musteriReferans, true), gettype($musteriReferans)), __LINE__);
        }
        $this->MusteriReferans = $musteriReferans;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsMusteriSevkAdresIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
