<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsMutabakatLogIntegration StructType
 * @subpackage Structs
 */
class ClsMutabakatLogIntegration extends ClsFaturaGeneric
{
    /**
     * The Kod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $Kod;
    /**
     * The DetayToplamNetTutar
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $DetayToplamNetTutar;
    /**
     * Constructor method for clsMutabakatLogIntegration
     * @uses ClsMutabakatLogIntegration::setKod()
     * @uses ClsMutabakatLogIntegration::setDetayToplamNetTutar()
     * @param int $kod
     * @param float $detayToplamNetTutar
     */
    public function __construct($kod = null, $detayToplamNetTutar = null)
    {
        $this
            ->setKod($kod)
            ->setDetayToplamNetTutar($detayToplamNetTutar);
    }
    /**
     * Get Kod value
     * @return int
     */
    public function getKod()
    {
        return $this->Kod;
    }
    /**
     * Set Kod value
     * @param int $kod
     * @return \StructType\ClsMutabakatLogIntegration
     */
    public function setKod($kod = null)
    {
        // validation for constraint: int
        if (!is_null($kod) && !(is_int($kod) || ctype_digit($kod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($kod, true), gettype($kod)), __LINE__);
        }
        $this->Kod = $kod;
        return $this;
    }
    /**
     * Get DetayToplamNetTutar value
     * @return float
     */
    public function getDetayToplamNetTutar()
    {
        return $this->DetayToplamNetTutar;
    }
    /**
     * Set DetayToplamNetTutar value
     * @param float $detayToplamNetTutar
     * @return \StructType\ClsMutabakatLogIntegration
     */
    public function setDetayToplamNetTutar($detayToplamNetTutar = null)
    {
        // validation for constraint: float
        if (!is_null($detayToplamNetTutar) && !(is_float($detayToplamNetTutar) || is_numeric($detayToplamNetTutar))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($detayToplamNetTutar, true), gettype($detayToplamNetTutar)), __LINE__);
        }
        $this->DetayToplamNetTutar = $detayToplamNetTutar;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsMutabakatLogIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
