<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsPaketTabloDetay StructType
 * @subpackage Structs
 */
class ClsPaketTabloDetay extends ClsEntity
{
    /**
     * The Paketkod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $Paketkod;
    /**
     * The Inout
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $Inout;
    /**
     * The Sonislemtarihi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $Sonislemtarihi;
    /**
     * The Kolonad
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Kolonad;
    /**
     * The Sonislemhost
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Sonislemhost;
    /**
     * Constructor method for clsPaketTabloDetay
     * @uses ClsPaketTabloDetay::setPaketkod()
     * @uses ClsPaketTabloDetay::setInout()
     * @uses ClsPaketTabloDetay::setSonislemtarihi()
     * @uses ClsPaketTabloDetay::setKolonad()
     * @uses ClsPaketTabloDetay::setSonislemhost()
     * @param int $paketkod
     * @param string $inout
     * @param string $sonislemtarihi
     * @param string $kolonad
     * @param string $sonislemhost
     */
    public function __construct($paketkod = null, $inout = null, $sonislemtarihi = null, $kolonad = null, $sonislemhost = null)
    {
        $this
            ->setPaketkod($paketkod)
            ->setInout($inout)
            ->setSonislemtarihi($sonislemtarihi)
            ->setKolonad($kolonad)
            ->setSonislemhost($sonislemhost);
    }
    /**
     * Get Paketkod value
     * @return int
     */
    public function getPaketkod()
    {
        return $this->Paketkod;
    }
    /**
     * Set Paketkod value
     * @param int $paketkod
     * @return \StructType\ClsPaketTabloDetay
     */
    public function setPaketkod($paketkod = null)
    {
        // validation for constraint: int
        if (!is_null($paketkod) && !(is_int($paketkod) || ctype_digit($paketkod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($paketkod, true), gettype($paketkod)), __LINE__);
        }
        $this->Paketkod = $paketkod;
        return $this;
    }
    /**
     * Get Inout value
     * @return string
     */
    public function getInout()
    {
        return $this->Inout;
    }
    /**
     * Set Inout value
     * @param string $inout
     * @return \StructType\ClsPaketTabloDetay
     */
    public function setInout($inout = null)
    {
        // validation for constraint: string
        if (!is_null($inout) && !is_string($inout)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($inout, true), gettype($inout)), __LINE__);
        }
        $this->Inout = $inout;
        return $this;
    }
    /**
     * Get Sonislemtarihi value
     * @return string
     */
    public function getSonislemtarihi()
    {
        return $this->Sonislemtarihi;
    }
    /**
     * Set Sonislemtarihi value
     * @param string $sonislemtarihi
     * @return \StructType\ClsPaketTabloDetay
     */
    public function setSonislemtarihi($sonislemtarihi = null)
    {
        // validation for constraint: string
        if (!is_null($sonislemtarihi) && !is_string($sonislemtarihi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonislemtarihi, true), gettype($sonislemtarihi)), __LINE__);
        }
        $this->Sonislemtarihi = $sonislemtarihi;
        return $this;
    }
    /**
     * Get Kolonad value
     * @return string|null
     */
    public function getKolonad()
    {
        return $this->Kolonad;
    }
    /**
     * Set Kolonad value
     * @param string $kolonad
     * @return \StructType\ClsPaketTabloDetay
     */
    public function setKolonad($kolonad = null)
    {
        // validation for constraint: string
        if (!is_null($kolonad) && !is_string($kolonad)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kolonad, true), gettype($kolonad)), __LINE__);
        }
        $this->Kolonad = $kolonad;
        return $this;
    }
    /**
     * Get Sonislemhost value
     * @return string|null
     */
    public function getSonislemhost()
    {
        return $this->Sonislemhost;
    }
    /**
     * Set Sonislemhost value
     * @param string $sonislemhost
     * @return \StructType\ClsPaketTabloDetay
     */
    public function setSonislemhost($sonislemhost = null)
    {
        // validation for constraint: string
        if (!is_null($sonislemhost) && !is_string($sonislemhost)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonislemhost, true), gettype($sonislemhost)), __LINE__);
        }
        $this->Sonislemhost = $sonislemhost;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsPaketTabloDetay
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
