<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsPaketTanim StructType
 * @subpackage Structs
 */
class ClsPaketTanim extends ClsEntity
{
    /**
     * The Kod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $Kod;
    /**
     * The Yon
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $Yon;
    /**
     * The Durum
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $Durum;
    /**
     * The Tabloadi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Tabloadi;
    /**
     * The Viewadi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Viewadi;
    /**
     * The Kriter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Kriter;
    /**
     * The Version
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Version;
    /**
     * Constructor method for clsPaketTanim
     * @uses ClsPaketTanim::setKod()
     * @uses ClsPaketTanim::setYon()
     * @uses ClsPaketTanim::setDurum()
     * @uses ClsPaketTanim::setTabloadi()
     * @uses ClsPaketTanim::setViewadi()
     * @uses ClsPaketTanim::setKriter()
     * @uses ClsPaketTanim::setVersion()
     * @param int $kod
     * @param string $yon
     * @param string $durum
     * @param string $tabloadi
     * @param string $viewadi
     * @param string $kriter
     * @param string $version
     */
    public function __construct($kod = null, $yon = null, $durum = null, $tabloadi = null, $viewadi = null, $kriter = null, $version = null)
    {
        $this
            ->setKod($kod)
            ->setYon($yon)
            ->setDurum($durum)
            ->setTabloadi($tabloadi)
            ->setViewadi($viewadi)
            ->setKriter($kriter)
            ->setVersion($version);
    }
    /**
     * Get Kod value
     * @return int
     */
    public function getKod()
    {
        return $this->Kod;
    }
    /**
     * Set Kod value
     * @param int $kod
     * @return \StructType\ClsPaketTanim
     */
    public function setKod($kod = null)
    {
        // validation for constraint: int
        if (!is_null($kod) && !(is_int($kod) || ctype_digit($kod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($kod, true), gettype($kod)), __LINE__);
        }
        $this->Kod = $kod;
        return $this;
    }
    /**
     * Get Yon value
     * @return string
     */
    public function getYon()
    {
        return $this->Yon;
    }
    /**
     * Set Yon value
     * @param string $yon
     * @return \StructType\ClsPaketTanim
     */
    public function setYon($yon = null)
    {
        // validation for constraint: string
        if (!is_null($yon) && !is_string($yon)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($yon, true), gettype($yon)), __LINE__);
        }
        $this->Yon = $yon;
        return $this;
    }
    /**
     * Get Durum value
     * @return string
     */
    public function getDurum()
    {
        return $this->Durum;
    }
    /**
     * Set Durum value
     * @param string $durum
     * @return \StructType\ClsPaketTanim
     */
    public function setDurum($durum = null)
    {
        // validation for constraint: string
        if (!is_null($durum) && !is_string($durum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($durum, true), gettype($durum)), __LINE__);
        }
        $this->Durum = $durum;
        return $this;
    }
    /**
     * Get Tabloadi value
     * @return string|null
     */
    public function getTabloadi()
    {
        return $this->Tabloadi;
    }
    /**
     * Set Tabloadi value
     * @param string $tabloadi
     * @return \StructType\ClsPaketTanim
     */
    public function setTabloadi($tabloadi = null)
    {
        // validation for constraint: string
        if (!is_null($tabloadi) && !is_string($tabloadi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tabloadi, true), gettype($tabloadi)), __LINE__);
        }
        $this->Tabloadi = $tabloadi;
        return $this;
    }
    /**
     * Get Viewadi value
     * @return string|null
     */
    public function getViewadi()
    {
        return $this->Viewadi;
    }
    /**
     * Set Viewadi value
     * @param string $viewadi
     * @return \StructType\ClsPaketTanim
     */
    public function setViewadi($viewadi = null)
    {
        // validation for constraint: string
        if (!is_null($viewadi) && !is_string($viewadi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($viewadi, true), gettype($viewadi)), __LINE__);
        }
        $this->Viewadi = $viewadi;
        return $this;
    }
    /**
     * Get Kriter value
     * @return string|null
     */
    public function getKriter()
    {
        return $this->Kriter;
    }
    /**
     * Set Kriter value
     * @param string $kriter
     * @return \StructType\ClsPaketTanim
     */
    public function setKriter($kriter = null)
    {
        // validation for constraint: string
        if (!is_null($kriter) && !is_string($kriter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kriter, true), gettype($kriter)), __LINE__);
        }
        $this->Kriter = $kriter;
        return $this;
    }
    /**
     * Get Version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->Version;
    }
    /**
     * Set Version value
     * @param string $version
     * @return \StructType\ClsPaketTanim
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->Version = $version;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsPaketTanim
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
