<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsPalyeGeneric StructType
 * @subpackage Structs
 */
class ClsPalyeGeneric extends ClsPalye
{
    /**
     * The PalyeTextKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PalyeTextKod;
    /**
     * The PalyeReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PalyeReferans;
    /**
     * The DetayUrunTextKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DetayUrunTextKod;
    /**
     * The DetayUrunReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DetayUrunReferans;
    /**
     * Constructor method for clsPalyeGeneric
     * @uses ClsPalyeGeneric::setPalyeTextKod()
     * @uses ClsPalyeGeneric::setPalyeReferans()
     * @uses ClsPalyeGeneric::setDetayUrunTextKod()
     * @uses ClsPalyeGeneric::setDetayUrunReferans()
     * @param string $palyeTextKod
     * @param string $palyeReferans
     * @param string $detayUrunTextKod
     * @param string $detayUrunReferans
     */
    public function __construct($palyeTextKod = null, $palyeReferans = null, $detayUrunTextKod = null, $detayUrunReferans = null)
    {
        $this
            ->setPalyeTextKod($palyeTextKod)
            ->setPalyeReferans($palyeReferans)
            ->setDetayUrunTextKod($detayUrunTextKod)
            ->setDetayUrunReferans($detayUrunReferans);
    }
    /**
     * Get PalyeTextKod value
     * @return string|null
     */
    public function getPalyeTextKod()
    {
        return $this->PalyeTextKod;
    }
    /**
     * Set PalyeTextKod value
     * @param string $palyeTextKod
     * @return \StructType\ClsPalyeGeneric
     */
    public function setPalyeTextKod($palyeTextKod = null)
    {
        // validation for constraint: string
        if (!is_null($palyeTextKod) && !is_string($palyeTextKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($palyeTextKod, true), gettype($palyeTextKod)), __LINE__);
        }
        $this->PalyeTextKod = $palyeTextKod;
        return $this;
    }
    /**
     * Get PalyeReferans value
     * @return string|null
     */
    public function getPalyeReferans()
    {
        return $this->PalyeReferans;
    }
    /**
     * Set PalyeReferans value
     * @param string $palyeReferans
     * @return \StructType\ClsPalyeGeneric
     */
    public function setPalyeReferans($palyeReferans = null)
    {
        // validation for constraint: string
        if (!is_null($palyeReferans) && !is_string($palyeReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($palyeReferans, true), gettype($palyeReferans)), __LINE__);
        }
        $this->PalyeReferans = $palyeReferans;
        return $this;
    }
    /**
     * Get DetayUrunTextKod value
     * @return string|null
     */
    public function getDetayUrunTextKod()
    {
        return $this->DetayUrunTextKod;
    }
    /**
     * Set DetayUrunTextKod value
     * @param string $detayUrunTextKod
     * @return \StructType\ClsPalyeGeneric
     */
    public function setDetayUrunTextKod($detayUrunTextKod = null)
    {
        // validation for constraint: string
        if (!is_null($detayUrunTextKod) && !is_string($detayUrunTextKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($detayUrunTextKod, true), gettype($detayUrunTextKod)), __LINE__);
        }
        $this->DetayUrunTextKod = $detayUrunTextKod;
        return $this;
    }
    /**
     * Get DetayUrunReferans value
     * @return string|null
     */
    public function getDetayUrunReferans()
    {
        return $this->DetayUrunReferans;
    }
    /**
     * Set DetayUrunReferans value
     * @param string $detayUrunReferans
     * @return \StructType\ClsPalyeGeneric
     */
    public function setDetayUrunReferans($detayUrunReferans = null)
    {
        // validation for constraint: string
        if (!is_null($detayUrunReferans) && !is_string($detayUrunReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($detayUrunReferans, true), gettype($detayUrunReferans)), __LINE__);
        }
        $this->DetayUrunReferans = $detayUrunReferans;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsPalyeGeneric
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
