<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsRepAdvisorIntegration StructType
 * @subpackage Structs
 */
class ClsRepAdvisorIntegration extends ClsEntity
{
    /**
     * The Kod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $Kod;
    /**
     * The Gsm
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $Gsm;
    /**
     * The SonIslemTarihi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $SonIslemTarihi;
    /**
     * The DistKriter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DistKriter;
    /**
     * The SiparisTarih
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SiparisTarih;
    /**
     * The KullaniciAd
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $KullaniciAd;
    /**
     * The DepoKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DepoKod;
    /**
     * The UrunKodu
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UrunKodu;
    /**
     * The Birim
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Birim;
    /**
     * Constructor method for clsRepAdvisorIntegration
     * @uses ClsRepAdvisorIntegration::setKod()
     * @uses ClsRepAdvisorIntegration::setGsm()
     * @uses ClsRepAdvisorIntegration::setSonIslemTarihi()
     * @uses ClsRepAdvisorIntegration::setDistKriter()
     * @uses ClsRepAdvisorIntegration::setSiparisTarih()
     * @uses ClsRepAdvisorIntegration::setKullaniciAd()
     * @uses ClsRepAdvisorIntegration::setDepoKod()
     * @uses ClsRepAdvisorIntegration::setUrunKodu()
     * @uses ClsRepAdvisorIntegration::setBirim()
     * @param int $kod
     * @param float $gsm
     * @param string $sonIslemTarihi
     * @param string $distKriter
     * @param string $siparisTarih
     * @param string $kullaniciAd
     * @param string $depoKod
     * @param string $urunKodu
     * @param string $birim
     */
    public function __construct($kod = null, $gsm = null, $sonIslemTarihi = null, $distKriter = null, $siparisTarih = null, $kullaniciAd = null, $depoKod = null, $urunKodu = null, $birim = null)
    {
        $this
            ->setKod($kod)
            ->setGsm($gsm)
            ->setSonIslemTarihi($sonIslemTarihi)
            ->setDistKriter($distKriter)
            ->setSiparisTarih($siparisTarih)
            ->setKullaniciAd($kullaniciAd)
            ->setDepoKod($depoKod)
            ->setUrunKodu($urunKodu)
            ->setBirim($birim);
    }
    /**
     * Get Kod value
     * @return int
     */
    public function getKod()
    {
        return $this->Kod;
    }
    /**
     * Set Kod value
     * @param int $kod
     * @return \StructType\ClsRepAdvisorIntegration
     */
    public function setKod($kod = null)
    {
        // validation for constraint: int
        if (!is_null($kod) && !(is_int($kod) || ctype_digit($kod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($kod, true), gettype($kod)), __LINE__);
        }
        $this->Kod = $kod;
        return $this;
    }
    /**
     * Get Gsm value
     * @return float
     */
    public function getGsm()
    {
        return $this->Gsm;
    }
    /**
     * Set Gsm value
     * @param float $gsm
     * @return \StructType\ClsRepAdvisorIntegration
     */
    public function setGsm($gsm = null)
    {
        // validation for constraint: float
        if (!is_null($gsm) && !(is_float($gsm) || is_numeric($gsm))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($gsm, true), gettype($gsm)), __LINE__);
        }
        $this->Gsm = $gsm;
        return $this;
    }
    /**
     * Get SonIslemTarihi value
     * @return string
     */
    public function getSonIslemTarihi()
    {
        return $this->SonIslemTarihi;
    }
    /**
     * Set SonIslemTarihi value
     * @param string $sonIslemTarihi
     * @return \StructType\ClsRepAdvisorIntegration
     */
    public function setSonIslemTarihi($sonIslemTarihi = null)
    {
        // validation for constraint: string
        if (!is_null($sonIslemTarihi) && !is_string($sonIslemTarihi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonIslemTarihi, true), gettype($sonIslemTarihi)), __LINE__);
        }
        $this->SonIslemTarihi = $sonIslemTarihi;
        return $this;
    }
    /**
     * Get DistKriter value
     * @return string|null
     */
    public function getDistKriter()
    {
        return $this->DistKriter;
    }
    /**
     * Set DistKriter value
     * @param string $distKriter
     * @return \StructType\ClsRepAdvisorIntegration
     */
    public function setDistKriter($distKriter = null)
    {
        // validation for constraint: string
        if (!is_null($distKriter) && !is_string($distKriter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($distKriter, true), gettype($distKriter)), __LINE__);
        }
        $this->DistKriter = $distKriter;
        return $this;
    }
    /**
     * Get SiparisTarih value
     * @return string|null
     */
    public function getSiparisTarih()
    {
        return $this->SiparisTarih;
    }
    /**
     * Set SiparisTarih value
     * @param string $siparisTarih
     * @return \StructType\ClsRepAdvisorIntegration
     */
    public function setSiparisTarih($siparisTarih = null)
    {
        // validation for constraint: string
        if (!is_null($siparisTarih) && !is_string($siparisTarih)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($siparisTarih, true), gettype($siparisTarih)), __LINE__);
        }
        $this->SiparisTarih = $siparisTarih;
        return $this;
    }
    /**
     * Get KullaniciAd value
     * @return string|null
     */
    public function getKullaniciAd()
    {
        return $this->KullaniciAd;
    }
    /**
     * Set KullaniciAd value
     * @param string $kullaniciAd
     * @return \StructType\ClsRepAdvisorIntegration
     */
    public function setKullaniciAd($kullaniciAd = null)
    {
        // validation for constraint: string
        if (!is_null($kullaniciAd) && !is_string($kullaniciAd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kullaniciAd, true), gettype($kullaniciAd)), __LINE__);
        }
        $this->KullaniciAd = $kullaniciAd;
        return $this;
    }
    /**
     * Get DepoKod value
     * @return string|null
     */
    public function getDepoKod()
    {
        return $this->DepoKod;
    }
    /**
     * Set DepoKod value
     * @param string $depoKod
     * @return \StructType\ClsRepAdvisorIntegration
     */
    public function setDepoKod($depoKod = null)
    {
        // validation for constraint: string
        if (!is_null($depoKod) && !is_string($depoKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($depoKod, true), gettype($depoKod)), __LINE__);
        }
        $this->DepoKod = $depoKod;
        return $this;
    }
    /**
     * Get UrunKodu value
     * @return string|null
     */
    public function getUrunKodu()
    {
        return $this->UrunKodu;
    }
    /**
     * Set UrunKodu value
     * @param string $urunKodu
     * @return \StructType\ClsRepAdvisorIntegration
     */
    public function setUrunKodu($urunKodu = null)
    {
        // validation for constraint: string
        if (!is_null($urunKodu) && !is_string($urunKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($urunKodu, true), gettype($urunKodu)), __LINE__);
        }
        $this->UrunKodu = $urunKodu;
        return $this;
    }
    /**
     * Get Birim value
     * @return string|null
     */
    public function getBirim()
    {
        return $this->Birim;
    }
    /**
     * Set Birim value
     * @param string $birim
     * @return \StructType\ClsRepAdvisorIntegration
     */
    public function setBirim($birim = null)
    {
        // validation for constraint: string
        if (!is_null($birim) && !is_string($birim)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($birim, true), gettype($birim)), __LINE__);
        }
        $this->Birim = $birim;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsRepAdvisorIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
