<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsSERutPlanIntegration StructType
 * @subpackage Structs
 */
class ClsSERutPlanIntegration extends ClsRutPlan
{
    /**
     * The RutAciklama
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RutAciklama;
    /**
     * The RutReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RutReferans;
    /**
     * The SahaElemaniAdi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SahaElemaniAdi;
    /**
     * The SahaElemaniReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SahaElemaniReferans;
    /**
     * Constructor method for clsSERutPlanIntegration
     * @uses ClsSERutPlanIntegration::setRutAciklama()
     * @uses ClsSERutPlanIntegration::setRutReferans()
     * @uses ClsSERutPlanIntegration::setSahaElemaniAdi()
     * @uses ClsSERutPlanIntegration::setSahaElemaniReferans()
     * @param string $rutAciklama
     * @param string $rutReferans
     * @param string $sahaElemaniAdi
     * @param string $sahaElemaniReferans
     */
    public function __construct($rutAciklama = null, $rutReferans = null, $sahaElemaniAdi = null, $sahaElemaniReferans = null)
    {
        $this
            ->setRutAciklama($rutAciklama)
            ->setRutReferans($rutReferans)
            ->setSahaElemaniAdi($sahaElemaniAdi)
            ->setSahaElemaniReferans($sahaElemaniReferans);
    }
    /**
     * Get RutAciklama value
     * @return string|null
     */
    public function getRutAciklama()
    {
        return $this->RutAciklama;
    }
    /**
     * Set RutAciklama value
     * @param string $rutAciklama
     * @return \StructType\ClsSERutPlanIntegration
     */
    public function setRutAciklama($rutAciklama = null)
    {
        // validation for constraint: string
        if (!is_null($rutAciklama) && !is_string($rutAciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rutAciklama, true), gettype($rutAciklama)), __LINE__);
        }
        $this->RutAciklama = $rutAciklama;
        return $this;
    }
    /**
     * Get RutReferans value
     * @return string|null
     */
    public function getRutReferans()
    {
        return $this->RutReferans;
    }
    /**
     * Set RutReferans value
     * @param string $rutReferans
     * @return \StructType\ClsSERutPlanIntegration
     */
    public function setRutReferans($rutReferans = null)
    {
        // validation for constraint: string
        if (!is_null($rutReferans) && !is_string($rutReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rutReferans, true), gettype($rutReferans)), __LINE__);
        }
        $this->RutReferans = $rutReferans;
        return $this;
    }
    /**
     * Get SahaElemaniAdi value
     * @return string|null
     */
    public function getSahaElemaniAdi()
    {
        return $this->SahaElemaniAdi;
    }
    /**
     * Set SahaElemaniAdi value
     * @param string $sahaElemaniAdi
     * @return \StructType\ClsSERutPlanIntegration
     */
    public function setSahaElemaniAdi($sahaElemaniAdi = null)
    {
        // validation for constraint: string
        if (!is_null($sahaElemaniAdi) && !is_string($sahaElemaniAdi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sahaElemaniAdi, true), gettype($sahaElemaniAdi)), __LINE__);
        }
        $this->SahaElemaniAdi = $sahaElemaniAdi;
        return $this;
    }
    /**
     * Get SahaElemaniReferans value
     * @return string|null
     */
    public function getSahaElemaniReferans()
    {
        return $this->SahaElemaniReferans;
    }
    /**
     * Set SahaElemaniReferans value
     * @param string $sahaElemaniReferans
     * @return \StructType\ClsSERutPlanIntegration
     */
    public function setSahaElemaniReferans($sahaElemaniReferans = null)
    {
        // validation for constraint: string
        if (!is_null($sahaElemaniReferans) && !is_string($sahaElemaniReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sahaElemaniReferans, true), gettype($sahaElemaniReferans)), __LINE__);
        }
        $this->SahaElemaniReferans = $sahaElemaniReferans;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsSERutPlanIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
