<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsSESef StructType
 * @subpackage Structs
 */
class ClsSESef extends ClsEntity
{
    /**
     * The Kod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $Kod;
    /**
     * The KullaniciKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $KullaniciKod;
    /**
     * The PersonelKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $PersonelKod;
    /**
     * The SonIslemTarihi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $SonIslemTarihi;
    /**
     * The Ilkkullanicikod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $Ilkkullanicikod;
    /**
     * The Sonkullanicikod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $Sonkullanicikod;
    /**
     * The Ilkislemtarihi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $Ilkislemtarihi;
    /**
     * The Ad
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Ad;
    /**
     * The SonIslemHost
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SonIslemHost;
    /**
     * The Referans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Referans;
    /**
     * Constructor method for clsSESef
     * @uses ClsSESef::setKod()
     * @uses ClsSESef::setKullaniciKod()
     * @uses ClsSESef::setPersonelKod()
     * @uses ClsSESef::setSonIslemTarihi()
     * @uses ClsSESef::setIlkkullanicikod()
     * @uses ClsSESef::setSonkullanicikod()
     * @uses ClsSESef::setIlkislemtarihi()
     * @uses ClsSESef::setAd()
     * @uses ClsSESef::setSonIslemHost()
     * @uses ClsSESef::setReferans()
     * @param int $kod
     * @param int $kullaniciKod
     * @param int $personelKod
     * @param string $sonIslemTarihi
     * @param int $ilkkullanicikod
     * @param int $sonkullanicikod
     * @param string $ilkislemtarihi
     * @param string $ad
     * @param string $sonIslemHost
     * @param string $referans
     */
    public function __construct($kod = null, $kullaniciKod = null, $personelKod = null, $sonIslemTarihi = null, $ilkkullanicikod = null, $sonkullanicikod = null, $ilkislemtarihi = null, $ad = null, $sonIslemHost = null, $referans = null)
    {
        $this
            ->setKod($kod)
            ->setKullaniciKod($kullaniciKod)
            ->setPersonelKod($personelKod)
            ->setSonIslemTarihi($sonIslemTarihi)
            ->setIlkkullanicikod($ilkkullanicikod)
            ->setSonkullanicikod($sonkullanicikod)
            ->setIlkislemtarihi($ilkislemtarihi)
            ->setAd($ad)
            ->setSonIslemHost($sonIslemHost)
            ->setReferans($referans);
    }
    /**
     * Get Kod value
     * @return int
     */
    public function getKod()
    {
        return $this->Kod;
    }
    /**
     * Set Kod value
     * @param int $kod
     * @return \StructType\ClsSESef
     */
    public function setKod($kod = null)
    {
        // validation for constraint: int
        if (!is_null($kod) && !(is_int($kod) || ctype_digit($kod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($kod, true), gettype($kod)), __LINE__);
        }
        $this->Kod = $kod;
        return $this;
    }
    /**
     * Get KullaniciKod value
     * @return int
     */
    public function getKullaniciKod()
    {
        return $this->KullaniciKod;
    }
    /**
     * Set KullaniciKod value
     * @param int $kullaniciKod
     * @return \StructType\ClsSESef
     */
    public function setKullaniciKod($kullaniciKod = null)
    {
        // validation for constraint: int
        if (!is_null($kullaniciKod) && !(is_int($kullaniciKod) || ctype_digit($kullaniciKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($kullaniciKod, true), gettype($kullaniciKod)), __LINE__);
        }
        $this->KullaniciKod = $kullaniciKod;
        return $this;
    }
    /**
     * Get PersonelKod value
     * @return int
     */
    public function getPersonelKod()
    {
        return $this->PersonelKod;
    }
    /**
     * Set PersonelKod value
     * @param int $personelKod
     * @return \StructType\ClsSESef
     */
    public function setPersonelKod($personelKod = null)
    {
        // validation for constraint: int
        if (!is_null($personelKod) && !(is_int($personelKod) || ctype_digit($personelKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($personelKod, true), gettype($personelKod)), __LINE__);
        }
        $this->PersonelKod = $personelKod;
        return $this;
    }
    /**
     * Get SonIslemTarihi value
     * @return string
     */
    public function getSonIslemTarihi()
    {
        return $this->SonIslemTarihi;
    }
    /**
     * Set SonIslemTarihi value
     * @param string $sonIslemTarihi
     * @return \StructType\ClsSESef
     */
    public function setSonIslemTarihi($sonIslemTarihi = null)
    {
        // validation for constraint: string
        if (!is_null($sonIslemTarihi) && !is_string($sonIslemTarihi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonIslemTarihi, true), gettype($sonIslemTarihi)), __LINE__);
        }
        $this->SonIslemTarihi = $sonIslemTarihi;
        return $this;
    }
    /**
     * Get Ilkkullanicikod value
     * @return int
     */
    public function getIlkkullanicikod()
    {
        return $this->Ilkkullanicikod;
    }
    /**
     * Set Ilkkullanicikod value
     * @param int $ilkkullanicikod
     * @return \StructType\ClsSESef
     */
    public function setIlkkullanicikod($ilkkullanicikod = null)
    {
        // validation for constraint: int
        if (!is_null($ilkkullanicikod) && !(is_int($ilkkullanicikod) || ctype_digit($ilkkullanicikod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($ilkkullanicikod, true), gettype($ilkkullanicikod)), __LINE__);
        }
        $this->Ilkkullanicikod = $ilkkullanicikod;
        return $this;
    }
    /**
     * Get Sonkullanicikod value
     * @return int
     */
    public function getSonkullanicikod()
    {
        return $this->Sonkullanicikod;
    }
    /**
     * Set Sonkullanicikod value
     * @param int $sonkullanicikod
     * @return \StructType\ClsSESef
     */
    public function setSonkullanicikod($sonkullanicikod = null)
    {
        // validation for constraint: int
        if (!is_null($sonkullanicikod) && !(is_int($sonkullanicikod) || ctype_digit($sonkullanicikod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sonkullanicikod, true), gettype($sonkullanicikod)), __LINE__);
        }
        $this->Sonkullanicikod = $sonkullanicikod;
        return $this;
    }
    /**
     * Get Ilkislemtarihi value
     * @return string
     */
    public function getIlkislemtarihi()
    {
        return $this->Ilkislemtarihi;
    }
    /**
     * Set Ilkislemtarihi value
     * @param string $ilkislemtarihi
     * @return \StructType\ClsSESef
     */
    public function setIlkislemtarihi($ilkislemtarihi = null)
    {
        // validation for constraint: string
        if (!is_null($ilkislemtarihi) && !is_string($ilkislemtarihi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ilkislemtarihi, true), gettype($ilkislemtarihi)), __LINE__);
        }
        $this->Ilkislemtarihi = $ilkislemtarihi;
        return $this;
    }
    /**
     * Get Ad value
     * @return string|null
     */
    public function getAd()
    {
        return $this->Ad;
    }
    /**
     * Set Ad value
     * @param string $ad
     * @return \StructType\ClsSESef
     */
    public function setAd($ad = null)
    {
        // validation for constraint: string
        if (!is_null($ad) && !is_string($ad)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ad, true), gettype($ad)), __LINE__);
        }
        $this->Ad = $ad;
        return $this;
    }
    /**
     * Get SonIslemHost value
     * @return string|null
     */
    public function getSonIslemHost()
    {
        return $this->SonIslemHost;
    }
    /**
     * Set SonIslemHost value
     * @param string $sonIslemHost
     * @return \StructType\ClsSESef
     */
    public function setSonIslemHost($sonIslemHost = null)
    {
        // validation for constraint: string
        if (!is_null($sonIslemHost) && !is_string($sonIslemHost)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonIslemHost, true), gettype($sonIslemHost)), __LINE__);
        }
        $this->SonIslemHost = $sonIslemHost;
        return $this;
    }
    /**
     * Get Referans value
     * @return string|null
     */
    public function getReferans()
    {
        return $this->Referans;
    }
    /**
     * Set Referans value
     * @param string $referans
     * @return \StructType\ClsSESef
     */
    public function setReferans($referans = null)
    {
        // validation for constraint: string
        if (!is_null($referans) && !is_string($referans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($referans, true), gettype($referans)), __LINE__);
        }
        $this->Referans = $referans;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsSESef
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
