<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsSESefIntegration StructType
 * @subpackage Structs
 */
class ClsSESefIntegration extends ClsSESef
{
    /**
     * The PersonelAd
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PersonelAd;
    /**
     * The PersonelReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PersonelReferans;
    /**
     * The KullaniciAdi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $KullaniciAdi;
    /**
     * The KullaniciReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $KullaniciReferans;
    /**
     * Constructor method for clsSESefIntegration
     * @uses ClsSESefIntegration::setPersonelAd()
     * @uses ClsSESefIntegration::setPersonelReferans()
     * @uses ClsSESefIntegration::setKullaniciAdi()
     * @uses ClsSESefIntegration::setKullaniciReferans()
     * @param string $personelAd
     * @param string $personelReferans
     * @param string $kullaniciAdi
     * @param string $kullaniciReferans
     */
    public function __construct($personelAd = null, $personelReferans = null, $kullaniciAdi = null, $kullaniciReferans = null)
    {
        $this
            ->setPersonelAd($personelAd)
            ->setPersonelReferans($personelReferans)
            ->setKullaniciAdi($kullaniciAdi)
            ->setKullaniciReferans($kullaniciReferans);
    }
    /**
     * Get PersonelAd value
     * @return string|null
     */
    public function getPersonelAd()
    {
        return $this->PersonelAd;
    }
    /**
     * Set PersonelAd value
     * @param string $personelAd
     * @return \StructType\ClsSESefIntegration
     */
    public function setPersonelAd($personelAd = null)
    {
        // validation for constraint: string
        if (!is_null($personelAd) && !is_string($personelAd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($personelAd, true), gettype($personelAd)), __LINE__);
        }
        $this->PersonelAd = $personelAd;
        return $this;
    }
    /**
     * Get PersonelReferans value
     * @return string|null
     */
    public function getPersonelReferans()
    {
        return $this->PersonelReferans;
    }
    /**
     * Set PersonelReferans value
     * @param string $personelReferans
     * @return \StructType\ClsSESefIntegration
     */
    public function setPersonelReferans($personelReferans = null)
    {
        // validation for constraint: string
        if (!is_null($personelReferans) && !is_string($personelReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($personelReferans, true), gettype($personelReferans)), __LINE__);
        }
        $this->PersonelReferans = $personelReferans;
        return $this;
    }
    /**
     * Get KullaniciAdi value
     * @return string|null
     */
    public function getKullaniciAdi()
    {
        return $this->KullaniciAdi;
    }
    /**
     * Set KullaniciAdi value
     * @param string $kullaniciAdi
     * @return \StructType\ClsSESefIntegration
     */
    public function setKullaniciAdi($kullaniciAdi = null)
    {
        // validation for constraint: string
        if (!is_null($kullaniciAdi) && !is_string($kullaniciAdi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kullaniciAdi, true), gettype($kullaniciAdi)), __LINE__);
        }
        $this->KullaniciAdi = $kullaniciAdi;
        return $this;
    }
    /**
     * Get KullaniciReferans value
     * @return string|null
     */
    public function getKullaniciReferans()
    {
        return $this->KullaniciReferans;
    }
    /**
     * Set KullaniciReferans value
     * @param string $kullaniciReferans
     * @return \StructType\ClsSESefIntegration
     */
    public function setKullaniciReferans($kullaniciReferans = null)
    {
        // validation for constraint: string
        if (!is_null($kullaniciReferans) && !is_string($kullaniciReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kullaniciReferans, true), gettype($kullaniciReferans)), __LINE__);
        }
        $this->KullaniciReferans = $kullaniciReferans;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsSESefIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
