<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsSecimliIskPro StructType
 * @subpackage Structs
 */
class ClsSecimliIskPro extends AbstractStructBase
{
    /**
     * The IskProKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $IskProKod;
    /**
     * The KademeSira
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $KademeSira;
    /**
     * The HediyeSira
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $HediyeSira;
    /**
     * The UrunList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfClsSecimliIskProGrup
     */
    public $UrunList;
    /**
     * Constructor method for clsSecimliIskPro
     * @uses ClsSecimliIskPro::setIskProKod()
     * @uses ClsSecimliIskPro::setKademeSira()
     * @uses ClsSecimliIskPro::setHediyeSira()
     * @uses ClsSecimliIskPro::setUrunList()
     * @param int $iskProKod
     * @param int $kademeSira
     * @param int $hediyeSira
     * @param \ArrayType\ArrayOfClsSecimliIskProGrup $urunList
     */
    public function __construct($iskProKod = null, $kademeSira = null, $hediyeSira = null, \ArrayType\ArrayOfClsSecimliIskProGrup $urunList = null)
    {
        $this
            ->setIskProKod($iskProKod)
            ->setKademeSira($kademeSira)
            ->setHediyeSira($hediyeSira)
            ->setUrunList($urunList);
    }
    /**
     * Get IskProKod value
     * @return int
     */
    public function getIskProKod()
    {
        return $this->IskProKod;
    }
    /**
     * Set IskProKod value
     * @param int $iskProKod
     * @return \StructType\ClsSecimliIskPro
     */
    public function setIskProKod($iskProKod = null)
    {
        // validation for constraint: int
        if (!is_null($iskProKod) && !(is_int($iskProKod) || ctype_digit($iskProKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($iskProKod, true), gettype($iskProKod)), __LINE__);
        }
        $this->IskProKod = $iskProKod;
        return $this;
    }
    /**
     * Get KademeSira value
     * @return int
     */
    public function getKademeSira()
    {
        return $this->KademeSira;
    }
    /**
     * Set KademeSira value
     * @param int $kademeSira
     * @return \StructType\ClsSecimliIskPro
     */
    public function setKademeSira($kademeSira = null)
    {
        // validation for constraint: int
        if (!is_null($kademeSira) && !(is_int($kademeSira) || ctype_digit($kademeSira))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($kademeSira, true), gettype($kademeSira)), __LINE__);
        }
        $this->KademeSira = $kademeSira;
        return $this;
    }
    /**
     * Get HediyeSira value
     * @return int
     */
    public function getHediyeSira()
    {
        return $this->HediyeSira;
    }
    /**
     * Set HediyeSira value
     * @param int $hediyeSira
     * @return \StructType\ClsSecimliIskPro
     */
    public function setHediyeSira($hediyeSira = null)
    {
        // validation for constraint: int
        if (!is_null($hediyeSira) && !(is_int($hediyeSira) || ctype_digit($hediyeSira))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($hediyeSira, true), gettype($hediyeSira)), __LINE__);
        }
        $this->HediyeSira = $hediyeSira;
        return $this;
    }
    /**
     * Get UrunList value
     * @return \ArrayType\ArrayOfClsSecimliIskProGrup|null
     */
    public function getUrunList()
    {
        return $this->UrunList;
    }
    /**
     * Set UrunList value
     * @param \ArrayType\ArrayOfClsSecimliIskProGrup $urunList
     * @return \StructType\ClsSecimliIskPro
     */
    public function setUrunList(\ArrayType\ArrayOfClsSecimliIskProGrup $urunList = null)
    {
        $this->UrunList = $urunList;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsSecimliIskPro
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
