<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsSharedDepozito StructType
 * @subpackage Structs
 */
class ClsSharedDepozito extends ClsEntity
{
    /**
     * The UrunRef
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $UrunRef;
    /**
     * The BirimSira
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $BirimSira;
    /**
     * The DepozitoUrunRef
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $DepozitoUrunRef;
    /**
     * The Miktar
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $Miktar;
    /**
     * Constructor method for clsSharedDepozito
     * @uses ClsSharedDepozito::setUrunRef()
     * @uses ClsSharedDepozito::setBirimSira()
     * @uses ClsSharedDepozito::setDepozitoUrunRef()
     * @uses ClsSharedDepozito::setMiktar()
     * @param int $urunRef
     * @param string $birimSira
     * @param int $depozitoUrunRef
     * @param float $miktar
     */
    public function __construct($urunRef = null, $birimSira = null, $depozitoUrunRef = null, $miktar = null)
    {
        $this
            ->setUrunRef($urunRef)
            ->setBirimSira($birimSira)
            ->setDepozitoUrunRef($depozitoUrunRef)
            ->setMiktar($miktar);
    }
    /**
     * Get UrunRef value
     * @return int
     */
    public function getUrunRef()
    {
        return $this->UrunRef;
    }
    /**
     * Set UrunRef value
     * @param int $urunRef
     * @return \StructType\ClsSharedDepozito
     */
    public function setUrunRef($urunRef = null)
    {
        // validation for constraint: int
        if (!is_null($urunRef) && !(is_int($urunRef) || ctype_digit($urunRef))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($urunRef, true), gettype($urunRef)), __LINE__);
        }
        $this->UrunRef = $urunRef;
        return $this;
    }
    /**
     * Get BirimSira value
     * @return string
     */
    public function getBirimSira()
    {
        return $this->BirimSira;
    }
    /**
     * Set BirimSira value
     * @param string $birimSira
     * @return \StructType\ClsSharedDepozito
     */
    public function setBirimSira($birimSira = null)
    {
        // validation for constraint: string
        if (!is_null($birimSira) && !is_string($birimSira)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($birimSira, true), gettype($birimSira)), __LINE__);
        }
        $this->BirimSira = $birimSira;
        return $this;
    }
    /**
     * Get DepozitoUrunRef value
     * @return int
     */
    public function getDepozitoUrunRef()
    {
        return $this->DepozitoUrunRef;
    }
    /**
     * Set DepozitoUrunRef value
     * @param int $depozitoUrunRef
     * @return \StructType\ClsSharedDepozito
     */
    public function setDepozitoUrunRef($depozitoUrunRef = null)
    {
        // validation for constraint: int
        if (!is_null($depozitoUrunRef) && !(is_int($depozitoUrunRef) || ctype_digit($depozitoUrunRef))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($depozitoUrunRef, true), gettype($depozitoUrunRef)), __LINE__);
        }
        $this->DepozitoUrunRef = $depozitoUrunRef;
        return $this;
    }
    /**
     * Get Miktar value
     * @return float
     */
    public function getMiktar()
    {
        return $this->Miktar;
    }
    /**
     * Set Miktar value
     * @param float $miktar
     * @return \StructType\ClsSharedDepozito
     */
    public function setMiktar($miktar = null)
    {
        // validation for constraint: float
        if (!is_null($miktar) && !(is_float($miktar) || is_numeric($miktar))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($miktar, true), gettype($miktar)), __LINE__);
        }
        $this->Miktar = $miktar;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsSharedDepozito
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
