<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsSharedUretici StructType
 * @subpackage Structs
 */
class ClsSharedUretici extends ClsEntity
{
    /**
     * The DistKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $DistKod;
    /**
     * The KDVdenMuaf
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $KDVdenMuaf;
    /**
     * The Kod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Kod;
    /**
     * The Ad
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Ad;
    /**
     * The Referans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Referans;
    /**
     * The MerkezKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MerkezKod;
    /**
     * Constructor method for clsSharedUretici
     * @uses ClsSharedUretici::setDistKod()
     * @uses ClsSharedUretici::setKDVdenMuaf()
     * @uses ClsSharedUretici::setKod()
     * @uses ClsSharedUretici::setAd()
     * @uses ClsSharedUretici::setReferans()
     * @uses ClsSharedUretici::setMerkezKod()
     * @param int $distKod
     * @param string $kDVdenMuaf
     * @param string $kod
     * @param string $ad
     * @param string $referans
     * @param string $merkezKod
     */
    public function __construct($distKod = null, $kDVdenMuaf = null, $kod = null, $ad = null, $referans = null, $merkezKod = null)
    {
        $this
            ->setDistKod($distKod)
            ->setKDVdenMuaf($kDVdenMuaf)
            ->setKod($kod)
            ->setAd($ad)
            ->setReferans($referans)
            ->setMerkezKod($merkezKod);
    }
    /**
     * Get DistKod value
     * @return int
     */
    public function getDistKod()
    {
        return $this->DistKod;
    }
    /**
     * Set DistKod value
     * @param int $distKod
     * @return \StructType\ClsSharedUretici
     */
    public function setDistKod($distKod = null)
    {
        // validation for constraint: int
        if (!is_null($distKod) && !(is_int($distKod) || ctype_digit($distKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($distKod, true), gettype($distKod)), __LINE__);
        }
        $this->DistKod = $distKod;
        return $this;
    }
    /**
     * Get KDVdenMuaf value
     * @return string
     */
    public function getKDVdenMuaf()
    {
        return $this->KDVdenMuaf;
    }
    /**
     * Set KDVdenMuaf value
     * @param string $kDVdenMuaf
     * @return \StructType\ClsSharedUretici
     */
    public function setKDVdenMuaf($kDVdenMuaf = null)
    {
        // validation for constraint: string
        if (!is_null($kDVdenMuaf) && !is_string($kDVdenMuaf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kDVdenMuaf, true), gettype($kDVdenMuaf)), __LINE__);
        }
        $this->KDVdenMuaf = $kDVdenMuaf;
        return $this;
    }
    /**
     * Get Kod value
     * @return string|null
     */
    public function getKod()
    {
        return $this->Kod;
    }
    /**
     * Set Kod value
     * @param string $kod
     * @return \StructType\ClsSharedUretici
     */
    public function setKod($kod = null)
    {
        // validation for constraint: string
        if (!is_null($kod) && !is_string($kod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kod, true), gettype($kod)), __LINE__);
        }
        $this->Kod = $kod;
        return $this;
    }
    /**
     * Get Ad value
     * @return string|null
     */
    public function getAd()
    {
        return $this->Ad;
    }
    /**
     * Set Ad value
     * @param string $ad
     * @return \StructType\ClsSharedUretici
     */
    public function setAd($ad = null)
    {
        // validation for constraint: string
        if (!is_null($ad) && !is_string($ad)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ad, true), gettype($ad)), __LINE__);
        }
        $this->Ad = $ad;
        return $this;
    }
    /**
     * Get Referans value
     * @return string|null
     */
    public function getReferans()
    {
        return $this->Referans;
    }
    /**
     * Set Referans value
     * @param string $referans
     * @return \StructType\ClsSharedUretici
     */
    public function setReferans($referans = null)
    {
        // validation for constraint: string
        if (!is_null($referans) && !is_string($referans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($referans, true), gettype($referans)), __LINE__);
        }
        $this->Referans = $referans;
        return $this;
    }
    /**
     * Get MerkezKod value
     * @return string|null
     */
    public function getMerkezKod()
    {
        return $this->MerkezKod;
    }
    /**
     * Set MerkezKod value
     * @param string $merkezKod
     * @return \StructType\ClsSharedUretici
     */
    public function setMerkezKod($merkezKod = null)
    {
        // validation for constraint: string
        if (!is_null($merkezKod) && !is_string($merkezKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($merkezKod, true), gettype($merkezKod)), __LINE__);
        }
        $this->MerkezKod = $merkezKod;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsSharedUretici
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
