<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsSuperSession StructType
 * @subpackage Structs
 */
class ClsSuperSession extends ClsEntity
{
    /**
     * The Kod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $Kod;
    /**
     * The EskiUrunKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $EskiUrunKod;
    /**
     * The YeniUrunKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $YeniUrunKod;
    /**
     * The EskiUrunKullanilmasin
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $EskiUrunKullanilmasin;
    /**
     * The SonIslemTarihi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $SonIslemTarihi;
    /**
     * The SonKullaniciKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $SonKullaniciKod;
    /**
     * The IlkIslemTarihi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $IlkIslemTarihi;
    /**
     * The IlkKullaniciKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $IlkKullaniciKod;
    /**
     * The Referans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Referans;
    /**
     * The SonIslemHost
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SonIslemHost;
    /**
     * Constructor method for clsSuperSession
     * @uses ClsSuperSession::setKod()
     * @uses ClsSuperSession::setEskiUrunKod()
     * @uses ClsSuperSession::setYeniUrunKod()
     * @uses ClsSuperSession::setEskiUrunKullanilmasin()
     * @uses ClsSuperSession::setSonIslemTarihi()
     * @uses ClsSuperSession::setSonKullaniciKod()
     * @uses ClsSuperSession::setIlkIslemTarihi()
     * @uses ClsSuperSession::setIlkKullaniciKod()
     * @uses ClsSuperSession::setReferans()
     * @uses ClsSuperSession::setSonIslemHost()
     * @param int $kod
     * @param int $eskiUrunKod
     * @param int $yeniUrunKod
     * @param string $eskiUrunKullanilmasin
     * @param string $sonIslemTarihi
     * @param int $sonKullaniciKod
     * @param string $ilkIslemTarihi
     * @param int $ilkKullaniciKod
     * @param string $referans
     * @param string $sonIslemHost
     */
    public function __construct($kod = null, $eskiUrunKod = null, $yeniUrunKod = null, $eskiUrunKullanilmasin = null, $sonIslemTarihi = null, $sonKullaniciKod = null, $ilkIslemTarihi = null, $ilkKullaniciKod = null, $referans = null, $sonIslemHost = null)
    {
        $this
            ->setKod($kod)
            ->setEskiUrunKod($eskiUrunKod)
            ->setYeniUrunKod($yeniUrunKod)
            ->setEskiUrunKullanilmasin($eskiUrunKullanilmasin)
            ->setSonIslemTarihi($sonIslemTarihi)
            ->setSonKullaniciKod($sonKullaniciKod)
            ->setIlkIslemTarihi($ilkIslemTarihi)
            ->setIlkKullaniciKod($ilkKullaniciKod)
            ->setReferans($referans)
            ->setSonIslemHost($sonIslemHost);
    }
    /**
     * Get Kod value
     * @return int
     */
    public function getKod()
    {
        return $this->Kod;
    }
    /**
     * Set Kod value
     * @param int $kod
     * @return \StructType\ClsSuperSession
     */
    public function setKod($kod = null)
    {
        // validation for constraint: int
        if (!is_null($kod) && !(is_int($kod) || ctype_digit($kod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($kod, true), gettype($kod)), __LINE__);
        }
        $this->Kod = $kod;
        return $this;
    }
    /**
     * Get EskiUrunKod value
     * @return int
     */
    public function getEskiUrunKod()
    {
        return $this->EskiUrunKod;
    }
    /**
     * Set EskiUrunKod value
     * @param int $eskiUrunKod
     * @return \StructType\ClsSuperSession
     */
    public function setEskiUrunKod($eskiUrunKod = null)
    {
        // validation for constraint: int
        if (!is_null($eskiUrunKod) && !(is_int($eskiUrunKod) || ctype_digit($eskiUrunKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($eskiUrunKod, true), gettype($eskiUrunKod)), __LINE__);
        }
        $this->EskiUrunKod = $eskiUrunKod;
        return $this;
    }
    /**
     * Get YeniUrunKod value
     * @return int
     */
    public function getYeniUrunKod()
    {
        return $this->YeniUrunKod;
    }
    /**
     * Set YeniUrunKod value
     * @param int $yeniUrunKod
     * @return \StructType\ClsSuperSession
     */
    public function setYeniUrunKod($yeniUrunKod = null)
    {
        // validation for constraint: int
        if (!is_null($yeniUrunKod) && !(is_int($yeniUrunKod) || ctype_digit($yeniUrunKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($yeniUrunKod, true), gettype($yeniUrunKod)), __LINE__);
        }
        $this->YeniUrunKod = $yeniUrunKod;
        return $this;
    }
    /**
     * Get EskiUrunKullanilmasin value
     * @return string
     */
    public function getEskiUrunKullanilmasin()
    {
        return $this->EskiUrunKullanilmasin;
    }
    /**
     * Set EskiUrunKullanilmasin value
     * @param string $eskiUrunKullanilmasin
     * @return \StructType\ClsSuperSession
     */
    public function setEskiUrunKullanilmasin($eskiUrunKullanilmasin = null)
    {
        // validation for constraint: string
        if (!is_null($eskiUrunKullanilmasin) && !is_string($eskiUrunKullanilmasin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eskiUrunKullanilmasin, true), gettype($eskiUrunKullanilmasin)), __LINE__);
        }
        $this->EskiUrunKullanilmasin = $eskiUrunKullanilmasin;
        return $this;
    }
    /**
     * Get SonIslemTarihi value
     * @return string
     */
    public function getSonIslemTarihi()
    {
        return $this->SonIslemTarihi;
    }
    /**
     * Set SonIslemTarihi value
     * @param string $sonIslemTarihi
     * @return \StructType\ClsSuperSession
     */
    public function setSonIslemTarihi($sonIslemTarihi = null)
    {
        // validation for constraint: string
        if (!is_null($sonIslemTarihi) && !is_string($sonIslemTarihi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonIslemTarihi, true), gettype($sonIslemTarihi)), __LINE__);
        }
        $this->SonIslemTarihi = $sonIslemTarihi;
        return $this;
    }
    /**
     * Get SonKullaniciKod value
     * @return int
     */
    public function getSonKullaniciKod()
    {
        return $this->SonKullaniciKod;
    }
    /**
     * Set SonKullaniciKod value
     * @param int $sonKullaniciKod
     * @return \StructType\ClsSuperSession
     */
    public function setSonKullaniciKod($sonKullaniciKod = null)
    {
        // validation for constraint: int
        if (!is_null($sonKullaniciKod) && !(is_int($sonKullaniciKod) || ctype_digit($sonKullaniciKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sonKullaniciKod, true), gettype($sonKullaniciKod)), __LINE__);
        }
        $this->SonKullaniciKod = $sonKullaniciKod;
        return $this;
    }
    /**
     * Get IlkIslemTarihi value
     * @return string
     */
    public function getIlkIslemTarihi()
    {
        return $this->IlkIslemTarihi;
    }
    /**
     * Set IlkIslemTarihi value
     * @param string $ilkIslemTarihi
     * @return \StructType\ClsSuperSession
     */
    public function setIlkIslemTarihi($ilkIslemTarihi = null)
    {
        // validation for constraint: string
        if (!is_null($ilkIslemTarihi) && !is_string($ilkIslemTarihi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ilkIslemTarihi, true), gettype($ilkIslemTarihi)), __LINE__);
        }
        $this->IlkIslemTarihi = $ilkIslemTarihi;
        return $this;
    }
    /**
     * Get IlkKullaniciKod value
     * @return int
     */
    public function getIlkKullaniciKod()
    {
        return $this->IlkKullaniciKod;
    }
    /**
     * Set IlkKullaniciKod value
     * @param int $ilkKullaniciKod
     * @return \StructType\ClsSuperSession
     */
    public function setIlkKullaniciKod($ilkKullaniciKod = null)
    {
        // validation for constraint: int
        if (!is_null($ilkKullaniciKod) && !(is_int($ilkKullaniciKod) || ctype_digit($ilkKullaniciKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($ilkKullaniciKod, true), gettype($ilkKullaniciKod)), __LINE__);
        }
        $this->IlkKullaniciKod = $ilkKullaniciKod;
        return $this;
    }
    /**
     * Get Referans value
     * @return string|null
     */
    public function getReferans()
    {
        return $this->Referans;
    }
    /**
     * Set Referans value
     * @param string $referans
     * @return \StructType\ClsSuperSession
     */
    public function setReferans($referans = null)
    {
        // validation for constraint: string
        if (!is_null($referans) && !is_string($referans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($referans, true), gettype($referans)), __LINE__);
        }
        $this->Referans = $referans;
        return $this;
    }
    /**
     * Get SonIslemHost value
     * @return string|null
     */
    public function getSonIslemHost()
    {
        return $this->SonIslemHost;
    }
    /**
     * Set SonIslemHost value
     * @param string $sonIslemHost
     * @return \StructType\ClsSuperSession
     */
    public function setSonIslemHost($sonIslemHost = null)
    {
        // validation for constraint: string
        if (!is_null($sonIslemHost) && !is_string($sonIslemHost)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonIslemHost, true), gettype($sonIslemHost)), __LINE__);
        }
        $this->SonIslemHost = $sonIslemHost;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsSuperSession
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
