<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsUrunFotoIntegration StructType
 * @subpackage Structs
 */
class ClsUrunFotoIntegration extends ClsEntity
{
    /**
     * The Kod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $Kod;
    /**
     * The UrunTextKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UrunTextKod;
    /**
     * The UrunReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UrunReferans;
    /**
     * The Foto1
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Foto1;
    /**
     * The Foto2
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Foto2;
    /**
     * Constructor method for clsUrunFotoIntegration
     * @uses ClsUrunFotoIntegration::setKod()
     * @uses ClsUrunFotoIntegration::setUrunTextKod()
     * @uses ClsUrunFotoIntegration::setUrunReferans()
     * @uses ClsUrunFotoIntegration::setFoto1()
     * @uses ClsUrunFotoIntegration::setFoto2()
     * @param int $kod
     * @param string $urunTextKod
     * @param string $urunReferans
     * @param string $foto1
     * @param string $foto2
     */
    public function __construct($kod = null, $urunTextKod = null, $urunReferans = null, $foto1 = null, $foto2 = null)
    {
        $this
            ->setKod($kod)
            ->setUrunTextKod($urunTextKod)
            ->setUrunReferans($urunReferans)
            ->setFoto1($foto1)
            ->setFoto2($foto2);
    }
    /**
     * Get Kod value
     * @return int
     */
    public function getKod()
    {
        return $this->Kod;
    }
    /**
     * Set Kod value
     * @param int $kod
     * @return \StructType\ClsUrunFotoIntegration
     */
    public function setKod($kod = null)
    {
        // validation for constraint: int
        if (!is_null($kod) && !(is_int($kod) || ctype_digit($kod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($kod, true), gettype($kod)), __LINE__);
        }
        $this->Kod = $kod;
        return $this;
    }
    /**
     * Get UrunTextKod value
     * @return string|null
     */
    public function getUrunTextKod()
    {
        return $this->UrunTextKod;
    }
    /**
     * Set UrunTextKod value
     * @param string $urunTextKod
     * @return \StructType\ClsUrunFotoIntegration
     */
    public function setUrunTextKod($urunTextKod = null)
    {
        // validation for constraint: string
        if (!is_null($urunTextKod) && !is_string($urunTextKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($urunTextKod, true), gettype($urunTextKod)), __LINE__);
        }
        $this->UrunTextKod = $urunTextKod;
        return $this;
    }
    /**
     * Get UrunReferans value
     * @return string|null
     */
    public function getUrunReferans()
    {
        return $this->UrunReferans;
    }
    /**
     * Set UrunReferans value
     * @param string $urunReferans
     * @return \StructType\ClsUrunFotoIntegration
     */
    public function setUrunReferans($urunReferans = null)
    {
        // validation for constraint: string
        if (!is_null($urunReferans) && !is_string($urunReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($urunReferans, true), gettype($urunReferans)), __LINE__);
        }
        $this->UrunReferans = $urunReferans;
        return $this;
    }
    /**
     * Get Foto1 value
     * @return string|null
     */
    public function getFoto1()
    {
        return $this->Foto1;
    }
    /**
     * Set Foto1 value
     * @param string $foto1
     * @return \StructType\ClsUrunFotoIntegration
     */
    public function setFoto1($foto1 = null)
    {
        // validation for constraint: string
        if (!is_null($foto1) && !is_string($foto1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($foto1, true), gettype($foto1)), __LINE__);
        }
        $this->Foto1 = $foto1;
        return $this;
    }
    /**
     * Get Foto2 value
     * @return string|null
     */
    public function getFoto2()
    {
        return $this->Foto2;
    }
    /**
     * Set Foto2 value
     * @param string $foto2
     * @return \StructType\ClsUrunFotoIntegration
     */
    public function setFoto2($foto2 = null)
    {
        // validation for constraint: string
        if (!is_null($foto2) && !is_string($foto2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($foto2, true), gettype($foto2)), __LINE__);
        }
        $this->Foto2 = $foto2;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsUrunFotoIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
