<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsUrunMuadilIntegration StructType
 * @subpackage Structs
 */
class ClsUrunMuadilIntegration extends ClsEntity
{
    /**
     * The AnaUrunKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $AnaUrunKod;
    /**
     * The DetayUrunKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $DetayUrunKod;
    /**
     * The AnaUrunTextKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $AnaUrunTextKod;
    /**
     * The AnaUrunReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $AnaUrunReferans;
    /**
     * The DetayUrunTextKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DetayUrunTextKod;
    /**
     * The DetayUrunReferans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DetayUrunReferans;
    /**
     * The Referans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Referans;
    /**
     * Constructor method for clsUrunMuadilIntegration
     * @uses ClsUrunMuadilIntegration::setAnaUrunKod()
     * @uses ClsUrunMuadilIntegration::setDetayUrunKod()
     * @uses ClsUrunMuadilIntegration::setAnaUrunTextKod()
     * @uses ClsUrunMuadilIntegration::setAnaUrunReferans()
     * @uses ClsUrunMuadilIntegration::setDetayUrunTextKod()
     * @uses ClsUrunMuadilIntegration::setDetayUrunReferans()
     * @uses ClsUrunMuadilIntegration::setReferans()
     * @param int $anaUrunKod
     * @param int $detayUrunKod
     * @param string $anaUrunTextKod
     * @param string $anaUrunReferans
     * @param string $detayUrunTextKod
     * @param string $detayUrunReferans
     * @param string $referans
     */
    public function __construct($anaUrunKod = null, $detayUrunKod = null, $anaUrunTextKod = null, $anaUrunReferans = null, $detayUrunTextKod = null, $detayUrunReferans = null, $referans = null)
    {
        $this
            ->setAnaUrunKod($anaUrunKod)
            ->setDetayUrunKod($detayUrunKod)
            ->setAnaUrunTextKod($anaUrunTextKod)
            ->setAnaUrunReferans($anaUrunReferans)
            ->setDetayUrunTextKod($detayUrunTextKod)
            ->setDetayUrunReferans($detayUrunReferans)
            ->setReferans($referans);
    }
    /**
     * Get AnaUrunKod value
     * @return int
     */
    public function getAnaUrunKod()
    {
        return $this->AnaUrunKod;
    }
    /**
     * Set AnaUrunKod value
     * @param int $anaUrunKod
     * @return \StructType\ClsUrunMuadilIntegration
     */
    public function setAnaUrunKod($anaUrunKod = null)
    {
        // validation for constraint: int
        if (!is_null($anaUrunKod) && !(is_int($anaUrunKod) || ctype_digit($anaUrunKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($anaUrunKod, true), gettype($anaUrunKod)), __LINE__);
        }
        $this->AnaUrunKod = $anaUrunKod;
        return $this;
    }
    /**
     * Get DetayUrunKod value
     * @return int
     */
    public function getDetayUrunKod()
    {
        return $this->DetayUrunKod;
    }
    /**
     * Set DetayUrunKod value
     * @param int $detayUrunKod
     * @return \StructType\ClsUrunMuadilIntegration
     */
    public function setDetayUrunKod($detayUrunKod = null)
    {
        // validation for constraint: int
        if (!is_null($detayUrunKod) && !(is_int($detayUrunKod) || ctype_digit($detayUrunKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($detayUrunKod, true), gettype($detayUrunKod)), __LINE__);
        }
        $this->DetayUrunKod = $detayUrunKod;
        return $this;
    }
    /**
     * Get AnaUrunTextKod value
     * @return string|null
     */
    public function getAnaUrunTextKod()
    {
        return $this->AnaUrunTextKod;
    }
    /**
     * Set AnaUrunTextKod value
     * @param string $anaUrunTextKod
     * @return \StructType\ClsUrunMuadilIntegration
     */
    public function setAnaUrunTextKod($anaUrunTextKod = null)
    {
        // validation for constraint: string
        if (!is_null($anaUrunTextKod) && !is_string($anaUrunTextKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($anaUrunTextKod, true), gettype($anaUrunTextKod)), __LINE__);
        }
        $this->AnaUrunTextKod = $anaUrunTextKod;
        return $this;
    }
    /**
     * Get AnaUrunReferans value
     * @return string|null
     */
    public function getAnaUrunReferans()
    {
        return $this->AnaUrunReferans;
    }
    /**
     * Set AnaUrunReferans value
     * @param string $anaUrunReferans
     * @return \StructType\ClsUrunMuadilIntegration
     */
    public function setAnaUrunReferans($anaUrunReferans = null)
    {
        // validation for constraint: string
        if (!is_null($anaUrunReferans) && !is_string($anaUrunReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($anaUrunReferans, true), gettype($anaUrunReferans)), __LINE__);
        }
        $this->AnaUrunReferans = $anaUrunReferans;
        return $this;
    }
    /**
     * Get DetayUrunTextKod value
     * @return string|null
     */
    public function getDetayUrunTextKod()
    {
        return $this->DetayUrunTextKod;
    }
    /**
     * Set DetayUrunTextKod value
     * @param string $detayUrunTextKod
     * @return \StructType\ClsUrunMuadilIntegration
     */
    public function setDetayUrunTextKod($detayUrunTextKod = null)
    {
        // validation for constraint: string
        if (!is_null($detayUrunTextKod) && !is_string($detayUrunTextKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($detayUrunTextKod, true), gettype($detayUrunTextKod)), __LINE__);
        }
        $this->DetayUrunTextKod = $detayUrunTextKod;
        return $this;
    }
    /**
     * Get DetayUrunReferans value
     * @return string|null
     */
    public function getDetayUrunReferans()
    {
        return $this->DetayUrunReferans;
    }
    /**
     * Set DetayUrunReferans value
     * @param string $detayUrunReferans
     * @return \StructType\ClsUrunMuadilIntegration
     */
    public function setDetayUrunReferans($detayUrunReferans = null)
    {
        // validation for constraint: string
        if (!is_null($detayUrunReferans) && !is_string($detayUrunReferans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($detayUrunReferans, true), gettype($detayUrunReferans)), __LINE__);
        }
        $this->DetayUrunReferans = $detayUrunReferans;
        return $this;
    }
    /**
     * Get Referans value
     * @return string|null
     */
    public function getReferans()
    {
        return $this->Referans;
    }
    /**
     * Set Referans value
     * @param string $referans
     * @return \StructType\ClsUrunMuadilIntegration
     */
    public function setReferans($referans = null)
    {
        // validation for constraint: string
        if (!is_null($referans) && !is_string($referans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($referans, true), gettype($referans)), __LINE__);
        }
        $this->Referans = $referans;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsUrunMuadilIntegration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
