<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for clsZincir StructType
 * @subpackage Structs
 */
class ClsZincir extends ClsEntity
{
    /**
     * The DistKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $DistKod;
    /**
     * The MerkezKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $MerkezKod;
    /**
     * The MagazaKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $MagazaKod;
    /**
     * The SonIslemTarihi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $SonIslemTarihi;
    /**
     * The Ilkislemtarihi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $Ilkislemtarihi;
    /**
     * The Ilkkullanicikod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $Ilkkullanicikod;
    /**
     * The Sonkullanicikod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $Sonkullanicikod;
    /**
     * The Referans
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Referans;
    /**
     * Constructor method for clsZincir
     * @uses ClsZincir::setDistKod()
     * @uses ClsZincir::setMerkezKod()
     * @uses ClsZincir::setMagazaKod()
     * @uses ClsZincir::setSonIslemTarihi()
     * @uses ClsZincir::setIlkislemtarihi()
     * @uses ClsZincir::setIlkkullanicikod()
     * @uses ClsZincir::setSonkullanicikod()
     * @uses ClsZincir::setReferans()
     * @param int $distKod
     * @param int $merkezKod
     * @param int $magazaKod
     * @param string $sonIslemTarihi
     * @param string $ilkislemtarihi
     * @param int $ilkkullanicikod
     * @param int $sonkullanicikod
     * @param string $referans
     */
    public function __construct($distKod = null, $merkezKod = null, $magazaKod = null, $sonIslemTarihi = null, $ilkislemtarihi = null, $ilkkullanicikod = null, $sonkullanicikod = null, $referans = null)
    {
        $this
            ->setDistKod($distKod)
            ->setMerkezKod($merkezKod)
            ->setMagazaKod($magazaKod)
            ->setSonIslemTarihi($sonIslemTarihi)
            ->setIlkislemtarihi($ilkislemtarihi)
            ->setIlkkullanicikod($ilkkullanicikod)
            ->setSonkullanicikod($sonkullanicikod)
            ->setReferans($referans);
    }
    /**
     * Get DistKod value
     * @return int
     */
    public function getDistKod()
    {
        return $this->DistKod;
    }
    /**
     * Set DistKod value
     * @param int $distKod
     * @return \StructType\ClsZincir
     */
    public function setDistKod($distKod = null)
    {
        // validation for constraint: int
        if (!is_null($distKod) && !(is_int($distKod) || ctype_digit($distKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($distKod, true), gettype($distKod)), __LINE__);
        }
        $this->DistKod = $distKod;
        return $this;
    }
    /**
     * Get MerkezKod value
     * @return int
     */
    public function getMerkezKod()
    {
        return $this->MerkezKod;
    }
    /**
     * Set MerkezKod value
     * @param int $merkezKod
     * @return \StructType\ClsZincir
     */
    public function setMerkezKod($merkezKod = null)
    {
        // validation for constraint: int
        if (!is_null($merkezKod) && !(is_int($merkezKod) || ctype_digit($merkezKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($merkezKod, true), gettype($merkezKod)), __LINE__);
        }
        $this->MerkezKod = $merkezKod;
        return $this;
    }
    /**
     * Get MagazaKod value
     * @return int
     */
    public function getMagazaKod()
    {
        return $this->MagazaKod;
    }
    /**
     * Set MagazaKod value
     * @param int $magazaKod
     * @return \StructType\ClsZincir
     */
    public function setMagazaKod($magazaKod = null)
    {
        // validation for constraint: int
        if (!is_null($magazaKod) && !(is_int($magazaKod) || ctype_digit($magazaKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($magazaKod, true), gettype($magazaKod)), __LINE__);
        }
        $this->MagazaKod = $magazaKod;
        return $this;
    }
    /**
     * Get SonIslemTarihi value
     * @return string
     */
    public function getSonIslemTarihi()
    {
        return $this->SonIslemTarihi;
    }
    /**
     * Set SonIslemTarihi value
     * @param string $sonIslemTarihi
     * @return \StructType\ClsZincir
     */
    public function setSonIslemTarihi($sonIslemTarihi = null)
    {
        // validation for constraint: string
        if (!is_null($sonIslemTarihi) && !is_string($sonIslemTarihi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonIslemTarihi, true), gettype($sonIslemTarihi)), __LINE__);
        }
        $this->SonIslemTarihi = $sonIslemTarihi;
        return $this;
    }
    /**
     * Get Ilkislemtarihi value
     * @return string
     */
    public function getIlkislemtarihi()
    {
        return $this->Ilkislemtarihi;
    }
    /**
     * Set Ilkislemtarihi value
     * @param string $ilkislemtarihi
     * @return \StructType\ClsZincir
     */
    public function setIlkislemtarihi($ilkislemtarihi = null)
    {
        // validation for constraint: string
        if (!is_null($ilkislemtarihi) && !is_string($ilkislemtarihi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ilkislemtarihi, true), gettype($ilkislemtarihi)), __LINE__);
        }
        $this->Ilkislemtarihi = $ilkislemtarihi;
        return $this;
    }
    /**
     * Get Ilkkullanicikod value
     * @return int
     */
    public function getIlkkullanicikod()
    {
        return $this->Ilkkullanicikod;
    }
    /**
     * Set Ilkkullanicikod value
     * @param int $ilkkullanicikod
     * @return \StructType\ClsZincir
     */
    public function setIlkkullanicikod($ilkkullanicikod = null)
    {
        // validation for constraint: int
        if (!is_null($ilkkullanicikod) && !(is_int($ilkkullanicikod) || ctype_digit($ilkkullanicikod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($ilkkullanicikod, true), gettype($ilkkullanicikod)), __LINE__);
        }
        $this->Ilkkullanicikod = $ilkkullanicikod;
        return $this;
    }
    /**
     * Get Sonkullanicikod value
     * @return int
     */
    public function getSonkullanicikod()
    {
        return $this->Sonkullanicikod;
    }
    /**
     * Set Sonkullanicikod value
     * @param int $sonkullanicikod
     * @return \StructType\ClsZincir
     */
    public function setSonkullanicikod($sonkullanicikod = null)
    {
        // validation for constraint: int
        if (!is_null($sonkullanicikod) && !(is_int($sonkullanicikod) || ctype_digit($sonkullanicikod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sonkullanicikod, true), gettype($sonkullanicikod)), __LINE__);
        }
        $this->Sonkullanicikod = $sonkullanicikod;
        return $this;
    }
    /**
     * Get Referans value
     * @return string|null
     */
    public function getReferans()
    {
        return $this->Referans;
    }
    /**
     * Set Referans value
     * @param string $referans
     * @return \StructType\ClsZincir
     */
    public function setReferans($referans = null)
    {
        // validation for constraint: string
        if (!is_null($referans) && !is_string($referans)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($referans, true), gettype($referans)), __LINE__);
        }
        $this->Referans = $referans;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClsZincir
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
