<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Doviz StructType
 * @subpackage Structs
 */
class Doviz extends AbstractStructBase
{
    /**
     * The DovizKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $DovizKod;
    /**
     * The DovizTip
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $DovizTip;
    /**
     * The DovizKur
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $DovizKur;
    /**
     * The DovizFiyat
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $DovizFiyat;
    /**
     * The DovizKurKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $DovizKurKod;
    /**
     * The DovizKurSira
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $DovizKurSira;
    /**
     * The DovizParaBirimi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ClsSharedParaBirimi
     */
    public $DovizParaBirimi;
    /**
     * Constructor method for Doviz
     * @uses Doviz::setDovizKod()
     * @uses Doviz::setDovizTip()
     * @uses Doviz::setDovizKur()
     * @uses Doviz::setDovizFiyat()
     * @uses Doviz::setDovizKurKod()
     * @uses Doviz::setDovizKurSira()
     * @uses Doviz::setDovizParaBirimi()
     * @param int $dovizKod
     * @param string $dovizTip
     * @param float $dovizKur
     * @param float $dovizFiyat
     * @param int $dovizKurKod
     * @param string $dovizKurSira
     * @param \StructType\ClsSharedParaBirimi $dovizParaBirimi
     */
    public function __construct($dovizKod = null, $dovizTip = null, $dovizKur = null, $dovizFiyat = null, $dovizKurKod = null, $dovizKurSira = null, \StructType\ClsSharedParaBirimi $dovizParaBirimi = null)
    {
        $this
            ->setDovizKod($dovizKod)
            ->setDovizTip($dovizTip)
            ->setDovizKur($dovizKur)
            ->setDovizFiyat($dovizFiyat)
            ->setDovizKurKod($dovizKurKod)
            ->setDovizKurSira($dovizKurSira)
            ->setDovizParaBirimi($dovizParaBirimi);
    }
    /**
     * Get DovizKod value
     * @return int
     */
    public function getDovizKod()
    {
        return $this->DovizKod;
    }
    /**
     * Set DovizKod value
     * @param int $dovizKod
     * @return \StructType\Doviz
     */
    public function setDovizKod($dovizKod = null)
    {
        // validation for constraint: int
        if (!is_null($dovizKod) && !(is_int($dovizKod) || ctype_digit($dovizKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($dovizKod, true), gettype($dovizKod)), __LINE__);
        }
        $this->DovizKod = $dovizKod;
        return $this;
    }
    /**
     * Get DovizTip value
     * @return string
     */
    public function getDovizTip()
    {
        return $this->DovizTip;
    }
    /**
     * Set DovizTip value
     * @param string $dovizTip
     * @return \StructType\Doviz
     */
    public function setDovizTip($dovizTip = null)
    {
        // validation for constraint: string
        if (!is_null($dovizTip) && !is_string($dovizTip)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dovizTip, true), gettype($dovizTip)), __LINE__);
        }
        $this->DovizTip = $dovizTip;
        return $this;
    }
    /**
     * Get DovizKur value
     * @return float
     */
    public function getDovizKur()
    {
        return $this->DovizKur;
    }
    /**
     * Set DovizKur value
     * @param float $dovizKur
     * @return \StructType\Doviz
     */
    public function setDovizKur($dovizKur = null)
    {
        // validation for constraint: float
        if (!is_null($dovizKur) && !(is_float($dovizKur) || is_numeric($dovizKur))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($dovizKur, true), gettype($dovizKur)), __LINE__);
        }
        $this->DovizKur = $dovizKur;
        return $this;
    }
    /**
     * Get DovizFiyat value
     * @return float
     */
    public function getDovizFiyat()
    {
        return $this->DovizFiyat;
    }
    /**
     * Set DovizFiyat value
     * @param float $dovizFiyat
     * @return \StructType\Doviz
     */
    public function setDovizFiyat($dovizFiyat = null)
    {
        // validation for constraint: float
        if (!is_null($dovizFiyat) && !(is_float($dovizFiyat) || is_numeric($dovizFiyat))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($dovizFiyat, true), gettype($dovizFiyat)), __LINE__);
        }
        $this->DovizFiyat = $dovizFiyat;
        return $this;
    }
    /**
     * Get DovizKurKod value
     * @return int
     */
    public function getDovizKurKod()
    {
        return $this->DovizKurKod;
    }
    /**
     * Set DovizKurKod value
     * @param int $dovizKurKod
     * @return \StructType\Doviz
     */
    public function setDovizKurKod($dovizKurKod = null)
    {
        // validation for constraint: int
        if (!is_null($dovizKurKod) && !(is_int($dovizKurKod) || ctype_digit($dovizKurKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($dovizKurKod, true), gettype($dovizKurKod)), __LINE__);
        }
        $this->DovizKurKod = $dovizKurKod;
        return $this;
    }
    /**
     * Get DovizKurSira value
     * @return string
     */
    public function getDovizKurSira()
    {
        return $this->DovizKurSira;
    }
    /**
     * Set DovizKurSira value
     * @param string $dovizKurSira
     * @return \StructType\Doviz
     */
    public function setDovizKurSira($dovizKurSira = null)
    {
        // validation for constraint: string
        if (!is_null($dovizKurSira) && !is_string($dovizKurSira)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dovizKurSira, true), gettype($dovizKurSira)), __LINE__);
        }
        $this->DovizKurSira = $dovizKurSira;
        return $this;
    }
    /**
     * Get DovizParaBirimi value
     * @return \StructType\ClsSharedParaBirimi|null
     */
    public function getDovizParaBirimi()
    {
        return $this->DovizParaBirimi;
    }
    /**
     * Set DovizParaBirimi value
     * @param \StructType\ClsSharedParaBirimi $dovizParaBirimi
     * @return \StructType\Doviz
     */
    public function setDovizParaBirimi(\StructType\ClsSharedParaBirimi $dovizParaBirimi = null)
    {
        $this->DovizParaBirimi = $dovizParaBirimi;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Doviz
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
