<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for IntegrationLogin StructType
 * @subpackage Structs
 */
class IntegrationLogin extends AbstractStructBase
{
    /**
     * The bytFirmaKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $bytFirmaKod;
    /**
     * The lngCalismaYili
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $lngCalismaYili;
    /**
     * The lngDistributorKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $lngDistributorKod;
    /**
     * The strUserName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $strUserName;
    /**
     * The strPassWord
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $strPassWord;
    /**
     * Constructor method for IntegrationLogin
     * @uses IntegrationLogin::setBytFirmaKod()
     * @uses IntegrationLogin::setLngCalismaYili()
     * @uses IntegrationLogin::setLngDistributorKod()
     * @uses IntegrationLogin::setStrUserName()
     * @uses IntegrationLogin::setStrPassWord()
     * @param string $bytFirmaKod
     * @param int $lngCalismaYili
     * @param int $lngDistributorKod
     * @param string $strUserName
     * @param string $strPassWord
     */
    public function __construct($bytFirmaKod = null, $lngCalismaYili = null, $lngDistributorKod = null, $strUserName = null, $strPassWord = null)
    {
        $this
            ->setBytFirmaKod($bytFirmaKod)
            ->setLngCalismaYili($lngCalismaYili)
            ->setLngDistributorKod($lngDistributorKod)
            ->setStrUserName($strUserName)
            ->setStrPassWord($strPassWord);
    }
    /**
     * Get bytFirmaKod value
     * @return string
     */
    public function getBytFirmaKod()
    {
        return $this->bytFirmaKod;
    }
    /**
     * Set bytFirmaKod value
     * @param string $bytFirmaKod
     * @return \StructType\IntegrationLogin
     */
    public function setBytFirmaKod($bytFirmaKod = null)
    {
        // validation for constraint: string
        if (!is_null($bytFirmaKod) && !is_string($bytFirmaKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bytFirmaKod, true), gettype($bytFirmaKod)), __LINE__);
        }
        $this->bytFirmaKod = $bytFirmaKod;
        return $this;
    }
    /**
     * Get lngCalismaYili value
     * @return int
     */
    public function getLngCalismaYili()
    {
        return $this->lngCalismaYili;
    }
    /**
     * Set lngCalismaYili value
     * @param int $lngCalismaYili
     * @return \StructType\IntegrationLogin
     */
    public function setLngCalismaYili($lngCalismaYili = null)
    {
        // validation for constraint: int
        if (!is_null($lngCalismaYili) && !(is_int($lngCalismaYili) || ctype_digit($lngCalismaYili))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($lngCalismaYili, true), gettype($lngCalismaYili)), __LINE__);
        }
        $this->lngCalismaYili = $lngCalismaYili;
        return $this;
    }
    /**
     * Get lngDistributorKod value
     * @return int
     */
    public function getLngDistributorKod()
    {
        return $this->lngDistributorKod;
    }
    /**
     * Set lngDistributorKod value
     * @param int $lngDistributorKod
     * @return \StructType\IntegrationLogin
     */
    public function setLngDistributorKod($lngDistributorKod = null)
    {
        // validation for constraint: int
        if (!is_null($lngDistributorKod) && !(is_int($lngDistributorKod) || ctype_digit($lngDistributorKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($lngDistributorKod, true), gettype($lngDistributorKod)), __LINE__);
        }
        $this->lngDistributorKod = $lngDistributorKod;
        return $this;
    }
    /**
     * Get strUserName value
     * @return string|null
     */
    public function getStrUserName()
    {
        return $this->strUserName;
    }
    /**
     * Set strUserName value
     * @param string $strUserName
     * @return \StructType\IntegrationLogin
     */
    public function setStrUserName($strUserName = null)
    {
        // validation for constraint: string
        if (!is_null($strUserName) && !is_string($strUserName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($strUserName, true), gettype($strUserName)), __LINE__);
        }
        $this->strUserName = $strUserName;
        return $this;
    }
    /**
     * Get strPassWord value
     * @return string|null
     */
    public function getStrPassWord()
    {
        return $this->strPassWord;
    }
    /**
     * Set strPassWord value
     * @param string $strPassWord
     * @return \StructType\IntegrationLogin
     */
    public function setStrPassWord($strPassWord = null)
    {
        // validation for constraint: string
        if (!is_null($strPassWord) && !is_string($strPassWord)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($strPassWord, true), gettype($strPassWord)), __LINE__);
        }
        $this->strPassWord = $strPassWord;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\IntegrationLogin
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
