<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for IntegrationSendCollectionPaid StructType
 * @subpackage Structs
 */
class IntegrationSendCollectionPaid extends AbstractStructBase
{
    /**
     * The tahsilatDurum
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $tahsilatDurum;
    /**
     * The bytFirmaKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $bytFirmaKod;
    /**
     * The lngCalismaYili
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $lngCalismaYili;
    /**
     * The lngDistributorKod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $lngDistributorKod;
    /**
     * The successRecords
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $successRecords;
    /**
     * The referenceColumn
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $referenceColumn;
    /**
     * The strUserName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $strUserName;
    /**
     * The strPassWord
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $strPassWord;
    /**
     * Constructor method for IntegrationSendCollectionPaid
     * @uses IntegrationSendCollectionPaid::setTahsilatDurum()
     * @uses IntegrationSendCollectionPaid::setBytFirmaKod()
     * @uses IntegrationSendCollectionPaid::setLngCalismaYili()
     * @uses IntegrationSendCollectionPaid::setLngDistributorKod()
     * @uses IntegrationSendCollectionPaid::setSuccessRecords()
     * @uses IntegrationSendCollectionPaid::setReferenceColumn()
     * @uses IntegrationSendCollectionPaid::setStrUserName()
     * @uses IntegrationSendCollectionPaid::setStrPassWord()
     * @param string $tahsilatDurum
     * @param string $bytFirmaKod
     * @param int $lngCalismaYili
     * @param int $lngDistributorKod
     * @param \ArrayType\ArrayOfString $successRecords
     * @param string $referenceColumn
     * @param string $strUserName
     * @param string $strPassWord
     */
    public function __construct($tahsilatDurum = null, $bytFirmaKod = null, $lngCalismaYili = null, $lngDistributorKod = null, \ArrayType\ArrayOfString $successRecords = null, $referenceColumn = null, $strUserName = null, $strPassWord = null)
    {
        $this
            ->setTahsilatDurum($tahsilatDurum)
            ->setBytFirmaKod($bytFirmaKod)
            ->setLngCalismaYili($lngCalismaYili)
            ->setLngDistributorKod($lngDistributorKod)
            ->setSuccessRecords($successRecords)
            ->setReferenceColumn($referenceColumn)
            ->setStrUserName($strUserName)
            ->setStrPassWord($strPassWord);
    }
    /**
     * Get tahsilatDurum value
     * @return string
     */
    public function getTahsilatDurum()
    {
        return $this->tahsilatDurum;
    }
    /**
     * Set tahsilatDurum value
     * @param string $tahsilatDurum
     * @return \StructType\IntegrationSendCollectionPaid
     */
    public function setTahsilatDurum($tahsilatDurum = null)
    {
        // validation for constraint: string
        if (!is_null($tahsilatDurum) && !is_string($tahsilatDurum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tahsilatDurum, true), gettype($tahsilatDurum)), __LINE__);
        }
        $this->tahsilatDurum = $tahsilatDurum;
        return $this;
    }
    /**
     * Get bytFirmaKod value
     * @return string
     */
    public function getBytFirmaKod()
    {
        return $this->bytFirmaKod;
    }
    /**
     * Set bytFirmaKod value
     * @param string $bytFirmaKod
     * @return \StructType\IntegrationSendCollectionPaid
     */
    public function setBytFirmaKod($bytFirmaKod = null)
    {
        // validation for constraint: string
        if (!is_null($bytFirmaKod) && !is_string($bytFirmaKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bytFirmaKod, true), gettype($bytFirmaKod)), __LINE__);
        }
        $this->bytFirmaKod = $bytFirmaKod;
        return $this;
    }
    /**
     * Get lngCalismaYili value
     * @return int
     */
    public function getLngCalismaYili()
    {
        return $this->lngCalismaYili;
    }
    /**
     * Set lngCalismaYili value
     * @param int $lngCalismaYili
     * @return \StructType\IntegrationSendCollectionPaid
     */
    public function setLngCalismaYili($lngCalismaYili = null)
    {
        // validation for constraint: int
        if (!is_null($lngCalismaYili) && !(is_int($lngCalismaYili) || ctype_digit($lngCalismaYili))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($lngCalismaYili, true), gettype($lngCalismaYili)), __LINE__);
        }
        $this->lngCalismaYili = $lngCalismaYili;
        return $this;
    }
    /**
     * Get lngDistributorKod value
     * @return int
     */
    public function getLngDistributorKod()
    {
        return $this->lngDistributorKod;
    }
    /**
     * Set lngDistributorKod value
     * @param int $lngDistributorKod
     * @return \StructType\IntegrationSendCollectionPaid
     */
    public function setLngDistributorKod($lngDistributorKod = null)
    {
        // validation for constraint: int
        if (!is_null($lngDistributorKod) && !(is_int($lngDistributorKod) || ctype_digit($lngDistributorKod))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($lngDistributorKod, true), gettype($lngDistributorKod)), __LINE__);
        }
        $this->lngDistributorKod = $lngDistributorKod;
        return $this;
    }
    /**
     * Get successRecords value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getSuccessRecords()
    {
        return $this->successRecords;
    }
    /**
     * Set successRecords value
     * @param \ArrayType\ArrayOfString $successRecords
     * @return \StructType\IntegrationSendCollectionPaid
     */
    public function setSuccessRecords(\ArrayType\ArrayOfString $successRecords = null)
    {
        $this->successRecords = $successRecords;
        return $this;
    }
    /**
     * Get referenceColumn value
     * @return string|null
     */
    public function getReferenceColumn()
    {
        return $this->referenceColumn;
    }
    /**
     * Set referenceColumn value
     * @param string $referenceColumn
     * @return \StructType\IntegrationSendCollectionPaid
     */
    public function setReferenceColumn($referenceColumn = null)
    {
        // validation for constraint: string
        if (!is_null($referenceColumn) && !is_string($referenceColumn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($referenceColumn, true), gettype($referenceColumn)), __LINE__);
        }
        $this->referenceColumn = $referenceColumn;
        return $this;
    }
    /**
     * Get strUserName value
     * @return string|null
     */
    public function getStrUserName()
    {
        return $this->strUserName;
    }
    /**
     * Set strUserName value
     * @param string $strUserName
     * @return \StructType\IntegrationSendCollectionPaid
     */
    public function setStrUserName($strUserName = null)
    {
        // validation for constraint: string
        if (!is_null($strUserName) && !is_string($strUserName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($strUserName, true), gettype($strUserName)), __LINE__);
        }
        $this->strUserName = $strUserName;
        return $this;
    }
    /**
     * Get strPassWord value
     * @return string|null
     */
    public function getStrPassWord()
    {
        return $this->strPassWord;
    }
    /**
     * Set strPassWord value
     * @param string $strPassWord
     * @return \StructType\IntegrationSendCollectionPaid
     */
    public function setStrPassWord($strPassWord = null)
    {
        // validation for constraint: string
        if (!is_null($strPassWord) && !is_string($strPassWord)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($strPassWord, true), gettype($strPassWord)), __LINE__);
        }
        $this->strPassWord = $strPassWord;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\IntegrationSendCollectionPaid
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
